#include "admin_pqlx.h"
GtkWidget *topWindow;
GtkWidget *statusBar;
GtkWidget *sideBar[TTLADMINTABS];
GtkWidget *NBtabs[TTLADMINTABS];
GtkWidget *dbInfo[DBTTLDETAILS];
GtkWidget *stats[TTLPDFSTATS];
GtkWidget *DBDefNB, *DBDefTabs[TTLDBINFOTABS];
GtkWidget *buttons[TTLINDBUTS];
GtkWidget *psdConf[PSDCONFTTLDETAILS];
GtkWidget *pngPlot[TTLPNGPLOTS];
GtkWidget *srvrCFGIDFile;
GtkWidget *evtQdisp;
GtkWidget *srvrFrame;
GtkWidget *dbDelete;
GtkWidget *search, *chnStats[TTLCHNSTATS], *spsEwin;
GtkWidget *dataVIEW[TTLDATAMODELS];
GPtrArray *dispState[TTLDBDISPSTATES][TTLDISPTYPES][TTLDISPDIRS];
FILE *logFP;
char *admin_tabs[TTLADMINTABS] = {" Definition ", " Channels ", " Exec/Logs " };
char *info_tabs[TTLDBINFOTABS] = { "Description", "Data Directories", "PSD Configuration", "PNG Settings" };
char *dd_hdrs[DD_TTLHDRS] = { "Directory", "Status", "Most Recent File", "Total\nTraces", "Total\nResponses"};
char *ch_hdrs[CH_TTLHDRS] = { "Channel\nName", "Start\nDate", "End\nDate", "Total\nTraces", "Total\nPSD's", "SPS\nEpochs", "Response\nFile"};
char *loge_hdrs[LOGE_TTLHDRS] = { "Program", "Execution Time", "Completion Time", "Duration", "Status" };
char *logm_hdrs[LOGM_TTLHDRS] = { "Type", "TimeStamp", "Message" };
char *eq_hdrs[EQ_TTLHDRS] = { "Total", "Event Type"};
char *spse_hdrs[SPSE_TTLHDRS] = { "Sample\nRate", "Start Date", "End Date" };
char *psdcfg_hdrs[PSDCFG_TTLHDRS] = { "Channel\nGroup" };
char *dateFormats[TTLPDFDATEFORMATS] = { "YYYY.DDD", "YYYY-MM-DD", "DD-MM-YYYY", "DD-mmm-YYYY" };
char *statStr[TTLPDFSTATS] = { "Min", "Max", "Mode", "Median", "Mean", "5%", "10%", "25%", "75%", "90%", "95%"};
char *types[TTLDBTYPES] = { "PRODUCTION", "SCRATCH" };
char *PSDtypes[PSDCFG_TTLTYPES] = { "CONTINUOUS", "TRIGGERED" };
char *accessTypes[TTLDBACCESS] = { "PUBLIC", "PRIVATE" };
char *onOff[2] = { "OFF", "ON" };
char *logMsgTypes[TTLSRVRLOGTYPES] = { "LOG", "ERROR", "BOTH" };
char *srvrStatus[TTLSRVREXECSTATES] = {"Completed", "Executing", "Paused", "Crashed"};
char *eventQS[TTLEQSTATI] = {"Executing", "Queued", "Pending", "Complete"};
GdkColor white =  {0, 0xffff, 0xffff, 0xffff},
black =  {0, 0x0000, 0x0000, 0x0000},
ltblue = {0, 0xdbdb, 0xd2d2, 0xecec},
darkblue = {0, 0x1313, 0x1616, 0x4d4d},
green =  {0, 0x0, 0xffff, 0x0};
GdkColor darkGrey = {0, 75*256-1, 75*256-1, 75*256-1},
lightGrey = {0, 125*256-1, 125*256-1, 125*256-1},
lightGrey1 = {0, 245*256-1, 245*256-1, 245*256-1},
lightGrey2 = {0, 200*256-1, 200*256-1, 200*256-1},
darkBlue = {0, 0, 0, 100*256-1},
blue = {0, 0, 0, 255*256-1},
red = {0, 255*256-1, 0, 0},
pink = {0, 255*256-1, 45*256-1, 0} ;
char *months[] = {"JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC" };
GdkGC *OGXC;  
PQLXSTATES pqlxStates;
ADMINDATA admin;
