#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pql_defines.h"
#include "pql_externs.h"
#include "gtk_pql_externs.h"
#if 0
void makePQLAbout(GtkWidget **aboutD)
{
GtkWidget *label, *hbox;
char str[50];
*aboutD = gtk_dialog_new_with_buttons("About PQL",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"12\">\tPQL (PASSCAL Quick Look)\t\n</span>");
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), label);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
sprintf(str, "<span font_desc=\"11\">Version: %s\n</span>", PROG_VERSION);
gtk_label_set_markup(GTK_LABEL(label), str);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Authorship:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tPQL I\n\t\tversion 1: Richard I. Boaz - 1991\n\t\tversion 2: Sid Hellman - 1993</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tPQL II\n\t\tversion 1: Richard I. Boaz - 2005\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Credits:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tPQL II Funded by:\n\t\tPASSCAL Instrument Center, Socorro, NM \n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">License:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tCopyright (C):\n\t\tRichard I. Boaz - 2005 - 2010</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tGNU General Public License, version 2\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Comments, Suggestions, and Bug Reports at:\t\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\thttp://wush.net/bugzilla/PQLX\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
}
void makePDFAbout(GtkWidget **aboutD)
{
GtkWidget *label, *hbox;
char str[50];
*aboutD = gtk_dialog_new_with_buttons("About PSD Viewer",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"12\">\tPQLX (PQL-eXtended)\t\n\t\tPSD Viewer\n</span>");
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), label);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
sprintf(str, "<span font_desc=\"11\">Version: %s\n</span>", PROG_VERSION);
gtk_label_set_markup(GTK_LABEL(label), str);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Authorship:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tPQLX\n\t\tRichard I. Boaz - 2006\n\tPSD Viewer\n\t\tRichard I. Boaz - 2006\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Credits:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tPDF - Version I:\n\t\tIRIS DMS - Seattle, WA\n\tPQLX &amp; PSD Viewer Funded by:\n\t\tUSGS - Golden, CO\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tPDF Algorithm by:\n\t\tDaniel E. McNamara - USGS\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tPDF Algorithm Details at:\n\t\thttp://geohazards.cr.usgs.gov/staffweb/\n\t\t\tmcnamara/PDFweb/Noise_PDFs.html\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Licensing:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tCopyright (C):\n\t\tRichard I. Boaz - 2006 - 2010</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tGNU General Public License, version 2\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Comments, Suggestions, &amp; Bug Reports at:\t\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\thttp://wush.net/bugzilla/PQLX\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox); 
return;
}
void makeSTNAbout(GtkWidget **aboutD)
{
GtkWidget *label, *hbox;
char str[50];
*aboutD = gtk_dialog_new_with_buttons("About STN Viewer",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"12\">\tPQLX (PQL-eXtended)\t\n\t\tSTN Viewer\n</span>");
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), label);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
sprintf(str, "<span font_desc=\"11\">Version: %s\n</span>", PROG_VERSION);
gtk_label_set_markup(GTK_LABEL(label), str);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Authorship:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tPQLX\n\t\tRichard I. Boaz - 2007 - 2010\n\tSTN Viewer\n\t\tRichard I. Boaz - 2007 - 2010\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Credits:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tSTN Viewer Funded by:\n\t\tIRIS DMS - Seattle, WA\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Licensing:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tCopyright (C):\n\t\tRichard I. Boaz - 2007 - 2010</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tGNU General Public License, version 2\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Comments, Suggestions, &amp; Bug Reports at:\t\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\thttp://wush.net/bugzilla/PQLX\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox); 
return;
}
gint about(GtkButton *button, gpointer s)
{
int  system = GPOINTER_TO_INT(s);
static GtkWidget *aboutPQL, *aboutPDF, *aboutSTN; 
GtkWidget *aboutD;
switch(system)
{
case PQLSYSTEM:
if (!aboutPQL)
{
makePQLAbout(&aboutPQL);
}
aboutD = aboutPQL;
break;
case PDFSYSTEM:
if (!aboutPDF)
{
makePDFAbout(&aboutPDF);
}
aboutD = aboutPDF;
break;
case STNSYSTEM:
if (!aboutSTN)
{
makeSTNAbout(&aboutSTN);
}
aboutD = aboutSTN;
break;
}
gtk_widget_show_all(aboutD);
gtk_dialog_run(GTK_DIALOG(aboutD));
gtk_widget_hide(aboutD);
return TRUE;
}
#endif
static GtkWidget *aboutPQLX()
{
GtkWidget *label, *hbox, *aboutD;
char  *str;
aboutD = gtk_dialog_new_with_buttons("About PQLX",
GTK_WINDOW(topWindow),
GTK_DIALOG_DESTROY_WITH_PARENT,
GTK_STOCK_OK, GTK_RESPONSE_OK,
NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"12\">\n\tPQLX\t\n</span>");
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(aboutD)->vbox), label);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
str = g_strdup_printf("<span font_desc=\"11\">Version: %s\n</span>", PROG_VERSION);
gtk_label_set_markup(GTK_LABEL(label), str);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(aboutD)->vbox), hbox);
free(str); 
#if 0
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Copyright Notice:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(aboutD)->vbox), hbox);
#endif
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tCopyright (c) Richard Boaz - 2004 - 2013\n\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(aboutD)->vbox), hbox);
#if 0
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">\tPQLX System Produced and Distributed\t\n\tin Cooperation with Nanometrics Inc.\n</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(aboutD)->vbox), hbox);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span font_desc=\"10\">Licensing:</span>");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(GTK_DIALOG(*aboutD)->vbox), hbox);
#endif
return aboutD;
}
gint about(GtkButton *button, gpointer s)
{
static GtkWidget *aboutD;
if (!aboutD)
aboutD = aboutPQLX();
gtk_widget_show_all(aboutD);
gtk_dialog_run(GTK_DIALOG(aboutD));
gtk_widget_hide(aboutD);
return TRUE;
}
