#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#if 0
void FNameRplc(char **strFrom)
{
char *replaceS, *replaceE, *toPtr, *newStr;
int  fromLen, toLen, newLen;
if (!pqlxStates.user.fname.replace ||
!pqlxStates.user.fname.replace->fromStr ||
!pqlxStates.user.fname.replace->toStr)
{ 
return; 
}
fromLen=strlen(pqlxStates.user.fname.replace->fromStr);
toLen=strlen(pqlxStates.user.fname.replace->toStr);
if (!(fromLen && toLen))
{ 
return; 
}
replaceS = g_strstr_len(*strFrom, strlen(*strFrom), pqlxStates.user.fname.replace->fromStr);
if (!replaceS)
{ 
return; 
}
newLen = strlen(*strFrom) - (fromLen - toLen);
newStr = calloc(newLen+1, sizeof(char));
replaceE = replaceS + fromLen; 
toPtr = newStr;
if (replaceS != *strFrom)
{ 
strncpy(toPtr, *strFrom, replaceS-*strFrom);
toPtr += replaceS-*strFrom;
}
strncpy(toPtr, pqlxStates.user.fname.replace->toStr, toLen);
toPtr += toLen;
strncpy(toPtr, replaceE, strlen(*strFrom)-(replaceE-*strFrom));
free(*strFrom);
*strFrom = newStr;
return;
}
#endif
#define PQLXSYSSTART "PQLXSTART"
void setSystemStartup(int which)
{
DBLDI dbldi;
DBLRECORDS dblrecs;
memset(&dbldi, 0, sizeof(DBLDI));
memset(&dblrecs, 0, sizeof(DBLRECORDS));
dbldi.descr.tableData = PDFDFAULTST;
dbldi.descr.dataEvent = WRITE_SNGL;
dbldi.data = &dblrecs;
dblrecs.numRecs = 1;
if((dblrecs.recs = calloc(dblrecs.numRecs, sizeof(void *)))==NULL)
{
fprintf(stderr, "Out of Memory, cannot continue.\n");
exit(-1);
}
dblrecs.recs[0] = calloc(1, sizeof(DEFAULTS_REC));
strncpy(((DEFAULTS_REC *) dblrecs.recs[0])->name, PQLXSYSSTART, strlen(PQLXSYSSTART));
sprintf(((DEFAULTS_REC *) dblrecs.recs[0])->value, "%d", which);
dbl_request(&dbldi);
free(dblrecs.recs[0]);
free(dblrecs.recs);
switch(which)
{
case PDFSYSTEM:
stnSettings.general.startup = FALSE;
break;
case STNSYSTEM:
pdfSettings.general.startup = FALSE;
break;
}   
}
void getSystemStartup()
{
DBLDI dbldi;
DEFAULTS_REC record;
memset(&dbldi, 0, sizeof(DBLDI));
dbldi.descr.tableData = PDFDFAULTST;
dbldi.descr.dataEvent = READ_SNGL;
dbldi.data = &record;
memset(&record, 0, sizeof(DEFAULTS_REC));
strcpy(record.name, PQLXSYSSTART);
dbl_request(&dbldi);
if (!strcmp(record.value, DBL_NO_RECORD))
{ 
pqlxStates.startupSys = PDFSYSTEM;
pdfSettings.general.startup = TRUE;
}
else
{
pqlxStates.startupSys = atoi(record.value);
}
switch(pqlxStates.startupSys)
{
case PDFSYSTEM:
pdfSettings.general.startup = TRUE;
break;
case STNSYSTEM:
stnSettings.general.startup = TRUE;
break;
}
readPDFsrvrs();
}
gboolean dirty(int system)
{
static char *dbName[NUM_SYSTEMS];
static int stnXDays;
gboolean ret = FALSE;
if (!dbName[system])
{ 
ret = TRUE;
dbName[system] = g_strdup(pqlxStates.conn.dbNm);
goto DONE;
}
if (strcmp(dbName[system], pqlxStates.conn.dbNm))
{ 
ret = TRUE;
free(dbName[system]);
dbName[system] = g_strdup(pqlxStates.conn.dbNm);
goto DONE;
}
if (stnXDays != stnSettings.general.stnXDays)
{ 
ret = TRUE;
goto DONE;
}
DONE:
stnXDays = stnSettings.general.stnXDays;
return ret;
}
