#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
static GtkTooltips *tips;
static char  toolTip[1000];
static GtkWidget *make_ReqEntries()
{
GtkWidget  *control_box, *controlFrame, *controlBox, *box3, *button,
*eBox, *box, *label, *frame, *box2, *entry, *actionB, *sep;
GtkSizeGroup *size_group;
control_box = gtk_event_box_new();
controlFrame = gtk_frame_new(NULL);
controlBox = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(controlBox), 5);
gtk_container_add(GTK_CONTAINER(controlFrame), controlBox);
gtk_container_add(GTK_CONTAINER(control_box), controlFrame);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &settings.colors.sb[0]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) 
"<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">REQUEST A PDF</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
rYRF = frame = gtk_frame_new("YEAR");
box = gtk_vbox_new(TRUE, 3);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Start:");
gtk_size_group_add_widget(size_group, label);
rYR[PDFREQSTART] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
label = gtk_label_new(" YYYY");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), box2, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("End:");
gtk_size_group_add_widget(size_group, label);
rYR[PDFREQEND] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), box2, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
frame = gtk_frame_new("DAY");
box3 = gtk_vbox_new(FALSE, 0);
rMDF = box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Start:");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
rDY[PDFREQSTART][0] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
label = gtk_label_new("/");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
rDY[PDFREQSTART][1] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
label = gtk_label_new(" MM/DD");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("End:");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
rDY[PDFREQEND][0] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
label = gtk_label_new("/");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
rDY[PDFREQEND][1] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
gtk_container_add(GTK_CONTAINER(box3), box);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
rAGOF = box = gtk_vbox_new(FALSE, 0);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Start Days AGO:");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
rDYA[PDFREQSTART] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 4);
gtk_entry_set_max_length(GTK_ENTRY(entry), 4);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
gtk_container_add(GTK_CONTAINER(box3), box);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("End Days AGO:");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
rDYA[PDFREQEND] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 4);
gtk_entry_set_max_length(GTK_ENTRY(entry), 4);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
gtk_container_add(GTK_CONTAINER(frame), box3);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("HOUR");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Start:");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
rHR[PDFREQSTART][0] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
label = gtk_label_new(":");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
rHR[PDFREQSTART][1] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
label = gtk_label_new(" HH:MM");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("End:");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
rHR[PDFREQEND][0] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
label = gtk_label_new(":");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
rHR[PDFREQEND][1] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
rFREQF = frame = gtk_frame_new("FREQUENCY");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Extract Days:");
gtk_size_group_add_widget(size_group, label);
rFREQ[PDFREQNUMEXTRACT] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Skip Days:");
gtk_size_group_add_widget(size_group, label);
rFREQ[PDFREQFREQUENCY] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(requestPDF), NULL);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(controlBox), sep, FALSE, FALSE, 7);
actionB = gtk_vbutton_box_new();
gtk_button_box_set_layout (GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_START);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Plot");
gtk_container_add(GTK_CONTAINER(actionB), button);
gtk_size_group_add_widget(size_group, button);
g_signal_connect(button, "clicked", G_CALLBACK(requestPDF), NULL);
strcpy(toolTip, "Request Data from DB and Plot");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
return control_box;
}
static GtkWidget *make_ReqButtons(int which, GtkSizeGroup *size_group)
{
int  i;
GtkWidget *widget, *vbox, *label, *combo;
GtkWidget *eBox, *frame, *box, *radioB;
widget = gtk_vbox_new(FALSE, 0);
switch(which)
{
case PDFREQPDF:
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Display Cell</span>");
gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
reqDispCell[which] = combo = gtk_combo_box_new_text();
for(i=0;i<TTLREQDISPCELLS;i++)
gtk_combo_box_insert_text(GTK_COMBO_BOX(combo), i, reqDispCells[i]);
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
gtk_box_pack_start(GTK_BOX(vbox), combo, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), vbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, vbox);
eBox = gtk_event_box_new();
frame = gtk_frame_new(" Request By ");
box = gtk_vbox_new(FALSE, 0);
gtk_size_group_add_widget(size_group, eBox);
reqBy[REQRANGE] = radioB = gtk_radio_button_new_with_label(NULL, "Range");
gtk_container_add(GTK_CONTAINER(box), radioB);
reqBy[REQFREQ] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "Frequency");
gtk_container_add(GTK_CONTAINER(box), radioB);
reqBy[REQAGO] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "Ago");
gtk_container_add(GTK_CONTAINER(box), radioB);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
g_signal_connect(reqBy[REQRANGE], "toggled", G_CALLBACK(RReqChg), GINT_TO_POINTER(REQRANGE));
g_signal_connect(reqBy[REQFREQ], "toggled", G_CALLBACK(RReqChg), GINT_TO_POINTER(REQFREQ));
g_signal_connect(reqBy[REQAGO], "toggled", G_CALLBACK(RReqChg), GINT_TO_POINTER(REQAGO));
break;
case PDFREQSPECTRO:
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Display Cell</span>");
gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
reqDispCell[which] = combo = gtk_combo_box_new_text();
for(i=0;i<NUMSPLITSCRNS;i++)
gtk_combo_box_insert_text(GTK_COMBO_BOX(combo), i, spectroDispCells[i]);
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
gtk_box_pack_start(GTK_BOX(vbox), combo, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), vbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, vbox);
#if 0
eBox = gtk_event_box_new();
frame = gtk_frame_new("Display by");
box = gtk_vbox_new(FALSE, 0);
gtk_size_group_add_widget(size_group, eBox);
reqBy[REQRANGE] = radioB = gtk_radio_button_new_with_label(NULL, "Date Range");
gtk_container_add(GTK_CONTAINER(box), radioB);
reqBy[REQFREQ] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "");
gtk_container_add(GTK_CONTAINER(box), radioB);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
g_signal_connect(reqBy[REQRANGE], "toggled", G_CALLBACK(RReqChg), GINT_TO_POINTER(REQRANGE));
g_signal_connect(reqBy[REQFREQ], "toggled", G_CALLBACK(RReqChg), GINT_TO_POINTER(REQFREQ));
#endif
break;
}
return widget;
}
static gint PDFReqDEL( GtkWidget *widget,
GdkEvent *event,
gpointer data )
{
gtk_grab_remove(reqWndw);
gtk_widget_hide(reqWndw);
return(TRUE);
}
void make_ReqDialog(gboolean full)
{
int  i;
GtkWidget *ctrlBox, *vbox, *actionB, *button, *menu_box, *vbox1;
GtkWidget *requestButtons, *requestEntries, *label, *combo;
GtkSizeGroup *size_group;
switch(full)
{
case TRUE:
if (!reqWndw)
{
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
if (!rdCHN)
rdCHN = gtk_combo_box_new();
tips = gtk_tooltips_new();
reqWndw = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_container_set_border_width(GTK_CONTAINER(reqWndw), 2);
gtk_window_set_position(GTK_WINDOW(reqWndw), GTK_WIN_POS_CENTER);
g_signal_connect(reqWndw, "delete-event", G_CALLBACK(PDFReqDEL), NULL);
ctrlBox = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(reqWndw), ctrlBox);
menu_box = gtk_event_box_new();
gtk_widget_modify_bg(menu_box, GTK_STATE_NORMAL, &settings.colors.sb[0]);
gtk_container_add(GTK_CONTAINER(ctrlBox), menu_box);
vbox1 = gtk_vbox_new(FALSE, 5);
gtk_container_add(GTK_CONTAINER(menu_box), vbox1);
gtk_container_set_border_width(GTK_CONTAINER(vbox1), 5);
vbox = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Channel</span>");
gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
combo = rdCHN;
gtk_box_pack_start(GTK_BOX(vbox), combo, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox1), vbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, vbox);
for (i = 0; i < TTLPDFREQTYPES; i++)
{
reqMenu[i] = requestButtons = make_ReqButtons(i, size_group);
gtk_box_pack_start(GTK_BOX(vbox1), requestButtons, FALSE, FALSE, 0);
}
actionB = gtk_vbutton_box_new();
gtk_box_pack_start(GTK_BOX(vbox1), actionB, FALSE, FALSE, 2);
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_START);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Clear");
gtk_container_add(GTK_CONTAINER(actionB), button);
gtk_size_group_add_widget(size_group, button);
g_signal_connect(button, "clicked", G_CALLBACK(clearReqEntries), NULL);
strcpy(toolTip, "Clear all Request Fields for New Input");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Cancel");
gtk_container_add(GTK_CONTAINER(actionB), button);
gtk_size_group_add_widget(size_group, button);
g_signal_connect(button, "clicked", G_CALLBACK(cancelPDFReq), GINT_TO_POINTER(FALSE));
strcpy(toolTip, "Return to Request Screen - No Changes");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
vbox = gtk_vbox_new(FALSE, 0);
requestEntries = make_ReqEntries();
gtk_box_pack_start(GTK_BOX(vbox), requestEntries, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(ctrlBox), vbox, TRUE, TRUE, 0);
gtk_widget_show_all(reqWndw);
gtk_widget_hide(rFREQF);
gtk_widget_hide(rAGOF);
gtk_window_set_transient_for((GtkWindow *) reqWndw, (GtkWindow *) topWindow);
}
break;
case FALSE:
if (!rdCHN)
rdCHN = gtk_combo_box_new();
break;
}
return;
}
