#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
GtkTooltips *tips;
static char  toolTip[1000];
static GtkSizeGroup *size_group, *size_group1;
static GtkWidget *make_Mbuttons(int type)
{
GtkWidget *widget, *menu_box, *eBox, *frame;
GtkWidget *combo, *vbox, *button, *box, *hbox;
GtkWidget *label, *sep;
int   scr = PDFMAIN;
menu_box = gtk_event_box_new();
widget = gtk_vbox_new(FALSE, 5);
gtk_container_set_border_width(GTK_CONTAINER(widget), 5);
gtk_container_add(GTK_CONTAINER(menu_box), widget);
switch (type)
{
case PDFSTND:
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new("ROWS");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"11\">ROWS</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">NTW.STN.LOC</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md1NSL = combo = gtk_combo_box_new();
gtk_container_add(GTK_CONTAINER(vbox), combo);
gtk_container_add(GTK_CONTAINER(widget), vbox);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Channel Group</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md1CHNG = combo = gtk_combo_box_new_text();
gtk_combo_box_insert_text(GTK_COMBO_BOX(combo), 0, "NONE");
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0); 
gtk_container_add(GTK_CONTAINER(vbox), combo);
gtk_container_add(GTK_CONTAINER(widget), vbox);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_container_add(GTK_CONTAINER(widget), sep);
gtk_widget_set_size_request(sep, BUTTONW, 10);
gtk_size_group_add_widget(size_group1, sep);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"11\">COLUMNS</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">PDF #1</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md1PDF1 = combo = gtk_combo_box_new();
gtk_container_add(GTK_CONTAINER(vbox), combo);
gtk_container_add(GTK_CONTAINER(widget), vbox);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">PDF #2</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md1PDF2 = combo = gtk_combo_box_new();
gtk_container_add(GTK_CONTAINER(vbox), combo);
gtk_container_add(GTK_CONTAINER(widget), vbox);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">PDF #3</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md1PDF3 = combo = gtk_combo_box_new();
gtk_container_add(GTK_CONTAINER(vbox), combo);
gtk_container_add(GTK_CONTAINER(widget), vbox);
break;
case PDFPDFD:
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Display PDF</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md2PDF = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md2PDF, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_container_add(GTK_CONTAINER(widget), sep);
gtk_widget_set_size_request(sep, BUTTONW, 10);
gtk_size_group_add_widget(size_group1, sep);
vbox = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"11\">ROWS</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">N.S.L #1</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md2NSL1 = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md2NSL1, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(widget), vbox);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">N.S.L #2</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md2NSL2 = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md2NSL2, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">N.S.L #3</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md2NSL3 = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md2NSL3, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_container_add(GTK_CONTAINER(widget), sep);
gtk_widget_set_size_request(sep, BUTTONW, 10);
gtk_size_group_add_widget(size_group1, sep);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"11\">COLUMNS</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Channel Group</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md2CHNG = combo = gtk_combo_box_new_text();
gtk_combo_box_insert_text(GTK_COMBO_BOX(combo), 0, "NONE");
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0); 
gtk_box_pack_start(GTK_BOX(vbox), md2CHNG, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
break;
case PDFBOTHD:
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new("ROWS");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"11\">ROWS</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Channel #1</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md3CHN1 = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md3CHN1, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Channel #2</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md3CHN2 = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md3CHN2, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Channel #3</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md3CHN3 = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md3CHN3, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_container_add(GTK_CONTAINER(widget), sep);
gtk_widget_set_size_request(sep, BUTTONW, 10);
gtk_size_group_add_widget(size_group1, sep);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new("ROWS");
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"11\">COLUMNS</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">PDF #1</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md3PDF1 = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md3PDF1, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">PDF #2</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md3PDF2 = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md3PDF2, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">PDF #3</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md3PDF3 = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), md3PDF3, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
break;
case PDFGROUP:
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Display PDF</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
md4PDF = combo = gtk_combo_box_new();
gtk_box_pack_start(GTK_BOX(vbox), combo, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(widget), vbox);
button = gtk_button_new_with_label("STATIONS");
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 3);
strcpy(toolTip, "Select STATIONS for Viewing");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(make_PDF_stationDialogue), NULL);
PDFeventB[0] = eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[PDFMAIN]);
frame = gtk_frame_new(NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> Channels </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(TRUE, 0);
chnFilterPDF = combo = gtk_combo_box_new_text();
pdfSignals[PDFCHNFLTSGNL] = g_signal_connect(combo, "changed", G_CALLBACK(pdfChnFltrSelectC), 
GINT_TO_POINTER(PDFMAIN));
strcpy(toolTip, "CHANNEL Display Filter");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), box, TRUE, TRUE, 2);
gtk_container_add(GTK_CONTAINER(frame), hbox);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, TRUE, TRUE, 0);
box = gtk_vbox_new(FALSE, 2);
chnCntLbl = label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> 0 / 0 </span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), box, TRUE, TRUE, 0);
button = gtk_button_new_with_label("Next");
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][scr], button);
g_signal_connect((button), "clicked", G_CALLBACK(nextPDFs), GINT_TO_POINTER(FORWARDS));
gtk_box_pack_start(GTK_BOX(box), button, TRUE, TRUE, 0);
strcpy(toolTip, "Display NEXT Set of PDF Plots");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Previous");
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][scr], button);
gtk_box_pack_start(GTK_BOX(box), button, TRUE, TRUE, 0);
g_signal_connect((button), "clicked", G_CALLBACK(nextPDFs), GINT_TO_POINTER(BACKWARDS));
strcpy(toolTip, "Display PREVIOUS Set of PDF Plots");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
break;
}
gtk_widget_modify_bg(menu_box, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[PDFMAIN]);
return menu_box;
}
static GtkWidget *makePDFsb(int type)
{
GtkWidget *widget, *button, *menu_box, *eBox;
GtkWidget *commandB, *box, *mouseBox, *hbox, *vbox, *combo;
GtkWidget *frame, *radioB, *radioB1, *radioB2, *radios[2];
GtkWidget *label, *sep;
int scr, i;
menu_box = gtk_event_box_new();
widget = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(widget), 5);
gtk_container_add(GTK_CONTAINER(menu_box), widget);
switch (type)
{
case PDFMAIN:
scr = PDFMAIN;
pdfSensitives[PDFDATABUSYSENS][scr] = g_ptr_array_new();
size_group1 = gtk_size_group_new(GTK_SIZE_GROUP_VERTICAL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"18\">PDF</span>");
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
gtk_widget_set_size_request(sep, BUTTONW, 10);
gtk_size_group_add_widget(size_group1, sep);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Display by");
box = gtk_vbox_new(FALSE, 0);
pMdisp[PDFGROUP] = radioB = gtk_radio_button_new_with_label(NULL, "Group");
gtk_container_add(GTK_CONTAINER(box), radioB);
strcpy(toolTip, "Display Single PDF for a Group of Channels");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
pMdisp[PDFSTND] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "Station");
gtk_container_add(GTK_CONTAINER(box), radioB);
strcpy(toolTip, "Display Multiple PDF's by Single Station");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
pMdisp[PDFPDFD] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "PDF");
gtk_container_add(GTK_CONTAINER(box), radioB);
strcpy(toolTip, "Display Single PDF for Multiple Stations");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
pMdisp[PDFBOTHD] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB), "Stn & PDF");
gtk_container_add(GTK_CONTAINER(box), radioB);
strcpy(toolTip, "Display Multiple PDF's for Multiple Stations");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 0);
gtk_widget_set_size_request(sep, BUTTONW, 10);
gtk_size_group_add_widget(size_group1, sep);
for(i=0;i<NUMPDFMAINDISPLAYMODES;i++)
{
MButtons[i] = make_Mbuttons(i);
gtk_box_pack_start(GTK_BOX(widget), MButtons[i], FALSE, FALSE, 0);
}
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Period Bounds");
strcpy(toolTip, "Plot Period Boundaries According to User Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), frame, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
button = gtk_button_new_with_label("Manage");
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 2);
strcpy(toolTip, "Define Period Boundaries - Per Channel Group");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(make_PeriodScaleDialog), GINT_TO_POINTER(scr));
hbox = gtk_hbox_new (FALSE, 0);
axisBnds[scr][ON] = radios[ON] = gtk_radio_button_new_with_label(NULL, "On");
gtk_container_add(GTK_CONTAINER(hbox), radios[ON]);
strcpy(toolTip, "Turn ON Period Boundaries");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radios[ON], toolTip, toolTip);
axisBnds[scr][OFF] = radios[OFF] = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radios[ON]), "Off");
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radios[pdfSettings.main.xAxis.active]), TRUE);  
strcpy(toolTip, "Turn OFF Period Boundaries");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radios[OFF], toolTip, toolTip);
g_signal_connect(radios[ON], "toggled", G_CALLBACK(axisToggle), GINT_TO_POINTER(scr));
gtk_container_add(GTK_CONTAINER(hbox), radios[OFF]);
gtk_container_add(GTK_CONTAINER(box), hbox);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Servers");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Connect to PSD Server/Database");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(servers), NULL);
button = gtk_button_new_with_label("Print");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Print PDF(s) to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(pdfPrint), GINT_TO_POINTER(scr));
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
g_signal_connect(button, "clicked", G_CALLBACK(raisePdfControls), GINT_TO_POINTER(REFNUM(type, 0, 0)));
strcpy(toolTip, "User Preference Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Admin");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Start PQLX Admin Program");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(execAdmin), NULL);
button = gtk_button_new_with_label("About");
gtk_container_add(GTK_CONTAINER(commandB), button);
g_signal_connect(button, "clicked", G_CALLBACK(about), GINT_TO_POINTER(PDFSYSTEM));
button = gtk_button_new_with_label("QUIT");
g_signal_connect(button, "clicked", G_CALLBACK(gtk_main_quit), NULL);
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "EXIT PQLX");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "F-Keys:\n"" F1 - Go To Trace Viewer\n"" F2 - Go To PDF:Detail\n"" F3 - Go To STN Viewer\n""\nOn PDF PLOT:\n""Take to DETAIL:\tCLICK\n""Display ColorBar:\tHover SE Corner");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(widget), box);
g_signal_connect(pMdisp[PDFGROUP], "toggled", G_CALLBACK(MDispChg), GINT_TO_POINTER(PDFGROUP));
g_signal_connect(pMdisp[PDFSTND], "toggled", G_CALLBACK(MDispChg), GINT_TO_POINTER(PDFSTND));
g_signal_connect(pMdisp[PDFPDFD], "toggled", G_CALLBACK(MDispChg), GINT_TO_POINTER(PDFPDFD));
g_signal_connect(pMdisp[PDFBOTHD], "toggled", G_CALLBACK(MDispChg), GINT_TO_POINTER(PDFBOTHD));
break;
case PDFDETAIL:
scr = PDFDETAIL;
pdfSensitives[PDFDATABUSYSENS][scr] = g_ptr_array_new();
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"18\">PDF</span>");
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Back");
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][scr], button);
gtk_box_pack_start(GTK_BOX(commandB), button, TRUE, FALSE, 0);  
g_signal_connect(button, "clicked", G_CALLBACK(DDispMv), GINT_TO_POINTER(DTLBACK));
strcpy(toolTip, "Display Previous Detail");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Forward");
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][scr], button);
gtk_box_pack_start(GTK_BOX(commandB), button, TRUE, FALSE, 0);
g_signal_connect(button, "clicked", G_CALLBACK(DDispMv), GINT_TO_POINTER(DTLFORW));
strcpy(toolTip, "Display Next Detail");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
pdfDtailCnt = label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> PDF# 0 </span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), box, FALSE, FALSE, 2);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Trace Plot");
box = gtk_vbox_new(FALSE, 0);
pdfTrcW[PDFDTRCNOPLOT] = radioB1 = gtk_radio_button_new_with_label(NULL, "Do Not Plot");
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][scr], radioB1);
gtk_container_add(GTK_CONTAINER(box), radioB1);
pdfTrcW[PDFDTRCENTIRE] = radioB2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Entire Trace");
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][scr], radioB2);
gtk_container_add(GTK_CONTAINER(box), radioB2);
pdfTrcW[PDFDTRCPSD] = radioB2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "PSD Portion");
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][scr], radioB2);
gtk_container_add(GTK_CONTAINER(box), radioB2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
strcpy(toolTip, "Do Not Plot Trace Information");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), pdfTrcW[PDFDTRCNOPLOT], toolTip, toolTip);
strcpy(toolTip, "Display Entire Trace");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), pdfTrcW[PDFDTRCENTIRE], toolTip, toolTip);
strcpy(toolTip, "Display only portion of Trace corresponding to PSD");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), pdfTrcW[PDFDTRCPSD], toolTip, toolTip);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Hour Sub-Select");
box = gtk_vbox_new(FALSE, 0);
radioB1 = gtk_radio_button_new_with_label(NULL, "Inclusive");
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][scr], radioB1);
gtk_container_add(GTK_CONTAINER(box), radioB1);
dHrMode = radioB2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Exclusive");
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][scr], radioB2);
gtk_container_add(GTK_CONTAINER(box), radioB2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
strcpy(toolTip, "Select PSD HOURS inside the bounding box");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB1, toolTip, toolTip);
strcpy(toolTip, "Select PSD HOURS outside the bounding box");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB2, toolTip, toolTip);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Save Data");
gtk_box_pack_start(GTK_BOX(commandB), button, TRUE, FALSE, 0);
strcpy(toolTip, "Save Sub-Selected Data (PDF or PSD Hours) to Text File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(pdfSave), NULL);
button = gtk_button_new_with_label("Print");
gtk_box_pack_start(GTK_BOX(commandB), button, TRUE, FALSE, 0);
strcpy(toolTip, "Print PDF(s) to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(pdfPrint), GINT_TO_POINTER(scr));
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "User Preference Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raisePdfControls), GINT_TO_POINTER(REFNUM(type, 0, 0)));
button = gtk_button_new_with_label("QUIT");
g_signal_connect(button, "clicked", G_CALLBACK(gtk_main_quit), NULL);
gtk_box_pack_start(GTK_BOX(commandB), button, TRUE, FALSE, 0);
strcpy(toolTip, "EXIT PQLX");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "F-Keys:\n"" F1 - Go To Trace Viewer\n"" F2 - Go To PDF:Request\n"" F3 - Go To STN Viewer\n""\nOn NW cell:\n"" Plot sub-PDF:\tCLICK\n"" Plot sub-PDF:\tCLICK+DRAG\n\n""On SW cell:\n"" Make New DETAIL:\tCLICK\n\n""On SE cell:\n"" Plot sub-PDF:\tCLICK+DRAG\n\n""On NE cell:\n"" Take TRACES to PQL:\tCLICK");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(widget), box);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pdfTrcW[pdfSettings.detail.trcExtract]), TRUE);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(dHrMode), pdfSettings.detail.pdfHrMode);
g_signal_connect(pdfTrcW[PDFDTRCNOPLOT], "toggled", G_CALLBACK(pdfRadioB3_chg), GINT_TO_POINTER(TRCEXTRACT));
g_signal_connect(pdfTrcW[PDFDTRCENTIRE], "toggled", G_CALLBACK(pdfRadioB3_chg), GINT_TO_POINTER(TRCEXTRACT));
g_signal_connect(pdfTrcW[PDFDTRCPSD], "toggled", G_CALLBACK(pdfRadioB3_chg), GINT_TO_POINTER(TRCEXTRACT));
g_signal_connect(dHrMode, "toggled", G_CALLBACK(radioOption), GINT_TO_POINTER(RDPDFHR));
break;
case PDFREQUEST:
scr = PDFREQUEST;
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"18\">PDF</span>");
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("REQUEST");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "PDF Request");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(plotRequest), GINT_TO_POINTER(PDFREQUEST));
button = gtk_button_new_with_label("Clear All");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Clear All Displays");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(clearAllReqs), GINT_TO_POINTER(PDFREQUEST));
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Print");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Print PDF(s) to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(pdfPrint), GINT_TO_POINTER(scr));
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "User Preference Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raisePdfControls), GINT_TO_POINTER(REFNUM(type, 0, 0)));
button = gtk_button_new_with_label("QUIT");
g_signal_connect(button, "clicked", G_CALLBACK(gtk_main_quit), NULL);
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "EXIT PQLX");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "F-Keys:\n"" F1 - Go To Trace Viewer\n"" F2 - Go To PDF::Movie\n"" F3 - Go To STN Viewer\n""\nOn PDF PLOT:\n"" Take to DETAIL:\tCLICK");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(widget), box);
break;
case PDFMOVIE:
scr = PDFMOVIE;
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"18\">PDF</span>");
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Screens");
box = gtk_hbox_new(FALSE, 0);
radioB1 = gtk_radio_button_new_with_label(NULL, "1");
gtk_box_pack_start(GTK_BOX(box), radioB1, FALSE, FALSE, 10);
radioB2 = gtk_radio_button_new_with_label(gtk_radio_button_get_group((GtkRadioButton *) radioB1), "4");
gtk_box_pack_start(GTK_BOX(box), radioB2, FALSE, FALSE, 10);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 0);
strcpy(toolTip, "DISPLAY 1 PDF Movie Screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB1, toolTip, toolTip);
strcpy(toolTip, "DISPLAY 4 PDF Movie Screens");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB2, toolTip, toolTip);
switch(pdfSettings.movie.display)
{
case MVDISP1:
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radioB1), TRUE);
break;
case MVDISP2:
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radioB2), TRUE);
break;
}
g_signal_connect(radioB2, "toggled", G_CALLBACK(newMvDisp), &pdfSettings.movie.display);
#if 0
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Hsplit[settings.split.pane]), TRUE);
g_signal_connect(Hsplit[SPLIT3], "toggled", G_CALLBACK(newSplit), &states.split.panes);
g_signal_connect(Hsplit[SPLIT2], "toggled", G_CALLBACK(newSplit), &states.split.panes);
#endif
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 7);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("MOVIE");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Movie Request");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(movieRequest), NULL);
button = gtk_button_new_with_label("Clear All");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Clear All Displays");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(clearAllReqs), GINT_TO_POINTER(PDFMOVIE));
#if 0
frame = gtk_frame_new(NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> Make Movie </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
vbox = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(widget), frame, FALSE, FALSE, 2);
mvDispB[MVDISP1] = commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Center");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Create PDF Movie");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(movieRequest), NULL);
mvDispB[MVDISP2] = commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(vbox), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("NW");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Create PDF Movie");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(movieRequest), NULL);
button = gtk_button_new_with_label("NE");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Create PDF Movie");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(movieRequest), NULL);
button = gtk_button_new_with_label("SW");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Create PDF Movie");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(movieRequest), NULL);
button = gtk_button_new_with_label("SE");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Create PDF Movie");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(movieRequest), NULL);
#endif
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Save");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Save Movie to Animated .gif File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(pdfMovieSave), NULL);
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "User Preference Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raisePdfControls), GINT_TO_POINTER(REFNUM(type, 0, 0)));
button = gtk_button_new_with_label("QUIT");
g_signal_connect(button, "clicked", G_CALLBACK(gtk_main_quit), NULL);
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "EXIT PQLX");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "F-Keys:\n"" F1 - Go To Trace Viewer\n"" F2 - Go To SPECTRO::System\n"" F3 - Go To STN Viewer\n""\nOn PDF Movie Frame:\n"" Take to DETAIL:\tCLICK");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(widget), box);
break;
case SPECTROMAIN:
scr = SPECTROMAIN;
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"16\">SPECTRO</span>");
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
gtk_widget_set_size_request(sep, BUTTONW, 10);
gtk_size_group_add_widget(size_group1, sep);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) "<span weight=\"bold\" foreground=\"white\">Display PDF</span>");
gtk_container_add(GTK_CONTAINER(vbox), label);
SPpdf = combo = gtk_combo_box_new();
strcpy(toolTip, "Select PDF to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(vbox), combo, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(widget), vbox, FALSE, FALSE, 3);
button = gtk_button_new_with_label("STATIONS");
gtk_box_pack_start(GTK_BOX(widget), button, FALSE, FALSE, 3);
strcpy(toolTip, "Select STATIONS for Viewing");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(make_PDF_stationDialogue), NULL);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[PDFMAIN]);
frame = gtk_frame_new(NULL);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> Channels </span>");
gtk_frame_set_label_widget(GTK_FRAME(frame), label);
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(TRUE, 0);
SPchnFilt = combo = gtk_combo_box_new_text();
pdfSignals[SPECTROCHNFLTSGNL] = g_signal_connect(combo, "changed", G_CALLBACK(pdfChnFltrSelectC), 
GINT_TO_POINTER(scr));
strcpy(toolTip, "CHANNEL Display Filter");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), box, TRUE, TRUE, 2);
gtk_container_add(GTK_CONTAINER(frame), hbox);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 3);
box = gtk_vbox_new(FALSE, 2);
SPchnCnt = label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\"> 0 / 0 </span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), box, FALSE, FALSE, 3);
button = gtk_button_new_with_label("Next");
g_signal_connect((button), "clicked", G_CALLBACK(nextPDFs), GINT_TO_POINTER(FORWARDS));
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 3);
strcpy(toolTip, "Display NEXT Set of Spectrogram Plots");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Previous");
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 3);
g_signal_connect((button), "clicked", G_CALLBACK(nextPDFs), GINT_TO_POINTER(BACKWARDS));
strcpy(toolTip, "Display PREVIOUS Set of Spectrogram Plots");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Period Bounds");
strcpy(toolTip, "Plot Period Boundaries According to User Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), frame, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
button = gtk_button_new_with_label("Manage");
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 2);
strcpy(toolTip, "Define Period Boundaries - Per Channel Group");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(make_PeriodScaleDialog), GINT_TO_POINTER(scr));
hbox = gtk_hbox_new (FALSE, 0);
axisBnds[scr][ON] = radios[ON] = gtk_radio_button_new_with_label(NULL, "On");
gtk_container_add(GTK_CONTAINER(hbox), radios[ON]);
strcpy(toolTip, "Turn ON Period Boundaries");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radios[ON], toolTip, toolTip);
axisBnds[scr][OFF] = radios[OFF] = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radios[ON]), "Off");
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radios[pdfSettings.spmain.xAxis.active]), TRUE);  
strcpy(toolTip, "Turn OFF Period Boundaries");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radios[OFF], toolTip, toolTip);
g_signal_connect(radios[ON], "toggled", G_CALLBACK(axisToggle), GINT_TO_POINTER(scr));
gtk_container_add(GTK_CONTAINER(hbox), radios[OFF]);
gtk_container_add(GTK_CONTAINER(box), hbox);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
frame = gtk_frame_new("PDF Display");
box = gtk_hbox_new(FALSE, 0);
pdfDisp[SPECTROTAB(scr)][ON] = radioB1 = gtk_radio_button_new_with_label(NULL, "On");
gtk_container_add(GTK_CONTAINER(box), radioB1);
pdfDisp[SPECTROTAB(scr)][OFF] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Off");
gtk_container_add(GTK_CONTAINER(box), radioB);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
strcpy(toolTip, "DISPLAY PDF");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB1, toolTip, toolTip);
strcpy(toolTip, "Do Not DISPLAY PDF");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
g_signal_connect(pdfDisp[SPECTROTAB(scr)][ON], "toggled", G_CALLBACK(radioOption), GINT_TO_POINTER(RSPDF));
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pdfDisp[SPECTROTAB(scr)][pdfSettings.spmain.PDF]), TRUE);  
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Servers");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Connect to PSD Server/Database");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(servers), NULL);
button = gtk_button_new_with_label("Print");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Print PDF(s) to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(pdfPrint), GINT_TO_POINTER(scr));
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "User Preference Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raisePdfControls), GINT_TO_POINTER(REFNUM(type, 0, 0)));
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("Admin");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Start PQLX Admin Program");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(execAdmin), NULL);
button = gtk_button_new_with_label("About");
gtk_container_add(GTK_CONTAINER(commandB), button);
g_signal_connect(button, "clicked", G_CALLBACK(about), GINT_TO_POINTER(PDFSYSTEM));
button = gtk_button_new_with_label("QUIT");
g_signal_connect(button, "clicked", G_CALLBACK(gtk_main_quit), NULL);
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "EXIT PQLX");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "F-Keys:\n"
" F1 - Go To Trace Viewer\n"
" F2 - Go To SPECTRO::Detail\n"
" F3 - Go To STN Viewer\n"
"\nOn SPECTRO PLOT:\n"
" Take to SPECTRO::DETAIL:\tCLICK\n"
" Invert Colors:\tColorBar CLICK\n"
"\nOn PDF PLOT:\n"
" Take to PDF::DETAIL:\tCLICK\n"
" Display ColorBar:\tHover SE Corner\n");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(widget), box);
g_signal_connect(pMdisp[PDFGROUP], "toggled", G_CALLBACK(MDispChg), GINT_TO_POINTER(PDFGROUP));
g_signal_connect(pMdisp[PDFSTND], "toggled", G_CALLBACK(MDispChg), GINT_TO_POINTER(PDFSTND));
g_signal_connect(pMdisp[PDFPDFD], "toggled", G_CALLBACK(MDispChg), GINT_TO_POINTER(PDFPDFD));
g_signal_connect(pMdisp[PDFBOTHD], "toggled", G_CALLBACK(MDispChg), GINT_TO_POINTER(PDFBOTHD));
break;
case SPECTRODETREQ:
scr = SPECTRODETREQ;
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"16\">SPECTRO</span>");
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), label, FALSE, FALSE, 3);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
button = gtk_button_new_with_label("REQUEST");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Spectrogram Request");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(plotRequest), GINT_TO_POINTER(scr));
button = gtk_button_new_with_label("Clear All");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Clear All Displays");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(clearAllReqs), GINT_TO_POINTER(scr));
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
eBox = gtk_event_box_new();
frame = gtk_frame_new("Period Bounds");
strcpy(toolTip, "Plot Period Boundaries According to User Definition");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), frame, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
button = gtk_button_new_with_label("Manage");
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 2);
strcpy(toolTip, "Define Period Boundaries - Per Channel Group");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(make_PeriodScaleDialog), GINT_TO_POINTER(scr));
hbox = gtk_hbox_new(FALSE, 0);
axisBnds[scr][ON] = radios[ON] = gtk_radio_button_new_with_label(NULL, "On");
gtk_container_add(GTK_CONTAINER(hbox), radios[ON]);
strcpy(toolTip, "Turn ON Period Boundaries");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radios[ON], toolTip, toolTip);
axisBnds[scr][OFF] = radios[OFF] = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radios[ON]), "Off");
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radios[pdfSettings.spreq.xAxis.active]), TRUE);  
strcpy(toolTip, "Turn OFF Period Boundaries");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radios[OFF], toolTip, toolTip);
g_signal_connect(radios[ON], "toggled", G_CALLBACK(axisToggle), GINT_TO_POINTER(scr));
gtk_container_add(GTK_CONTAINER(hbox), radios[OFF]);
gtk_container_add(GTK_CONTAINER(box), hbox);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
frame = gtk_frame_new("PDF Display");
box = gtk_hbox_new(FALSE, 0);
pdfDisp[SPECTROTAB(scr)][ON] = radioB1 = gtk_radio_button_new_with_label(NULL, "On");
gtk_container_add(GTK_CONTAINER(box), radioB1);
pdfDisp[SPECTROTAB(scr)][OFF] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radioB1), "Off");
gtk_container_add(GTK_CONTAINER(box), radioB);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
strcpy(toolTip, "DISPLAY PDF");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB1, toolTip, toolTip);
strcpy(toolTip, "Do Not DISPLAY PDF");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
g_signal_connect(pdfDisp[SPECTROTAB(scr)][ON], "toggled", G_CALLBACK(radioOption), GINT_TO_POINTER(RSPDF));
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pdfDisp[SPECTROTAB(scr)][pdfSettings.spreq.PDF]), TRUE);  
eBox = gtk_event_box_new();
frame = gtk_frame_new("Zooming");
strcpy(toolTip, "Zooming Options");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), frame, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_container_add(GTK_CONTAINER(eBox), frame);
gtk_box_pack_start(GTK_BOX(widget), eBox, FALSE, FALSE, 2);
#if 0
button = gtk_button_new_with_label("Sync");
gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 2);
strcpy(toolTip, "Align All Spectrograms vs. Smallest Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(alignSpectro), NULL);
#endif
combo = gtk_combo_box_new_text();
gtk_box_pack_start(GTK_BOX(box), combo, FALSE, FALSE, 2);
strcpy(toolTip, "Set Zooming Scope");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), combo, toolTip, toolTip);
for(i=0;i<TTLZOOMSCOPES;i++)
{
gtk_combo_box_append_text(GTK_COMBO_BOX(combo), zoomScope[i]);
}
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), pdfSettings.spreq.zoom.scope);
g_signal_connect(combo, "changed", G_CALLBACK(pdfComboSel), GINT_TO_POINTER(PDFCBOZOOMSCOPE));
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_size_group_add_widget(size_group1, sep);
gtk_box_pack_start(GTK_BOX(widget), sep, FALSE, FALSE, 3);
commandB = gtk_vbox_new(FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), commandB, FALSE, FALSE, 2);
#if 0
button = gtk_button_new_with_label("Print");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "Print Screen to Postscript or PNG File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(spectroPrint), GINT_TO_POINTER(scr));
#endif
button = gtk_button_new_with_label("Controls");
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "User Preference Settings");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
g_signal_connect(button, "clicked", G_CALLBACK(raisePdfControls), GINT_TO_POINTER(REFNUM(type, 0, 0)));
button = gtk_button_new_with_label("QUIT");
g_signal_connect(button, "clicked", G_CALLBACK(gtk_main_quit), NULL);
gtk_container_add(GTK_CONTAINER(commandB), button);
strcpy(toolTip, "EXIT PQLX");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
box = gtk_vbox_new(FALSE, 0);
mouseBox = gtk_event_box_new();
label = gtk_label_new("mouse tips");
gtk_container_add(GTK_CONTAINER(mouseBox), label);
gtk_box_pack_end(GTK_BOX(box), mouseBox, FALSE, FALSE, 2);
strcpy(toolTip, "F-Keys:\n"
" F1 - Go To Trace Viewer\n"
" F2 - Go To PDF::System\n"
" F3 - Go To STN Viewer\n"
"\nOn Spectrogram PLOT:\n"
" ZOOM:\tCLICK+DRAG, or\n"
"\t\tMouse Wheel\n"
" Invert Colors:\tColorBar CLICK\n"
"\nOn PDF PLOT:\n"
" Take to PDF::DETAIL:\tCLICK\n"
" Display ColorBar:\tHover SE Corner\n");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), mouseBox, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(widget), box);
break;
}
gtk_widget_modify_bg(menu_box, GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[scr]);
gtk_size_group_add_widget(size_group, widget);
return menu_box;
}
static GtkWidget *make_movieScreen(int screen)
{
GtkWidget *slider, *button, *vbox, *hbox, *image, *vbox2, *bbox, *eBox, *frame;
GtkWidget *da, *vbox3, *vbox4, *label;
GtkObject *adj;
int ref = PDFMOVIE*MAXNUMBERS + screen;
vbox = gtk_vbox_new(FALSE, 0);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
MVPDFDA[screen] = da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(frame), da);
gtk_box_pack_start(GTK_BOX(vbox), frame, TRUE, TRUE, 2);
g_signal_connect(da, "configure_event", G_CALLBACK(PDF_cfg),GINT_TO_POINTER(ref));
g_signal_connect(da, "expose_event", G_CALLBACK(PDF_exp), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
gtk_widget_set_events(da, gtk_widget_get_events(da) 
| GDK_BUTTON_PRESS_MASK
| GDK_BUTTON_RELEASE_MASK);
ctrlBarEB[screen] = eBox = gtk_event_box_new();
bbox = gtk_hbutton_box_new ();
gtk_button_box_set_layout (GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_SPREAD);
vbox2 = gtk_vbox_new(FALSE, 0);
#if 0
slider = gtk_hscale_new_with_range (0, PDFMAXFRAMERATE, 1);
adj = gtk_adjustment_new((gdouble) pdfSettings.movie.frameRate[screen],
(gdouble) 0, (gdouble) PDFMAXFRAMERATE+1,
(gdouble) 1, (gdouble) 5, (gdouble) 1);
gtk_range_set_adjustment(GTK_RANGE (slider), GTK_ADJUSTMENT (adj));
gtk_box_pack_start(GTK_BOX(vbox2), slider, FALSE, FALSE, 2);
g_signal_connect(slider, "value-changed", G_CALLBACK(pdfMFrameRate), GINT_TO_POINTER(screen));
gtk_widget_set_size_request(slider, PDFMAXFRAMERATE*2, -1);
strcpy(toolTip, "Adjust Frame Rate (F/sec) (0 = Step)");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), slider, toolTip, toolTip);
#endif
hbox = gtk_hbutton_box_new ();
gtk_button_box_set_layout (GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_EDGE);
vbox4 = gtk_vbox_new(TRUE, 2);
label = gtk_label_new("Start:");
gtk_container_add(GTK_CONTAINER(vbox4), label);
mDT[screen][CHNSTART] = label = gtk_label_new(NULL);
gtk_container_add(GTK_CONTAINER(vbox4), label);
gtk_box_pack_start(GTK_BOX(hbox), vbox4, FALSE, FALSE, 2);
vbox3 = gtk_vbutton_box_new();
gtk_button_box_set_layout (GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_EDGE);
image = gtk_image_new_from_stock("gtk-media-previous", GTK_ICON_SIZE_SMALL_TOOLBAR);
button = gtk_button_new();
gtk_button_set_image(GTK_BUTTON (button), image);
gtk_widget_set_size_request(button, 10, 20);
g_signal_connect(button, "clicked", G_CALLBACK(pdfMoviePlay), GINT_TO_POINTER(screen*TTLPDFMCMDS + PDFM_BEGIN));
gtk_container_add(GTK_CONTAINER(vbox3), button);
gtk_box_pack_start(GTK_BOX(hbox), vbox3, FALSE, FALSE, 2);
strcpy(toolTip, "Rewind to Beginning");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
mFR[screen] = slider = gtk_hscale_new_with_range (PDFMINFRAMERATE, PDFMAXFRAMERATE, 1);
adj = gtk_adjustment_new((gdouble) 0,
(gdouble) PDFMINFRAMERATE, (gdouble) PDFMAXFRAMERATE+1,
(gdouble) 1, (gdouble) 1, (gdouble) 1);
gtk_range_set_adjustment(GTK_RANGE (slider), GTK_ADJUSTMENT (adj));
gtk_box_pack_start(GTK_BOX(hbox), slider, TRUE, TRUE, 2);
g_signal_connect(slider, "value-changed", G_CALLBACK(pdfMFrameRate), GINT_TO_POINTER(screen));
gtk_widget_set_size_request(slider, (PDFMAXFRAMERATE+(PDFMINFRAMERATE*-1))*1.5, -1);
strcpy(toolTip, "Play Movie -\n0 = Stop\n< 0 = Backwards\n> 0 = Forwards\n"
"Value = Frames/Second\n"
"Mouse Wheel Down = Increase\n"
"Mouse Wheel Up = Decrease");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), slider, toolTip, toolTip);
#if 0
image = gtk_image_new_from_stock("gtk-media-rewind", GTK_ICON_SIZE_BUTTON);
mCmd[screen][PDFM_BACKWARD] = button = gtk_button_new();
gtk_button_set_image(GTK_BUTTON (button), image);
g_signal_connect(button, "clicked", G_CALLBACK(pdfMoviePlay), GINT_TO_POINTER(screen*TTLPDFMCMDS + PDFM_BACKWARD));
gtk_container_add(GTK_CONTAINER(hbox), button);
strcpy(toolTip, "Play - Reverse");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
image = gtk_image_new_from_stock("gtk-media-pause", GTK_ICON_SIZE_BUTTON);
mCmd[screen][PDFM_PAUSEB] = button = gtk_button_new();
gtk_button_set_image(GTK_BUTTON (button), image);
g_signal_connect(button, "clicked", G_CALLBACK(pdfMoviePlay), GINT_TO_POINTER(screen*TTLPDFMCMDS + PDFM_PAUSEB));
gtk_container_add(GTK_CONTAINER(hbox), button);
strcpy(toolTip, "Stop");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
image = gtk_image_new_from_stock("gtk-media-forward", GTK_ICON_SIZE_BUTTON);
mCmd[screen][PDFM_FORWARD] = button = gtk_button_new();
gtk_button_set_image(GTK_BUTTON (button), image);
g_signal_connect(button, "clicked", G_CALLBACK(pdfMoviePlay), GINT_TO_POINTER(screen*TTLPDFMCMDS + PDFM_FORWARD));
gtk_container_add(GTK_CONTAINER(hbox), button);
strcpy(toolTip, "Play - Forward");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
image = gtk_image_new_from_stock("gtk-media-pause", GTK_ICON_SIZE_BUTTON);
mCmd[screen][PDFM_PAUSEF] = button = gtk_button_new();
gtk_button_set_image(GTK_BUTTON (button), image);
g_signal_connect(button, "clicked", G_CALLBACK(pdfMoviePlay), GINT_TO_POINTER(screen*TTLPDFMCMDS + PDFM_PAUSEF));
gtk_container_add(GTK_CONTAINER(hbox), button);
strcpy(toolTip, "Stop");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
#endif
vbox3 = gtk_vbutton_box_new();
gtk_button_box_set_layout (GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_EDGE);
image = gtk_image_new_from_stock("gtk-media-next", GTK_ICON_SIZE_SMALL_TOOLBAR);
button = gtk_button_new();
gtk_button_set_image(GTK_BUTTON (button), image);
gtk_widget_set_size_request(button, 10, 20);
g_signal_connect(button, "clicked", G_CALLBACK(pdfMoviePlay), GINT_TO_POINTER(screen*TTLPDFMCMDS + PDFM_END));
gtk_container_add(GTK_CONTAINER(vbox3), button);
gtk_box_pack_start(GTK_BOX(hbox), vbox3, FALSE, FALSE, 2);
strcpy(toolTip, "Forward to End");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
vbox4 = gtk_vbox_new(TRUE, 2);
label = gtk_label_new("Stop:");
gtk_container_add(GTK_CONTAINER(vbox4), label);
mDT[screen][CHNEND] = label = gtk_label_new(NULL);
gtk_container_add(GTK_CONTAINER(vbox4), label);
gtk_box_pack_start(GTK_BOX(hbox), vbox4, FALSE, FALSE, 2);
gtk_box_pack_end(GTK_BOX(vbox2), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(bbox), vbox2);
gtk_container_add(GTK_CONTAINER(eBox), bbox);
gtk_box_pack_end(GTK_BOX(vbox), eBox, FALSE, FALSE, 2);
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &pdfSettings.drawing.ctrlBar);
return vbox;
}
static GtkWidget *makePDFTab(int screen)
{
GtkWidget  *tableL4a, *tableL4b;
GtkWidget  *vboxL2, *hboxL3a, *hboxL3b;
GtkWidget  *insert, *frame, *da;
int    i, j, ref, mask=0;
switch(screen)
{
case PDFMAIN:
vboxL2 = gtk_vbox_new(FALSE, 0);
hboxL3a = gtk_hbox_new(FALSE, 0);
hboxL3b = gtk_hbox_new(FALSE, 0);
tableL4b = gtk_table_new(MMAXPDFROWS, MMAXPDFCOLS, TRUE);
for(i=0;i<MMAXPDFROWS;i++)
{
for(j=0;j<MMAXPDFCOLS;j++)
{
ref = REFNUM(screen, i, j); 
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
MPDFDA[i][j] = da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(frame), da);
g_signal_connect(da, "configure_event", G_CALLBACK(PDF_cfg), GINT_TO_POINTER(ref));
g_signal_connect(da, "expose_event", G_CALLBACK(PDF_exp), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "enter_notify_event", G_CALLBACK(grabFocus), NULL);
g_signal_connect(da, "leave_notify_event", G_CALLBACK(grabFocus), NULL);
gtk_widget_set_events (da, gtk_widget_get_events (da) 
| GDK_BUTTON_PRESS_MASK
| GDK_BUTTON_RELEASE_MASK
| GDK_LEAVE_NOTIFY_MASK
| GDK_ENTER_NOTIFY_MASK
| GDK_POINTER_MOTION_MASK 
| GDK_POINTER_MOTION_HINT_MASK
| GDK_KEY_PRESS_MASK);
gtk_table_attach(GTK_TABLE(tableL4b), frame, j, j+1, i, i+1, 
GTK_EXPAND | GTK_FILL, 
GTK_EXPAND | GTK_FILL, 
1, 1);
}
}
gtk_box_pack_start(GTK_BOX(hboxL3b), tableL4b, TRUE, TRUE, 0);
gtk_box_pack_start(GTK_BOX(vboxL2), hboxL3a, FALSE, TRUE, 0);
gtk_box_pack_start(GTK_BOX(vboxL2), hboxL3b, TRUE, TRUE, 0);
insert = vboxL2;
break;
case PDFDETAIL:
vboxL2 = gtk_vbox_new(FALSE, 0);
tableL4a = gtk_table_new(DMAXPDFROWS, 1, TRUE);
for(i=0;i<DMAXPDFROWS;i++)
{
for(j=0;j<DMAXPDFCOLS;j++)
{
ref = REFNUM(screen, i, j); 
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
DPDFDA[i][j] = da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(frame), da);
g_signal_connect(da, "configure_event", G_CALLBACK(PDF_cfg), GINT_TO_POINTER(ref));
g_signal_connect(da, "expose_event", G_CALLBACK(PDF_exp), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "enter_notify_event", G_CALLBACK(grabFocus), NULL);
g_signal_connect(da, "leave_notify_event", G_CALLBACK(grabFocus), NULL);
switch(i + j*DMAXPDFCOLS)
{
case 0+0: 
g_signal_connect(da, "button_release_event", 
G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "motion_notify_event", 
G_CALLBACK(dragEventPDF), GINT_TO_POINTER(ref));
mask = GDK_POINTER_MOTION_MASK | 
GDK_POINTER_MOTION_HINT_MASK | 
GDK_BUTTON_RELEASE_MASK;
break;
case 0+1*2: 
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
mask = GDK_BUTTON_RELEASE_MASK;
break;
case 1+1*2: 
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventPDF), GINT_TO_POINTER(ref));
mask = GDK_POINTER_MOTION_MASK | 
GDK_POINTER_MOTION_HINT_MASK | 
GDK_BUTTON_RELEASE_MASK;
break;
case 1+0*2: 
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventPDF), GINT_TO_POINTER(ref));
mask = GDK_POINTER_MOTION_MASK | 
GDK_POINTER_MOTION_HINT_MASK | 
GDK_BUTTON_RELEASE_MASK;
break;
}
gtk_widget_set_events (da, gtk_widget_get_events (da) 
| GDK_BUTTON_PRESS_MASK
| GDK_KEY_PRESS_MASK
| GDK_ENTER_NOTIFY_MASK
| GDK_LEAVE_NOTIFY_MASK
| mask);
gtk_table_attach(GTK_TABLE(tableL4a), frame, j, j+1, i, i+1, 
GTK_EXPAND | GTK_FILL, 
GTK_EXPAND | GTK_FILL, 
1, 1);
}
}
gtk_box_pack_start(GTK_BOX(vboxL2), tableL4a, TRUE, TRUE, 0);
insert = vboxL2;
break;
case PDFREQUEST:
vboxL2 = gtk_vbox_new(FALSE, 0);
tableL4a = gtk_table_new(RMAXPDFROWS, 1, TRUE);
for(i=0;i<RMAXPDFROWS;i++)
{
for(j=0;j<RMAXPDFCOLS;j++)
{
ref = REFNUM(screen, i, j); 
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN); 
RPDFDA[i][j] = da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(frame), da); 
g_signal_connect(da, "configure_event", G_CALLBACK(PDF_cfg),GINT_TO_POINTER(ref));
g_signal_connect(da, "expose_event", G_CALLBACK(PDF_exp), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "enter_notify_event", G_CALLBACK(grabFocus), NULL);
g_signal_connect(da, "leave_notify_event", G_CALLBACK(grabFocus), NULL);
gtk_widget_set_events (da, gtk_widget_get_events (da) 
| GDK_BUTTON_PRESS_MASK
| GDK_BUTTON_RELEASE_MASK
| GDK_POINTER_MOTION_MASK 
| GDK_POINTER_MOTION_HINT_MASK
| GDK_ENTER_NOTIFY_MASK
| GDK_LEAVE_NOTIFY_MASK
| GDK_KEY_PRESS_MASK);
gtk_table_attach(GTK_TABLE(tableL4a), frame, j, j+1, i, i+1, 
GTK_EXPAND | GTK_FILL, 
GTK_EXPAND | GTK_FILL, 
1, 1);
}
}
gtk_box_pack_start(GTK_BOX(vboxL2), tableL4a, TRUE, TRUE, 0);
insert = vboxL2;
break;
case PDFMOVIE:
{
GtkWidget *hbox, *box;
hbox = gtk_hbox_new(FALSE, 0);
mvDisp[MVDISP1] = box = make_movieScreen(PDFM5);
gtk_box_pack_start(GTK_BOX(hbox), box, TRUE, TRUE, 0);
mvDisp[MVDISP2] = vboxL2 = gtk_vbox_new(FALSE, 0);
tableL4a = gtk_table_new(MVMAXROWS, 1, TRUE);
for(i=0;i<MVMAXROWS;i++)
{
for(j=0;j<MVMAXCOLS;j++)
{
gtk_table_attach(GTK_TABLE(tableL4a), make_movieScreen(i*MVMAXCOLS+j), 
j, j+1, i, i+1, 
GTK_EXPAND | GTK_FILL, 
GTK_EXPAND | GTK_FILL, 
1, 1);
}
}
gtk_box_pack_start(GTK_BOX(vboxL2), tableL4a, TRUE, TRUE, 0);
gtk_box_pack_start(GTK_BOX(hbox), vboxL2, TRUE, TRUE, 0);
insert = hbox;
}
break;
}
return(insert);
}
static GtkWidget *makeSPECTROTab(int screen)
{
GtkWidget  *tableL4a, *vboxL2;
GtkWidget  *insert, *frame, *da;
int    i, j, ref;
switch(screen)
{
case SPECTROMAIN:
{
GtkWidget *hpane, *vbox;
vboxL2 = gtk_vbox_new(FALSE, 0);
hpane = gtk_hpaned_new();
for(j=0;j<SMAXCOLS;j++)
{
tableL4a = gtk_table_new(SMAXROWS, 1, TRUE);
vbox = gtk_vbox_new(FALSE, 0);
if (j==COLPDF)
pdfPane[SPECTROTAB(screen)] = vbox;
for(i=0;i<SMAXROWS;i++)
{
ref = REFNUM(screen, i, j);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN); 
SPMAINDA[i][j] = da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(frame), da);
g_signal_connect(da, "configure_event", G_CALLBACK(PDF_cfg),GINT_TO_POINTER(ref));
g_signal_connect(da, "expose_event", G_CALLBACK(PDF_exp), GINT_TO_POINTER(ref));
switch (j)
{
case COLSPEC:
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventSPECTRO), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventSPECTRO), GINT_TO_POINTER(ref));
break;
case COLPDF:
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventSPECTROPDF), GINT_TO_POINTER(ref));
break;
}
gtk_widget_set_events(da, gtk_widget_get_events(da) 
| GDK_BUTTON_PRESS_MASK
| GDK_BUTTON_RELEASE_MASK
| GDK_POINTER_MOTION_MASK 
| GDK_POINTER_MOTION_HINT_MASK
| GDK_ENTER_NOTIFY_MASK
| GDK_LEAVE_NOTIFY_MASK
| GDK_KEY_PRESS_MASK);
gtk_table_attach(GTK_TABLE(tableL4a), frame, 0, 1, i, i+1, 
GTK_EXPAND | GTK_FILL, 
GTK_EXPAND | GTK_FILL, 
0, 0);
}
gtk_container_add(GTK_CONTAINER(vbox), tableL4a);
switch (j)
{
case COLPDF:
gtk_paned_pack1(GTK_PANED(hpane), vbox, TRUE, TRUE);
break;
case COLSPEC:
gtk_paned_pack2(GTK_PANED(hpane), vbox, TRUE, TRUE);
break;
}
}
gtk_paned_set_position((GtkPaned *) hpane, 350);
gtk_box_pack_start(GTK_BOX(vboxL2), hpane, TRUE, TRUE, 0);
insert = vboxL2;
}
break;
case SPECTRODETREQ:
{
GtkWidget *hpane, *vbox;
vboxL2 = gtk_vbox_new(FALSE, 0);
hpane = gtk_hpaned_new();
for(j=0;j<SMAXCOLS;j++)
{
tableL4a = gtk_table_new(SMAXROWS, 1, TRUE);
vbox = gtk_vbox_new(FALSE, 0);
if (j==COLPDF)
pdfPane[SPECTROTAB(screen)] = vbox;
for(i=0;i<SMAXROWS;i++)
{
ref = REFNUM(screen, i, j);
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN); 
SPREQDA[i][j] = da = gtk_drawing_area_new();
gtk_container_add(GTK_CONTAINER(frame), da);
g_signal_connect(da, "configure_event", G_CALLBACK(PDF_cfg),GINT_TO_POINTER(ref));
g_signal_connect(da, "expose_event", G_CALLBACK(PDF_exp), GINT_TO_POINTER(ref));
switch (j)
{
case COLSPEC:
g_signal_connect(da, "button_press_event", G_CALLBACK(mouseEventSPECTRO), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventSPECTRO), GINT_TO_POINTER(ref));
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventSPECTRO), GINT_TO_POINTER(ref));
g_signal_connect(da, "scroll_event", G_CALLBACK(scrollEventSPECTRO), GINT_TO_POINTER(ref));
break;
case COLPDF:
g_signal_connect(da, "motion_notify_event", G_CALLBACK(dragEventPDF), GINT_TO_POINTER(ref));
g_signal_connect(da, "button_release_event", G_CALLBACK(mouseEventSPECTROPDF), GINT_TO_POINTER(ref));
break;
}
gtk_widget_set_events(da, gtk_widget_get_events(da) 
| GDK_BUTTON_PRESS_MASK
| GDK_BUTTON_RELEASE_MASK
| GDK_POINTER_MOTION_MASK 
| GDK_POINTER_MOTION_HINT_MASK
| GDK_ENTER_NOTIFY_MASK
| GDK_LEAVE_NOTIFY_MASK
| GDK_KEY_PRESS_MASK);
gtk_table_attach(GTK_TABLE(tableL4a), frame, 0, 1, i, i+1, 
GTK_EXPAND | GTK_FILL, 
GTK_EXPAND | GTK_FILL, 
0, 0);
}
gtk_container_add(GTK_CONTAINER(vbox), tableL4a);
switch (j)
{
case COLPDF:
gtk_paned_pack1(GTK_PANED(hpane), vbox, TRUE, TRUE);
break;
case COLSPEC:
gtk_paned_pack2(GTK_PANED(hpane), vbox, TRUE, TRUE);
break;
}
}
gtk_paned_set_position((GtkPaned *) hpane, 350);
gtk_box_pack_start(GTK_BOX(vboxL2), hpane, TRUE, TRUE, 0);
insert = vboxL2;
}
break;
}
return(insert);
}
void make_pdf_dataScreens()
{
int    i, j;
GtkWidget   *vbox, *hbox, *nb;
GtkWidget   *frame, *insert;
tips = gtk_tooltips_new();
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
systems[PDFSYSTEM] = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(topBox), systems[PDFSYSTEM]);
vbox = gtk_vbox_new(FALSE, 0);     
sysCbo[PDFSYSTEM] = gtk_combo_box_new_text();
for (i=j=0;i<NUM_SYSTEMS;i++)
{
gtk_combo_box_insert_text(GTK_COMBO_BOX(sysCbo[PDFSYSTEM]), i, systemNames[i]);
}
gtk_box_pack_start(GTK_BOX(vbox), sysCbo[PDFSYSTEM], FALSE, FALSE, 0);
sysCboSgnl[PDFSYSTEM] = g_signal_connect(sysCbo[PDFSYSTEM], "changed", G_CALLBACK(systemChg), NULL);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
gtk_box_pack_start(GTK_BOX(systems[PDFSYSTEM]), vbox, FALSE, FALSE, 0);
for (i=0; i < TTLPDFSCREENS; i++)
{
PSDsb[i] = makePDFsb(i);
gtk_box_pack_start(GTK_BOX(hbox), PSDsb[i], FALSE, FALSE, 0);
}
vbox = gtk_vbox_new(FALSE, 0);
PSDnb = nb = gtk_notebook_new();
gtk_box_pack_start(GTK_BOX(vbox), nb, TRUE, TRUE, 0);
statusBarPDF = gtk_statusbar_new();
gtk_box_pack_end(GTK_BOX(vbox), statusBarPDF, FALSE, FALSE, 0);
PSDbooks[PDFNB] = gtk_notebook_new();
gtk_notebook_append_page(GTK_NOTEBOOK(nb), PSDbooks[PDFNB], gtk_label_new(" PDF "));
g_ptr_array_add(pdfSensitives[PDFDATABUSYSENS][PDFDETAIL], PSDbooks[PDFNB]);
for (i = 0; i < TTLPDFTABS; i++)
{ 
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
insert = makePDFTab(i);
gtk_container_add(GTK_CONTAINER(frame), insert);
gtk_notebook_append_page(GTK_NOTEBOOK(PSDbooks[PDFNB]), frame, gtk_label_new(pdfNBNames[i]));
}
PSDbooks[SPECTRONB] = gtk_notebook_new();
gtk_notebook_append_page(GTK_NOTEBOOK(nb), PSDbooks[SPECTRONB], gtk_label_new(" SPECTRO "));
for (i = TTLPDFTABS, j=0; i < TTLPDFSCREENS; i++, j++)
{ 
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
insert = makeSPECTROTab(i);
gtk_container_add(GTK_CONTAINER(frame), insert);
gtk_notebook_append_page(GTK_NOTEBOOK(PSDbooks[SPECTRONB]), frame, gtk_label_new(spectroNBNames[j]));
}
gtk_box_pack_start(GTK_BOX(systems[PDFSYSTEM]), vbox, TRUE, TRUE, 0);
g_object_unref(size_group);
return;
}
void make_pdf()
{
int i;
memset(&pdfStates, 0, sizeof(PDFSTATES));
memset(&pdfSettings, 0, sizeof(PDFSETTINGS));
read_PDFdefaults(&pdfSettings);
make_pdf_dataScreens();
make_ReqDialog(FALSE);
make_MovieDialog(FALSE);
gtk_widget_show_all(systems[PDFSYSTEM]);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pMdisp[pdfSettings.main.display]), TRUE);  
switch(pdfSettings.main.display)
{
case PDFGROUP:
gtk_widget_hide(MButtons[PDFSTND]);
gtk_widget_hide(MButtons[PDFPDFD]);
gtk_widget_hide(MButtons[PDFBOTHD]);
break;
case PDFSTND:
gtk_widget_hide(MButtons[PDFGROUP]);
gtk_widget_hide(MButtons[PDFPDFD]);
gtk_widget_hide(MButtons[PDFBOTHD]);
break;
case PDFPDFD:
gtk_widget_hide(MButtons[PDFSTND]);
gtk_widget_hide(MButtons[PDFGROUP]);
gtk_widget_hide(MButtons[PDFBOTHD]);
break;
case PDFBOTHD:
gtk_widget_hide(MButtons[PDFSTND]);
gtk_widget_hide(MButtons[PDFGROUP]);
gtk_widget_hide(MButtons[PDFPDFD]);
break;
}
for (i=1 ; i < TTLPDFSCREENS; i++)
gtk_widget_hide(PSDsb[i]);
switch(pdfSettings.movie.display)
{
case MVDISP1:
gtk_widget_hide(mvDisp[MVDISP2]);
break;
case MVDISP2:
gtk_widget_hide(mvDisp[MVDISP1]);
break;
}
pdfStates.system = PDFNB;
pdfStates.screen = PDFMAIN;
manage_PDF_signals(CONNECTSIGS);
readSTNchnFilters(PDFSYSTEM);
setPDFchnFiltCbos();
for(i=0;i<TTLMOVIESCREENS;i++)
pdfStates.movie.films[i] = g_hash_table_new_full(g_int_hash, g_int_equal, 
free, (GDestroyNotify) freeFilm);
return ;
}
