#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>
#include <gdk/gdkkeysyms.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
enum {
CHNID,
PDFID
};
void setCell(int scr, int row, int col, int type, int id, char *name)
{ 
int i, j, rowS, rowE, colS, colE, svID;
char *svNm;
switch(scr)
{
#if 0
14-jan-2012: this code removed since detail screen has no such combo boxes 
case PDFDETAIL:
switch(type)
{
int svChn, svPdf;
case CHNID:
if (pdfStates.detail.pdfReq[row])
{
svPdf = pdfStates.detail.pdfReq[row]->keys.pdfKey;
freePDF(pdfStates.detail.pdfReq[row]);
if (pdfStates.detail.pdfReq[row]->data.pdf)
free(pdfStates.detail.pdfReq[row]->data.pdf);
if (pdfStates.detail.pdfReq[row]->data.name)
free(pdfStates.detail.pdfReq[row]->data.name);
pdfStates.detail.pdfReq[row]->data.pdf = NULL;
memset(pdfStates.detail.pdfReq[row], 0, sizeof(PDFREQ));
pdfStates.detail.pdfReq[row]->keys.chnKey = id;
pdfStates.detail.pdfReq[row]->keys.pdfKey = svPdf;
pdfStates.detail.pdfReq[row]->data.name = g_strdup(name);
}
else
{
pdfStates.detail.pdfReq[row] = calloc(1, sizeof(PDFREQ));
pdfStates.detail.pdfReq[row]->keys.chnKey = id;
pdfStates.detail.pdfReq[row]->data.name = g_strdup(name);
}
break;
case PDFID:
if (pdfStates.detail.pdfReq[row])
{
svChn = pdfStates.detail.pdfReq[row]->keys.chnKey;
freePDF(pdfStates.detail.pdfReq[row]);
if (pdfStates.detail.pdfReq[row]->data.pdf)
free(pdfStates.detail.pdfReq[row]->data.pdf);
if (pdfStates.detail.pdfReq[row]->data.name)
free(pdfStates.detail.pdfReq[row]->data.name);
pdfStates.detail.pdfReq[row]->data.pdf = NULL;
memset(pdfStates.detail.pdfReq[row], 0, sizeof(PDFREQ));
pdfStates.detail.pdfReq[row]->keys.chnKey = svChn;
pdfStates.detail.pdfReq[row]->keys.pdfKey = id;
pdfStates.detail.pdfReq[row]->data.name = g_strdup(name);
}
else
{
pdfStates.detail.pdfReq[row] = calloc(1, sizeof(PDFREQ));
pdfStates.detail.pdfReq[row]->keys.pdfKey = id;
pdfStates.detail.pdfReq[row]->data.name = g_strdup(name);
}
break;
}
freeDetail(ALLCELLS);
pdfStates.detail.pdfReq[row]->keys.fillTmp = TRUE;
gtk_widget_queue_resize(DPDFDA[row][col]); 
break;
#endif
case PDFMAIN:
if (pdfSettings.main.display == PDFGROUP)  
break;
rowS = row;
rowE = row+1;
if (row==-1)
{ 
rowS = 0;
rowE = MMAXPDFROWS;
}
colS = col;
colE = col+1;
if (col==-1)
{ 
colS = 0;
colE = MMAXPDFCOLS;
}
for(i=rowS;i<rowE;i++)
{
for(j=colS;j<colE;j++)
{
#if 0
if (pdfStates.main.pdfReq[pdfSettings.main.display][i][j].data.pdf)
{
free(pdfStates.main.pdfReq[pdfSettings.main.display][i][j].data.pdf);
}
#endif
switch(type)
{
case CHNID:
svID = pdfStates.main.pdfReq[pdfSettings.main.display][i][j].keys.pdfKey;
svNm = pdfStates.main.pdfReq[pdfSettings.main.display][i][j].data.name;
break;
case PDFID:
svID = pdfStates.main.pdfReq[pdfSettings.main.display][i][j].keys.chnKey;
svNm = pdfStates.main.pdfReq[pdfSettings.main.display][i][j].data.name;
break;
}
freePDF(&pdfStates.main.pdfReq[pdfSettings.main.display][i][j], TRUE);
switch(type)
{
case CHNID:
pdfStates.main.pdfReq[pdfSettings.main.display][i][j].keys.chnKey = id;
pdfStates.main.pdfReq[pdfSettings.main.display][i][j].data.name = g_strdup(name);
pdfStates.main.pdfReq[pdfSettings.main.display][i][j].keys.pdfKey = svID;
break;
case PDFID:
pdfStates.main.pdfReq[pdfSettings.main.display][i][j].keys.pdfKey = id;
pdfStates.main.pdfReq[pdfSettings.main.display][i][j].keys.chnKey = svID;
pdfStates.main.pdfReq[pdfSettings.main.display][i][j].data.name = svNm;
break;
}
gtk_widget_queue_resize(MPDFDA[i][j]); 
}
}
break;
}
return;
}
GNode *fndStn;
GNode *fndLoc;
gboolean findLoc(GNode *node, int *id)
{ 
NSLCDATA *nodeD=node->data;
if (nodeD->id == *id)
{
fndLoc = node;
return TRUE;
}
return FALSE;
}
gboolean findStn(GNode *node, int *id)
{ 
NSLCDATA *nodeD=node->data;
if (nodeD->id == *id)
{
fndStn = node;
return TRUE;
}
return FALSE;
}
gint findGrp(gconstpointer *grpStr, gconstpointer *cmpStr)
{ 
if (!(strcmp((char *) grpStr, (char *) cmpStr)))
{
return 0;
}
return 1;
}
void getGroups(GtkComboBox *combo, GSList **chnGrpLPtr)
{
int   i;
char  nodeInfo[50], nodeID[50]; 
static char  chnGrp[4], *chnGrpP; 
NSLCDATA *nodeD, find;
GSList  *fndChnG, *ntwI;
GtkTreeIter iter;
GNode  *found, *fndChn;
GValue value = {0, };
struct {
char network[12], station[12], location[12];
int idNtw, idStn, idLoc;
} findData;
memset(&findData, 0, sizeof(findData));
gtk_combo_box_get_active_iter(GTK_COMBO_BOX(combo), &iter);
gtk_tree_model_get_value(GTK_TREE_MODEL(storeNSL), &iter, 0, &value);
strcpy(nodeInfo, g_value_get_string(&value));
g_value_unset(&value);
sscanf(nodeInfo, "%[^.].%[^.].%s", findData.network, findData.station, findData.location);
gtk_tree_model_get_value(GTK_TREE_MODEL(storeNSL), &iter, 1, &value);
strcpy(nodeID, g_value_get_string(&value));
g_value_unset(&value);
sscanf(nodeID, "%d.%d.%d", &findData.idNtw, &findData.idStn, &findData.idLoc);
for(i=0, ntwI = ntwPDF;ntwI!=NULL;i++, ntwI=g_slist_next(ntwI))
{ 
found=ntwI->data;    
nodeD=found->data;
if (nodeD->id == findData.idNtw)
break;
}
fndStn = NULL;
fndLoc = NULL;
g_node_traverse(found, G_IN_ORDER, G_TRAVERSE_NON_LEAVES, -1, 
(GNodeTraverseFunc) findStn, (gpointer) &(findData.idStn));
if (!fndStn)
{ 
return;
}
memset(&find, 0, sizeof(NSLCDATA));
strcpy(find.name, findData.location);
find.id = findData.idLoc;
g_node_traverse(fndStn, G_IN_ORDER, G_TRAVERSE_NON_LEAVES, -1,
(GNodeTraverseFunc) findLoc, (gpointer) &(find.id));
if (!fndLoc)
{ 
fprintf(stderr, "Internal Error constructing Channel Group...\n");
return;
}
memset(chnGrp, 0, sizeof(chnGrp));
for(i=0, fndChn=g_node_first_child(fndLoc);fndChn;fndChn=g_node_next_sibling(fndChn))
{ 
nodeD = fndChn->data;
if (strlen(nodeD->name)==1)
{ 
chnGrp[i++]=nodeD->name[0];
if (i<3)
continue;
}
else
{
chnGrp[2] = '*'; chnGrp[3] = 0;
chnGrp[0] = nodeD->name[0]; chnGrp[1] = nodeD->name[1];
}
i=0;
if (!(*chnGrpLPtr))
{ 
*chnGrpLPtr = g_slist_insert(*chnGrpLPtr, g_strndup(chnGrp, 3), -1);
}
else
{ 
chnGrpP = g_strndup(chnGrp, 3);
if((fndChnG = g_slist_find_custom(*chnGrpLPtr, chnGrpP, (GCompareFunc) findGrp))==NULL)
{ 
*chnGrpLPtr = g_slist_insert(*chnGrpLPtr, chnGrpP, -1);
}
else
{
free(chnGrpP);
}
}
}
}
void cboSelect(GtkComboBox *combo, gpointer t)
{
int  type = GPOINTER_TO_INT(t);
int  screen, row, col, i, j;
char  *chnGrpPtr;
NSLCDATA *nodeD;
GNode  *fndChn;
GSList  *chnGrpL=NULL, *fndChnG;
GtkTreeIter iter;
GValue value = {0, };
static int numChnGrps[2];
GtkWidget *cboCHNG;
static GNode *fndLocP[3];
switch(type)
{
case CBONSL:  
switch(pdfSettings.main.display)
{
case PDFSTND: 
getGroups(combo, &chnGrpL);
cboCHNG = md1CHNG;
break;
case PDFPDFD: 
getGroups(GTK_COMBO_BOX(md2NSL1), &chnGrpL);
fndLocP[0] = fndLoc;
getGroups(GTK_COMBO_BOX(md2NSL2), &chnGrpL);
fndLocP[1] = fndLoc;
getGroups(GTK_COMBO_BOX(md2NSL3), &chnGrpL);
fndLocP[2] = fndLoc;
cboCHNG = md2CHNG;
break;
}
for(i=numChnGrps[pdfSettings.main.display];i>1;i--)
{ 
gtk_combo_box_remove_text(GTK_COMBO_BOX(cboCHNG), i-1);
}
numChnGrps[pdfSettings.main.display]=1;
for(fndChnG=chnGrpL;fndChnG;fndChnG=g_slist_next(fndChnG))
{ 
gtk_combo_box_append_text(GTK_COMBO_BOX(cboCHNG), (char *) fndChnG->data);
numChnGrps[pdfSettings.main.display]++;
}
g_slist_free(chnGrpL);
if (numChnGrps[pdfSettings.main.display] == 2)
{ 
gtk_combo_box_set_active(GTK_COMBO_BOX(cboCHNG), 1); 
}
else
{
gtk_combo_box_set_active(GTK_COMBO_BOX(cboCHNG), 0); 
}
break;
case CBOCHNG:  
chnGrpPtr = gtk_combo_box_get_active_text(GTK_COMBO_BOX(combo));
if(!chnGrpPtr)
break;  
if (!strcmp(chnGrpPtr, "NONE"))
{ 
setCell(PDFMAIN, -1, -1, CHNID, 0, NULL);
break;
}
row=col=0;
if (chnGrpPtr[2] == '*')
{
switch(pdfSettings.main.display)
{
case PDFSTND:
for(i=0, fndChn=g_node_first_child(fndLoc);fndChn;fndChn=g_node_next_sibling(fndChn))
{ 
nodeD = fndChn->data;
if (!strncmp(nodeD->name, chnGrpPtr, 2))
{
setCell(PDFMAIN, row++, -1, CHNID, nodeD->id, nodeD->fullname);
}
}
break;
case PDFPDFD: 
for(j=0;j<MMAXPDFROWS;j++, col=0)
{ 
for(i=0, fndChn=g_node_first_child(fndLocP[j]);fndChn;fndChn=g_node_next_sibling(fndChn))
{ 
nodeD = fndChn->data;
if (!strncmp(nodeD->name, chnGrpPtr, 2))
{
setCell(PDFMAIN, j, col++, CHNID, nodeD->id, nodeD->fullname);
}
}
}
break;
}
}
break;
case CBONSLC:  
gtk_combo_box_get_active_iter(combo, &iter);
switch(pdfStates.screen)
{
case PDFMAIN:
col = -1;
if ((long) combo == (long) md3CHN1)
row = 0;
else if ((long) combo == (long) md3CHN2)
row = 1;
else if ((long) combo == (long) md3CHN3)
row = 2;
break;
case PDFDETAIL:
row = col = 0;
break;
case PDFREQUEST:
gtk_tree_model_get_value(GTK_TREE_MODEL(storeCHN), &iter, 1, &value);
pdfStates.request.req.chnKey = g_value_get_int(&value);
g_value_unset(&value);
break;
}
if (pdfStates.screen==PDFMAIN )  
{ 
int chni;
const gchar *str;
gtk_tree_model_get_value(GTK_TREE_MODEL(storeCHN), &iter, 1, &value);
chni = g_value_get_int(&value);
g_value_unset(&value);
gtk_tree_model_get_value(GTK_TREE_MODEL(storeCHN), &iter, 0, &value);
str = g_value_get_string(&value);
if (!str)
return;
setCell(pdfStates.screen, row, col, CHNID, chni, (char*) str);
g_value_unset(&value);
}
break;
case CBOPDF:  
{
gboolean set = TRUE;
const gchar *valueStr;
int  pdfType, pdfKey;
if (!gtk_combo_box_get_active_iter(combo, &iter))
return;
gtk_tree_model_get_value(GTK_TREE_MODEL(storePDF), &iter, 1, &value);
valueStr = g_value_get_string(&value);
if (!valueStr)
{
gdk_beep();
return;
}
sscanf(valueStr, "%d:%d", &pdfType, &pdfKey);
g_value_unset(&value); valueStr = NULL;
switch (pdfStates.screen)
{
case PDFMAIN:
screen = PDFMAIN;
row=-1;
switch(pdfSettings.main.display)
{
case PDFSTND:
if ((long) combo == (long) md1PDF1)
col = 0;
else if ((long) combo == (long) md1PDF2)
col = 1;
else if ((long) combo == (long) md1PDF3)
col = 2;
break;
case PDFPDFD:
col = -1;
break;
case PDFBOTHD:
if ((long) combo == (long) md3PDF1)
col = 0;
else if ((long) combo == (long) md3PDF2)
col = 1;
else if ((long) combo == (long) md3PDF3)
col = 2;
break;
case PDFGROUP:
set = FALSE;
pdfStates.main.group.pdfKey = pdfKey;
pdfStates.main.group.pdfType = pdfType;
nextPDFs(NULL, GINT_TO_POINTER(PDFGREINIT));
break;
}
break;
case SPECTROMAIN:
set = FALSE;
pdfStates.spmain.group.pdfKey = pdfKey;
nextPDFs(NULL, GINT_TO_POINTER(PDFGREINIT));
break;
}
if (set)
setCell(screen, row, col, PDFID, pdfKey, NULL);
}
break;
}
return;
}
