#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
void setStnCtrlSettings()
{
int i, j, selected, dbSel;
static int numSrvrs;
char *tmpStr;
SERVERDBS *srvrInfo;
DBLST *dbInfo;
GSList *iter;
memcpy(&ctrlStnSettings, &stnSettings, sizeof(STNSETTINGS));
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (stnStart), ctrlStnSettings.general.startup);
gtk_spin_button_set_value((GtkSpinButton *) STNXdays, ctrlStnSettings.general.stnXDays);
gtk_spin_button_set_value((GtkSpinButton *) STNdays, ctrlStnSettings.main.days);
gtk_spin_button_set_value((GtkSpinButton *) STNlines, ctrlStnSettings.main.lines);
gtk_toggle_button_set_active(
GTK_TOGGLE_BUTTON (STNunitsR[ctrlStnSettings.display.units[STNMAIN]]), TRUE);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (STNunitsD), !ctrlStnSettings.display.unitsD);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (STNyAxis[STNMAIN]), !ctrlStnSettings.display.yAxis[STNMAIN]);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (STNpql[ctrlStnSettings.pqlDest]), TRUE);   
#if 0
if (pqlxStates.user.fname.replace && (pqlxStates.conn.state == SRVRCONNECTED))
{
gtk_entry_set_text(GTK_ENTRY(STNrplc[REPLACEFROM]), pqlxStates.user.fname.replace->fromStr);
gtk_entry_set_text(GTK_ENTRY(STNrplc[REPLACETO]), pqlxStates.user.fname.replace->toStr);
}
else
{
gtk_entry_set_text(GTK_ENTRY(STNrplc[REPLACEFROM]), "");
gtk_entry_set_text(GTK_ENTRY(STNrplc[REPLACETO]), "");
}
#endif
for (j=0;j<TTLSTNSCREENS;j++)
for (i=0;i<STNMAXCOLOURS;i++)
{
if (stnColors[j][i])
gtk_color_button_set_color(GTK_COLOR_BUTTON (stnColors[j][i]), 
&ctrlStnSettings.drawing.colors[j][i]);
}
g_signal_handler_block(stnSrvrDefault[SRVRDEFAULT], stnSignals2[STNSRVRDFAULTSGNL][0]);
for(j=0;j<numSrvrs;j++)
{
gtk_combo_box_remove_text(GTK_COMBO_BOX (stnSrvrDefault[SRVRDEFAULT]), 0);
}
numSrvrs = g_slist_length(pqlxStates.servers.srvrDB) + 1; 
gtk_combo_box_append_text(GTK_COMBO_BOX (stnSrvrDefault[SRVRDEFAULT]), "NONE");
selected = NONE;  
for(j=0, iter = pqlxStates.servers.srvrDB;
iter;
iter = g_slist_next(iter), j++)
{
srvrInfo = iter->data;
gtk_combo_box_append_text(GTK_COMBO_BOX (stnSrvrDefault[SRVRDEFAULT]), 
srvrInfo->data.srvrName);
if (ctrlStnSettings.general.server &&
srvrInfo->data.srvrName &&
!strcmp(ctrlStnSettings.general.server, srvrInfo->data.srvrName))
selected = j;
}
g_signal_handler_unblock(stnSrvrDefault[SRVRDEFAULT], stnSignals2[STNSRVRDFAULTSGNL][0]);
gtk_combo_box_set_active(GTK_COMBO_BOX (stnSrvrDefault[SRVRDEFAULT]), selected+1);
if (selected != NONE)  
{ 
g_signal_handler_block(stnSrvrDefault[DBDEFAULT], stnSignals2[STNDBDFAULTSGNL][0]);
for(j = dbSel = 0, iter = srvrInfo->data.dbsList;
iter;
iter = g_slist_next(iter), j++)
{
dbInfo = iter->data;
if (ctrlStnSettings.general.database &&
!strcmp(ctrlStnSettings.general.database, dbInfo->dbName))
dbSel = j;
}
gtk_combo_box_set_active(GTK_COMBO_BOX (stnSrvrDefault[DBDEFAULT]), dbSel);
g_signal_handler_unblock(stnSrvrDefault[DBDEFAULT], stnSignals2[STNDBDFAULTSGNL][0]);
}
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (STNyAxis[STNANALYSIS]), !ctrlStnSettings.display.yAxis[STNANALYSIS]);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (STNevtEpiCtr[ctrlStnSettings.event.epiOrder]), TRUE);
while (stnStates.event.models &&
stnSettings.event.models)
{
char *modelNm, *phaseNm, *modelNm1, *modelStr;
int  modelNum;
GSList *iter;
TTMODEL *model;
TTNAME *phase;
MODELPHASES *phases;
modelNm = strtok(stnSettings.event.modelSel, MODELSEP); 
if (modelNm)
{
for(iter = stnStates.event.models, i=0;
iter;
iter = g_slist_next(iter), i++)
{ 
model = iter->data;
if (!strcmp(modelNm, model->name))
{
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (g_slist_nth_data(STNevtModelsR, i))))
modelChg(g_slist_nth_data(STNevtModelsR, i), GINT_TO_POINTER(i));
else
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (g_slist_nth_data(STNevtModelsR, i)), TRUE);
break;
}
}
}
else
{ 
iter = NULL;
i=0;
}
modelNum = i;
if(!iter)
{ 
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (g_slist_nth_data(STNevtModelsR, 0)), TRUE);
stnStates.event.model = g_slist_nth_data(stnStates.event.models, 0);
break;
}
for(iter = stnSettings.event.models;
iter;
iter = g_slist_next(iter))
{
modelStr = g_strdup(iter->data);
modelNm1 = strtok(modelStr, MODELSEP);
free(modelStr);
if (!strcmp(modelNm1, modelNm))
{
break;
}
}
phases = g_slist_nth_data(STNevtModelPhases, i);
for((phaseNm = strtok(NULL, MODELSEP));
phaseNm;
(phaseNm = strtok(NULL, MODELSEP)))
{ 
for(iter=model->phases, i=0;
iter;
iter=g_slist_next(iter), i++)
{ 
phase = iter->data;
if (!strcmp(phaseNm, phase->name))
{
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (g_slist_nth_data(phases->phasesR, i)), TRUE);
break;
}
}
}
phases = g_slist_nth_data(STNevtAlignPhases, modelNum);
for(iter=model->phases, i=0;
iter;
iter=g_slist_next(iter), i++)
{ 
phase = iter->data;
if (!strcmp(phase->name, ctrlStnSettings.event.alignPhase))
{
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (g_slist_nth_data(phases->phasesR, i)), TRUE);
break;
}
}
break;
}
if(!ctrlStnSettings.event.models &&
STNevtModelsR)
{ 
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (g_slist_nth_data(STNevtModelsR, 0))))
modelChg(g_slist_nth_data(STNevtModelsR, 0), GINT_TO_POINTER(0));
else
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (g_slist_nth_data(STNevtModelsR, 0)), TRUE);
}
for(i=0;i<MAXPICKS;i++)
{
gtk_entry_set_text(GTK_ENTRY(STNuserP[i]), ctrlStnSettings.event.userP[i]);
}
gtk_spin_button_set_value((GtkSpinButton *) STNuserPA, ctrlStnSettings.event.userPA+1);
for (i=0; i<TTLPOPUPWIN; i++)
{
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (STNPopup[i]),
ctrlStnSettings.analysis.popup.type[i]);
}
for (j=0; j<TTLPOPUPWIN; j++)
for (i=0; i<STNMAXPOPUPCOLOURS; i++)
{
if (STNColors[j][i])
gtk_color_button_set_color(GTK_COLOR_BUTTON (STNColors[j][i]), 
&ctrlStnSettings.analysis.popup.colors[j][i]);
}
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (STNSpecAmp), 
!ctrlStnSettings.analysis.popup.spectra.yAxis);
tmpStr = g_strdup_printf("%f", ctrlStnSettings.analysis.popup.spectra.yMax);
gtk_entry_set_text(GTK_ENTRY(STNSpecYMax), tmpStr); free(tmpStr);
gtk_spin_button_set_value((GtkSpinButton *) STNSpecDecades, 
ctrlStnSettings.analysis.popup.spectra.decades);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (STNSpecFreq), 
!ctrlStnSettings.analysis.popup.spectra.xAxis);
tmpStr = g_strdup_printf("%f", ctrlStnSettings.analysis.popup.spectra.xMax);
gtk_entry_set_text(GTK_ENTRY(STNSpecXMax), tmpStr); free(tmpStr);
tmpStr = g_strdup_printf("%f", ctrlStnSettings.analysis.popup.spectra.xMin);
gtk_entry_set_text(GTK_ENTRY(STNSpecXMin), tmpStr); free(tmpStr);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (STNPsdHL), 
!ctrlStnSettings.analysis.popup.psd.hlnm);
tmpStr = g_strdup_printf("%d", ctrlStnSettings.analysis.popup.psd.yMax);
gtk_entry_set_text(GTK_ENTRY(STNPsdYMax), tmpStr); free(tmpStr);
tmpStr = g_strdup_printf("%d", ctrlStnSettings.analysis.popup.psd.yMin);
gtk_entry_set_text(GTK_ENTRY(STNPsdYMin), tmpStr); free(tmpStr);
tmpStr = g_strdup_printf("%f", ctrlStnSettings.analysis.popup.psd.xMax);
gtk_entry_set_text(GTK_ENTRY(STNPsdXMax), tmpStr); free(tmpStr);
tmpStr = g_strdup_printf("%f", ctrlStnSettings.analysis.popup.psd.xMin);
gtk_entry_set_text(GTK_ENTRY(STNPsdXMin), tmpStr); free(tmpStr);
}
void getStnCtrlSettings()
{
int i, j, which=-1;
GdkColor *fg, *bg;
gboolean reset=FALSE, specPSDreset[TTLPOPUPWIN] = {FALSE, FALSE};
char  *tmpStr;
ctrlStnSettings.general.startup = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (stnStart));
if (stnSettings.general.server)
free(stnSettings.general.server);
if (pdfSettings.general.database)
free(stnSettings.general.database);
ctrlStnSettings.general.server = gtk_combo_box_get_active_text(
GTK_COMBO_BOX (stnSrvrDefault[SRVRDEFAULT]));
ctrlStnSettings.general.database = gtk_combo_box_get_active_text(
GTK_COMBO_BOX (stnSrvrDefault[DBDEFAULT]));
if (!ctrlStnSettings.general.database)
ctrlStnSettings.general.database = g_strdup("");
ctrlStnSettings.general.stnXDays = gtk_spin_button_get_value((GtkSpinButton *) STNXdays);
ctrlStnSettings.main.days = gtk_spin_button_get_value((GtkSpinButton *) STNdays);
ctrlStnSettings.main.lines = gtk_spin_button_get_value((GtkSpinButton *) STNlines);
ctrlStnSettings.display.yAxis[STNMAIN] = !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (STNyAxis[STNMAIN]));
ctrlStnSettings.display.units[STNMAIN] = gtk_toggle_button_get_active(
GTK_TOGGLE_BUTTON (STNunitsR[STNCOUNTS]))
? STNCOUNTS
: STNSENSITIVITY;
ctrlStnSettings.display.unitsD = !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (STNunitsD));
ctrlStnSettings.display.units[STNANALYSIS] = ctrlStnSettings.display.units[STNMAIN];
switch(ctrlStnSettings.display.unitsD)
{
case TRUE:
gtk_widget_show(stnUnitsB[STNMAIN]);
gtk_widget_show(stnUnitsB[STNANALYSIS]);
break;
case FALSE:
gtk_widget_hide(stnUnitsB[STNMAIN]);
gtk_widget_hide(stnUnitsB[STNANALYSIS]);
break;
}
for(i=0;i<TTLPQLDESTS;i++)
{
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (STNpql[i])) == TRUE)
{
ctrlStnSettings.pqlDest = i;
break;
}
}
#if 0
if (pqlxStates.conn.state == SRVRCONNECTED)
{
srvrDB=g_strdup_printf("%s.%s", pqlxStates.conn.srvrNm, pqlxStates.conn.dbNm);
rplc = calloc(1, sizeof(DBRPLCSTR));
rplc->fromStr = g_strdup(gtk_entry_get_text(GTK_ENTRY(STNrplc[REPLACEFROM])));
rplc->toStr = g_strdup(gtk_entry_get_text(GTK_ENTRY(STNrplc[REPLACETO])));
if (!strlen(rplc->fromStr))
{
rplc->fromStr = g_strdup(" ");
rplc->toStr = g_strdup(" ");
}
g_hash_table_replace(pqlxStates.user.fname.rplc, srvrDB, rplc);
pqlxStates.user.fname.replace = g_hash_table_lookup(pqlxStates.user.fname.rplc, srvrDB);
}
#endif
if (ctrlStnSettings.main.days != stnSettings.main.days ||
ctrlStnSettings.main.lines != stnSettings.main.lines)
{
reset = TRUE;
}
if (ctrlStnSettings.display.yAxis[STNMAIN] != stnSettings.display.yAxis[STNMAIN])
{
stnStates.pmap.dirty[STNMAIN][0] = stnStates.pmap.dirty[STNMAIN][1] = TRUE;;
}
if (ctrlStnSettings.display.units[STNMAIN] != stnSettings.display.units[STNMAIN])
{
stnStates.pmap.dirty[STNMAIN][0] = stnStates.pmap.dirty[STNMAIN][1] = TRUE;;
stnStates.pmap.dirty[STNANALYSIS][0] = stnStates.pmap.dirty[STNANALYSIS][1] = TRUE;;
}
for (j=0;j<TTLSTNSCREENS;j++)
{
if (ctrlStnSettings.display.yFixed[j][MAX]) free(ctrlStnSettings.display.yFixed[j][MAX]);
if (ctrlStnSettings.display.yFixed[j][MIN]) free(ctrlStnSettings.display.yFixed[j][MIN]);
ctrlStnSettings.display.yFixed[j][MAX] = g_strdup(gtk_entry_get_text(GTK_ENTRY(stnYfixed[j][MAX])));
ctrlStnSettings.display.yFixed[j][MIN] = g_strdup(gtk_entry_get_text(GTK_ENTRY(stnYfixed[j][MIN])));
}
ctrlStnSettings.display.yAxis[STNANALYSIS] = !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (STNyAxis[STNANALYSIS]));
if (ctrlStnSettings.display.yAxis[STNANALYSIS] != stnSettings.display.yAxis[STNANALYSIS])
{
stnStates.pmap.dirty[STNANALYSIS][0] = stnStates.pmap.dirty[STNANALYSIS][1] = TRUE;;
}
ctrlStnSettings.event.epiOrder = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (STNevtEpiCtr[STNEVTEPINEAR1ST]))
? STNEVTEPINEAR1ST
: STNEVTEPIFAR1ST;
if (stnSettings.event.dispOrder == EVTDISPEVT &&
ctrlStnSettings.event.epiOrder != stnSettings.event.epiOrder)
{
stnStates.pmap.dirty[STNANALYSIS][0] = TRUE;
}
{ 
GSList *iter;
MODELPHASES *phases;
TTMODEL *model = stnStates.event.model;
TTNAME *phase;
char *str1, *str2, *align, *modelStr, *modelInfo, *modelN;
int  modelNum;
if (stnStates.event.models)
{
#if 0
if (ctrlStnSettings.event.model)
phaseL = ctrlStnSettings.event.model;
else
phaseL = g_strdup("");
#endif
if (ctrlStnSettings.event.modelSel)
{
free(ctrlStnSettings.event.modelSel);
ctrlStnSettings.event.modelSel = NULL;
}
ctrlStnSettings.event.modelSel = g_strdup(model->name);
modelStr = g_strdup_printf("%s`", model->name);
for(iter = STNevtModelPhases, i=0;
iter;
iter = g_slist_next(iter), i++)
{ 
phases = iter->data;
if (phases->modelKey == model->key)
{
modelNum = i;
break;
}
}
phases = g_slist_nth_data(STNevtModelPhases, modelNum);
for(iter = phases->phasesR, i=0;
iter;
iter = g_slist_next(iter), i++)
{
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (iter->data)))
{
phase = g_slist_nth_data(model->phases, i);
str1 = g_strdup_printf("%s`", phase->name);
str2 = g_strconcat(modelStr, str1, NULL);
free(str1); free(modelStr);
modelStr = str2;
continue;
}
}
for(iter = ctrlStnSettings.event.models;
iter;
iter = g_slist_next(iter))
{ 
modelInfo = iter->data;
modelN = strtok(modelInfo, MODELSEP);
if (!strcmp(stnStates.event.model->name, modelN))
break;
}
if (!iter)
{ 
ctrlStnSettings.event.models = g_slist_prepend(ctrlStnSettings.event.models, modelStr);
stnStates.pmap.dirty[STNANALYSIS][0] = TRUE;
}
else
{ 
if (strcmp(modelStr, modelInfo))
stnStates.pmap.dirty[STNANALYSIS][0] = TRUE;
free(modelInfo);
iter->data = modelStr;
}
phases = g_slist_nth_data(STNevtAlignPhases, modelNum);
if (ctrlStnSettings.event.alignPhase)
align = ctrlStnSettings.event.alignPhase;
else
align = g_strdup("");
for(iter = phases->phasesR, i=0;
iter;
iter = g_slist_next(iter), i++)
{
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (iter->data)))
{
phase = g_slist_nth_data(model->phases, i);
ctrlStnSettings.event.alignPhase = g_strdup_printf("%s", phase->name);
break;
}
}
if (strcmp(align, ctrlStnSettings.event.alignPhase))
{ 
stnStates.pmap.dirty[STNANALYSIS][0] = TRUE;
}
free(align);
}
{ 
char *models=NULL, *strPtr;
if (ctrlStnSettings.event.modelsSV)
{
free(ctrlStnSettings.event.modelsSV);
ctrlStnSettings.event.modelsSV = g_strdup("");
}
for(iter = ctrlStnSettings.event.models;
iter;
iter = g_slist_next(iter))
{
#if 0   
if (g_slist_next(iter))
{
models = g_strdup_printf("%s%c", iter->data, MODELSSEP);
}
else
{
models = g_strdup_printf("%s", iter->data);
}
#endif
models = g_strdup_printf("%s%s", (char *) iter->data, MODELSSEP);
strPtr = ctrlStnSettings.event.modelsSV;
ctrlStnSettings.event.modelsSV = g_strconcat(strPtr, models, NULL);
free(strPtr);
free(models);
}
}
}
for(i=0;i<MAXPICKS;i++)
{
strcpy(ctrlStnSettings.event.userP[i], gtk_entry_get_text(GTK_ENTRY(STNuserP[i])));
}
ctrlStnSettings.event.userPA = gtk_spin_button_get_value((GtkSpinButton *) STNuserPA)-1;
for (i=0; i<TTLPOPUPWIN; i++)
{
ctrlStnSettings.analysis.popup.type[i] = 
gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (STNPopup[i]));
}
ctrlStnSettings.analysis.popup.spectra.yAxis = !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (STNSpecAmp));
tmpStr = g_strdup(gtk_entry_get_text(GTK_ENTRY(STNSpecYMax)));
sscanf(tmpStr, "%f", &ctrlStnSettings.analysis.popup.spectra.yMax); free(tmpStr);
ctrlStnSettings.analysis.popup.spectra.decades = gtk_spin_button_get_value((GtkSpinButton *) STNSpecDecades);
ctrlStnSettings.analysis.popup.spectra.xAxis = !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (STNSpecFreq));
tmpStr = g_strdup(gtk_entry_get_text(GTK_ENTRY(STNSpecXMax)));
sscanf(tmpStr, "%f", &ctrlStnSettings.analysis.popup.spectra.xMax); free(tmpStr);
tmpStr = g_strdup(gtk_entry_get_text(GTK_ENTRY(STNSpecXMin)));
sscanf(tmpStr, "%f", &ctrlStnSettings.analysis.popup.spectra.xMin); free(tmpStr);
if (ctrlStnSettings.analysis.popup.spectra.yAxis != stnSettings.analysis.popup.spectra.yAxis ||
ctrlStnSettings.analysis.popup.spectra.yMax != stnSettings.analysis.popup.spectra.yMax ||
ctrlStnSettings.analysis.popup.spectra.decades != stnSettings.analysis.popup.spectra.decades ||
ctrlStnSettings.analysis.popup.spectra.xAxis != stnSettings.analysis.popup.spectra.xAxis ||
ctrlStnSettings.analysis.popup.spectra.xMax != stnSettings.analysis.popup.spectra.xMax ||
ctrlStnSettings.analysis.popup.spectra.xMin != stnSettings.analysis.popup.spectra.xMin)
specPSDreset[SPECTRA_WIN] = TRUE;
ctrlStnSettings.analysis.popup.psd.hlnm = 
!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (STNPsdHL));
tmpStr = g_strdup(gtk_entry_get_text(GTK_ENTRY(STNPsdYMax)));
sscanf(tmpStr, "%d", &ctrlStnSettings.analysis.popup.psd.yMax); free(tmpStr);
tmpStr = g_strdup(gtk_entry_get_text(GTK_ENTRY(STNPsdYMin)));
sscanf(tmpStr, "%d", &ctrlStnSettings.analysis.popup.psd.yMin); free(tmpStr);
tmpStr = g_strdup(gtk_entry_get_text(GTK_ENTRY(STNPsdXMax)));
sscanf(tmpStr, "%f", &ctrlStnSettings.analysis.popup.psd.xMax); free(tmpStr);
tmpStr = g_strdup(gtk_entry_get_text(GTK_ENTRY(STNPsdXMin)));
sscanf(tmpStr, "%f", &ctrlStnSettings.analysis.popup.psd.xMin); free(tmpStr);
if (ctrlStnSettings.analysis.popup.psd.hlnm != stnSettings.analysis.popup.psd.hlnm ||
ctrlStnSettings.analysis.popup.psd.yMax != stnSettings.analysis.popup.psd.yMax ||
ctrlStnSettings.analysis.popup.psd.yMin != stnSettings.analysis.popup.psd.yMin ||
ctrlStnSettings.analysis.popup.psd.xMax != stnSettings.analysis.popup.psd.xMax ||
ctrlStnSettings.analysis.popup.psd.xMin != stnSettings.analysis.popup.psd.xMin)
specPSDreset[PSD_WIN] = TRUE;
memcpy(&stnSettings, &ctrlStnSettings, sizeof(STNSETTINGS));
for (j=0;j<TTLSTNSCREENS;j++)
for (i=0;i<STNMAXCOLOURS;i++)
{
if (stnSettings.drawing.colors[j][i].pixel)
{
switch(i)
{
case STNFG:
bg = &stnSettings.drawing.colors[j][STNBG];
fg = &stnSettings.drawing.colors[j][STNFG];
makeSTNGC(j, STNFGBG, fg, bg, STNDA[j]);
switch(j)
{
case STNMAIN:
which = STNFLBL;
break;
case STNANALYSIS:
which = STNFLBLA;
break;
}
makeFONTGC(which, fg, bg);
stnStates.pmap.dirty[j][0] = stnStates.pmap.dirty[j][1] = TRUE;;
break;
case STNBG:
bg = &stnSettings.drawing.colors[j][STNBG];
fg = &stnSettings.drawing.colors[j][STNFG];
makeSTNGC(j, STNFGBG, fg, bg, STNDA[j]);
switch(j)
{
case STNMAIN:
which = STNFLBL;
break;
case STNANALYSIS:
which = STNFLBLA;
break;
}
makeFONTGC(which, fg, bg);
fg = &stnSettings.drawing.colors[j][STNGP];
makeSTNGC(j, STNGAPI, fg, bg, STNDA[j]);
fg = &stnSettings.drawing.colors[j][STNOP];
makeSTNGC(j, STNOLAP, fg, bg, STNDA[j]);
stnStates.pmap.dirty[j][0] = stnStates.pmap.dirty[j][1] = TRUE;;
break;
case STNSB:
bg = &stnSettings.drawing.colors[j][STNBG];
fg = &stnSettings.drawing.colors[j][STNSB]; 
makeSTNGC(j, STNSBAR, fg, bg, STNDA[j]);
gtk_widget_modify_bg(STNbuttons[j], GTK_STATE_NORMAL, 
&stnSettings.drawing.colors[j][STNSB]);
if (j==STNMAIN)
{
gtk_widget_modify_bg(STNeventB[0], GTK_STATE_NORMAL, 
&stnSettings.drawing.colors[j][STNSB]);
gtk_widget_modify_bg(STNeventB[1], GTK_STATE_NORMAL, 
&stnSettings.drawing.colors[j][STNSB]);
gtk_widget_modify_bg(STNeventB[2], GTK_STATE_NORMAL, 
&stnSettings.drawing.colors[j][STNSB]);
gtk_widget_modify_bg(STNeventB[3], GTK_STATE_NORMAL, 
&stnSettings.drawing.colors[j][STNSB]);
}
break;
case STNGP:
bg = &stnSettings.drawing.colors[j][STNBG];
fg = &stnSettings.drawing.colors[j][STNGP];
makeSTNGC(j, STNGAPI, fg, bg, STNDA[j]);
stnStates.pmap.dirty[j][0] = stnStates.pmap.dirty[j][1] = TRUE;;
break;
case STNOP:
bg = &stnSettings.drawing.colors[j][STNBG];
fg = &stnSettings.drawing.colors[j][STNOP];
makeSTNGC(j, STNOLAP, fg, bg, STNDA[j]);
stnStates.pmap.dirty[j][0] = stnStates.pmap.dirty[j][1] = TRUE;;
break;
case STNPA:
bg = &stnSettings.drawing.colors[j][STNBG];
fg = &stnSettings.drawing.colors[j][STNPA];
makeSTNGC(j, STNARR, fg, bg, STNDA[j]);
stnStates.pmap.dirty[j][0] = stnStates.pmap.dirty[j][1] = TRUE;;
break;
case STNUP:
bg = &stnSettings.drawing.colors[j][STNBG];
fg = &stnSettings.drawing.colors[j][STNUP];
makeSTNGC(j, STNPICK, fg, bg, STNDA[j]);
stnStates.pmap.dirty[j][0] = stnStates.pmap.dirty[j][1] = TRUE;;
break;
}
stnSettings.drawing.colors[j][i].pixel = FALSE;
}
}
for (j=0; j<TTLPOPUPWIN; j++)
for (i=0; i<STNMAXPOPUPCOLOURS; i++)
{
switch(j)
{
case SPECTRA_WIN:
which = STNFLBLS;
break;
case PSD_WIN:
which = STNFLBLP;
break;
case PM_WIN:
which = STNFLBLPM;
break;
}
if (stnSettings.analysis.popup.colors[j][i].pixel)
{
switch(i)
{
case STNFG:
bg = &stnSettings.analysis.popup.colors[j][STNBG];
fg = &stnSettings.analysis.popup.colors[j][STNFG];
makeSTNgc(fg, bg, STNDA[0], (GdkGC **) &(stnSettings.analysis.popup.ctxt[j][i]));
makeFONTGC(which, fg, bg);
specPSDreset[j] = TRUE;
break;
case STNBG:
bg = &stnSettings.analysis.popup.colors[j][STNBG];
fg = &stnSettings.analysis.popup.colors[j][STNFG]; 
makeSTNgc(fg, bg, STNDA[0], (GdkGC **) &(stnSettings.analysis.popup.ctxt[j][i]));
makeFONTGC(which, fg, bg);
specPSDreset[j] = TRUE;
break;
case STNSB:
bg = &stnSettings.analysis.popup.colors[j][STNBG];
fg = &stnSettings.analysis.popup.colors[j][STNSB]; 
makeSTNgc(fg, bg, STNDA[0], (GdkGC **) &(stnSettings.analysis.popup.ctxt[j][i]));
specPSDreset[j] = TRUE;
break;
case STNPMC:
bg = &stnSettings.analysis.popup.colors[j][STNBG];
fg = &stnSettings.analysis.popup.colors[j][STNPMC]; 
makeSTNgc(fg, bg, STNDA[0], (GdkGC **) &(stnSettings.analysis.popup.ctxt[j][i]));
makeFONTGC(STNFLBLPMC, fg, bg);
specPSDreset[j] = TRUE;
break;
case STNPMEBA:
bg = &stnSettings.analysis.popup.colors[j][STNBG];
fg = &stnSettings.analysis.popup.colors[j][STNPMEBA]; 
makeSTNgc(fg, bg, STNDA[0], (GdkGC **) &(stnSettings.analysis.popup.ctxt[j][i]));
makeFONTGC(STNFLBLPMEBA, fg, bg);
specPSDreset[j] = TRUE;
break;
case STNHL:  
case STNPMSP:
case STNPMEP:
case STNPMLA:
specPSDreset[j] = TRUE;
break;
}
stnSettings.analysis.popup.colors[j][i].pixel = FALSE;
}
}
memcpy(&ctrlStnSettings, &stnSettings, sizeof(STNSETTINGS));
for(i=0;i<TTLPOPUPWIN;i++)
{
if (specPSDreset[i])
g_idle_add((GSourceFunc) reSetPopup, GINT_TO_POINTER(i));
}
if (reset)
{ 
stnStates.request.type = STNINIT;
} 
}
