#include <string.h>
#include <math.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pql_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
typedef struct
{
int  stop, lastPoint, dataSize, dataType;
int  ptInc, decInc, inc, rec_no;
int  samples, trcH, tScale;
int  width, height;
double tm, tm_inc;
struct
{
gint32 *ptr;
short *sptr;
float *lptr;
double *dptr;
} data;
struct
{
int  *gaps, *olaps;
int  gapNum, olapNum;
int  gapON, olapON;
} GO;
GdkGC  *gc;
traceInfo *trc;
} plotInfo;
static int setGO(GdkPixmap *pixmap, graph *gr, plotInfo *pInfo)
{
int  pix_x0, pix_y0, pix_x1, pix_y1;
int  gapInc, ret=FALSE, decInc;
double pt1, pt2;
traceInfo *trcData = pInfo->trc;
if (stnSettings.display.overlay[stnStates.screen])
return ret;  
decInc = 0;
if (trcData->trace.numGaps)
{
for(pInfo->GO.gapNum=0, pInfo->GO.gaps = trcData->trace.gaps;  
pInfo->GO.gapNum < trcData->trace.numGaps &&     
pInfo->GO.gaps[GAPBEG] < pInfo->ptInc;       
pInfo->GO.gapNum++);
if (pInfo->GO.gapNum)  
if (pInfo->ptInc < pInfo->GO.gaps[(pInfo->GO.gapNum-1)*2+1])
pInfo->GO.gapNum--;
if (pInfo->GO.gapNum < trcData->trace.numGaps)
if (pInfo->ptInc > (pInfo->GO.gaps[GAPBEG]) &&
pInfo->ptInc < (pInfo->GO.gaps[GAPEND]))
{ 
gapInc = (pInfo->GO.gaps[(pInfo->GO.gapNum)*2+1] - pInfo->ptInc)/ pInfo->inc;
if (gapInc)
{ 
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNFGBG][NORMALGC];
if (gapInc + gr->pix_xmin > gr->pix_xmax)
{ 
pix_y0 = ANATOPM + (pInfo->trcH * (pInfo->rec_no) + pInfo->trcH/2);
gdk_draw_line(pixmap, pInfo->gc, 
gr->pix_xmin, pix_y0,
gr->pix_xmax, pix_y0);
ret = TRUE;  
}
else
{ 
#if 0
int dataType;
if (states.filter.on) 
{
dataType = MY_FLOAT;
}
else
{
dataType = trcData->data.head.data_form;
}
#endif
switch (pInfo->dataType)
{
case BIT32:
pt1 = (double) pInfo->data.ptr[pInfo->GO.gaps[(pInfo->GO.gapNum)*2]-1]; 
pt2 = (double) pInfo->data.ptr[pInfo->GO.gaps[(pInfo->GO.gapNum)*2+1]];
break;
case BIT16:
pt1 = (double) pInfo->data.sptr[pInfo->GO.gaps[GAPBEG]-1];
pt2 = (double) pInfo->data.sptr[pInfo->GO.gaps[GAPEND]];
break;
case MY_FLOAT:
pt1 = (double) pInfo->data.lptr[pInfo->GO.gaps[GAPBEG]-1];
pt2 = (double) pInfo->data.lptr[pInfo->GO.gaps[GAPEND]];
break;
case MY_DOUBLE:
pt1 = (double) pInfo->data.dptr[pInfo->GO.gaps[GAPBEG]-1];
pt2 = (double) pInfo->data.dptr[pInfo->GO.gaps[GAPEND]];
break;
}
pix_x0 = USER2PIXX(gr, pInfo->tm);
pix_y0 = USER2PIXY(gr, pt1);
if (pix_y0 < ANATOPM + pInfo->trcH*(pInfo->rec_no))
{ 
pix_y0 = ANATOPM + pInfo->trcH*(pInfo->rec_no);
}
if (pix_y0 > ANATOPM + pInfo->trcH*(pInfo->rec_no+1))
{ 
pix_y0 = ANATOPM + pInfo->trcH*(pInfo->rec_no+1);
}
pInfo->ptInc += (pInfo->inc * (gapInc));
pInfo->tm += (pInfo->tm_inc * (double) (gapInc));
pix_x1 = USER2PIXX(gr, pInfo->tm);
pix_y1 = USER2PIXY(gr, pt2);
if (pix_y1 < ANATOPM + pInfo->trcH*(pInfo->rec_no))
{ 
pix_y1 = ANATOPM + pInfo->trcH*(pInfo->rec_no);
}
if (pix_y1 > ANATOPM + pInfo->trcH*(pInfo->rec_no+1))
{ 
pix_y1 = ANATOPM + pInfo->trcH*(pInfo->rec_no+1);
}
if (pix_x1 > gr->pix_xmax)
pix_x1 = gr->pix_xmax;
gdk_draw_line(pixmap, pInfo->gc, pix_x0, pix_y0, pix_x1, pix_y1);
pInfo->GO.gapNum++;
pInfo->gc = GXC[NORMALGC][MAGNIFYSCR];
decInc = pInfo->GO.gaps[GAPBEG-1] - pInfo->ptInc;
}
}
else
{
decInc = pInfo->GO.gaps[GAPBEG] - pInfo->ptInc;
}
}
}
if (trcData->trace.overlaps)
{
for(pInfo->GO.olapNum=0, pInfo->GO.olaps = trcData->trace.overlaps; 
pInfo->GO.olapNum < trcData->trace.numOlaps &&     
pInfo->GO.olaps[OLAPBEG] < pInfo->ptInc;      
pInfo->GO.olapNum++);
if (pInfo->GO.olapNum)  
if (pInfo->ptInc < pInfo->GO.olaps[(pInfo->GO.olapNum-1)*2+1])
pInfo->GO.olapNum--;
if ((pInfo->ptInc > pInfo->GO.olaps[OLAPBEG]) &&
(pInfo->ptInc < pInfo->GO.olaps[OLAPEND]))
{
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNOLAP][NORMALGC];
pInfo->GO.olapON = TRUE;
}
}
pInfo->decInc = decInc;
pInfo->stop = pInfo->lastPoint;
if (pInfo->GO.olapON)
{
pInfo->stop = pInfo->GO.olaps[OLAPEND];  
}
else
{
if (pInfo->GO.gapNum < trcData->trace.numGaps)
{
pInfo->stop = pInfo->GO.gaps[GAPBEG];  
}
if (pInfo->GO.olapNum < trcData->trace.numOlaps) 
{
if (pInfo->GO.gapNum < trcData->trace.numGaps)
{ 
if (pInfo->GO.olaps[OLAPBEG] < pInfo->GO.gaps[GAPBEG])
{
pInfo->stop = pInfo->GO.olaps[OLAPBEG];  
}
}
else
{
pInfo->stop = pInfo->GO.olaps[OLAPBEG];  
}
}
}
return ret;
}
#define FLAGMARGIN 2
#define FLAGFACTOR 12
#define MAXFLAG  10
#define MINFLAG  5
static int *vertical, flagSize, totVert;
static int checkGO(GdkPixmap *pixmap, graph *gr, plotInfo *pInfo, int x, int y)
{
GdkPoint flag[3];
static int vertPos, gapIter;
int   gapInc, ret=FALSE, decInc;
int   pix_x0, pix_x1=0, pix_y1;
double  pt2=0;
gboolean gap = FALSE;
traceInfo *trcData = pInfo->trc;
if (stnSettings.display.overlay[stnStates.screen])
return ret;  
if (!flagSize)
{
flagSize = gr->pix_ydif/FLAGFACTOR;
flagSize = (flagSize > MAXFLAG) 
? MAXFLAG 
: ((flagSize < MINFLAG) 
? MINFLAG 
: flagSize);
totVert = 50; 
vertical = (int *) calloc(totVert, sizeof(int));
}
if (pInfo->GO.gapNum < trcData->trace.numGaps)
{ 
gapIter = 0;
vertPos=0;
while(x < vertical[vertPos])
vertPos++;
if (pInfo->ptInc+pInfo->decInc >= pInfo->GO.gaps[GAPBEG])
{ 
gap = TRUE;
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNGAPI][NORMALGC];
pix_x0 = USER2PIXX(gr, pInfo->tm);
if(!gapIter) 
gdk_draw_line(pixmap, pInfo->gc,
pix_x0, gr->pix_ymin + vertPos*(flagSize+1) + FLAGMARGIN, 
pix_x0, y);
flag[0].x = pix_x0;
flag[0].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + FLAGMARGIN;
flag[1].x = pix_x0;
flag[1].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + 
flagSize + FLAGMARGIN;
flag[2].x = pix_x0 + flagSize;
flag[2].y = gr->pix_ymin + vertPos*(flagSize+1) + gapIter*(flagSize+1) + 
flagSize/2 + FLAGMARGIN;
gdk_draw_polygon(pixmap, pInfo->gc, TRUE, flag, 3);
if (vertPos+gapIter>totVert)
{
totVert += 50;
vertical = (int *) realloc(vertical, totVert*sizeof(int));
}
vertical[vertPos+gapIter] = flag[2].x + 1;
gapIter++;
gapInc = (pInfo->GO.gaps[GAPEND] - 
pInfo->GO.gaps[GAPBEG] - 
(pInfo->ptInc - pInfo->GO.gaps[GAPBEG])) /
pInfo->inc;
if (gapInc)
{ 
switch (pInfo->dataType)
{
case BIT32:
pt2 = (double) pInfo->data.ptr[pInfo->GO.gaps[GAPEND]];
break;
case BIT16:
pt2 = (double) pInfo->data.sptr[pInfo->GO.gaps[GAPEND]];
break;
case MY_FLOAT:
pt2 = (double) pInfo->data.lptr[pInfo->GO.gaps[GAPEND]];
break;
case MY_DOUBLE:
pt2 = (double) pInfo->data.dptr[pInfo->GO.gaps[GAPEND]];
break;
}
pInfo->ptInc += (pInfo->inc * (gapInc));
pInfo->tm += (pInfo->tm_inc * (double) (gapInc));
pix_x1 = USER2PIXX(gr, pInfo->tm);
if (pInfo->tScale == FIXEDS ||
pInfo->tScale == CHNGROUPS)
{
if (pt2 < gr->user_ymin)
pt2 = gr->user_ymin;
if (pt2 > gr->user_ymax)
pt2 = gr->user_ymax;
}
pix_y1 = USER2PIXY(gr, pt2);
if (pix_x1 > gr->pix_xmax)
{
pix_x1 = gr->pix_xmax;
ret = TRUE;
}
if (pix_y1 < ANATOPM + pInfo->trcH * (pInfo->rec_no))
{
pix_y1 = ANATOPM + pInfo->trcH * (pInfo->rec_no);
ret = TRUE;
}
if (pix_y1 > ANATOPM + pInfo->trcH * (pInfo->rec_no+1))
{
pix_y1 = ANATOPM + pInfo->trcH * (pInfo->rec_no+1);
ret = TRUE;
}
gdk_draw_line(pixmap, pInfo->gc, pix_x0, y, pix_x1, pix_y1);
}
pInfo->GO.gapNum++;
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNFGBG][NORMALGC];
decInc = pInfo->GO.gaps[GAPBEG-1] - pInfo->ptInc;
pInfo->decInc = decInc;
}
else
{
decInc = 0;
}
}  
if (pInfo->GO.olapNum < trcData->trace.numOlaps)
{
if ( !pInfo->GO.olapON)
{
gapIter = 0;
vertPos=0;
while(x < vertical[vertPos])
vertPos++;
}
if (!pInfo->GO.olapON && 
pInfo->ptInc+pInfo->decInc >= pInfo->GO.olaps[OLAPBEG])
{ 
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNOLAP][NORMALGC];
if (gap)
x = pix_x1;
if(!gapIter) 
gdk_draw_line(pixmap, pInfo->gc, x, 
gr->pix_ymin + vertPos*(flagSize+1) + FLAGMARGIN, 
x, y);
flag[0].x = x;
flag[0].y = gr->pix_ymin + vertPos*(flagSize+1) + 
gapIter*(flagSize+1) + FLAGMARGIN;
flag[1].x = x;
flag[1].y = gr->pix_ymin+ + vertPos*(flagSize+1) + 
gapIter*(flagSize+1) + flagSize + FLAGMARGIN;
flag[2].x = x + flagSize;
flag[2].y = gr->pix_ymin+ vertPos*(flagSize+1) + 
gapIter*(flagSize+1) + flagSize/2 + FLAGMARGIN;
gdk_draw_polygon(pixmap, pInfo->gc, TRUE, flag, 3);
if (vertPos+gapIter>totVert)
{
totVert += 50;
vertical = (int *) realloc(vertical, totVert*sizeof(int));
}
vertical[vertPos+gapIter] = flag[2].x + 1;
gapIter++;
pInfo->GO.olapON = TRUE;
} 
if (pInfo->GO.olapON && pInfo->ptInc+pInfo->decInc >= 
pInfo->GO.olaps[OLAPEND])
{ 
pInfo->GO.olapNum++;
pInfo->gc = stnSettings.drawing.ctxts[stnStates.screen][STNFGBG][NORMALGC];
pInfo->GO.olapON = FALSE;
}
}  
pInfo->stop = pInfo->lastPoint;
if (pInfo->GO.olapON)
{
pInfo->stop = pInfo->GO.olaps[OLAPEND];  
}
else
{
if (pInfo->GO.gapNum < trcData->trace.numGaps)
{
pInfo->stop = pInfo->GO.gaps[GAPBEG];  
}
if (pInfo->GO.olapNum < trcData->trace.numOlaps) 
{
if (pInfo->GO.gapNum < trcData->trace.numGaps)
{ 
if (pInfo->GO.olaps[OLAPBEG] < 
pInfo->GO.gaps[GAPBEG])
{
pInfo->stop = pInfo->GO.olaps[OLAPBEG];  
}
}
else
{
pInfo->stop = pInfo->GO.olaps[OLAPBEG];  
}
}
}
return ret;
}
static void initData(plotInfo *plotI, traceInfo *trc, ANADATA *anaData, int recNo)
{
gboolean filtON = FALSE;
int   activeFilter;
DATAINFO *dataInfo;
char  *dataPtr;
flagSize = 0;
vertical = NULL;
plotI->tScale = stnSettings.display.yScale[stnStates.screen];
plotI->rec_no = recNo;
switch(stnStates.screen)
{
case STNMAIN:
activeFilter = stnStates.display.dataFilter.active;
filtON = stnStates.display.dataFilter.on;
dataPtr = trc->data.dataInfo.data;
plotI->samples = trc->data.dataInfo.head.numSamples;
break;
case STNANALYSIS:
activeFilter = stnStates.analysis.dataFilter.active;
filtON = stnStates.analysis.dataFilter.on;
dataPtr = anaData->dataInfo.data;
plotI->data.ptr = (gint32 *) dataPtr;   
plotI->data.lptr = (float *) dataPtr;
plotI->dataSize = sizeof(float);
plotI->dataType = MY_FLOAT;
plotI->samples = anaData->dataInfo.head.numSamples;
break;
}
if (filtON)
{
dataInfo = g_slist_nth_data(trc->data.dataFilt, activeFilter);
plotI->data.lptr = (float *) dataInfo->data;
plotI->dataType = MY_FLOAT;
plotI->dataSize = dsizes[plotI->dataType];
}
else if (stnStates.screen != STNANALYSIS)
{
plotI->dataType = trc->data.head.data_form;
plotI->dataSize = dsizes[plotI->dataType];
plotI->data.ptr = (gint32 *) dataPtr;
plotI->data.sptr = (short *) dataPtr;
plotI->data.lptr = (float *) dataPtr;
plotI->data.dptr = (double *) dataPtr;
}
if (stnSettings.display.overlay[stnStates.screen])
{
int gcidx = recNo % 30;
plotI->gc = OGXC[gcidx];
}
else
{
plotI->gc = stnSettings.drawing.ctxts[stnStates.screen][STNFGBG][NORMALGC];
}
plotI->GO.gaps = trc->trace.gaps;
plotI->GO.olaps = trc->trace.overlaps;
plotI->tm_inc = (double) (((trc->data.head.sampInt) / 1000000.) * ((float) plotI->inc));
plotI->GO.gapON = plotI->GO.olapON = FALSE;
plotI->GO.olapNum = plotI->GO.gapNum = 0;
plotI->decInc = 0;
#if 0
temp_float = ((1000000.0/trc->data.head.sampInt) *(trc->magnify.begin - trc->data.head.epochs));
temp_float_2 = ((ceil)(temp_float));
temp_int_2 = ((ceil)(temp_float)); 
temp_int = temp_int_2 * plotI->dataSize;
trc->magnify.data_start = (char *) (((int) plotI->data.ptr) + temp_int);
#endif
plotI->ptInc = ((long) trc->magnify.data_start - (long) plotI->data.ptr)/plotI->dataSize;
plotI->stop = plotI->samples;      
if (plotI->GO.gapNum < trc->trace.numGaps)
{
plotI->stop = plotI->GO.gaps[0];    
}
if (plotI->GO.olapNum < trc->trace.numOlaps) 
{
if (plotI->GO.gaps)
{ 
if (plotI->GO.olaps[0] < plotI->GO.gaps[0])
{
plotI->stop = plotI->GO.olaps[0];  
}
}
else
{
plotI->stop = plotI->GO.olaps[0];   
}
}
}
void stn_mag_plot(GdkPixmap *pixmap, graph *gr, traceInfo *trcData, ANADATA *anaData,
int inc, int recNo, int scr)
{
int  ndata;
int  y1, y2, pix_x0, pix_x1, pix_y0, pix_y1;
double fmax, fmin=0, fpt, sps, tmStart;
double ceil(), begin;
float l_trace;
int  width, height;
short *sptr;
gint32 *ptr;
float *lptr;
double *dptr;
plotInfo pInfo;
begin = trcData->magnify.begin;
ndata = trcData->magnify.num_points_shown;
if (!ndata) 
return;
memset(&pInfo, 0, sizeof(pInfo));
pInfo.trc = trcData;
l_trace = ((float) trcData->data.dataInfo.head.numSamples / 
(1000000. / trcData->data.head.sampInt));
pInfo.GO.gapON = pInfo.GO.olapON = FALSE;
pInfo.GO.olapNum = pInfo.GO.gapNum = 0;
tmStart = begin + trcData->magnify.offset;
pInfo.tm = tmStart;
pInfo.inc = inc;
pInfo.tm_inc = (double) (((trcData->data.head.sampInt) / 1000000.) * 
((float) pInfo.inc));
if(((ceil)(trcData->magnify.end)) == ((ceil)(l_trace)))
ndata -= inc;  
initData(&pInfo, trcData, anaData, recNo);
lptr = (float *) pInfo.data.lptr;
ptr = (gint32 *) pInfo.data.ptr;
sptr = (short *) pInfo.data.sptr;
dptr = (double *) pInfo.data.dptr;
gdk_drawable_get_size(pixmap, &width, &height);
switch(scr)
{
int trcCnt;
case STNANALYSIS:
trcCnt = g_slist_length(stnStates.analysis.traces);
pInfo.trcH = (height - (ANATOPM + ANABOTM))/trcCnt;
break;
}
pInfo.stop = pInfo.lastPoint = pInfo.ptInc + ndata + 1;
sps = 1000000. / (double) trcData->data.head.sampInt;
if (setGO(pixmap, gr, &pInfo))
{ 
return;
}
pix_x0 = pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
if (pInfo.tScale == FIXEDS ||
pInfo.tScale == CHNGROUPS)
{
if (fmin<gr->user_ymin)
fmin = gr->user_ymin;
if (fmin>gr->user_ymax)
fmin = gr->user_ymax;
}
pix_y0 = pix_y1 = USER2PIXY(gr, fmin);
for (; 
pInfo.ptInc < pInfo.lastPoint - pInfo.inc; 
pix_x0 = pix_x1, pix_y0 = pix_y1)
{
if (pInfo.inc > 1) 
{
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
fmax = fmin;
for (fpt = fmax;   
(pInfo.decInc < pInfo.inc) &&   
(pInfo.ptInc + pInfo.decInc < pInfo.stop); 
pInfo.decInc++) 
{
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fpt);
if (fpt < fmin)
{
fmin = fpt;
continue;
}
if (fpt > fmax)
fmax = fpt;
}
if (pInfo.tScale == FIXEDS ||
pInfo.tScale == CHNGROUPS)
{
if (fmin < gr->user_ymin)
fmin = gr->user_ymin;
if(fmax > gr->user_ymax)
fmax = gr->user_ymax;
if (fmin > gr->user_ymax)
fmin = gr->user_ymax;
if(fmax < gr->user_ymin)
fmax = gr->user_ymin;
}
y1 = USER2PIXY(gr, (double) fmin);
y2 = USER2PIXY(gr, (double) fmax);
gdk_draw_line(pixmap, pInfo.gc, pix_x1, y1, pix_x1, y2);
}   
if (pInfo.ptInc+pInfo.decInc == pInfo.stop) 
{ 
int lastStop = pInfo.stop;
if (checkGO(pixmap, gr, &pInfo, pix_x1, pix_y1) &&
pInfo.stop > lastStop)
break; 
while (pInfo.stop < lastStop)
{ 
pix_x1 = USER2PIXX(gr, (double) (pInfo.stop/sps));
lastStop = pInfo.stop;
if (checkGO(pixmap, gr, &pInfo, pix_x1, pix_y1) &&
pInfo.stop > lastStop)
break; 
}
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
if (pInfo.tScale == FIXEDS ||
pInfo.tScale == CHNGROUPS)
{
if (fmin<gr->user_ymin)
fmin = gr->user_ymin;
if (fmin>gr->user_ymax)
fmin = gr->user_ymax;
}
pix_x1 = USER2PIXX(gr, pInfo.tm);
pix_y1 = USER2PIXY(gr, fmin);
}
else
{ 
if(pInfo.inc == 1 && pInfo.ptInc+1 == pInfo.stop)
{ 
pInfo.decInc++;
continue;
}
pInfo.ptInc += pInfo.inc;
pInfo.tm += pInfo.tm_inc;
pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, (pInfo.ptInc), fmin);
if (pInfo.tScale == FIXEDS ||
pInfo.tScale == CHNGROUPS)
{
if (fmin<gr->user_ymin)
fmin = gr->user_ymin;
if (fmin>gr->user_ymax)
fmin = gr->user_ymax;
}
pix_y1 = USER2PIXY(gr, fmin);
gdk_draw_line(pixmap, pInfo.gc, pix_x0, pix_y0, pix_x1, pix_y1);
pInfo.decInc = 0;
}
}   
if (pInfo.inc > 1) 
{ 
DATAP(pInfo.dataType, (pInfo.ptInc), fmin);
fmax = fmin;
for (fpt = fmin, pInfo.decInc=0; 
pInfo.decInc + pInfo.ptInc < ndata;
pInfo.decInc++)
{
DATAP(pInfo.dataType, pInfo.decInc, fpt);
if (fpt < fmin)
fmin = fpt;
if (fpt > fmax)
fmax = fpt;
}
if (pInfo.tScale == FIXEDS ||
pInfo.tScale == CHNGROUPS)
{
if (fmin < gr->user_ymin)
fmin = gr->user_ymin;
if(fmax > gr->user_ymax)
fmax = gr->user_ymax;
if (fmin > gr->user_ymax)
fmin = gr->user_ymax;
if(fmax < gr->user_ymin)
fmax = gr->user_ymin;
}
y1 = USER2PIXY(gr, (double) fmin);
y2 = USER2PIXY(gr, (double) fmax);
gdk_draw_line(pixmap, pInfo.gc, pix_x1, y1, pix_x1, y2);
}   
if (vertical)
free(vertical);
}     
#define OVERLAPBOUND(bd) ((double) ((double) overlap->bounds[bd] / sps))
#if 0
static void 
plotOlap(GdkPixmap *pixmap, graph *gr, int record, char *udata, double begin, double end, int inc)
{
int y1, y2, pix_x0, pix_x1, pix_y0, pix_y1;
double fmax, fmin, fpt, offset;
double sps;
short *sptr;
gint32 *ptr;
float *lptr;
double *dptr;
plotInfo pInfo;
GSList *iter;
OVERLAP *overlap;
float plot_length;
int  ndata, startPt;
traceInfo *trcData = g_slist_nth_data(states.trace.selection, record);
memset(&pInfo, 0, sizeof(plotInfo));
offset = trcData->magnify.offset;
pInfo.inc = inc;
pInfo.gc = PGXC[MAGNIFYSCR][1];  
pInfo.tm_inc = (double) (((trcData->data.head.sampInt) / 1000000.) * ((float) pInfo.inc));
pInfo.ptInc = 0;
sps = 1000000. / (double) trcData->data.head.sampInt;
switch (trcData->data.head.data_form) 
{
case BIT32:
pInfo.dataSize = sizeof(gint32);
pInfo.dataType = BIT32;
break;
case BIT16:
pInfo.dataSize = sizeof(short);
pInfo.dataType = BIT16;
break;
case MY_FLOAT:
pInfo.dataSize = sizeof(float);
pInfo.dataType = MY_FLOAT;
break;
case MY_DOUBLE:
pInfo.dataSize = sizeof(double);
pInfo.dataType = MY_DOUBLE;
break;
}
startPt = ((int) udata - (int) trcData->data.dataInfo.data)/pInfo.dataSize;
for(iter=trcData->trace.olapData;
iter;
iter=g_slist_next(iter))
{ 
overlap = iter->data;
if (OVERLAPBOUND(START) > end ||
OVERLAPBOUND(END) < begin)
continue;
if (OVERLAPBOUND(START) < begin)
{ 
pInfo.ptInc = (begin - OVERLAPBOUND(START)) * sps;
pInfo.tm = begin + offset - (trcData->data.head.sampInt/1000000.);
}
else
{ 
pInfo.ptInc = 0; 
pInfo.tm = begin + offset + ((overlap->bounds[START]-startPt)/sps);
}
plot_length = trcData->magnify.end - trcData->magnify.begin;
ndata = (int) ((1000000. / trcData->data.head.sampInt) * plot_length);
pInfo.lastPoint = (pInfo.ptInc + ndata + 1) > overlap->len ? overlap->len : (pInfo.ptInc + ndata + 1);
switch (trcData->data.head.data_form) 
{
case BIT32:
ptr = pInfo.data.ptr = (gint32 *) overlap->data;
break;
case BIT16:
sptr = pInfo.data.sptr = (short *) overlap->data;
break;
case MY_FLOAT:
lptr = pInfo.data.lptr = (float *) overlap->data;
break;
case MY_DOUBLE:
dptr = pInfo.data.dptr = (double *) overlap->data;
break;
}
pix_x0 = pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, pInfo.ptInc, fmin);
pix_y0 = pix_y1 = USER2PIXY(gr, (double) fmin);
for ( pInfo.decInc = pInfo.ptInc%pInfo.inc+1; 
pInfo.ptInc < pInfo.lastPoint - pInfo.inc; 
pix_x0 = pix_x1, pix_y0 = pix_y1)
{
if (pInfo.inc > 1) 
{
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
fmax = fmin;
for ( fpt = fmax;        
(pInfo.decInc < pInfo.inc) &&   
(pInfo.decInc < overlap->len);
pInfo.decInc++) 
{
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fpt);
if (fpt < fmin)
{
fmin = fpt;
continue;
}
if (fpt > fmax)
fmax = fpt;
}
y1 = USER2PIXY(gr, (double) fmin);
y2 = USER2PIXY(gr, (double) fmax);
gdk_draw_line(pixmap, pInfo.gc, pix_x1, y1, pix_x1, y2);
}
pInfo.ptInc += pInfo.inc;
pInfo.tm += pInfo.tm_inc;
pix_x1 = USER2PIXX(gr, pInfo.tm);
DATAP(pInfo.dataType, (pInfo.ptInc), fmin);
pix_y1 = USER2PIXY(gr, (double) fmin);
gdk_draw_line(pixmap, pInfo.gc, pix_x0, pix_y0, pix_x1, pix_y1);
pInfo.decInc = 0;
}
if (pInfo.inc > 1) 
{ 
DATAP(pInfo.dataType, (pInfo.ptInc+pInfo.decInc), fmin);
fmax = fmin;
for (fpt = fmin;
pInfo.decInc + pInfo.ptInc < overlap->len;
pInfo.decInc++)
{
DATAP(pInfo.dataType, (pInfo.decInc), fpt);
if (fpt < fmin)
fmin = fpt;
if (fpt > fmax)
fmax = fpt;
}
y1 = USER2PIXY(gr, (double) fmin);
y2 = USER2PIXY(gr, (double) fmax);
gdk_draw_line(pixmap, pInfo.gc, pix_x1, y1, pix_x1, y2);
}  
}
}
#endif
#if 0
void magnify_proc(GtkWidget *da, GdkPixmap *pixmap, int wind_width, int wind_height, gboolean init)
{
graph *locGR = &states.trace.GR[states.currentScreen];
if (!locGR->pix_xmax) 
return;
if (!states.magnify.limits.selection.user.left && 
!states.magnify.limits.selection.user.right)
{ 
states.magnify.limits.selection.user.left = 
PIX2USERX(locGR, states.trace.limits.selection.pix[states.currentScreen].left);
if (states.trace.limits.selection.pix[states.currentScreen].right == 0) 
{
states.magnify.limits.selection.user.right = 
states.magnify.limits.selection.user.left + settings.magnify.length;
if (states.magnify.limits.selection.user.right > states.trace.plot.length[settings.trace.time])
states.magnify.limits.selection.user.right = states.trace.plot.length[settings.trace.time];
states.trace.limits.selection.pix[states.currentScreen].right = 
USER2PIXX(locGR, states.magnify.limits.selection.user.right);
}
else
states.magnify.limits.selection.user.right = 
PIX2USERX(locGR, states.trace.limits.selection.pix[states.currentScreen].right);
init = TRUE;
}
else
{ 
if (!states.user.drag.xAxis)
{ 
locGR = &states.trace.GR[states.currentScreen];
states.trace.limits.selection.pix[states.currentScreen].left = 
USER2PIXX(locGR, states.magnify.limits.selection.user.left);
states.trace.limits.selection.pix[states.currentScreen].right = 
USER2PIXX(locGR, states.magnify.limits.selection.user.right);
}
}
states.magnify.limits.selection.user.length = 
states.magnify.limits.selection.user.right - 
states.magnify.limits.selection.user.left;
states.trace.limits.selection.pix[states.currentScreen].length = 
states.trace.limits.selection.pix[states.currentScreen].right - 
states.trace.limits.selection.pix[states.currentScreen].left;
states.magnify.limits.selection.pix.left = states.magnify.limits.selection.pix.right = 0;
memset(&states.magnify.GR[states.currentScreen], 0, sizeof(states.magnify.GR[states.currentScreen]));
get_mag_times();
get_mag_max_mins(init);
mag_plot_files(da, pixmap, wind_width, wind_height, -1);
return;
}
#endif
