#!/bin/bash

# copy/extract the source files from the PQLX source tree
# but not the makefiles, these are PQL-specific and are already
# located in the destination directory
# this means that if the makefile changes in the PQLX source tree
# the change, if required for PQL, must be made by hand to the PQL-only version

# clean up the source directories first
/bin/rm PQL/src/*.c
/bin/rm PQL/utils/data/*.c
/bin/rm PQL/utils/hlpr/*.c
/bin/rm PQL/utils/tform/*.c
/bin/rm PQL/utils/tform/include/*.h
/bin/rm PQL/utils/gdbm/src/*.[ch]
#/bin/rm PQL/utils/gdbm/src/*.h
/bin/rm PQL/utils/dbl/src/*.[ch]
#/bin/rm PQL/utils/dbl/src/*.h
/bin/rm -fr PQL/contrib/*/*
/bin/rm -fr PQL/contrib/*/.svn
/bin/rm PQL/include/*
/bin/rm PQL/include/*/*
/bin/rm -fr PQL/include/*/.svn
/bin/rm PQL/utils/convLDB/*.[ch]

cp -r $PQLX/src/contrib/libmseed PQL/contrib
cp -r $PQLX/src/contrib/vfbb PQL/contrib
cp -r $PQLX/src/contrib/gdbm PQL/contrib
cp -r $PQLX/src/contrib/tdb PQL/contrib
cp -r $PQLX/src/utils/data/*.c PQL/utils/data
cp -r $PQLX/src/utils/data/include/*.h PQL/utils/data/include
cp -r $PQLX/src/utils/hlpr/*.c PQL/utils/hlpr
cp -r $PQLX/src/utils/tform/*.c PQL/utils/tform
cp -r $PQLX/src/utils/tform/include/*.h PQL/utils/tform/include
cp -r $PQLX/src/db/dbl/src/*.[ch] PQL/utils/dbl/src
#cp -r $PQLX/src/db/dbl/src/*.h PQL/utils/dbl/src
cp -r $PQLX/src/db/gdbm/src/*.[ch] PQL/utils/gdbm/src
#cp -r $PQLX/src/db/gdbm/src/*.h PQL/utils/gdbm/src
cp -r PQLX/PQL/src/*.c PQL/src
cp -r $PQLXINC/* PQL/include
cp -r $PQLX/src/utils/convLDB/*.[ch] PQL/utils/convLDB
cp PQLX/CMN/src/gtk_filters_cmn.c PQL/src

/bin/rm -fr PQL/contrib/*/.svn
/bin/rm -fr PQL/include/*/.svn
