#include <mysql.h>
#include <sys/time.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
extern GSList *ntw;
gboolean isPDFchn(char *channel);
int insertData(MYSQL *conn, SQLDI *sqldi)
{
int  ret=PQLXSUCCESS;
SQLDI evtdi;
gchar *sqlStr=NULL;
switch(sqldi->descr.tableData)
{
case LOGEXECTBL:
{ 
LOGIN *login = sqldi->data;
sqlStr = g_strdup_printf(SQL_LOGEXEC_PUT,
login->keys.pgmName);
ret = db_exec_sql(conn, sqlStr);
logKey = mysql_insert_id(conn);
bug15752(conn);
}
break;
case LOGTBLLOCK:
{
LOGMSG *logMsg = sqldi->data;
switch(GPOINTER_TO_INT(sqldi->data2))
{
case PQLXLOCK:
sqlStr = g_strdup_printf(SQL_LOGMSG_LOCK,
logMsg->keys.dbName);
break;
case PQLXUNLOCK:
sqlStr = g_strdup_printf(SQL_LOGMSG_UNLOCK,
logMsg->keys.dbName);
break;
}
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case LOGMSGTBL:
{ 
LOGMSG *logMsg = sqldi->data;
sqlStr = g_strdup_printf(SQL_LOGMSG_PUT,
logKey,
((logMsg->data.type == MSGTYPE_LOG) 
? 1
: 4),
logMsg->data.msg);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
}
break;
case SCANTBL:
{
SCAN *scan=sqldi->data;
if (scan->keys.scanType == PDFIMPORT)
{ 
sqlStr = g_strdup_printf(SQL_DIRS_PUT,
scanTypes[scan->keys.scanType],
scan->keys.directory,
scan->keys.scanTime);
ret = db_exec_sql(conn, sqlStr);
scan->keys.dirKey = mysql_insert_id(conn);
}            
sqlStr = g_strdup_printf(SQL_SCAN_PUT, 
scan->keys.dirKey, 
scan->keys.scanTime,
scan->data.nTrace, 
scan->data.nResp, 
scan->data.nNtw, 
scan->data.nStn,
scan->data.nLoc, 
scan->data.nChn);
ret = db_exec_sql(conn, sqlStr);
sqlStr = g_strdup_printf(SQL_EVENT_DIRS,
scan->keys.dirKey);
ret = db_exec_sql(conn, sqlStr);
}
break;
case TRCTBL:
{
TRC1 *trc1 = sqldi->data;
sqlStr = g_strdup_printf(SQL_TRC_INS,
trc1->keys.chnKey,
dataTypes[trc1->keys.fileType],
trc1->keys.directory,
trc1->keys.filename);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
memset(&evtdi, 0, sizeof(SQLDI));
evtdi.event.type = TRC1evt;
evtdi.event.typeKey = mysql_insert_id(conn);
evtdi.event.chnKey = trc1->keys.chnKey;
evtdi.descr.tableData = EVENT_PUT;
_db_event(conn, &evtdi);
}
break;
case RESPTBL:
{
TRC1 *trc1 = sqldi->data;
sqlStr = g_strdup_printf(SQL_RESP_INSSP,
trc1->keys.chnKey,
trc1->keys.directory,
trc1->keys.filename);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case IDTBL:
{
IDS *id = sqldi->data;
sqlStr = g_strdup_printf(SQL_IDS_PUT,
id->keys.type,
id->data.name);
ret = db_exec_sql(conn, sqlStr);
id->keys.idKey = mysql_insert_id(conn);
bug15752(conn);
}
break;
case CHNITBL:
{
int  chnKey;
CHNI *chni = sqldi->data;
sqlStr = g_strdup_printf(SQL_CHNI_PUT,
chni->keys.idKeys[0],
chni->keys.idKeys[1],
chni->keys.idKeys[2],
chni->keys.idKeys[3]);
ret = db_exec_sql(conn, sqlStr);
chnKey = chni->keys.chniKey = mysql_insert_id(conn);
bug15752(conn);
if (isPDFchn(chni->keys.name))
PSDTblProc(conn, chnKey);
#if 0
{
sqlStr = g_strdup_printf(SQL_PSDIDX_MKTBL, dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDD_MKTBL, dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_PDFD_MK, dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_PDFSH_MK, dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_PDFSS_MK, dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_BLINE_TBLMK, dbName, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_EVENT_PUTNP, PSDIDX, chnKey, 0, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
#endif
}
break;
case GLAPTBL:
{
TRC1  *trc1 = sqldi->data;
MYSQL_STMT *glapStmt = mysql_stmt_init(conn);
MYSQL_BIND param[4];
int   i, startPt, endPt;
char  insS[5], *gapT = "GAP", *olapT = "OLAP";
unsigned long typeLen;
if (!glapStmt)
{
fprintf(stderr, "Could not init insert statement for GLAP Table.\n");
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_GLAP_INS);
if (mysql_stmt_prepare(glapStmt, sqlStr, strlen(sqlStr)))
{
fprintf(stderr, "Could not prepare insert statement for GLAP Table.\n");
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
free(sqlStr);
break;
}
free(sqlStr);
memset(param, 0, sizeof(param));
param[0].buffer_type = MYSQL_TYPE_LONG;
param[0].buffer = (void *) &sqldi->event.typeKey;
param[0].is_unsigned = 0;
param[0].is_null = 0;
param[1].buffer_type = MYSQL_TYPE_STRING;
param[1].buffer = (void *) insS;
param[1].buffer_length = sizeof(insS);
param[1].is_null = 0;
param[1].length = &typeLen;
param[2].buffer_type = MYSQL_TYPE_LONG;
param[2].buffer = (void *) &startPt;
param[2].is_unsigned = 0;
param[2].is_null = 0;
param[3].buffer_type = MYSQL_TYPE_LONG;
param[3].buffer = (void * ) &endPt;
param[3].is_unsigned = 0;
param[3].is_null = 0;
if (mysql_stmt_bind_param(glapStmt, param))
{
fprintf(stderr, "Could not bind parameters for GLAP Table.\n");
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
break;
}
if (trc1->data.gaps)
{
strcpy(insS, gapT);
typeLen = strlen(insS);;
for(i=0;i<trc1->data.nGaps;i++)
{
startPt = trc1->data.gaps[i*2];
endPt = trc1->data.gaps[i*2+1];
if (mysql_stmt_execute(glapStmt))
{
fprintf(stderr, "Unable to insert to GLAP table (gap, i=%d)\n", i);
fprintf(stderr, "\tError %u (%s): %s\n",
mysql_stmt_errno(glapStmt),
mysql_stmt_sqlstate(glapStmt),
mysql_stmt_error(glapStmt));
ret = FAILURE;
break;
}
}
}
if (trc1->data.olaps)
{
strcpy(insS, olapT);
typeLen = strlen(insS);;
for(i=0;i<trc1->data.nOlaps;i++)
{
startPt = trc1->data.olaps[i*2];
endPt = trc1->data.olaps[i*2+1];
if (mysql_stmt_execute(glapStmt) != 0)
{
fprintf(stderr, "Unable to insert to GLAP table (overlap, i=%d)\n", i);
fprintf(stderr, "Error: %s\n", mysql_error(conn));
ret = FAILURE;
break;
}
}
}
mysql_stmt_close(glapStmt);
}
break;
case PSDTBLLOCK:
{
GSList  *PSDData = sqldi->data;
int chnKey = ((PSD1 *) (PSDData->data))->keys.chnKey;
switch(GPOINTER_TO_INT(sqldi->data2))
{
case PQLXLOCK:
sqlStr = g_strdup_printf(SQL_PSDD_LOCK,
dbName, chnKey);
break;
case PQLXUNLOCK:
sqlStr = g_strdup_printf(SQL_PSDD_UNLCK,
dbName, chnKey);
break;
}
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case PSDTBL:
{
GSList  *PSDData = sqldi->data, *iter;
int   type = GPOINTER_TO_INT(sqldi->data2);
PSD1  *psd = PSDData->data;
int   i, chnKey, strTtl;
char  *str;
gboolean valid = TRUE;
GPtrArray *strings;
chnKey = psd->keys.chnKey;
sqldi->descr.tableData = PSDTBLLOCK;
sqldi->data2 = GINT_TO_POINTER(PQLXLOCK);
insertData(conn, sqldi);
if (type == PSD2evt)
{ 
int   cnt;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
PSD1  *psdF = psd,
*psdL = (PSD1*)((g_slist_last(PSDData))->data);
sqlStr = g_strdup_printf(SQL_PSDD_DELCNT,
dbName, chnKey,
psdF->keys.trcKey,
psdF->data.sTime.date.yr,
psdF->data.sTime.date.jday,
psdF->data.sTime.date.hr, 
psdF->data.sTime.date.mn,
psdL->data.sTime.date.hr, 
psdL->data.sTime.date.mn,
(int) psdL->data.sTime.date.sec);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
goto PSDTBLINSLV;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
cnt = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
if (cnt > 0)
{
char *psdD = g_strdup_printf("`%sDATA`.`psd%d`", dbName, chnKey);
char *psdI = g_strdup_printf("`%sDATA`.`psd%didx`", dbName, chnKey);
sqlStr = g_strdup_printf(SQL_PSDD_DELD,
psdD, psdD, psdI,
psdD, psdI,
psdI, psdF->keys.trcKey,
psdI, psdF->data.sTime.date.yr, psdF->data.sTime.date.jday,
psdI, psdF->data.sTime.date.hr, psdF->data.sTime.date.mn, 
psdI, psdL->data.sTime.date.hr, psdL->data.sTime.date.mn, (int) psdL->data.sTime.date.sec);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
goto PSDTBLDONE;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDD_DELI,
psdI, psdI,
psdI, psdF->keys.trcKey,
psdI, psdF->data.sTime.date.yr, psdF->data.sTime.date.jday,
psdI, psdF->data.sTime.date.hr, psdF->data.sTime.date.mn, 
psdI, psdL->data.sTime.date.hr, psdL->data.sTime.date.mn, (int) psdL->data.sTime.date.sec);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
goto PSDTBLDONE;
}
PSDTBLDONE:
bug15752(conn);
free(psdD);  free(psdI);
if (ret == FAILURE)
{
goto PSDTBLINSLV;
}
}
}
for (iter = PSDData;
iter && valid;
iter = g_slist_next(iter))
{ 
psd = iter->data;
sqlStr = g_strdup_printf(SQL_PSDI_INS,
dbName, chnKey, 
psd->keys.trcKey,
psd->data.sTime.date.yr,
psd->data.sTime.date.jday,
psd->data.sTime.date.hr, 
psd->data.sTime.date.mn,
(int) psd->data.sTime.date.sec,
psd->data.eTime.date.hr, 
psd->data.eTime.date.mn,
(int) psd->data.eTime.date.sec);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
valid = FALSE;
continue;  
}
psd->data.psdKey = mysql_insert_id(conn); bug15752(conn);
}
if (!valid)  
{ 
goto PSDTBLINSLV;
}
for (iter = PSDData, strTtl = strlen(SQL_PSDD_INS1), strings = g_ptr_array_new();
iter;
iter = g_slist_next(iter))
{ 
psd = iter->data;
for (i=0;i<psd->data.nPeriods;i++)
{
str = g_strdup_printf("(%d,%.10f,%d)", 
psd->data.psdKey, 
psd->data.period[i], 
psd->data.power[i]);
strTtl += strlen(str) + 2;
if (strTtl >= 1024*1024)
{
insertPSD(conn, sqldi, chnKey, strings);
strings = g_ptr_array_new();
strTtl = strlen(SQL_PSDD_INS1) + strlen(str) + 2;
}
g_ptr_array_add(strings, str);
}
free(psd->data.period);
free(psd->data.power);
free(psd);
}
insertPSD(conn, sqldi, chnKey, strings);
PSDTBLINSLV:   
sqldi->descr.tableData = PSDTBLLOCK;
sqldi->data2 = GINT_TO_POINTER(PQLXUNLOCK);
insertData(conn, sqldi);
}
break;
#if 0
code replaced by CM version, this version is more efficient
case PSDTBL:
{
GSList  *PSDData = sqldi->data, *iter;
int   type = GPOINTER_TO_INT(sqldi->data2);
PSD1  *psd = PSDData->data;
int   i, chnKey, strTtl;
char  *str;
gboolean valid = TRUE;
GPtrArray *strings;
chnKey = psd->keys.chnKey;
sqldi->descr.tableData = PSDTBLLOCK;
sqldi->data2 = GINT_TO_POINTER(PQLXLOCK);
insertData(conn, sqldi);
if (type == PSD2evt)
{ 
int   cnt;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
PSD1  *psdF = psd,
*psdL = (PSD1*)((g_slist_last(PSDData))->data);
sqlStr = g_strdup_printf(SQL_PSDD_DELCNT,
dbName, chnKey,
psdF->keys.trcKey,
psdF->data.sTime.date.yr,
psdF->data.sTime.date.jday,
psdF->data.sTime.date.hr, 
psdF->data.sTime.date.mn,
psdL->data.sTime.date.hr, 
psdL->data.sTime.date.mn,
(int) psdL->data.sTime.date.sec);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
cnt = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set = NULL;
if (cnt > 0)
{
char *psdD = g_strdup_printf("`%sDATA`.`psd%d`", dbName, chnKey);
char *psdI = g_strdup_printf("`%sDATA`.`psd%didx`", dbName, chnKey);
sqlStr = g_strdup_printf(SQL_PSDD_DELD,
psdD, psdD, psdI,
psdD, psdI,
psdI, psdF->keys.trcKey,
psdI, psdF->data.sTime.date.yr, psdF->data.sTime.date.jday,
psdI, psdF->data.sTime.date.hr, psdF->data.sTime.date.mn, 
psdI, psdL->data.sTime.date.hr, psdL->data.sTime.date.mn, (int) psdL->data.sTime.date.sec);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
goto PSDTBLDONE;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDD_DELI,
psdI, psdI,
psdI, psdF->keys.trcKey,
psdI, psdF->data.sTime.date.yr, psdF->data.sTime.date.jday,
psdI, psdF->data.sTime.date.hr, psdF->data.sTime.date.mn, 
psdI, psdL->data.sTime.date.hr, psdL->data.sTime.date.mn, (int) psdL->data.sTime.date.sec);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
goto PSDTBLDONE;
}
PSDTBLDONE:
bug15752(conn);
free(psdD);  free(psdI);
if (ret == FAILURE)
{
sqldi->descr.tableData = PSDTBLLOCK;
sqldi->data2 = GINT_TO_POINTER(PQLXUNLOCK);
insertData(conn, sqldi);
break;
}
}
}
for (iter = PSDData;
iter && valid;
iter = g_slist_next(iter))
{ 
psd = iter->data;
sqlStr = g_strdup_printf(SQL_PSDI_INS,
dbName, chnKey, 
psd->keys.trcKey,
psd->data.sTime.date.yr,
psd->data.sTime.date.jday,
psd->data.sTime.date.hr, 
psd->data.sTime.date.mn,
(int) psd->data.sTime.date.sec,
psd->data.eTime.date.hr, 
psd->data.eTime.date.mn,
(int) psd->data.eTime.date.sec);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
valid = FALSE;
continue;  
}
psd->data.psdKey = mysql_insert_id(conn); bug15752(conn);
}
sqldi->descr.tableData = PSDTBLLOCK;
sqldi->data2 = GINT_TO_POINTER(PQLXUNLOCK);
insertData(conn, sqldi);
for (iter = PSDData, strTtl = strlen(SQL_PSDD_INS1), strings = g_ptr_array_new();
iter && valid;
iter = g_slist_next(iter))
{ 
psd = iter->data;
for (i=0;i<psd->data.nPeriods;i++)
{
str = g_strdup_printf("(%d,%.10f,%d)", psd->data.psdKey, 
psd->data.period[i], psd->data.power[i]);
strTtl += strlen(str) + 2;
if (strTtl >= 1024*1024)
{ 
insertPSD(conn, sqldi, chnKey, strings);
strings = g_ptr_array_new();
strTtl = strlen(SQL_PSDD_INS1) + strlen(str) + 2;
}
g_ptr_array_add(strings, str);
}
}
if (valid)
{ 
insertPSD(conn, sqldi, chnKey, strings);
}
}
break;
#endif
case CHNMETAINFOTBL:
case EVENTINFOTBL:
insertXML(conn, sqldi);
break;
case SYSPDFSTATS:
{
PDFSTATS *pdfStats = sqldi->data;
PDFSTATS1 *pdfStats1;
char  *valuesPtr, *str;
int   i, ttlPeriods, chnKey = GPOINTER_TO_INT(sqldi->data2);
GPtrArray *strings = g_ptr_array_new();
pdfStats1 = pdfStats->stats;
ttlPeriods = pdfStats->ttlPeriods;
for (i=0;i<ttlPeriods;i++)
{
str = g_strdup_printf("(%d,%.10f,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d)", 
pdfStats->pdfKey, 
pdfStats1[i].period, pdfStats1[i].statV[PDFSTAT_MIN], 
pdfStats1[i].statV[PDFSTAT_MAX], pdfStats1[i].statV[PDFSTAT_MODE],
pdfStats1[i].statV[PDFSTAT_MEDIAN], pdfStats1[i].statV[PDFSTAT_MEAN],
pdfStats1[i].statV[PDFSTAT_P5], pdfStats1[i].statV[PDFSTAT_P10], 
pdfStats1[i].statV[PDFSTAT_P25], pdfStats1[i].statV[PDFSTAT_P75], 
pdfStats1[i].statV[PDFSTAT_P90], pdfStats1[i].statV[PDFSTAT_P95]);
g_ptr_array_add(strings, str);
}
g_ptr_array_add(strings, NULL);
valuesPtr = g_strjoinv(",", (char **) strings->pdata);
sqlStr = g_strdup_printf(SQL_PDFST_STATSI,
dbName, chnKey, valuesPtr);
free(valuesPtr);
g_ptr_array_foreach(strings, (GFunc) freeStr, NULL);
g_ptr_array_free(strings, TRUE);
sqldi->event.errorNO = db_exec_sql(conn, sqlStr); bug15752(conn);   
}
break;
case TTMODELTBL:
{
TTINFO *ttInfo = sqldi->data;
int  *which = sqldi->data2;
switch(*which)
{
case MODELINSM:
{
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
GSList  *phaseI;
TTNAME *phase;
sqlStr = g_strdup_printf(SQL_MODEL_KEY,
ttInfo->keys.model->name);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
if (row)
{ 
int model_pk = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
sqlStr = g_strdup_printf(SQL_MODEL_DEL1, model_pk);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_MODEL_DEL2, model_pk);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_MODEL_DEL3, model_pk);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_MODEL_DEL4, model_pk);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_MODEL_OPT1);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_MODEL_OPT2);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
bug15752(conn);
}
else
{
mysql_free_result(res_set); res_set = NULL;
}
sqlStr = g_strdup_printf(SQL_MODEL_INSN,
ttInfo->keys.model->name);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
ttInfo->keys.model->key = mysql_insert_id(conn);
bug15752(conn);
for(phaseI = ttInfo->keys.model->phases;
phaseI;
phaseI = g_slist_next(phaseI))
{
phase = phaseI->data;
sqlStr = g_strdup_printf(SQL_MODEL_INSP,
ttInfo->keys.model->key,
phase->name);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
phase->key = mysql_insert_id(conn);
bug15752(conn);
}
}
break;
case MODELINST:
{
GSList *ttimeI=ttInfo->data.ttimes;
TTIME *ttime;
char *valuesPtr;
GPtrArray *strings = g_ptr_array_new();
for (ttimeI = ttimeI;
ttimeI;
ttimeI=g_slist_next(ttimeI))
{
ttime = ttimeI->data;
g_ptr_array_add(strings, g_strdup_printf("(%d,%d,%5.2f,%6.3f,%7.3f)", 
ttInfo->keys.model->key, ttime->phaseKey, 
ttime->depth, ttime->distance, ttime->ttime));
free(ttime);
}
g_ptr_array_add(strings, NULL);
valuesPtr = g_strjoinv(",", (char **) strings->pdata);
sqlStr = g_strdup_printf(SQL_MODEL_INST,
valuesPtr);
free(valuesPtr);
g_ptr_array_foreach(strings, (GFunc) freeStr, NULL);
g_ptr_array_free(strings, TRUE);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
bug15752(conn);
}
break;
case MODELINSB:
{
sqlStr = g_strdup_printf(SQL_MODEL_INSB1,
ttInfo->keys.model->key);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_MODEL_INSB2,
ttInfo->keys.model->key);
if ((ret = db_exec_sql(conn, sqlStr)) == SQL_FAILURE)
{
break;
}
bug15752(conn);
}
break;
}
}
break;
default:
fprintf(stderr, "Internal Error: No Database Table specified for insert operation.\n");
ret = FAILURE;
break;
}
return ret;
}
int updateByEvent(MYSQL *conn, SQLDI *sqldi)
{
int ret = PQLXSUCCESS;
gchar *sqlStr;
if (sqldi->event.errorNO)
{
sqlStr = g_strdup_printf(SQL_EVENT_END, 
sqldi->event.errorNO, 
sqldi->event.id);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
return ret;
}
switch(sqldi->event.type)
{
case TRC1evt:
{
TRC1 *trc1=sqldi->data;
sqlStr = g_strdup_printf(SQL_TRC1_VALS, 
trc1->data.sTime.date.yr,
trc1->data.sTime.date.mo,
trc1->data.sTime.date.day,
trc1->data.sTime.date.hr,
trc1->data.sTime.date.mn,
(int) trc1->data.sTime.date.sec,
trc1->data.sTime.m_secs,
trc1->data.eTime.date.yr,
trc1->data.eTime.date.mo,
trc1->data.eTime.date.day,
trc1->data.eTime.date.hr,
trc1->data.eTime.date.mn,
(int) trc1->data.eTime.date.sec,
trc1->data.eTime.m_secs,
trc1->data.stats[MAX], 
trc1->data.stats[MIN], 
trc1->data.stats[MEAN],
trc1->data.nGaps,
trc1->data.nOlaps,
trc1->data.nSamps,
trc1->data.sampInt,
sqldi->event.typeKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret == PQLXSUCCESS &&
(trc1->data.gaps || trc1->data.olaps))
{ 
sqldi->descr.tableData = GLAPTBL;
insertData(conn, sqldi);
}
}
break;
default:
break;
}
switch(sqldi->event.type)
{
case TRC1evt:
{ 
int  trcKey = sqldi->event.typeKey;
int  chnKey = sqldi->event.chnKey;
sqlStr = g_strdup_printf(SQL_EVENTQ_LOCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_EVENT_PSD1, trcKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_EVENT_FOLLOWUPS, chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
sqlStr = g_strdup_printf(SQL_EVENTQ_UNLCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case PSD1evt:
{
PSD1  *psd = sqldi->data;
int   trcKey = sqldi->event.typeKey;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
gboolean failure;
if (psd->keys.overlapPSD)
{
sqlStr = g_strdup_printf(SQL_EVENT_PSD2,
trcKey);
ret = db_exec_sql(conn, sqlStr);  
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
failure = (gboolean) atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
bug15752(conn);
if (failure)
{ 
sqlStr = g_strdup_printf(SQL_EVENT_PSD2ERR);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
fprintf(stderr, "There appears to be multiple versions of the same trace file in the DB:\n");
while ((row = mysql_fetch_row(res_set)))
{
fprintf(stderr, "\t%s\n", row[0]);
}
mysql_free_result(res_set); res_set = NULL;
bug15752(conn);
}
}
}
break;
default:
break;
}
sqldi->descr.tableData = EVENT_DEL;
ret = _db_event(conn, sqldi);
return ret;
}
int updateByData(MYSQL *conn, SQLDI *sqldi)
{
int ret = PQLXSUCCESS;
switch(sqldi->descr.tableData)
{
case SRVRCOMPLETE:
{
char *sqlStr;
sqlStr = g_strdup_printf(SQL_LOGEXEC_DONE, logKey);
ret = db_exec_sql(conn, sqlStr);
}
break;
}
return ret;
}
