#include <mysql.h>
#include <sys/time.h>
#include <stdlib.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
#include "xml_input.h"
int insertXML(MYSQL *conn, SQLDI *sqldi)
{
gchar   *sqlStr;
int   ret=PQLXSUCCESS;
switch(sqldi->descr.tableData)
{
case CHNMETAINFOTBL:
{
XMLINFO  *xmlInfo = sqldi->data;
GSList  *iter;
CHNMETAINFO *chnMETAInfo;
for(iter=xmlInfo->data.info; iter; iter = g_slist_next(iter))
{
chnMETAInfo = iter->data;
sqlStr = g_strdup_printf(SQL_CHNMETA_DEL,
chnMETAInfo->values[DBCHNMETACHNID],
chnMETAInfo->values[DBCHNMETASTART],
chnMETAInfo->values[DBCHNMETAEND]);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret == FAILURE)
break;
sqlStr = g_strdup_printf(SQL_CHNMETA_INS, 
chnMETAInfo->values[DBCHNMETACHNID],
chnMETAInfo->values[DBCHNMETASTART],
chnMETAInfo->values[DBCHNMETAEND],
chnMETAInfo->values[DBCHNMETALAT],
chnMETAInfo->values[DBCHNMETALON],
chnMETAInfo->values[DBCHNMETAELEV],
chnMETAInfo->values[DBCHNMETADEPTH],
chnMETAInfo->values[DBCHNMETASENSITIVITY],
chnMETAInfo->values[DBCHNMETAUNITS],
chnMETAInfo->values[DBCHNMETAINSTID],
chnMETAInfo->values[DBCHNMETAAZIMUTH],
chnMETAInfo->values[DBCHNMETADIP],
chnMETAInfo->values[DBCHNMETASAMPINT],
chnMETAInfo->values[DBCHNMETASITENAME]);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret == FAILURE)
break;
}
} 
break;
case EVENTINFOTBL:
{
XMLINFO  *xmlInfo = sqldi->data;
GSList  *iter, *magIter;
ORIGININFO *originInfo;
MAGINFO  *magInfo;
int   seisKey;
for(iter=xmlInfo->data.info; iter; iter = g_slist_next(iter))
{
originInfo = iter->data;
sqlStr = g_strdup_printf(SQL_SEISE_DEL,
originInfo->values[DBSEISORIGINID]);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret == FAILURE)
break;
sqlStr = g_strdup_printf(SQL_SEISE_INS,
originInfo->values[DBSEISDESCR],
originInfo->values[DBSEISEVENTID],
originInfo->values[DBSEISORIGINID],
originInfo->values[DBSEISCAT],
originInfo->values[DBSEISTIME],
originInfo->values[DBSEISMSEC],
originInfo->values[DBSEISLAT],
originInfo->values[DBSEISLON],
originInfo->values[DBSEISDEPTH]);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret == FAILURE)
break;
seisKey = mysql_insert_id(conn);
for(magIter = originInfo->mags;magIter;magIter=g_slist_next(magIter))
{
magInfo = magIter->data;
sqlStr = g_strdup_printf(SQL_SEISM_INS,
seisKey,
magInfo->values[DBMAGMAG],
magInfo->values[DBMAGTYPE]);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
if (ret == FAILURE)
break;
}
}
}
break;
}
return ret;
}
