#ifndef __DB_IFACE_DEFS_H
#define __DB_IFACE_DEFS_H
#ifndef MAXSTNLINES
#define MAXSTNLINES 36
#endif
enum { 
CONNECT,
RECONNECT,
DISCONNECT,
DISCONNECTSNGL,
EVENTQ,
GET_DATA,
INSERT_DATA,
UPDATE_DATA,
DELETE_DATA,
INIT,
METADATA,
SYSTEM_DATA,
DBUPGRADE,
DBMAINTAIN,
DBADMIN,
DBMAINTRUNNING,
TTLDBENTRY
};
enum { 
SYNC,
ASYNC
};
enum { 
PAUSEevt=0,
TRC1evt,
PSD1evt,
PSD2evt,
RESP1=10,
PSDIDX=90,
PSDDELTRC,
PSDDELCHN,
SPSE,
PSDDELDTE,
STATCHNI=97,
STATDIR,
SYSPDF=100,
SYSPDFPNG,
SYSSPECPNG,
SYSBLINECMP=110,
SRVRINIT=1000
};
enum {
SCANTBL=1,
EVTTBL,
EVENT_GET,
EVENT_PUT,
EVENT_PUTS,
EVENT_DEL,
EVENT_INPROC,
EVENT_PAUSE,
EVENT_PAUSE_INPROC,
EVENT_RESUME,
EVENT_GET_PAUSE,
EVENT_GET_RESUME,
EVENT_GET_UNPROC,
EVENT_GET_NOPROC,
EVENT_PUT_SYSPDF,
TRCTBL,
TRCTBLNEXT,
IDTBL,
CHNITBL,
GLAPTBL,
PSDTBLLOCK,
PSDTBL,
PSDTBLDEL,
RESPTBL,
CRASHEVENTS,
PSDTRC,
PSDHR,
PDFHR,
SPECTROTBL,
SRVRDBSL,
SRVRDBSR,
SRVRDBLST,
SRVRCOMPLETE,
PDFDATERNG,
PDFDATE,
PDFDATES,
PDFPERPOW,
PSDIDXLOCK,
IDXTMPTBL1,
IDXTMPTBL2,
STNINFO,
DTBNDRY,
STNPDF,
SRVRSTT,
PSDCFGPOWERBOUNDS,
PDFBOUNDSTBL,
CHNMETAINFOTBL,
CHNMETAINFOLIST,
EVENTINFOTBL,
DBLISTING,
PNGWWWDEF,
SYSBLINEDEFS,
SYSPDFDEFS,
SYSPDFSTATS,
PDFPERIODTTL,
PDFSTATLINES,
PDFMFRAME,
TTMODELTBL,
INSTRTBL,
TTLTBLQRYS
};
enum { 
ADMIN_DBDEL = TTLTBLQRYS,
ADMIN_DBCREATE,
ADMIN_DBSAVE,
ADMIN_DBINFO,
ADMIN_CHNINFO,
ADMIN_DDINFO,
ADMIN_REPSD,
LOGNEXTEXEC,
LOGEXECTBL,
LOGEXECUPD,
LOGMSGTBL,
LOGMSGTBLNEXT,
LOGTBLLOCK, 
ADMIN_EVENTQ,
SYSPDFREFRESH,
TTLADMINEVENTS
};
enum { 
SPCHNIUPD=TTLADMINEVENTS,
SYSDIRSTATS,
SYSSPSEPOCHS,
SYSBASELINE,
SYSPDFEVTS,
PNGEVTS,
PSDDELEVT,
PSDDELETIONS,
PSDCHNDELETE,
PSDDELDATE,
PSDDELFINISH, 
PDFTRUNC,
PDFTBL,
PSDINDECES,
SYSKEEPALIVE,
SYSDBTBLOPT,
SYSEVENTCLEAN,
SYSEVENTCNT,
SYSDBTMPDROP,
SYSDBPSDOPTCHANS,
SYSDBPSDDELCHAN,
SYSDBPSDCLEAN,
SYSDBLOGS,
SYSTBLOPT,
SYSDBGLAP,
SYSTRCDEL,
SYSMETATBLOPTEVENT,
SYSTBLREPAIR,
SYSSRVRFINISH,
TTLSYSEVENTS=SYSDBTMPDROP-TTLTBLQRYS
};
enum {
TRCCRASH,
SYSCRASH,
TTLCRASHTYPES
};
enum { 
DU_NONE,
DU_NEW,
DU_UPD,
TTLDUCMDS
};
enum { 
SRVRSTTCHN,
SRVRSTTTRC,
SRVRSTTMETA,
SRVRSTTPSD,
SRVRSTPSDOL,
SRVRSTPSDIDX,
SRVRSTSYSPDF,
TTLSRVRSTT
};
enum { 
MSGTYPE_LOG,
MSGTYPE_ERR,
MSGTYPE_BOTH,
TTLSRVRLOGTYPES
};
enum { 
EQ_EXEC,
EQ_QUED,
EQ_PEND,
EQ_DONE,
TTLEQSTATI
};
enum {
FILESCAN,
PDFIMPORT,
NUMSCANTYPES
};
enum { 
PDFREQ_YRSTART,
PDFREQ_YREND,
PDFREQ_DYSTARTM,
PDFREQ_DYSTARTD,
PDFREQ_DYENDM,
PDFREQ_DYENDD,
PDFREQ_HRSTARTH,
PDFREQ_HRSTARTM,
PDFREQ_HRSTARTS,
PDFREQ_HRENDH,
PDFREQ_HRENDM,
PDFREQ_HRENDS,
PDFREQ_FREQED,
PDFREQ_FREQFD,
PDFREQ_PERIODS,
PDFREQ_PERIODE,
PDFREQ_POWERS,
PDFREQ_POWERE,
MAXNUMPDFREQCRIT
};
#define TTLDTTMPDFREQ (PDFREQ_FREQFD+1)
enum { 
PDFSTAT_MIN,
PDFSTAT_MAX,
PDFSTAT_MODE,
PDFSTAT_MEDIAN,
PDFSTAT_MEAN,
PDFSTAT_P5,
PDFSTAT_P10,
PDFSTAT_P25,
PDFSTAT_P75,
PDFSTAT_P90,
PDFSTAT_P95,
TTLPDFSTATS
};
enum {
CHNSTART,
CHNEND,
TTLCHNBOUNDS
};
enum {
YMIN,
YMAX,
TTLYBOUNDS
};
enum {
PQLXLOCK,
PQLXUNLOCK
};
enum {
USERCPU,
ALLCPU,
TTLCPUTYPES
};
enum {
SYSPNGMAKE,
SYSPNGPROC
};
enum {
PDFTYPE_SYSTEM,
PDFTYPE_BASELINE,
PDFTYPE_REQUEST,
TTLPDFTYPES
};
enum {
IDX1,
CNT1,
IDX2,
CNT2,
TTLTMPTBLS
};
enum {
LONGNM,
TTLNAMETYPES
};
enum {
SQRSTNPDF=45,
SQRSTNMAIN=(SQRSTNPDF+MAXSTNLINES)
};
enum {
STNEVTHR,
STNEVTMN,
STNEVTSC,
STNEVTMSC,
STNEVTDY,
STNEVTMO,
STNEVTYR,
TTLSTNEVTTIMES,
STNEVTLAT=0,
STNEVTLON,
STNEVTDEP,
STNEVTMAG,
TTLSTNEVTLOCS,
TTLSTNEVENTINFO=(TTLSTNEVTTIMES+TTLSTNEVTLOCS)
};
enum {
MODELINSM,
MODELINST,
MODELINSB
};
#define MAXSQRCONNS (MAXSTNLINES*4+1)
#define LOGCONN (MAXSQRCONNS+1)
#define MAXDBCONNS (LOGCONN+1)
#define MAXPERSISTENT 25
enum {
DBVERSION0,
DBVERSION1,
DBVERSION2,
DBVERSION3,
DBVERSION4,
DBVERSION5,
DBVERSION6,
DBVERSION7,
DBVERSION8,
DBVERSION9,
DBVERSION10,
DBVERSION11,
DBVERSION12,
DBVERSION13,
DBVERSION14,
DBVERSION15,
DBVERSION16,
DBVERSION17,
DBVERSION18,
DBVERSION19,
DBVERSION20,
DBVERSION21,
DBVERSION22,
DBVERSION23,
DBVERSION24,
DBVERSION25,
DBVERSION26,
DBVERSION27,
DBVERSION28,
DBVERSION29,
DBVERSION30,
DBVERSION31,
DBVERSION32,
DBVERSION33,
DBVERSION34,
TTLDBVERSIONS
};
enum {
PDBVERSION0,
PDBVERSION1,
PDBVERSION2,
PDBVERSION3,
TTLPDBVERSIONS
};
#endif
