#ifndef __DBLF_H
#define __DBLF_H
#include <time.h>
#include <glib.h>
#include "ptime.h"
#include "db_iface_defs.h"
#include "dbl_iface_defs.h"
typedef struct _DATAL_INFO
{ 
int tableData; 
int dataEvent; 
} DATAL_INFO;
typedef struct _DBLDI
{ 
DATAL_INFO descr;
void *data;
void *data2;
} DBLDI;
typedef struct _DBLRECORDS
{
int numRecs;
void **recs;
} DBLRECORDS;
typedef struct _DEFAULTS_REC
{
char name[100];
char value[255];
} DEFAULTS_REC;
typedef struct _FILTER_REC
{
char name[FNAMELEN];
int poles[2];
float cutoff[2];
} FILTER_REC;
#ifndef PQL_ONLY
typedef struct _PDF_REC
{
char name[25];
float criteria[MAXNUMPDFREQCRIT];
} PDF_REC;
typedef struct _PDF
{
int numRecs;
PDF_REC *recs;
} PDF;
typedef struct _PDFSRVR_REC
{
char *name;
} PDFSRVR_REC;
typedef struct _STN_CHN_FILTER
{
char *name;
} STN_CHN_FILTER;
typedef struct _STN_CHN_YSCALE
{
char *name;
char *loc, *chn;
char *scale[2];
} STN_CHN_YSCALE;
typedef struct _STN_GRP_YSCALE
{
char *name;
GSList *chns; 
} STN_GRP_YSCALE;
#endif
#endif
