#include "pql_version.h"
#include "pql_defines.h"
#include "pql_externs.h"
#include "pqlx_externs.h" 
#include "gtk_pql_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
void logMsg(int type, gpointer d)
{
switch (type)
{
case LOGMSG_PROG_STARTUP:
{
LOGIN *login = (LOGIN *) d;
int  numCPUs = login->keys.numCPUs;
switch (numCPUs)
{
case 1:
fprintf(stdout, "%s Process Started (version %s):\t(%d CPU)\n", 
login->keys.pgmName, PROG_VERSION, login->keys.numCPUs);
break;
default:
fprintf(stdout, "%s Process Started (version %s):\t(%d CPU's)\n", 
login->keys.pgmName, PROG_VERSION, login->keys.numCPUs);
break;
}
}
break;
case LOGMSG_PROG_QUIT:
{
char *procName = (char *) d;
fprintf(stdout, "%s %s\n", procName, PQLXENDEDMSG);
}
break;
case LOGMSG_CONN_ATTEMPT:
{
LOGIN *login = (LOGIN *) d;
fprintf(stdout, "Attempting to Connect to MySQL DB Server:\t");
fprintf(stdout, "(PQLX DB = '%s', Server = '%s')\n", 
login->keys.dbname, login->keys.hostname);
}
break;
case LOGMSG_CONN_SUCCESS:
{
LOGIN *login = (LOGIN *) d;
fprintf(stdout, "Connection to MySQL DB Server Successful:\t");
fprintf(stdout, "(PQLX DB Version 0.%d)\n", 
login->data.dbVersion);
}
break;
}
}
