#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <sys/types.h>
#include <dirent.h>
#include "PSD.h"
char outFile[255];
static FILE *dbg1, *dbg2, *dbg3, *dbg4, *dbg8;
void debugOUT(char *output, int debugFile)
{
strcpy(outFile, StnInfo.AnalysisDir);
strcat(outFile, "dbg/");
mkdir(outFile, S_IRUSR|S_IWUSR|S_IXUSR|
S_IRGRP|S_IWGRP|S_IXGRP|
S_IROTH|S_IWOTH|S_IXOTH);
switch(debugFile)
{
case 1: 
if (!dbg1) 
{
strcat(outFile, "datatrace1.txt");
if((dbg1 = fopen(outFile, "w")) == NULL) 
{
printf("Unable to open output file %s\n", outFile);
}
}
fprintf(dbg1, "%s", output);
break;
case 2:
if (!dbg2) {
strcat(outFile, "datatrace2.plt");
if((dbg2 = fopen(outFile, "w")) == NULL) 
{
printf("Unable to open output file %s\n", outFile);
return;
}
fprintf(dbg2, "%s", "<?xml version=\"1.0\" standalone=\"no\"?>\n");
fprintf(dbg2, "%s", "<!DOCTYPE model PUBLIC \"-//UC Berkeley//DTD PlotML 1//EN\"\n");
fprintf(dbg2, "%s", "\"http://ptolemy.eecs.berkeley.edu/xml/dtd/PlotML_1.dtd\">\n");
fprintf(dbg2, "%s", "<plot>\n");
fprintf(dbg2, "%s", "<xLog/>\n");
fprintf(dbg2, "%s", "<dataset name=\"fft\" marks=\"points\" connected=\"yes\" stems=\"no\">\n");
}
fprintf(dbg2, "%s", output);
break;
case 3:
if (!dbg3) {
strcat(outFile, "datatrace3.txt");
if((dbg3 = fopen(outFile, "w")) == NULL) 
{
printf("Unable to open output file %s\n", outFile);
}
}
fprintf(dbg3, "%s", output);
break;
case 4:
if (!dbg4) {
strcat(outFile, "dantaper/datatrace4.plt");
if((dbg4 = fopen(outFile, "w")) == NULL) 
{
printf("Unable to open output file %s\n", outFile);
return;
}
fprintf(dbg4, "%s", "<?xml version=\"1.0\" standalone=\"no\"?>\n");
fprintf(dbg4, "%s", "<!DOCTYPE model PUBLIC \"-//UC Berkeley//DTD PlotML 1//EN\"\n");
fprintf(dbg4, "%s", "\"http://ptolemy.eecs.berkeley.edu/xml/dtd/PlotML_1.dtd\">\n");
fprintf(dbg4, "%s", "<plot>\n");
fprintf(dbg4, "%s", "<dataset name=\"noise\" marks=\"points\" connected=\"yes\" stems=\"no\">\n");
}
fprintf(dbg4, "%s", output);
break;
case 8: 
if (!dbg8) {
strcat(outFile, "FFT.txt");
if((dbg8 = fopen(outFile, "w")) == NULL) 
{
printf("Unable to open output file %s\n", outFile);
}
}
fprintf(dbg8, "%s", output);
break;
default:;
}
}
void debugFlData(float *data, int numSamps, int file)
{
char outStr[255];
int i;
static int done1=FALSE, done2=FALSE, done3=FALSE, iter1=0, iter2=0, iter3=0, iter4=0;
FILE *fp;
strcpy(outFile, StnInfo.AnalysisDir);
strcat(outFile, "dbg/");
mkdir(outFile, S_IRUSR|S_IWUSR|S_IXUSR|
S_IRGRP|S_IWGRP|S_IXGRP|
S_IROTH|S_IWOTH|S_IXOTH);
switch(file)
{
case 1:
if (done1) return;
done1 = TRUE;
break;
case 2:
if (done2) return;
done2 = TRUE;
break;
case 3:
if (done3) return;
done3 = TRUE;
break;
case 4:
sprintf(outFile, "FFTsection%d.plt", ++iter1);
if((fp = fopen(outFile, "w")) == NULL) 
{
printf("Unable to open output file %s\n", outFile);
return;
}
fprintf(fp, "%s", "<?xml version=\"1.0\" standalone=\"no\"?>\n");
fprintf(fp, "%s", "<!DOCTYPE model PUBLIC \"-//UC Berkeley//DTD PlotML 1//EN\"\n");
fprintf(fp, "%s", "\"http://ptolemy.eecs.berkeley.edu/xml/dtd/PlotML_1.dtd\">\n");
fprintf(fp, "%s", "<plot>\n");
fprintf(fp, "%s", "<dataset name=\"noise\" marks=\"points\" connected=\"yes\" stems=\"no\">\n");
for(i=0;i<numSamps;i++) 
{
sprintf(outStr, "<p x=\"%d\" y=\"%f\">\n", i+1, *(data+i));
fprintf(fp, outStr);
}
fprintf(fp, "</dataset>\n");
fprintf(fp, "</plot>\n");
fclose(fp);
return;
break;
case 5:
sprintf(outFile, "dantaper%d.plt", ++iter2);
if((fp = fopen(outFile, "w")) == NULL) 
{
printf("Unable to open output file %s\n", outFile);
return;
}
fprintf(fp, "%s", "<?xml version=\"1.0\" standalone=\"no\"?>\n");
fprintf(fp, "%s", "<!DOCTYPE model PUBLIC \"-//UC Berkeley//DTD PlotML 1//EN\"\n");
fprintf(fp, "%s", "\"http://ptolemy.eecs.berkeley.edu/xml/dtd/PlotML_1.dtd\">\n");
fprintf(fp, "%s", "<plot>\n");
fprintf(fp, "%s", "<dataset name=\"noise\" marks=\"points\" connected=\"yes\" stems=\"no\">\n");
for(i=0;i<numSamps;i++) 
{
sprintf(outStr, "<p x=\"%d\" y=\"%f\">\n", i+1, *(data+i));
fprintf(fp, outStr);
}
fprintf(fp, "</dataset>\n");
fprintf(fp, "</plot>\n");
fclose(fp);
return;
break;
case 6:
sprintf(outFile, "ribtaper%d.plt", ++iter3);
if((fp = fopen(outFile, "w")) == NULL) 
{
printf("Unable to open output file %s\n", outFile);
return;
}
fprintf(fp, "%s", "<?xml version=\"1.0\" standalone=\"no\"?>\n");
fprintf(fp, "%s", "<!DOCTYPE model PUBLIC \"-//UC Berkeley//DTD PlotML 1//EN\"\n");
fprintf(fp, "%s", "\"http://ptolemy.eecs.berkeley.edu/xml/dtd/PlotML_1.dtd\">\n");
fprintf(fp, "%s", "<plot>\n");
fprintf(fp, "%s", "<dataset name=\"noise\" marks=\"points\" connected=\"yes\" stems=\"no\">\n");
for(i=0;i<numSamps;i++) 
{
sprintf(outStr, "<p x=\"%d\" y=\"%f\">\n", i+1, *(data+i));
fprintf(fp, outStr);
}
fprintf(fp, "</dataset>\n");
fprintf(fp, "</plot>\n");
fclose(fp);
return;
break;
case 7:
sprintf(outFile, "dantaper%d.plt", ++iter4);
if((fp = fopen(outFile, "w")) == NULL) 
{
printf("Unable to open output file %s\n", outFile);
return;
}
fprintf(fp, "%s", "<?xml version=\"1.0\" standalone=\"no\"?>\n");
fprintf(fp, "%s", "<!DOCTYPE model PUBLIC \"-//UC Berkeley//DTD PlotML 1//EN\"\n");
fprintf(fp, "%s", "\"http://ptolemy.eecs.berkeley.edu/xml/dtd/PlotML_1.dtd\">\n");
fprintf(fp, "%s", "<plot>\n");
fprintf(fp, "%s", "<dataset name=\"noise\" marks=\"points\" connected=\"yes\" stems=\"no\">\n");
for(i=0;i<numSamps;i++) 
{
sprintf(outStr, "<p x=\"%d\" y=\"%f\">\n", i+1, *(data+i));
fprintf(fp, outStr);
}
fprintf(fp, "</dataset>\n");
fprintf(fp, "</plot>\n");
fclose(fp);
return;
break;
}
for(i=0;i<numSamps;i++) 
{
sprintf(outStr, "%d:\t\t%8.2f\n", i+1, *(data+i));
debugOUT(outStr, file);
}
}
void debugIntData(int *data, int numSamps)
{
char outStr[255];
int  i;
static int done=0;
for(i=0;i<numSamps;i++) 
{
sprintf(outStr, "%d:\t\t%d\n", i+1, *(data+i));
debugOUT(outStr, 2);
}
}
void debugSeisData(SEIS_DATA *data, int file)
{
char outStr[255];
int  i;
DType *period=data->period, *power=data->power;
for(i=0;i<data->cnt;i++, period++, power++) 
{
sprintf(outStr, "%d:\t\t%f\t%f\n", i, *period, *power);
debugOUT(outStr, file);
}
}
void debugClose()
{
if (dbg1) fclose(dbg1);
if (dbg2) {
fprintf(dbg2, "</dataset>\n");
fprintf(dbg2, "</plot>\n");
fclose(dbg2);
}
if (dbg3) fclose(dbg3);
if (dbg4) {
fprintf(dbg4, "</dataset>\n");
fprintf(dbg4, "</plot>\n");
fclose(dbg4);
}
if (dbg8) fclose(dbg8);
}
