#ifndef __PDFGLOBS_include
#define __PDFGLOBS_include
extern int dsizes[TTLDTYPES];
void debugOUT(char *string, int outFile);
void debugFlData(float *data, int numSamps, int file);
void debugIntData(int *data, int numSamps);
void debugSeisData(SEIS_DATA *data, int file);
void debugClose();
void *myMalloc(int size);
void *myRealloc(void *ptr, int size);
void myFree(void *ptr);
int readTracePSD1(PSD_DATA *, PSD1 *);
int readTracePSD2(PSD_DATA *analysis, PSD1 *psd);
int getRealData(PSDSTRUCTS *psdStructs);
int PSD_analyze(RDATA *realData, PSD_DATA *analysis);
int PSD_smooth(PSD_DATA *analysis);
int PSD_smooth1(PSD_DATA *analysis);
int PSD_bin(PSD_DATA *analysis);
int remResp(PSD_DATA *analysis, gboolean reRead);
void cleanUP(PSDSTRUCTS*);
void free_PSDDATA(PSD_DATA *analysis);
void storePDFResults(PSD_DATA *analysis, PSD1 *psd);
void DbPDFResults(int type);
extern TRCDATAINFO trcInfo;
extern STN_DATA StnInfo;
#endif
