#include "globmatch.h"
#define GLOBMATCH_TRUE 1
#define GLOBMATCH_FALSE 0
int
globmatch (char *string, char *pattern)
{
int negate;
int match;
int c;
while ( *pattern )
{
if ( !*string && *pattern != '*' )
return GLOBMATCH_FALSE;
switch ( c = *pattern++ )
{
case '*':
while ( *pattern == '*' )
pattern++;
if ( !*pattern )
return GLOBMATCH_TRUE;
if ( *pattern != '?' && *pattern != '[' && *pattern != '\\' )
while ( *string && *pattern != *string )
string++;
while ( *string )
{
if ( globmatch(string, pattern) )
return GLOBMATCH_TRUE;
string++;
}
return GLOBMATCH_FALSE;
case '?':
if ( *string )
break;
return GLOBMATCH_FALSE;
case '[':
if ( *pattern != GLOBMATCH_NEGATE )
negate = GLOBMATCH_FALSE;
else
{
negate = GLOBMATCH_TRUE;
pattern++;
}
match = GLOBMATCH_FALSE;
while ( !match && (c = *pattern++) )
{
if ( !*pattern )
return GLOBMATCH_FALSE;
if ( *pattern == '-' )  
{
if ( !*++pattern )
return GLOBMATCH_FALSE;
if ( *pattern != ']' )
{
if ( *string == c || *string == *pattern ||
( *string > c && *string < *pattern ) )
match = GLOBMATCH_TRUE;
}
else
{  
if ( *string >= c )
match = GLOBMATCH_TRUE;
break;
}
}
else   
{
if ( c == *string )
match = GLOBMATCH_TRUE;
if ( *pattern != ']' )
{
if ( *pattern == *string )
match = GLOBMATCH_TRUE;
}
else
break;
}
} 
if ( negate == match )
return GLOBMATCH_FALSE;
while ( *pattern && *pattern != ']' )
pattern++;
if ( !*pattern++ ) 
return GLOBMATCH_FALSE;
break;
case '\\':
if ( *pattern )
c = *pattern++;
default:
if ( c != *string )
return GLOBMATCH_FALSE;
break;
}
string++;
}
return !*string;
}
