#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_pdf.h"
GtkWidget *PSDnb;      
GtkWidget *PSDbooks[TTLPSDNB];  
GtkWidget *pdfCtrlWindow;    
GtkWidget *reqWndw, *movieWndw;
GtkWidget *PSDCTRLnb;      
GtkWidget *PSDCTRLbooks[TTLPSDNB];  
GtkWidget *MPDFDA[MMAXPDFROWS][MMAXPDFCOLS];
GtkWidget *DPDFDA[DMAXPDFROWS][DMAXPDFCOLS];
GtkWidget *RPDFDA[RMAXPDFROWS][RMAXPDFCOLS];
GtkWidget *MVPDFDA[TTLMOVIESCREENS];
GtkWidget *SPMAINDA[SMAXROWS][SMAXCOLS];
GtkWidget *SPREQDA[SMAXROWS][SMAXCOLS];
GtkWidget  *Mrowlbl[MMAXPDFROWS][NUMIDS],  
*Mcollbl[MMAXPDFCOLS];    
GtkWidget *pMdisp[NUMPDFMAINDISPLAYMODES]; 
GtkWidget *md1NSL, *md1CHNG, *md1PDF1, *md1PDF2, *md1PDF3;   
GtkWidget *md2PDF, *md2NSL1, *md2NSL2, *md2NSL3, *md2CHNG;   
GtkWidget *md3CHN1, *md3CHN2, *md3CHN3, *md3PDF1, *md3PDF2, *md3PDF3; 
GtkWidget *md4PDF, *chnCntLbl;          
GtkWidget *statusBarPDF;
GtkWidget *dHrMode, *dTrc;
GtkWidget *pdfStart, *CWBServer, *CWBPort;
GtkWidget *pdfDtailCnt;
GtkWidget *pdfTrcW[MAXTRCEXTRACTS];
GtkWidget *rdCHN;
GtkWidget *reqBy[NUMREQTYPES], *rYR[2], *rDY[2][2], *rYRF,
*rHR[2][2], *rDYA[2], *rFREQ[2], *rFREQF, *rAGOF, *rMDF;
GtkWidget *rdCHNmv;
GtkWidget *mDY[PDFREQBOUNDS][PDFREQDAYS], *mHR[PDFREQBOUNDS][PDFREQHOURS], *mINT;
GtkWidget *mCmd[TTLMOVIESCREENS][TTLPDFMCMDBUTTONS], *ctrlBarEB[TTLMOVIESCREENS];
GtkWidget *mvDisp[TTLMOVIEDISPLAYS];
GtkWidget *mCUM[2], *mFR[TTLMOVIESCREENS], *mDT[TTLMOVIESCREENS][2];
GtkWidget *movieDisp, *movieDispCell;
GtkWidget *SPpdf, *SPchnFilt, *SPchnCnt;
GtkWidget *pdfPane[TTLSPECTROTABS];
GtkWidget *pdfDisp[TTLSPECTROTABS][2];
GtkWidget *reqDispCell[TTLPDFREQTYPES], *reqMenu[TTLPDFREQTYPES];
GtkWidget *axisBnds[TTLPDFSCREENS][TTLPERBOUNDS];
GtkWidget *pdfStats[TTLPDFSCREENS][TTLPDFSTATS]; 
GtkWidget *pdfColors[TTLPDFSCREENS];
GtkWidget *ctrlBar;
GtkWidget *pdfSrvrDefault[2];
GtkWidget *pdfDateFormat;
GtkWidget *fdUnit;
GtkWidget *spZoomPct;
GtkWidget *blineOptions, *blPct;
GSList  *PSDblineCtrlR;       
GtkWidget *PSDsb[TTLPDFSCREENS];   
GtkWidget *MButtons[NUMPDFMAINDISPLAYMODES]; 
GtkWidget *PDFeventB[1];      
GtkWidget *chnFilterPDF;
GtkTreeStore *storeNSL, *storeCHN, *storeCHNG, *storePDF;
GtkTreeIter nslNI, nslSI, nslLI;    
GtkTreeIter nslcNI, nslcSI, nslcLI, nslcCI; 
GtkTreeIter chnGI;        
GtkTreeIter pdf1I, pdf2I;      
GPtrArray *pdfSensitives[TTLPDFSENSARRAYS][TTLPDFSCREENS];
gulong pdfSignals[MAXPDFSIGNALTYPES];
const int scrSizes[TTLPDFSCREENS][2] = 
{{MMAXPDFROWS, MMAXPDFCOLS},
{DMAXPDFROWS, DMAXPDFCOLS},
{RMAXPDFROWS, RMAXPDFCOLS},
{MVMAXROWS, MVMAXCOLS},
{SMAXROWS, SMAXCOLS},
{SMAXROWS, SMAXCOLS}};
char *pdfNBNames[TTLPDFTABS] = {" System ", " Detail ", " Request ", " Movie "};
char *spectroNBNames[TTLSPECTROTABS] = {" System ", " Detail/Request "};
char *dateFormats[TTLPDFDATEFORMATS] = { "YYYY.DDD", "YYYY-MM-DD", "DD-MM-YYYY", "DD-mmm-YYYY" };
char *reqDispCells[TTLREQDISPCELLS] = {"Upper Left", "Upper Middle", "Upper Right",
"Middle Left", "Middle Middle", "Middle Right",
"Lower Left", "Lower Middle", "Lower Right"};
char *spectroDispCells[NUMSPLITSCRNS] = {"TOP", "MIDDLE", "BOTTOM" };
char *movieDispCells[TTLMOVIEDISPCELLS] = {"Upper Left", "Upper Right",
"Lower Left", "Lower Right"};
char *zoomScope[TTLZOOMSCOPES] = { "Single", "All" };
PDFSTATES pdfStates;
PDFSETTINGS pdfSettings, ctrlPdfSettings;
GQueue *resizeQ[TTLMOVIESCREENS];
#ifdef DBG_PDF_DETAIL
FILE *dbgFP;
#endif
