#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
static GtkTooltips *tips;
static char  toolTip[1000];
static GtkSizeGroup *size_group;
static void cancelMovieReq(GtkWidget *widget, gpointer nil)
{
gtk_grab_remove(movieWndw);
gtk_widget_hide(movieWndw);
}
static GtkWidget *make_MovieEntries()
{
GtkWidget  *control_box, *controlFrame, *controlBox, 
*eBox, *box, *label, *frame, *box2, *entry,
*radioB, *actionB, *button, *sep;
tips = gtk_tooltips_new();
control_box = gtk_event_box_new();
controlFrame = gtk_frame_new(NULL);
controlBox = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(controlBox), 5);
gtk_container_add(GTK_CONTAINER(controlFrame), controlBox);
gtk_container_add(GTK_CONTAINER(control_box), controlFrame);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &settings.colors.sb[0]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label), (const gchar *) 
"<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">REQUEST A MOVIE</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame = gtk_frame_new("Bounds");
box = gtk_vbox_new(TRUE, 3);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Start Day:");
gtk_size_group_add_widget(size_group, label);
mDY[PDFREQSTART][PDFREQYR] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
label = gtk_label_new("/");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
mDY[PDFREQSTART][PDFREQMO] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
label = gtk_label_new("/");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
mDY[PDFREQSTART][PDFREQDY] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
label = gtk_label_new(" YYYY/MM/DD");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), box2, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("End Day:");
gtk_size_group_add_widget(size_group, label);
mDY[PDFREQEND][PDFREQYR] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
label = gtk_label_new("/");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
mDY[PDFREQEND][PDFREQMO] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
label = gtk_label_new("/");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
mDY[PDFREQEND][PDFREQDY] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
gtk_box_pack_start(GTK_BOX(box), box2, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("HOUR");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Start:");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
mHR[PDFREQSTART][PDFREQHR] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
label = gtk_label_new(":");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
mHR[PDFREQSTART][PDFREQMN] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
label = gtk_label_new(" HH:MM");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("End:");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
mHR[PDFREQEND][PDFREQHR] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
label = gtk_label_new(":");
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
mHR[PDFREQEND][PDFREQMN] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 2);
gtk_entry_set_max_length(GTK_ENTRY(entry), 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("INTERVAL");
box = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
box2 = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Interval Days:");
gtk_size_group_add_widget(size_group, label);
mINT = entry = gtk_entry_new();
strcpy(toolTip, "The Number of Days Included in Each Movie Frame");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(box), box2);
g_signal_connect(entry, "activate", G_CALLBACK(moviePDF), NULL);
g_signal_connect(entry, "activate", G_CALLBACK(cancelMovieReq), NULL);
frame = gtk_frame_new("PDF Date Range");
box = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
mCUM[0] = radioB = gtk_radio_button_new_with_label(NULL, "Cumulative");
strcpy(toolTip, "Start Date Remains Fixed for each PDF Movie Frame");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), radioB, FALSE, FALSE, 20);
mCUM[1] = radioB = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) mCUM[0]), "Individual");
strcpy(toolTip, "Start Date Advances Interval Number of Days");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radioB, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), radioB, FALSE, FALSE, 20);
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(mCUM[!pdfSettings.movie.cumulative]), TRUE);
sep = gtk_hseparator_new();
gtk_widget_modify_fg(sep, GTK_STATE_NORMAL, &myWhite);
gtk_box_pack_start(GTK_BOX(controlBox), sep, FALSE, FALSE, 7);
actionB = gtk_vbutton_box_new();
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
gtk_button_box_set_layout (GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_START);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Make Movie");
gtk_container_add(GTK_CONTAINER(actionB), button);
gtk_size_group_add_widget(size_group, button);
g_signal_connect(button, "clicked", G_CALLBACK(moviePDF), NULL);
strcpy(toolTip, "Request Data from DB and Make Movie");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
return control_box;
}
static GtkWidget *make_MovieButtons()
{
GtkWidget *widget, *button, *menu_box, *vbox, *label, *combo;
GtkWidget *actionB;
int  i;
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
menu_box = gtk_event_box_new();
widget = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(widget), 5);
gtk_container_add(GTK_CONTAINER(menu_box), widget);
vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Channel</span>");
gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
combo = rdCHNmv;
gtk_box_pack_start(GTK_BOX(vbox), combo, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), vbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, vbox);
movieDisp = vbox = gtk_vbox_new(FALSE, 2);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL(label),
(const gchar *) "<span weight=\"bold\" foreground=\"white\">Display Cell</span>");
gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
movieDispCell = combo = gtk_combo_box_new_text();
for(i=0;i<TTLMOVIEDISPCELLS;i++)
gtk_combo_box_insert_text(GTK_COMBO_BOX(combo), i, movieDispCells[i]);
gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
gtk_box_pack_start(GTK_BOX(vbox), combo, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(widget), vbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, vbox);
actionB = gtk_vbutton_box_new();
gtk_box_pack_start(GTK_BOX(widget), actionB, FALSE, FALSE, 2);
gtk_button_box_set_layout (GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_START);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Clear");
gtk_container_add(GTK_CONTAINER(actionB), button);
gtk_size_group_add_widget(size_group, button);
g_signal_connect(button, "clicked", G_CALLBACK(clearMovieEntries), NULL);
strcpy(toolTip, "Clear all Request Fields for New Input");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Cancel");
gtk_container_add(GTK_CONTAINER(actionB), button);
gtk_size_group_add_widget(size_group, button);
g_signal_connect(button, "clicked", G_CALLBACK(cancelMovieReq), NULL);
strcpy(toolTip, "Return to Movie Screen - No Changes");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_widget_modify_bg(menu_box, GTK_STATE_NORMAL, &settings.colors.sb[0]);
return menu_box;
}
void make_MovieDialog(gboolean full)
{
GtkWidget *ctrlBox, *vbox;
GtkWidget *movieButtons, *movieEntries;
switch(full)
{
case TRUE:
if (!movieWndw)
{
tips = gtk_tooltips_new();
movieWndw = gtk_window_new (GTK_WINDOW_TOPLEVEL);
gtk_window_set_title (GTK_WINDOW(movieWndw), "PDF MOVIE REQUESTOR"); 
gtk_container_set_border_width(GTK_CONTAINER(movieWndw), 2);
gtk_window_set_position(GTK_WINDOW(movieWndw), GTK_WIN_POS_CENTER);
g_signal_connect(movieWndw, "delete-event", G_CALLBACK(cancelMovieReq), NULL);
ctrlBox = gtk_hbox_new (FALSE, 0);
gtk_container_add (GTK_CONTAINER(movieWndw), ctrlBox);
movieButtons = make_MovieButtons ();
gtk_box_pack_start(GTK_BOX(ctrlBox), movieButtons, FALSE, FALSE, 0);
vbox = gtk_vbox_new(FALSE, 0);
movieEntries = make_MovieEntries();
gtk_box_pack_start(GTK_BOX(vbox), movieEntries, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(ctrlBox), vbox, TRUE, TRUE, 0);
gtk_widget_show_all (movieWndw);
gtk_window_set_transient_for((GtkWindow *) movieWndw, (GtkWindow *) topWindow);
}
break;
case FALSE:
if (!rdCHNmv)
{
rdCHNmv = gtk_combo_box_new();
}
break;
}
return;
}
