#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_pdf.h"
#include "gtk_pdf_externs.h"
#include "util_externs.h"
void setPdfCtrlSettings()
{ 
int j, selected=0, dbSel=0, i;
static int numSrvrs;
char *tmpStr;
SERVERDBS *srvrInfo;
DBLST *dbInfo;
GSList *iter;
memcpy(&ctrlPdfSettings, &pdfSettings, sizeof(PDFSETTINGS));
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pdfStart), ctrlPdfSettings.general.startup);
for (j=0;j<TTLPDFSCREENS;j++)
{
if (pdfColors[j])
gtk_color_button_set_color(GTK_COLOR_BUTTON (pdfColors[j]), 
&ctrlPdfSettings.drawing.sbC[j]);
}
if (ctrlBar)
gtk_color_button_set_color(GTK_COLOR_BUTTON (ctrlBar), 
&ctrlPdfSettings.drawing.ctrlBar);
g_signal_handler_block(pdfSrvrDefault[SRVRDEFAULT], pdfSignals[PDFSRVRDFAULTSGNL]);
for(j=0;j<numSrvrs;j++)
{
gtk_combo_box_remove_text(GTK_COMBO_BOX(pdfSrvrDefault[SRVRDEFAULT]), 0);
}
numSrvrs = g_slist_length(pqlxStates.servers.srvrDB) + 1; 
gtk_combo_box_append_text(GTK_COMBO_BOX(pdfSrvrDefault[SRVRDEFAULT]), "NONE");
selected = NONE;  
for(j=0, iter = pqlxStates.servers.srvrDB;
iter;
iter = g_slist_next(iter), j++)
{
srvrInfo = iter->data;
gtk_combo_box_append_text(GTK_COMBO_BOX(pdfSrvrDefault[SRVRDEFAULT]), 
srvrInfo->data.srvrName);
if (ctrlPdfSettings.general.server &&
srvrInfo->data.srvrName &&
!strcmp(ctrlPdfSettings.general.server, srvrInfo->data.srvrName))
selected = j;
}
g_signal_handler_unblock(pdfSrvrDefault[SRVRDEFAULT], pdfSignals[PDFSRVRDFAULTSGNL]);
gtk_combo_box_set_active(GTK_COMBO_BOX(pdfSrvrDefault[SRVRDEFAULT]), selected+1);
if (selected != NONE)  
{ 
srvrInfo = g_slist_nth_data(pqlxStates.servers.srvrDB, selected);
g_signal_handler_block(pdfSrvrDefault[DBDEFAULT], pdfSignals[PDFDBDFAULTSGNL]);
for(j = dbSel = 0, iter = srvrInfo->data.dbsList;
iter;
iter = g_slist_next(iter), j++)
{
dbInfo = iter->data;
if (ctrlPdfSettings.general.database &&
!strcmp(ctrlPdfSettings.general.database, dbInfo->dbName))
dbSel = j;
}
gtk_combo_box_set_active(GTK_COMBO_BOX(pdfSrvrDefault[DBDEFAULT]), dbSel);
g_signal_handler_unblock(pdfSrvrDefault[DBDEFAULT], pdfSignals[PDFDBDFAULTSGNL]);
}
if (ctrlPdfSettings.detail.CWB.inetAddr)
gtk_entry_set_text(GTK_ENTRY(CWBServer), ctrlPdfSettings.detail.CWB.inetAddr);
if (ctrlPdfSettings.detail.CWB.port)
{ 
tmpStr = g_strdup_printf("%d", ctrlPdfSettings.detail.CWB.port);
gtk_entry_set_text(GTK_ENTRY(CWBPort), tmpStr);
free(tmpStr);
}
gtk_spin_button_set_value((GtkSpinButton *) spZoomPct, ctrlPdfSettings.spreq.zoom.scrollPct);
gtk_combo_box_set_active(GTK_COMBO_BOX(pdfDateFormat), ctrlPdfSettings.common.dateFormat);
gtk_combo_box_set_active(GTK_COMBO_BOX(fdUnit), ctrlPdfSettings.common.fdUnits);
for(j=0; j<TTLPDFSCREENS; j++)
{
for(i=0;i<TTLPDFSTATS;i++)
{
gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pdfStats[j][i]),
ctrlPdfSettings.common.statistics[j][i]);
}
}
}
void getPdfCtrlSettings()
{ 
int i, j, k;
gboolean rePlot = FALSE;
GSList *iter;
BLINEDEF  *blineDef;
PDFREQ  *pdfReq;
int   svPDFid, svCHNid, svPDFtype;
ctrlPdfSettings.general.startup = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pdfStart));
if (pdfSettings.general.server)
free(pdfSettings.general.server);
if (pdfSettings.general.database)
free(pdfSettings.general.database);
ctrlPdfSettings.general.server = gtk_combo_box_get_active_text(
GTK_COMBO_BOX(pdfSrvrDefault[SRVRDEFAULT]));
ctrlPdfSettings.general.database = gtk_combo_box_get_active_text(
GTK_COMBO_BOX(pdfSrvrDefault[DBDEFAULT]));
if (!ctrlPdfSettings.general.database)
ctrlPdfSettings.general.database = g_strdup("");
ctrlPdfSettings.detail.CWB.inetAddr = g_strdup(gtk_entry_get_text(GTK_ENTRY(CWBServer)));
ctrlPdfSettings.detail.CWB.port = atoi(gtk_entry_get_text(GTK_ENTRY(CWBPort)));
if (mCUM[0])
ctrlPdfSettings.movie.cumulative = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(mCUM[0]));
ctrlPdfSettings.common.dateFormat = gtk_combo_box_get_active(GTK_COMBO_BOX(pdfDateFormat));
ctrlPdfSettings.common.fdUnits = gtk_combo_box_get_active(GTK_COMBO_BOX(fdUnit));
for(j=0; j<TTLPDFSCREENS; j++)
{
for(i=0;i<TTLPDFSTATS;i++)
{
ctrlPdfSettings.common.statistics[j][i] = 
gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pdfStats[j][i]));
}
}
ctrlPdfSettings.spreq.zoom.scrollPct = gtk_spin_button_get_value((GtkSpinButton *) spZoomPct);
if (ctrlPdfSettings.common.dateFormat != pdfSettings.common.dateFormat ||
ctrlPdfSettings.common.fdUnits != pdfSettings.common.fdUnits)
rePlot = TRUE;
if (memcmp(&ctrlPdfSettings.common.statistics[pdfStates.screen],
&pdfSettings.common.statistics[pdfStates.screen], 
sizeof(pdfSettings.common.statistics[pdfStates.screen])))
{
int  j, k, screen = pdfStates.screen, nRows, nCols;
PDFREQ *pdfReqPtr, *pdfReq;
void *stats;
SQLDI sqldi;
memset(&sqldi, 0, sizeof(SQLDI));
sqldi.args.dataEvent = GET_DATA;
sqldi.descr.tableData = PDFSTATLINES;
switch(screen)
{ 
case PDFMAIN:
nRows = MMAXPDFROWS;
nCols = MMAXPDFCOLS;
pdfReqPtr = &pdfStates.main.pdfReq[pdfSettings.main.display][0][0];
break;
case PDFDETAIL:
nRows = DMAXPDFROWS;
nCols = DMAXPDFCOLS;
break;
case PDFREQUEST:
nRows = RMAXPDFROWS;
nCols = RMAXPDFCOLS;
pdfReqPtr = &pdfStates.request.pdfReq[0][0];
break;
case SPECTROMAIN:
nRows = SMAXROWS;
nCols = SPDFCOLS;
pdfReqPtr = &pdfStates.spmain.pdfReq[0][0];
break;
case SPECTRODETREQ:
nRows = SMAXROWS;
nCols = SPDFCOLS;
pdfReqPtr = &pdfStates.spdetreq.pdfReq[0][0];
break;
}
stats = &ctrlPdfSettings.common.statistics[screen]; 
for(j=0; j<nRows; j++)
for(k=0; k<nCols; k++)
{
switch (screen)
{
case PDFDETAIL:  
pdfReq = pdfStates.detail.pdfReq[j*nCols+k];
break;
default:   
pdfReq = pdfReqPtr + j*nCols + k;
break;
}
if (pdfReq)
{
memcpy(&pdfReq->keys.statistics, stats, sizeof(gboolean) * TTLPDFSTATS);
if (pdfReq->keys.pdfKey)
{
sqldi.data = pdfReq;
db_request(&sqldi);
rePlot = TRUE;
}
}
}
}
if (pqlxGData.systemBLINEs)
{
ctrlPdfSettings.main.bline.pct = gtk_spin_button_get_value((GtkSpinButton *) blPct);
for (iter = PSDblineCtrlR, i=0;
iter;
iter = g_slist_next(iter), i++)
{
BLINECTRL  *blineCtrl = iter->data;
if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(blineCtrl->widg)))
{
rePlot = TRUE;
break;
}
}
blineDef = g_slist_nth_data(pqlxGData.systemBLINEs, i);
if (blineDef)
{
ctrlPdfSettings.main.bline.blineKey = blineDef->blineKey;
if (ctrlPdfSettings.main.bline.blineKey != pdfSettings.main.bline.blineKey ||
ctrlPdfSettings.main.bline.pct != pdfSettings.main.bline.pct)
{
for(j=0; j<MMAXPDFROWS; j++)
for(k=0; k<MMAXPDFCOLS; k++)
{
pdfReq = &pdfStates.main.pdfReq[pdfSettings.main.display][j][k];
if (!pdfReq->keys.chnKey)
continue;
svPDFtype = pdfReq->keys.pdfType;
svPDFid = pdfReq->keys.pdfKey;
svCHNid = pdfReq->keys.chnKey;
freePDF(pdfReq, TRUE);
pdfReq->keys.pdfKey = svPDFid;
pdfReq->keys.chnKey = svCHNid;
pdfReq->keys.pdfType = svPDFtype;
pdfReq->keys.fillTmp = TRUE;
}
rePlot = TRUE;
}
}
}
memcpy(&pdfSettings, &ctrlPdfSettings, sizeof(PDFSETTINGS));
for (j=0;j<TTLPDFSCREENS;j++)
{
if (pdfSettings.drawing.sbC[j].pixel)
{
gtk_widget_modify_bg(PSDsb[j], GTK_STATE_NORMAL, 
&pdfSettings.drawing.sbC[j]);
if (j==PDFMAIN)
{
for(i=0;i<NUMPDFMAINDISPLAYMODES;i++)
gtk_widget_modify_bg(MButtons[i], GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[j]);
gtk_widget_modify_bg(PDFeventB[0], GTK_STATE_NORMAL, &pdfSettings.drawing.sbC[j]);
}
pdfSettings.drawing.sbC[j].pixel = FALSE;
}
}
if (pdfSettings.drawing.ctrlBar.pixel)
{
for (i=0;i<TTLMOVIESCREENS;i++)
gtk_widget_modify_bg(ctrlBarEB[i], GTK_STATE_NORMAL, &pdfSettings.drawing.ctrlBar);
pdfSettings.drawing.ctrlBar.pixel = FALSE;
}
memcpy(&ctrlPdfSettings, &pdfSettings, sizeof(PDFSETTINGS));
if (rePlot)
{
resetDrawings();
}
}
