#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "pql_defines.h"
#include "pql_externs.h"
#include "gtk_pql_externs.h"
void g_xmajt(), g_xmidt(), g_xmint();
void g_ymajt(), g_ymidt(), g_ymint();
gboolean g_eq();
double p[77] = {1e-38, 1e-37, 1e-36, 1e-35, 1e-34, 1e-33, 1e-32, 1e-31, 1e-30,
1e-29, 1e-28, 1e-27, 1e-26, 1e-25, 1e-24, 1e-23, 1e-22, 1e-21,
1e-20, 1e-19, 1e-18, 1e-17, 1e-16, 1e-15, 1e-14, 1e-13, 1e-12,
1e-11, 1e-10, 1e-9, 1e-8, 1e-7, 1e-6, 1e-5, 1e-4, 1e-3, 1e-2,
1e-1, 1e0, 1e1, 1e2, 1e3, 1e4, 1e5, 1e6, 1e7, 1e8, 1e9, 1e10,
1e11, 1e12, 1e13, 1e14, 1e15, 1e16, 1e17, 1e18, 1e19, 1e20, 1e21,
1e22, 1e23, 1e24, 1e25, 1e26, 1e27, 1e28, 1e29, 1e30, 1e31, 1e32,
1e33, 1e34, 1e35, 1e36, 1e37, 1e38};
double eps;
int pwr, ts, ns;
GdkPixmap  *pixmap;
GdkGC *grct;
graph *locgrph;
int    frmt;
int majtick = 7; 
int midtick = 4;
int mintick = 3;
int    pix_xmax; 
int strwidth; 
int charwidth; 
static int charheight;
static double lastnum; 
static double nextnum; 
static double label_offset;
static double startTime;
void xaxis(pixmp, grc, grph, x0, y0, xn, tside, nside, ndivs, offset, inv, epoch)
GdkPixmap *pixmp;
GdkGC *grc;
graph *grph;
double x0, y0, xn;
int tside, nside, ndivs;
double offset;
gboolean  inv; 
double   epoch; 
{
double xylen, ptr, cnt, divcon, mincon, maxcon;
double true_xmin, true_xmax;
int pix_x0, pix_x1, pix_y0, last_pix_x0=0, height;
double exp();
grct = grc;
pixmap = pixmp;
locgrph = grph;
startTime = epoch;
gdk_drawable_get_size(pixmp, &pix_xmax, &height);
if (locgrph->logx) {
true_xmin = exp(2.302585 * locgrph->user_xmin);
true_xmax = exp(2.302585 * locgrph->user_xmax);
}
else {
true_xmin = locgrph->user_xmin;
true_xmax = locgrph->user_xmax;
}
mincon = (true_xmin < 0.) ? 1.01 :.99;
maxcon = (true_xmax < 0.) ?.99 : 1.01;
if (x0 < true_xmin * mincon || xn > true_xmax * maxcon) {
fprintf(stderr, "xaxis: x axis outside xy window\n");
return;
}
if (x0 > xn) {
fprintf(stderr, "xaxis: start point greater than end point\n");
return;
}
if ((tside != -1 && tside != 0 && tside != 1) || (nside != -1 && nside != 0 && nside != 1)) {
fprintf(stderr, "xaxis: tside and nside must be -1, 0 or 1\n");
return;
}
lastnum = true_xmin;
if (ndivs <= 1)
ndivs = 10;  
if (locgrph->logx) {
for (pwr = 76; p[pwr] > x0; pwr--);
label_offset = 0.;
}
else {
xylen = xn - x0;
for (pwr = 76; p[pwr] >= xylen; pwr--);
label_offset = offset;
}
ptr = 0.;
cnt = ((locgrph->logx == 0) ? ((double) ndivs) : 0.);
divcon = p[pwr] / (double) ndivs; 
eps =.5 * p[pwr - 2]; 
ts = tside;   
ns = nside;   
if (x0 + label_offset != 0.) {
while (1) {
if (locgrph->logx)
cnt += 1.;
if (x0 + label_offset > 0.) {
ptr += p[pwr];
if (ptr > x0 + label_offset)
break;
}
else {
ptr -= p[pwr];
if (ptr < x0 + label_offset)
break;
}
}
if (!(locgrph->logx)) {
if (x0 + label_offset < 0.)
cnt = 0.;
while (1) {
if (x0 + label_offset > 0.) {
ptr -= divcon;
cnt -= 1.;
if (ptr - eps < x0 + label_offset)
break;
}
else {
ptr += divcon;
cnt += 1.;
if (ptr + eps > x0 + label_offset)
break;
}
}
if (x0 + label_offset > 0.) {
ptr += divcon;
cnt += 1.;
}
}
}
ptr -= label_offset;
pix_x0 = USER2PIXX(locgrph, x0);
pix_x1 = USER2PIXX(locgrph, xn);
pix_y0 = USER2PIXY(locgrph, y0);
gdk_draw_line(pixmap, grct, pix_x0, pix_y0, pix_x1, pix_y0);
g_xmajt(x0, pix_x0, pix_y0, inv, TRUE);
if (startTime) last_pix_x0 = pix_x0 - strwidth/2;  
if (locgrph->logx) 
{
while (ptr <= xn + eps) 
{
pix_x0 = USER2PIXX(locgrph, ptr);
if (cnt == 10.) 
{
g_xmajt(ptr, pix_x0, pix_y0, inv, TRUE);
cnt = 1.;
pwr++;
}
else
g_xmidt(pix_x0, pix_y0);
ptr += p[pwr];
cnt += 1.;
}
}
else 
{
while (ptr <= xn + eps) 
{
pix_x0 = USER2PIXX(locgrph, ptr);
if (!startTime)
{ 
if (g_eq(cnt, (double) ndivs,.1)) 
{ 
g_xmajt(ptr, pix_x0, pix_y0, inv, TRUE);
cnt = 1.;
}
else 
{ 
if (g_eq(cnt, (double) ndivs *.5,.1))
g_xmidt(pix_x0, pix_y0);
else
g_xmint(pix_x0, pix_y0);
cnt += 1.;
}
}
else
{ 
if (pix_x0 >= last_pix_x0 + strwidth*1.3)
{
g_xmajt(ptr, pix_x0, pix_y0, FALSE, TRUE);
last_pix_x0 = pix_x0;
}
else
{
if (pix_x0 < 0)
{
break;
}
else
{
g_xmidt(pix_x0, pix_y0);
}
}
}
ptr += divcon;
}
}
g_xmajt(xn, pix_x1, pix_y0, inv, !inv);
}
void g_xmajt(pt, xpt, ypt, inv, prt)
double pt;
int xpt, ypt, prt;
gboolean  inv;
{
char outpt[20];
int len, hz_offset, pix_x0, pix_y0=0;
settings.general.font.font = AXISF;
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt - majtick);
else 
if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt + majtick);
if (!ns || !prt)
return;
if (g_eq(0., pt, p[pwr - 5]))
pt = 0.;
if ((int) pt/1000000 > 0 && !startTime)
sprintf(outpt, "%.4g", pt + label_offset);
else 
{
memset(outpt, 0, 20);
if (startTime)
{ 
static int  day;
struct ptime date;
int    msec, jday;
double   startT;
startT = startTime + pt;
passcal_etoh(&date, startT);
msec = (((float) (startT - (int) startT))*1000.0);
jday = get_julday(date.mo, date.day, date.yr);
if (day != jday)
{
sprintf(outpt, "%03d %02d:%02d:%02d.%03d", jday, date.hr, date.mn, (int) date.sec, msec);
day = jday;
}
else
{
sprintf(outpt, "%02d:%02d:%02d.%03d", date.hr, date.mn, (int) date.sec, msec);
}
}
else
{ 
sprintf(outpt, "%10.8f", pt);
}
for(len=strlen(outpt)-1;len > 0; len--) 
{
if(outpt[len] == '0')
outpt[len] = 0;
else
break;
}
}
for (len = 0; outpt[len] != '\0'; len++);
if (outpt[len - 1] == '.') 
{
outpt[len - 1] = '\0';
len--;
}
if (!charheight)
charheight = fontSIZE(outpt, HEIGHT);
g_strstrip(outpt);
strwidth = fontSIZE(outpt, WIDTH);
hz_offset = strwidth / 2;
pix_x0 = xpt - hz_offset;
nextnum = PIX2USERX(locgrph, pix_x0);
if (nextnum > lastnum) 
{ 
if (pix_x0 + strwidth > pix_xmax)
pix_x0 = pix_xmax - strwidth - 1;
if ((ns == 1) && (ts != 1))
pix_y0 = ypt - charheight - 1; 
else if ((ns == 1) && (ts == 1))
pix_y0 = ypt - 2 * majtick;
else if ((ns == -1) && (ts != -1))
pix_y0 = ypt + 2; 
else if ((ns == -1) && (ts == -1))
pix_y0 = ypt + charheight + 2 * majtick;
fontDraw(pixmap, outpt, pix_x0, pix_y0, NORMALGC, SAMESCR, -1, -1);
lastnum = PIX2USERX(locgrph, xpt + hz_offset);
} 
}
void g_xmidt(xpt, ypt)
int xpt, ypt;
{
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt - midtick);
else 
if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt + midtick);
}
void g_xmint(xpt, ypt)
int xpt, ypt;
{
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt - midtick);
else 
if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt, ypt + midtick);
}
#define MIDM 0
#define BELOW 1
#define ABOVE 2
void yaxis(pixmp, grc, grph, x0, y0, yn, tside, nside, ndivs, offset, format)
GdkPixmap *pixmp;
GdkGC *grc;
graph *grph;
double x0, y0, yn;
int tside, nside, ndivs, format;
double offset;
{
double xylen, ptr, cnt, divcon, mincon, maxcon;
double true_ymin, true_ymax;
int pix_x0, pix_y0, pix_y1;
double exp();
grct = grc;
pixmap = pixmp;
locgrph = grph;
frmt = format;
if (locgrph->logy) {
true_ymin = exp(2.302585 * locgrph->user_ymin);
true_ymax = exp(2.302585 * locgrph->user_ymax);
}
else {
true_ymin = locgrph->user_ymin;
true_ymax = locgrph->user_ymax;
}
mincon = (true_ymin < 0.) ? 1.01 :.99;
maxcon = (true_ymax < 0.) ?.99 : 1.01;
if (y0 < true_ymin * mincon || yn > true_ymax * maxcon) {
fprintf(stderr, "yaxis: y axis outside xy window\n");
return;
}
if (y0 > yn) {
fprintf(stderr, "yaxis: start point greater than end point\n");
return;
}
if ((tside != -1 && tside != 0 && tside != 1) || (nside != -1 && nside != 0 && nside != 1)) {
fprintf(stderr, "yaxis: tside and nside must be -1, 0 or 1\n");
return;
}
lastnum = true_ymin;
if (ndivs <= 0)
ndivs = 10;
if (locgrph->logy) {
for (pwr = 76; p[pwr] > y0; pwr--);
label_offset = 0.;
}
else {
xylen = yn - y0;
for (pwr = 76; p[pwr] >= xylen; pwr--);
label_offset = offset;
}
if (pwr <2)
pwr = 2;
ptr = 0.;
cnt = ((locgrph->logy == 0) ? ((double) ndivs) : 0.);
divcon = p[pwr] / (double) ndivs;
eps =.5 * p[pwr - 2];
ts = tside;
ns = nside;
if (y0 + label_offset != 0.) {
while (1) {
if (locgrph->logy)
cnt += 1.;
if (y0 + label_offset > 0.) 
{
ptr += p[pwr];
if (ptr > y0 + label_offset)
break;
}
else 
{
ptr -= p[pwr];
if (ptr < y0 + label_offset)
break;
}
}
if (!(locgrph->logy)) {
if (y0 + label_offset < 0.)
cnt = 0.;
while (1) {
if (y0 + label_offset > 0.) {
ptr -= divcon;
cnt -= 1.;
if (ptr - eps < y0 + label_offset)
break;
}
else {
ptr += divcon;
cnt += 1.;
if (ptr + eps > y0 + label_offset)
break;
}
}
if (y0 + label_offset > 0.) {
ptr += divcon;
cnt += 1.;
}
}
}
ptr -= label_offset;
pix_x0 = USER2PIXX(locgrph, x0);
pix_y0 = USER2PIXY(locgrph, y0);
pix_y1 = USER2PIXY(locgrph, yn);
gdk_draw_line(pixmap, grct, pix_x0, pix_y0, pix_x0, pix_y1);
g_ymajt(y0, pix_x0, pix_y0, 1, ABOVE);
if (locgrph->logy) {
while (ptr <= yn + eps) {
pix_y0 = USER2PIXY(locgrph, ptr);
if (cnt == 10.) {
g_ymajt(ptr, pix_x0, pix_y0, 0, MIDM);
cnt = 1.;
pwr++;
}
else
g_ymidt(pix_x0, pix_y0);
ptr += p[pwr];
cnt += 1.;
}
}
else {
while (ptr <= yn + eps) {
pix_y0 = USER2PIXY(locgrph, ptr);
if (g_eq(cnt, (double) ndivs,.1)) {
g_ymajt(ptr, pix_x0, pix_y0, 0, MIDM);
cnt = 1.;
}
else {
if (g_eq(cnt, (double) ndivs *.5,.1))
g_ymidt(pix_x0, pix_y0);
else
g_ymint(pix_x0, pix_y0);
cnt += 1.;
}
ptr += divcon;
}
}
g_ymajt(yn, pix_x0, pix_y1, 1, BELOW);
}
void g_ymajt(pt, xpt, ypt, print, pos)
double pt;
int xpt, ypt, print, pos;
{
int len, hz_offset, pix_x0=0, pix_y0=0;
char outpt[20];
settings.general.font.font = AXISF;
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt + majtick, ypt);
else 
if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt - majtick, ypt);
if (ns == 0 || print == 0)
return;
switch(frmt)
{
case MYFLOAT:
if (g_eq(0., pt, p[pwr - 5]))
pt = 0.;
if ((int) pt/1000000 > 0)
sprintf(outpt, "%.5g", pt + label_offset);
else 
{
memset(outpt, 0, 20);
if (abs(pt) < 1.)
{
sprintf(outpt, "%.8f", pt);
}
else
{
sprintf(outpt, "%.3f", pt);
}
for(len=strlen(outpt)-1;len > 0; len--) 
{
if(outpt[len] == '0')
outpt[len] = 0;
else
break;
}
}
break;
case MYINT:
memset(outpt, 0, 20);
sprintf(outpt, "%d", (int) pt);
break;
}
for (len = 0; outpt[len] != '\0'; len++);
if (outpt[len - 1] == '.') 
{
if(abs(pt)>1)
outpt[len - 1] = '\0';
else
strcpy(outpt, "0.0");
}
charheight = fontSIZE(outpt, HEIGHT);
hz_offset = fontSIZE(outpt, WIDTH);
switch(pos) 
{
case MIDM:
pix_y0 = ypt + charheight / 2;
break;
case BELOW:
pix_y0 = ypt; 
break;
case ABOVE:
pix_y0 = ypt - charheight;
break;
}
if ((ns == 1) && (ts != 1))
pix_x0 = xpt + majtick;
else if ((ns == 1) && (ts == 1))
pix_x0 = xpt + 2 * majtick;
else if ((ns == -1) && (ts == -1))
pix_x0 = xpt - hz_offset - 2 * majtick;
else if ((ns == -1) && (ts != -1))
pix_x0 = xpt - hz_offset - majtick/2;
fontDraw(pixmap, outpt, pix_x0, pix_y0, NORMALGC, SAMESCR, -1, -1);
}
void g_ymidt(xpt, ypt)
int xpt, ypt;
{
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt + midtick, ypt);
else if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt - midtick, ypt);
}
void g_ymint(xpt, ypt)
int xpt, ypt;
{
if (ts == 1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt + midtick, ypt);
else if (ts == -1)
gdk_draw_line(pixmap, grct, xpt, ypt, xpt - midtick, ypt);
}
gboolean g_eq(x, y, e)
double x, y, e;
{
if ((x < y - e) || (x > y + e))
return (0);
else
return (1);
}
