#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
static GtkTooltips *tips;
static char  toolTip[1000];
static void make_stnCtrlScreens();
void modelChg(GtkWidget *radio, gpointer w)
{
GSList *iter;
MODELPHASES *phases;
int  which = GPOINTER_TO_INT(w);
if (!gtk_toggle_button_get_active((GtkToggleButton *) radio))
return;    
for(iter = STNevtModelPhases;
iter;
iter = g_slist_next(iter))
{
phases = iter->data;
gtk_widget_hide(phases->widget);
}
phases = g_slist_nth_data(STNevtModelPhases, which);
gtk_widget_show(phases->widget);
for(iter = STNevtAlignPhases;
iter;
iter = g_slist_next(iter))
{
phases = iter->data;
gtk_widget_hide(phases->widget);
}
phases = g_slist_nth_data(STNevtAlignPhases, which);
gtk_widget_show(phases->widget);
stnStates.event.model = g_slist_nth_data(stnStates.event.models, which);
}
void makeModelsCtrls(GSList *models)
{
int  i, j;
char *str;
GSList *iter, *iter2;
MODELPHASES *phases;
TTMODEL *model;
TTNAME *phase;
GtkWidget *frame, *box1, *box2, *hbox1, *hbox2, *radio1=NULL, *radio2;
if (STNevtModels)
{ 
gtk_widget_destroy(STNevtModels);
STNevtModels = NULL;
g_slist_free(STNevtModelsR);
STNevtModelsR = NULL;
for(iter = STNevtModelPhases;
iter;
iter = g_slist_next(iter))
{
phases = iter->data;
gtk_widget_destroy(phases->widget);
g_slist_free(phases->phasesR);
free(phases);
}
g_slist_free(STNevtModelPhases);
STNevtModelPhases = NULL;
for(iter = STNevtAlignPhases;
iter;
iter = g_slist_next(iter))
{
phases = iter->data;
gtk_widget_destroy(phases->widget);
g_slist_free(phases->phasesR);
free(phases);
}
g_slist_free(STNevtAlignPhases);
STNevtAlignPhases = NULL;
}
if (!models)
return;
STNevtModels = frame = gtk_frame_new("Models");
box1 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box1);
for(iter = models, i=0;
iter;
iter = g_slist_next(iter), i++)
{
model = iter->data;
if (!(i%3))
{
hbox1 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(box1), hbox1, TRUE, FALSE, 2);
}
radio1 = gtk_radio_button_new_with_label(
!radio1 ? NULL : gtk_radio_button_get_group((GtkRadioButton *) radio1), 
model->name);
STNevtModelsR = g_slist_append(STNevtModelsR, radio1);
g_signal_connect(radio1, "toggled", G_CALLBACK(modelChg), GINT_TO_POINTER(i));
gtk_box_pack_start(GTK_BOX(hbox1), radio1, FALSE, FALSE, 10);
str = g_strdup_printf("%s Phases", model->name);
frame = gtk_frame_new(str);  free(str);
box2 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box2);
phases = calloc(1, sizeof(MODELPHASES));
phases->widget = frame;
phases->modelKey = model->key;
for(iter2 = model->phases, j=0;
iter2;
iter2 = g_slist_next(iter2), j++)
{
phase = iter2->data;
if (!(j%4))
{
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(box2), hbox2, TRUE, FALSE, 2);
}
radio2 = gtk_check_button_new_with_label(phase->name);
gtk_box_pack_start(GTK_BOX(hbox2), radio2, FALSE, FALSE, 10);
phases->phasesR = g_slist_append(phases->phasesR, radio2);
}
STNevtModelPhases = g_slist_append(STNevtModelPhases, phases);
str = g_strdup_printf("X-Axis Alignment");
frame = gtk_frame_new(str);  free(str);
box2 = gtk_vbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), box2);
phases = calloc(1, sizeof(MODELPHASES));
phases->widget = frame;
phases->modelKey = model->key;
for(iter2 = model->phases, j=0, radio2=NULL;
iter2;
iter2 = g_slist_next(iter2), j++)
{
phase = iter2->data;
if (!(j%4))
{
hbox2 = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(box2), hbox2, TRUE, FALSE, 2);
}
radio2 = gtk_radio_button_new_with_label(
!radio2 ? NULL : gtk_radio_button_get_group((GtkRadioButton *) radio2), 
phase->name);
gtk_box_pack_start(GTK_BOX(hbox2), radio2, FALSE, FALSE, 10);
phases->phasesR = g_slist_append(phases->phasesR, radio2);
}
STNevtAlignPhases = g_slist_append(STNevtAlignPhases, phases);
}
if (STNEvtCtrol)
{ 
gtk_box_pack_start(GTK_BOX(STNEvtCtrol), STNevtModels, FALSE, FALSE, 0);
gtk_box_reorder_child(GTK_BOX(STNEvtCtrol), STNevtModels, 2);
for(iter = STNevtModelPhases, i=3;
iter;
iter = g_slist_next(iter),i++)
{
phases = iter->data;
gtk_box_pack_start(GTK_BOX(STNEvtCtrol), phases->widget, FALSE, FALSE, 0);
gtk_box_reorder_child(GTK_BOX(STNEvtCtrol), phases->widget, i);
}
for(iter = STNevtAlignPhases, i--;
iter;
iter = g_slist_next(iter),i++)
{
phases = iter->data;
gtk_box_pack_start(GTK_BOX(STNEvtCtrol), phases->widget, FALSE, FALSE, 0);
gtk_box_reorder_child(GTK_BOX(STNEvtCtrol), phases->widget, i);
}
gtk_widget_show_all(STNEvtCtrol);
}
}
void raiseStnControls(GtkButton *button, gpointer *scr)
{ 
int screen = GPOINTER_TO_INT(scr);
if (!stnCtrlWindow)
{
make_stnCtrlScreens();
}
setStnCtrlSettings();
if (screen == STNANLCTRL &&
stnStates.event.event)
screen = STNEVTCTRL;
gtk_notebook_set_current_page((GtkNotebook *) stnControlScreens, screen);
gtk_widget_show(stnCtrlWindow);
return;
}
static void xclStnControls(GtkButton *button, gpointer r)
{
gboolean replot = (gboolean) GPOINTER_TO_INT(r);
if (stnCtrlWindow)
{ 
gtk_widget_hide(stnCtrlWindow);
gtk_grab_remove(stnCtrlWindow);
}
if (replot)
{
getStnCtrlSettings();
stnStates.display.initiate = TRUE;
makeSTNDrawing(stnStates.screen);
if (stnStates.request.type == STNINIT && ntw)
{
stnStates.request.endDate = g_date_new_dmy(stnStates.main.dateRng[CURDTE].day, 
stnStates.main.dateRng[CURDTE].mo, 
stnStates.main.dateRng[CURDTE].yr);
freeAllSTNData();
getAllSTNdata();
}
} 
} 
static gboolean destroyStnControls(GtkWidget *widget, void *nothing)
{
xclStnControls(NULL, GINT_TO_POINTER(FALSE));
return TRUE;
}
static gboolean setStnColour(GtkWidget *widget, gpointer w)
{
int which = GPOINTER_TO_INT(w);
int screen = (which)/(STNMAXCOLOURS);
int color = (which-screen*STNMAXCOLOURS);
gtk_color_button_get_color(GTK_COLOR_BUTTON (widget), 
&ctrlStnSettings.drawing.colors[screen][color]);
ctrlStnSettings.drawing.colors[screen][color].pixel = TRUE;
return TRUE;
}
static gboolean setSpecColor(GtkWidget *widget, gpointer w)
{
int which = GPOINTER_TO_INT(w);
int popup = which/STNMAXPOPUPCOLOURS;
int color = which-popup*STNMAXPOPUPCOLOURS;
gtk_color_button_get_color(GTK_COLOR_BUTTON (widget), 
&ctrlStnSettings.analysis.popup.colors[popup][color]);
ctrlStnSettings.analysis.popup.colors[popup][color].pixel = TRUE;
return TRUE;
}
static GtkWidget *make_controls(int screen)
{
GtkWidget *controlBox, *control_box, *ctr, *label, *eBox, *hbox, *vbox;
GtkWidget *frame, *box, *controlFrame, *actionB, *button, *hbox1, *box1, *box2;
GtkWidget *frame1, *colorB, *radio1, *radio2, *combo, *entry, *frame2;
GtkAdjustment *spinAdj;
static GtkSizeGroup *size_group;
GtkSizeGroup *size_group1;
int   i, scr;    
char  pickTag[25];
control_box = gtk_event_box_new();
controlFrame = gtk_frame_new(NULL);
controlBox = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(controlBox), 5);
gtk_container_add(GTK_CONTAINER(controlFrame), controlBox);
gtk_container_add(GTK_CONTAINER(control_box), controlFrame);
switch(screen)
{
case STNMAINCTRL:
scr = STNMAIN;
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[scr][STNSB]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">MAIN SCREEN OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("STN System");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 2);
hbox1 = gtk_hbox_new(FALSE, 0);
stnStart = gtk_check_button_new();
gtk_box_pack_end(GTK_BOX(hbox1), stnStart, FALSE, FALSE, 2);
label = gtk_label_new("Default Startup System");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(hbox), hbox1, TRUE, TRUE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
strcpy(toolTip, "STN System is Displayed at Program Startup");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), stnStart, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 2);
label = gtk_label_new("Exclude STN Days");
spinAdj = (GtkAdjustment *) gtk_adjustment_new(stnSettings.general.stnXDays, 0.0, MAXSTNXDAYS, 
1.0, 5.0, 0.0);
STNXdays = ctr = gtk_spin_button_new(spinAdj, 1.0, 0);
gtk_box_pack_start(GTK_BOX(hbox), ctr, TRUE, TRUE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 0, .5);
strcpy(toolTip, "Exclude Stations Having NO DATA (all channels) Since Number of Days\n0 = ALL STATIONS");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), ctr, toolTip, toolTip);
size_group1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 2);
stnSrvrDefault[SRVRDEFAULT] = combo = gtk_combo_box_new_text();
stnSignals2[STNSRVRDFAULTSGNL][0] = g_signal_connect(combo, "changed", G_CALLBACK(srvrDefault), GINT_TO_POINTER(SRVRDEFAULT));
gtk_widget_set_size_request(combo, 10, -1);
label = gtk_label_new("Default PQLX Server");
gtk_box_pack_start(GTK_BOX(hbox), combo, TRUE, TRUE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group1, label);
gtk_misc_set_alignment(GTK_MISC (label), 0, .5);
hbox = gtk_hbox_new(FALSE, 2);
stnSrvrDefault[DBDEFAULT] = combo = gtk_combo_box_new_text();
stnSignals2[STNDBDFAULTSGNL][0] = g_signal_connect(combo, "changed", G_CALLBACK(srvrDefault), GINT_TO_POINTER(DBDEFAULT));
label = gtk_label_new("Default PQLX Database");
gtk_widget_set_size_request(combo, 10, -1);
gtk_box_pack_start(GTK_BOX(hbox), combo, TRUE, TRUE, 2);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group1, label);
gtk_misc_set_alignment(GTK_MISC (label), 0, .5);
frame = gtk_frame_new("Plotting");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Display Days: ");
spinAdj = (GtkAdjustment *) gtk_adjustment_new(stnSettings.main.days, 1.0, 
MAXSTNDAYS, 1.0, 5.0, 0.0);
STNdays = ctr = gtk_spin_button_new(spinAdj, 1.0, 0);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), ctr, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define Number of Days to DISPLAY per Screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), ctr, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Display Lines: ");
spinAdj = (GtkAdjustment *) gtk_adjustment_new(stnSettings.main.lines, 1.0, 
MAXSTNLINES, 1.0, 5.0, 0.0);
STNlines = ctr = gtk_spin_button_new(spinAdj, 1.0, 0);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), ctr, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define Maximum Number of Lines to DISPLAY per Screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), ctr, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Y Axis Display: ");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
radio1 = gtk_radio_button_new_with_label(NULL, "On");
gtk_box_pack_start(GTK_BOX(hbox), radio1, TRUE, FALSE, 2);
STNyAxis[scr] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Off");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Units Display");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
STNunitsR[STNCOUNTS] = radio1 = gtk_radio_button_new_with_label(NULL, "Counts");
gtk_box_pack_start(GTK_BOX(hbox), radio1, TRUE, FALSE, 2);
strcpy(toolTip, "Display Data as COUNTS");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
STNunitsR[STNSENSITIVITY] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Sensitivity");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
strcpy(toolTip, "Display Data with Sensitivity Applied");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Sidebar Control: ");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
radio1 = gtk_radio_button_new_with_label(NULL, "Display");
strcpy(toolTip, "Display the 'Display Units' Sidebar Control"
"\nApplies to all STN Tabs");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(hbox), radio1, TRUE, FALSE, 2);
STNunitsD = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Hide");
strcpy(toolTip, "DO NOT Display the 'Display Units' Sidebar Control"
"\nApplies to all STN Tabs");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("PQL Navigation");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
STNpql[PQLTRC] = radio1 = gtk_radio_button_new_with_label(NULL, "Trace");
gtk_box_pack_start(GTK_BOX(hbox), radio1, TRUE, FALSE, 2);
strcpy(toolTip, "Take selected traces to TRACE screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
STNpql[PQLMAG] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Magnify");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
strcpy(toolTip, "Take selected traces to MAGNIFY screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
hbox = gtk_hbox_new(FALSE, 0);
STNpql[PQLSPLT2] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Split 2");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
strcpy(toolTip, "Take selected traces to SPLIT 2 screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
STNpql[PQLSPLT3] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Split 3");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
strcpy(toolTip, "Take selected traces to SPLIT 3 screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
#if 0
frame = gtk_frame_new("File Pathname Substitution");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("From: ");
STNrplc[REPLACEFROM] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define the Pathname string to be replaced\nSettable only when connected");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
if (pqlxStates.conn.state != SRVRCONNECTED)
gtk_widget_set_sensitive(entry, FALSE);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("To: ");
STNrplc[REPLACETO] = entry = gtk_entry_new();
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define the Pathname string to replace with\nSettable only when connected");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
if (pqlxStates.conn.state != SRVRCONNECTED)
gtk_widget_set_sensitive(entry, FALSE);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
#endif
frame = gtk_frame_new("Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame1 = gtk_frame_new("Foreground");
colorB = stnColors[STNMAIN][STNFG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Foreground");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNFG));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the FOREGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
frame1 = gtk_frame_new("Background");
colorB = stnColors[STNMAIN][STNBG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Background");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNBG));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the BACKGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
frame1 = gtk_frame_new("Sidebar");
colorB = stnColors[STNMAIN][STNSB] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Sidebar");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNSB));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_end(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
frame1 = gtk_frame_new("Gap");
colorB = stnColors[STNMAIN][STNGP] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Gap");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNGP));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the GAP Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
frame1 = gtk_frame_new("Overlap");
colorB = stnColors[STNMAIN][STNOP] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Overlap");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNOP));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the OVERLAP Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
g_object_unref(size_group);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclStnControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[scr][STNSB]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break;
case STNEVTCTRL:
scr = STNANALYSIS;
STNEvtCtrol = controlBox;
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[scr][STNSB]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">EVENT OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("Epicentral Ordering");
box = gtk_vbox_new(FALSE, 0);
STNevtEpiCtr[STNEVTEPINEAR1ST] = radio1 = gtk_radio_button_new_with_label(NULL, "Nearest First");
gtk_box_pack_start(GTK_BOX(box), radio1, FALSE, FALSE, 2);
strcpy(toolTip, "Order Nearest Arrival First");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
STNevtEpiCtr[STNEVTEPIFAR1ST] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Farthest First");
strcpy(toolTip, "Order Farthest Arrival First");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), radio2, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
if (STNevtModels)
{
GSList  *iter;
MODELPHASES *phases;
gtk_box_pack_start(GTK_BOX(STNEvtCtrol), STNevtModels, FALSE, FALSE, 0);
for(iter = STNevtModelPhases;
iter;
iter = g_slist_next(iter))
{
phases = iter->data;
gtk_box_pack_start(GTK_BOX(STNEvtCtrol), phases->widget, FALSE, FALSE, 0);
}
for(iter = STNevtAlignPhases;
iter;
iter = g_slist_next(iter))
{
phases = iter->data;
gtk_box_pack_start(GTK_BOX(STNEvtCtrol), phases->widget, FALSE, FALSE, 0);
}
}
frame1 = gtk_frame_new("User Picks");
box1 = gtk_vbox_new(FALSE, 0);
strcpy(toolTip, "Define User Pick Name");
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
for(i=0;i<MAXPICKS/2;i++)
{
box2 = gtk_hbox_new(FALSE, 0);
sprintf(pickTag, "Pick #%d", i*2+1);
label = gtk_label_new(pickTag);
gtk_size_group_add_widget(size_group, label);
STNuserP[i*2] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 10);
gtk_entry_set_max_length(GTK_ENTRY(entry), 10);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNuserP[i*2], toolTip, toolTip);
sprintf(pickTag, "Pick #%d", i*2+2);
label = gtk_label_new(pickTag);
gtk_size_group_add_widget(size_group, label);
STNuserP[i*2+1] = entry = gtk_entry_new();
gtk_entry_set_width_chars(GTK_ENTRY(entry), 10);
gtk_entry_set_max_length(GTK_ENTRY(entry), 10);
gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box2), entry, FALSE, FALSE, 2);
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNuserP[i*2+1], toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(box1), box2);
}
g_object_unref(size_group);
gtk_container_add(GTK_CONTAINER(frame1), box1);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("X-Axis Alignment: ");
spinAdj = (GtkAdjustment *) gtk_adjustment_new(stnSettings.main.days, 1.0, 
MAXPICKS, 1.0, 1.0, 0.0);
STNuserPA = ctr = gtk_spin_button_new(spinAdj, 1.0, 0);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), ctr, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box1), hbox, FALSE, FALSE, 2);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define User Pick # for X-Axis Alignment");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), ctr, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), frame1, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclStnControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[scr][STNSB]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break;
case STNANLCTRL:
scr = STNANALYSIS;
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[scr][STNSB]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">ANALYSIS SCREEN OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("Plotting");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Y Axis Display: ");
gtk_size_group_add_widget(size_group, label);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
radio1 = gtk_radio_button_new_with_label(NULL, "On");
gtk_box_pack_start(GTK_BOX(hbox), radio1, TRUE, FALSE, 2);
STNyAxis[scr] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Off");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
frame1 = gtk_frame_new("Foreground");
colorB = stnColors[STNANALYSIS][STNFG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Foreground");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNFG));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the FOREGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
frame1 = gtk_frame_new("Background");
colorB = stnColors[STNANALYSIS][STNBG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Background");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNBG));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the BACKGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
frame1 = gtk_frame_new("Sidebar");
colorB = stnColors[STNANALYSIS][STNSB] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Sidebar");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNSB));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_end(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
frame1 = gtk_frame_new("Gap");
colorB = stnColors[STNANALYSIS][STNGP] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Gap");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNGP));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the GAP Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
frame1 = gtk_frame_new("Overlap");
colorB = stnColors[STNANALYSIS][STNOP] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Overlap");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNOP));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the OVERLAP Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
gtk_container_add(GTK_CONTAINER(vbox), hbox);
frame1 = gtk_frame_new("Arrivals");
colorB = stnColors[STNANALYSIS][STNPA] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "Arrivals");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNPA));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the ARRIVALS Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
frame1 = gtk_frame_new("User");
colorB = stnColors[STNANALYSIS][STNUP] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (colorB), "User");
g_signal_connect(colorB, "color-set", G_CALLBACK(setStnColour), GINT_TO_POINTER((scr*STNMAXCOLOURS)+STNUP));
gtk_widget_set_size_request(colorB, 60, 40);
gtk_container_add(GTK_CONTAINER(frame1), colorB);
gtk_box_pack_start(GTK_BOX(hbox), frame1, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, frame1);
strcpy(toolTip, "Set the User Picks Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), colorB, toolTip, toolTip);
g_object_unref(size_group);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclStnControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[scr][STNSB]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break; 
case STNPSDCTRL:
#if 0
controlFrame = gtk_frame_new(NULL);
gtk_container_add(GTK_CONTAINER(controlBox), controlFrame);
controlBox = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(controlBox), 5);
gtk_container_add(GTK_CONTAINER(controlFrame), controlBox);
#endif
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, 
&stnSettings.analysis.popup.colors[SPECTRA_WIN][STNSB]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">PSD SCREEN OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("Display");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
radio1 = gtk_radio_button_new_with_label(NULL, "Single");
gtk_box_pack_start(GTK_BOX(hbox), radio1, TRUE, FALSE, 2);
strcpy(toolTip, "All PSD Plots To a Single Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
STNPopup[PSD_WIN] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Separate");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
strcpy(toolTip, "Each PSD Plot to Its Own Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Amplitude");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Maximum (dB): ");
STNPsdYMax = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 25);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define MAXIMUM dB to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Minimum (dB): ");
STNPsdYMin = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 25);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
g_object_unref(size_group);
strcpy(toolTip, "Define MINIMUM dB to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Period");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Maximum (Sec): ");
STNPsdXMax = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 25);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define MAXIMUM PERIOD to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Minimum (Sec): ");
STNPsdXMin = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 25);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
g_object_unref(size_group);
strcpy(toolTip, "Define MINIMUM PERIOD to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("HNM & LNM Display");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
radio1 = gtk_radio_button_new_with_label(NULL, "ON");
gtk_box_pack_start(GTK_BOX(hbox), radio1, TRUE, FALSE, 2);
strcpy(toolTip, "Display High and Low Noise Models");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
STNPsdHL = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "OFF");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
strcpy(toolTip, "DO NOT Display High and Low Noise Models");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame2 = gtk_frame_new("Line");
STNColors[PSD_WIN][STNHL] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PSD_WIN][STNHL]), "HLNM Line");
g_signal_connect(STNColors[PSD_WIN][STNHL], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PSD_WIN*STNMAXPOPUPCOLOURS+STNHL));
gtk_widget_set_size_request(STNColors[PSD_WIN][STNHL], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PSD_WIN][STNHL]);
gtk_box_pack_end(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the HLNM Line Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PSD_WIN][STNHL], toolTip, toolTip);
frame = gtk_frame_new("Colors");
hbox = gtk_hbox_new(FALSE, 0);
frame2 = gtk_frame_new("Foreground");
STNColors[PSD_WIN][STNFG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PSD_WIN][STNFG]), "Foreground");
g_signal_connect(STNColors[PSD_WIN][STNFG], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PSD_WIN*STNMAXPOPUPCOLOURS+STNFG));
gtk_widget_set_size_request(STNColors[PSD_WIN][STNFG], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PSD_WIN][STNFG]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the FOREGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PSD_WIN][STNFG], toolTip, toolTip);
frame2 = gtk_frame_new("Background");
STNColors[PSD_WIN][STNBG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PSD_WIN][STNBG]), "Background");
g_signal_connect(STNColors[PSD_WIN][STNBG], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PSD_WIN*STNMAXPOPUPCOLOURS+STNBG));
gtk_widget_set_size_request(STNColors[PSD_WIN][STNBG], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PSD_WIN][STNBG]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the BACKGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PSD_WIN][STNBG], toolTip, toolTip);
frame2 = gtk_frame_new("Sidebar");
STNColors[PSD_WIN][STNSB] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PSD_WIN][STNSB]), "Sidebar");
g_signal_connect(STNColors[PSD_WIN][STNSB], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PSD_WIN*STNMAXPOPUPCOLOURS+STNSB));
gtk_widget_set_size_request(STNColors[PSD_WIN][STNSB], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PSD_WIN][STNSB]);
gtk_box_pack_end(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PSD_WIN][STNSB], toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), hbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclStnControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, &stnSettings.drawing.colors[SPECTRA_WIN][STNSB]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break;
case STNSPECCTRL:
#if 0
controlFrame = gtk_frame_new(NULL);
gtk_container_add(GTK_CONTAINER(controlBox), controlFrame);
controlBox = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(controlBox), 5);
gtk_container_add(GTK_CONTAINER(controlFrame), controlBox);
#endif
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, 
&stnSettings.analysis.popup.colors[SPECTRA_WIN][STNSB]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">SPECTRA SCREEN OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("Display");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
radio1 = gtk_radio_button_new_with_label(NULL, "Single");
gtk_box_pack_start(GTK_BOX(hbox), radio1, TRUE, FALSE, 2);
strcpy(toolTip, "All Spectra Plots To a Single PopUp Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
STNPopup[SPECTRA_WIN] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Separate");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
strcpy(toolTip, "Each Spectra Plot to Its Own PopUp Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Amplitude");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
label = gtk_label_new("Scale: ");
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
radio1 = gtk_radio_button_new_with_label(NULL, "Logarithmic");
gtk_box_pack_start(GTK_BOX(hbox), radio1, FALSE, FALSE, 2);
STNSpecAmp = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Linear");
gtk_box_pack_start(GTK_BOX(hbox), radio2, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define AMPLITUDE Scale as LOGARITHMIC");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
strcpy(toolTip, "Define AMPLITUDE Scale as LINEAR");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Maximum: ");
STNSpecYMax = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 25);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define MAXIMUM AMPLITUDE to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Decades: ");
spinAdj = (GtkAdjustment *) gtk_adjustment_new(stnSettings.analysis.popup.spectra.decades, 
0.1, 8.0, 1.0, 1.0, 0.0);
STNSpecDecades = ctr = gtk_spin_button_new(spinAdj, 1.0, 1);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), ctr, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
g_object_unref(size_group);
strcpy(toolTip, "Define Number of AMPLITUDE DECADES to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), ctr, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Frequency");
box = gtk_vbox_new(FALSE, 0);
size_group = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Scale: ");
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
radio1 = gtk_radio_button_new_with_label(NULL, "Logarithmic");
gtk_box_pack_start(GTK_BOX(hbox), radio1, FALSE, FALSE, 2);
STNSpecFreq = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Linear");
gtk_box_pack_start(GTK_BOX(hbox), radio2, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define FREQUENCY Scale as LOGARITHMIC");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
strcpy(toolTip, "Define FREQUENCY Scale as LINEAR");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Maximum (Hz): ");
STNSpecXMax = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 25);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
strcpy(toolTip, "Define MAXIMUM FREQUENCY to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
label = gtk_label_new("Minimum (Hz): ");
STNSpecXMin = entry = gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(entry), 25);
gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_size_group_add_widget(size_group, label);
gtk_misc_set_alignment(GTK_MISC (label), 1, .5);
g_object_unref(size_group);
strcpy(toolTip, "Define MINIMUM FREQUENCY to Display");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), entry, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Colors");
hbox = gtk_hbox_new(FALSE, 0);
frame2 = gtk_frame_new("Foreground");
STNColors[SPECTRA_WIN][STNFG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[SPECTRA_WIN][STNFG]), "Foreground");
g_signal_connect(STNColors[SPECTRA_WIN][STNFG], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(SPECTRA_WIN*STNMAXPOPUPCOLOURS+STNFG));
gtk_widget_set_size_request(STNColors[SPECTRA_WIN][STNFG], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[SPECTRA_WIN][STNFG]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the FOREGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[SPECTRA_WIN][STNFG], toolTip, toolTip);
frame2 = gtk_frame_new("Background");
STNColors[SPECTRA_WIN][STNBG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[SPECTRA_WIN][STNBG]), "Background");
g_signal_connect(STNColors[SPECTRA_WIN][STNBG], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(SPECTRA_WIN*STNMAXPOPUPCOLOURS+STNBG));
gtk_widget_set_size_request(STNColors[SPECTRA_WIN][STNBG], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[SPECTRA_WIN][STNBG]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the BACKGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[SPECTRA_WIN][STNBG], toolTip, toolTip);
frame2 = gtk_frame_new("Sidebar");
STNColors[SPECTRA_WIN][STNSB] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[SPECTRA_WIN][STNSB]), "Sidebar");
g_signal_connect(STNColors[SPECTRA_WIN][STNSB], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(SPECTRA_WIN*STNMAXPOPUPCOLOURS+STNSB));
gtk_widget_set_size_request(STNColors[SPECTRA_WIN][STNSB], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[SPECTRA_WIN][STNSB]);
gtk_box_pack_end(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[SPECTRA_WIN][STNSB], toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(frame), hbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
g_signal_connect(button, "clicked", G_CALLBACK(xclStnControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN to SPECTRA Screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(actionB), button);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, 
&stnSettings.analysis.popup.colors[SPECTRA_WIN][STNSB]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break;
case STNPMCTRL:
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, 
&stnSettings.analysis.popup.colors[SPECTRA_WIN][STNSB]);
box = gtk_vbox_new(FALSE, 0);
label = gtk_label_new(NULL);
gtk_label_set_markup(GTK_LABEL (label), 
(const gchar *) "<span weight=\"bold\" foreground=\"white\" font_desc=\"12\">PM SCREEN OPTIONS</span>");
gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(eBox), box);
gtk_box_pack_start(GTK_BOX(controlBox), eBox, FALSE, FALSE, 2);
frame = gtk_frame_new("Display");
box = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
radio1 = gtk_radio_button_new_with_label(NULL, "Single");
gtk_box_pack_start(GTK_BOX(hbox), radio1, TRUE, FALSE, 2);
strcpy(toolTip, "All PSD Plots To a Single Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio1, toolTip, toolTip);
STNPopup[PM_WIN] = radio2 = gtk_radio_button_new_with_label(
gtk_radio_button_get_group((GtkRadioButton *) radio1), "Separate");
gtk_box_pack_start(GTK_BOX(hbox), radio2, TRUE, FALSE, 2);
strcpy(toolTip, "Each PSD Plot to Its Own Window");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), radio2, toolTip, toolTip);
gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 2);
gtk_container_add(GTK_CONTAINER(frame), box);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame = gtk_frame_new("Particle Motion Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame2 = gtk_frame_new("Foreground");
STNColors[PM_WIN][STNFG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PM_WIN][STNFG]), "Foreground");
g_signal_connect(STNColors[PM_WIN][STNFG], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNFG));
gtk_widget_set_size_request(STNColors[PM_WIN][STNFG], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNFG]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the FOREGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNFG], toolTip, toolTip);
frame2 = gtk_frame_new("Background");
STNColors[PM_WIN][STNBG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PM_WIN][STNBG]), "Background");
g_signal_connect(STNColors[PM_WIN][STNBG], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNBG));
gtk_widget_set_size_request(STNColors[PM_WIN][STNBG], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNBG]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the BACKGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNBG], toolTip, toolTip);
frame2 = gtk_frame_new("Sidebar");
STNColors[PM_WIN][STNSB] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PM_WIN][STNSB]), "Sidebar");
g_signal_connect(STNColors[PM_WIN][STNSB], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNSB));
gtk_widget_set_size_request(STNColors[PM_WIN][STNSB], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNSB]);
gtk_box_pack_end(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the SIDEBAR Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNSB], toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
frame2 = gtk_frame_new("Compass Lines");
STNColors[PM_WIN][STNPMC] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PM_WIN][STNPMC]), "Compass Lines");
g_signal_connect(STNColors[PM_WIN][STNPMC], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNPMC));
gtk_widget_set_size_request(STNColors[PM_WIN][STNPMC], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNPMC]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the PM Compass Line Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNPMC], toolTip, toolTip);
frame2 = gtk_frame_new("Event BA");
STNColors[PM_WIN][STNPMEBA] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PM_WIN][STNPMEBA]), "End Point");
g_signal_connect(STNColors[PM_WIN][STNPMEBA], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNPMEBA));
gtk_widget_set_size_request(STNColors[PM_WIN][STNPMEBA], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNPMEBA]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the PM Event Back Azimuth Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNPMEBA], toolTip, toolTip);
frame2 = gtk_frame_new("Line Az");
STNColors[PM_WIN][STNPMLA] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON(STNColors[PM_WIN][STNPMLA]), "Line Azimuth");
g_signal_connect(STNColors[PM_WIN][STNPMLA], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNPMLA));
gtk_widget_set_size_request(STNColors[PM_WIN][STNPMLA], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNPMLA]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the PM User Line Azimuth Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNPMLA], toolTip, toolTip);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
frame2 = gtk_frame_new("Start Point");
STNColors[PM_WIN][STNPMSP] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PM_WIN][STNPMSP]), "Start Point");
g_signal_connect(STNColors[PM_WIN][STNPMSP], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNPMSP));
gtk_widget_set_size_request(STNColors[PM_WIN][STNPMSP], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNPMSP]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the PM Start Point Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNPMSP], toolTip, toolTip);
frame2 = gtk_frame_new("End Point");
STNColors[PM_WIN][STNPMEP] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PM_WIN][STNPMEP]), "End Point");
g_signal_connect(STNColors[PM_WIN][STNPMEP], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNPMEP));
gtk_widget_set_size_request(STNColors[PM_WIN][STNPMEP], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNPMEP]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the PM End Point Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNPMEP], toolTip, toolTip);
#if 0
frame = gtk_frame_new("Trace Display Colors");
vbox = gtk_vbox_new(FALSE, 0);
hbox = gtk_hbox_new(FALSE, 0);
gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(frame), vbox);
gtk_box_pack_start(GTK_BOX(controlBox), frame, FALSE, FALSE, 2);
frame2 = gtk_frame_new("Foreground");
STNColors[PM_WIN][STNFG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PM_WIN][STNFG]), "Foreground");
g_signal_connect(STNColors[PM_WIN][STNFG], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNFG));
gtk_widget_set_size_request(STNColors[PM_WIN][STNFG], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNFG]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the FOREGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNFG], toolTip, toolTip);
frame2 = gtk_frame_new("Background");
STNColors[PM_WIN][STNBG] = gtk_color_button_new();
gtk_color_button_set_title(GTK_COLOR_BUTTON (STNColors[PM_WIN][STNBG]), "Background");
g_signal_connect(STNColors[PM_WIN][STNBG], "color-set", G_CALLBACK(setSpecColor), GINT_TO_POINTER(PM_WIN*STNMAXPOPUPCOLOURS+STNBG));
gtk_widget_set_size_request(STNColors[PM_WIN][STNBG], 60, 40);
gtk_container_add(GTK_CONTAINER(frame2), STNColors[PM_WIN][STNBG]);
gtk_box_pack_start(GTK_BOX(hbox), frame2, FALSE, FALSE, 2);
strcpy(toolTip, "Set the BACKGROUND Colour");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), STNColors[PM_WIN][STNBG], toolTip, toolTip);
#endif
actionB = gtk_hbutton_box_new();
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_SPREAD);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Continue");
g_signal_connect(button, "clicked", G_CALLBACK(xclStnControls), GINT_TO_POINTER(TRUE));
strcpy(toolTip, "APPLY New Settings and RETURN to PM Screen");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_container_add(GTK_CONTAINER(actionB), button);
gtk_box_pack_start(GTK_BOX(controlBox), actionB, FALSE, FALSE, 2);
eBox = gtk_event_box_new();
gtk_widget_modify_bg(eBox, GTK_STATE_NORMAL, 
&stnSettings.analysis.popup.colors[PM_WIN][STNSB]);
gtk_container_add(GTK_CONTAINER(controlBox), eBox);
break;
}
return control_box;
}
static GtkWidget *make_CtrlButtons()
{
GtkWidget *widget, *button, *menu_box;
GtkWidget *actionB;
menu_box = gtk_event_box_new();
widget = gtk_vbox_new(FALSE, 0);
gtk_container_set_border_width(GTK_CONTAINER(widget), 5);
gtk_container_add(GTK_CONTAINER(menu_box), widget);
actionB = gtk_vbutton_box_new();
gtk_box_pack_start(GTK_BOX(widget), actionB, FALSE, FALSE, 0);
gtk_button_box_set_layout(GTK_BUTTON_BOX(actionB), GTK_BUTTONBOX_START);
gtk_box_set_spacing(GTK_BOX(actionB), 2);
button = gtk_button_new_with_label("Set Defaults");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(save_STNdefaults), &ctrlStnSettings);
sprintf(toolTip, "WRITE STN System Settings to DEFAULTS File ($HOME/.pql/stn.dfaults.db), Re-Read on PQLX StartUp");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Restore Defaults");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(restore_STNdefaults), NULL);
strcpy(toolTip, "RE-READ STN Settings from DEFAULTS File");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
#if 0
button = gtk_button_new_with_label("HELP");
gtk_container_add(GTK_CONTAINER(actionB), button);
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
#endif
button = gtk_button_new_with_label("Cancel");
gtk_container_add(GTK_CONTAINER(actionB), button);
g_signal_connect(button, "clicked", G_CALLBACK(xclStnControls), GINT_TO_POINTER(FALSE));
strcpy(toolTip, "DO NOT APPLY Settings Changes");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
button = gtk_button_new_with_label("Bug Reports");
gtk_box_pack_end(GTK_BOX(widget), button, FALSE, FALSE, 0);
g_signal_connect(button, "clicked", G_CALLBACK(bugReport), NULL);
strcpy(toolTip, "Technical Support Information");
gtk_tooltips_set_tip(GTK_TOOLTIPS(tips), button, toolTip, toolTip);
gtk_widget_modify_bg(menu_box, GTK_STATE_NORMAL, &stnSettings.drawing.colors[STNMAINCTRL][STNSB]);
return menu_box;
}
static void make_stnCtrlScreens()
{
GtkWidget *ctrlBox, *vbox;
GtkWidget *frame, *container;
if (!stnCtrlWindow)
{
tips = gtk_tooltips_new();
stnCtrlWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_window_set_title(GTK_WINDOW(stnCtrlWindow), "STN System - Controls"); 
gtk_container_set_border_width(GTK_CONTAINER(stnCtrlWindow), 2);
gtk_window_set_position(GTK_WINDOW(stnCtrlWindow), GTK_WIN_POS_CENTER);
g_signal_connect(stnCtrlWindow, "delete-event", G_CALLBACK(destroyStnControls), NULL);
ctrlBox = gtk_hbox_new (FALSE, 0);
gtk_container_add (GTK_CONTAINER(stnCtrlWindow), ctrlBox);
container = make_CtrlButtons ();
gtk_box_pack_start(GTK_BOX(ctrlBox), container, FALSE, FALSE, 0);
vbox = gtk_vbox_new(FALSE, 0);
stnControlScreens = gtk_notebook_new ();
gtk_box_pack_start(GTK_BOX(vbox), stnControlScreens, TRUE, TRUE, 0);
gtk_box_pack_start(GTK_BOX(ctrlBox), vbox, TRUE, TRUE, 0);
#if 0
statusBarCtrl = gtk_statusbar_new();
gtk_box_pack_start(GTK_BOX(vbox), statusBarCtrl, FALSE, FALSE, 0);
gtk_box_pack_start(GTK_BOX(ctrlBox), vbox, TRUE, TRUE, 0);
#endif
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
container = make_controls(STNMAINCTRL);
gtk_container_add(GTK_CONTAINER(frame), container);
gtk_notebook_append_page (GTK_NOTEBOOK(stnControlScreens), frame, gtk_label_new(" Main "));
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
container = make_controls(STNANLCTRL);
gtk_container_add(GTK_CONTAINER(frame), container);
gtk_notebook_append_page (GTK_NOTEBOOK(stnControlScreens), frame, gtk_label_new(" Analysis "));
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
container = make_controls(STNEVTCTRL);
gtk_container_add(GTK_CONTAINER(frame), container);
gtk_notebook_append_page (GTK_NOTEBOOK(stnControlScreens), frame, gtk_label_new(" Event "));
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
container = make_controls(STNSPECCTRL);
gtk_container_add(GTK_CONTAINER(frame), container);
gtk_notebook_append_page (GTK_NOTEBOOK(stnControlScreens), frame, gtk_label_new(" Spectra "));
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
container = make_controls(STNPSDCTRL);
gtk_container_add(GTK_CONTAINER(frame), container);
gtk_notebook_append_page (GTK_NOTEBOOK(stnControlScreens), frame, gtk_label_new(" PSD "));
frame = gtk_frame_new(NULL);
gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
container = make_controls(STNPMCTRL);
gtk_container_add(GTK_CONTAINER(frame), container);
gtk_notebook_append_page (GTK_NOTEBOOK(stnControlScreens), frame, gtk_label_new(" PM "));
gtk_window_set_transient_for((GtkWindow *) stnCtrlWindow, (GtkWindow *) topWindow); 
gtk_widget_show_all (stnCtrlWindow);
}
return;
}
