#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
#define LINELEN 120
#define SEQNUMID "B058F03"
#define SENSID  "B058F04"
static void anaFilter(ANADATA *anaData)
{
_iir(&anaData->dataInfo, &anaData->dataInfo, stnStates.analysis.dataFilter.active);
}
#if 0
static float getSens(char *respFile)
{
char input[LINELEN+1], *line;
int  seqNum;
float sensitivity = 0.0;
FILE *fp = fopen(respFile, "r");
if (!fp)
return sensitivity;
while((line=fgets(input, LINELEN, fp)))
{
if (strstr(input, SEQNUMID))
{
sscanf(input, "%*s %*s %*s %*s %d", &seqNum);
if (seqNum != 0)
continue;  
line=fgets(input, LINELEN, fp);
while (line && !strstr(input, SENSID))
line=fgets(input, LINELEN, fp);
if (line)
sscanf(input, "%*s %*s %f", &sensitivity);
break;
}
}
fclose(fp);
return sensitivity;
}
#endif
void analyzeData(ANADATA *anaData, int tForm)
{
DATAINFO *dataInfo = &anaData->dataInfo;
switch(tForm)
{
case ANADIFFERENTIATE:
{
dxdy(dataInfo);
}
break;
case ANAINTEGRATE:
{ 
integrate(dataInfo);
}
break;
case ANADEMEAN:
demean(dataInfo, dataInfo->amps.mean);
break;
case ANAFILTER:
anaFilter(anaData);
break;
case ANAREVPOL:
polarityReverse(dataInfo);
break;
case ANADETREND:
detrend(dataInfo);
break;
case ANAUVW:
break;
case ANADECONVOLVE:
{
char *respFile = getResp(anaData);
if (respFile)
{
deconvolve(dataInfo, anaData->trc, respFile);
anaData->tForm.deconvolve = TRUE;
}
}
break;
}
}
