#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
#include "util_externs.h"
#define SETMAXMINPTRS(trcData, minPtr, maxPtr) {minPtr = &trcData->data.stats[MIN];maxPtr = &trcData->data.stats[MAX];}
enum {
CHANNELDATA,
TRACEDATA
};
typedef struct _CHNARGS
{
CHNDATA *chnData;
int  chnNum;
} CHNARGS;
typedef struct _TRCARGS
{
TRCDATA *trcData;
TRCPLOT *trcPlot;
} TRCARGS;
extern GdkPixmap *pmap;
extern int  chnW, labelW, labelH, trcCnt, width, height;
extern GDate *startD, *endD;
GSList  *trcPlotList;
int   trcCntr;
gboolean memGovernor = FALSE, freeMem=FALSE;
int   memTrcMax;
static int x;
static char *getMemory(int amount)
{
char  *dataBuf;
if (((dataBuf = calloc(1, amount)) == NULL))
{
freeMem = TRUE;
freeTrcData(trcPlotList);
memGovernor = TRUE;
memTrcMax = trcCntr;
dataBuf = calloc(1, amount);
}
return dataBuf;
}
gint sortTrcArgs(TRCARGS *trcA1, TRCARGS *trcA2)
{
TRCPLOT *trc1=trcA1->trcPlot, *trc2=trcA2->trcPlot;
return (trc1->pixel[STARTDT] - trc2->pixel[STARTDT] + 1);
}
static gboolean updateProg(gpointer i)
{
gboolean init = (gboolean) GPOINTER_TO_INT(i);
gdouble prog;
char progText[65];
if (stnSettings.main.data != STNDTA)
return FALSE;
if (init)
{
trcCntr = 0;
gtk_widget_show(stnProgBar);
gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR (stnProgBar), (double) 0.0);
sprintf(progText, "(0 of %d) 0%%", trcCnt);
gtk_progress_bar_set_text(GTK_PROGRESS_BAR (stnProgBar), progText);
return FALSE;
}
prog = (gdouble) ((++trcCntr)/(gdouble) trcCnt);
if (prog>1.0)
return FALSE;
gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR (stnProgBar), (prog));
sprintf(progText, "(%d of %d) %4.1f%%", trcCntr, trcCnt, (prog)*100.);
gtk_progress_bar_set_text(GTK_PROGRESS_BAR (stnProgBar), progText);
return FALSE;
}
static void maxMinGlbl(GSList *chnBeg)
{
GSList *chnIter; 
CHNDATA *chnData;
double max, min;
switch(stnSettings.display.yScale[STNMAIN])
{
case WINDS:  
chnIter=chnBeg;
chnData = chnIter->data;
max = chnData->display.stats[RELATIVE][MAX];
min = chnData->display.stats[RELATIVE][MIN];
for(chnIter=g_slist_next(chnIter);
chnIter;
chnIter=g_slist_next(chnIter))
{
chnData = chnIter->data;
if (chnData->display.stats[RELATIVE][MAX] > max)
max = chnData->display.stats[RELATIVE][MAX];
if (chnData->display.stats[RELATIVE][MIN] < min)
min = chnData->display.stats[RELATIVE][MIN];
}
for(chnIter=chnBeg;chnIter;chnIter=g_slist_next(chnIter))
{
chnData = chnIter->data;
chnData->display.stats[ABSOLUTE][MAX] = max;
chnData->display.stats[ABSOLUTE][MIN] = min;
}
break;
case CHNGROUPS: 
{
int  i;
double val;
char *chnName;
GSList *iter, *autoScaleIter;
AUTOSCALE *autoScale;
YCHNSCALE *yChnScale;
for(chnIter=chnBeg;chnIter;chnIter=g_slist_next(chnIter))
{ 
chnData = chnIter->data;
chnData->display.stats[ABSOLUTE][MAX] = chnData->display.stats[RELATIVE][MAX];
chnData->display.stats[ABSOLUTE][MIN] = chnData->display.stats[RELATIVE][MIN];
}
for(chnIter=chnBeg;chnIter;chnIter=g_slist_next(chnIter))
{
chnData = chnIter->data;
chnName = getChnGrpName(chnData->data.name, STNMAIN);
if (!chnName)
continue;  
autoScaleIter = g_slist_find_custom(stnStates.display.yScaleGrp[STNMAIN].autoScale,
chnName, (GCompareFunc) getAutoScale);
if (!autoScaleIter)
continue;
autoScale = autoScaleIter->data;
autoScale->channels = g_slist_append(autoScale->channels, chnData);
}
for(iter = stnStates.display.yScaleGrp[STNMAIN].autoScale;
iter;
iter = g_slist_next(iter))
{
autoScale = iter->data;
if (!autoScale->channels) 
continue;
yChnScale = g_slist_find_custom(stnStates.display.yScaleGrp[STNMAIN].chnGroupScale->chnScales,
autoScale->name, (GCompareFunc) getChnScale)->data;
for(i=0;i<2; i++)
{ 
if (!strcmp(yChnScale->scale[i], YSCALEAUTO))
{ 
chnIter = autoScale->channels;
chnData = chnIter->data;
val = chnData->display.stats[RELATIVE][i];
for(chnIter=g_slist_next(chnIter);
chnIter;
chnIter=g_slist_next(chnIter))
{ 
chnData = chnIter->data;
switch(i)
{
case MAX:
val = (chnData->display.stats[RELATIVE][i] > val)
? chnData->display.stats[RELATIVE][i]
: val;
break;
case MIN:
val = (chnData->display.stats[RELATIVE][i] < val)
? chnData->display.stats[RELATIVE][i]
: val;
break;
}
}
for(chnIter=autoScale->channels;
chnIter;
chnIter=g_slist_next(chnIter))
{ 
chnData = chnIter->data;
chnData->display.stats[ABSOLUTE][i] = val;
}
}
}
}
}
break;
}
}
void maxMin(CHNDATA *chnData)
{ 
GSList *trcIter = chnData->data.traceFiles;
TRCDATA *trcData;
double *minPtr, *maxPtr, factor=1.0;
trcData = trcIter->data;
while(trcIter && !trcData->display.plot)
{ 
trcIter = g_slist_next(trcIter);
if (trcIter)
trcData = trcIter->data;
}
if (!trcIter)
return;
if (stnSettings.display.units[STNMAIN] == STNSENSITIVITY &&
chnData->data.chnMETA)
{
CHNMETA *chnMeta;
chnMeta = chnData->data.chnMETA->data;
factor = ((chnMeta->sensitivity) ? chnMeta->sensitivity : (double) 1.0);
}
SETMAXMINPTRS(trcData, minPtr, maxPtr)
chnData->display.stats[RELATIVE][MAX] = *maxPtr / factor;
chnData->display.stats[RELATIVE][MIN] = *minPtr / factor;
trcIter = g_slist_next(trcIter);
while(trcIter)
{
trcData = trcIter->data;
if (!trcData->display.plot)
{
trcIter = g_slist_next(trcIter);
continue;
}
SETMAXMINPTRS(trcData, minPtr, maxPtr)
if (chnData->display.stats[RELATIVE][MAX] < *maxPtr/factor)
chnData->display.stats[RELATIVE][MAX] = *maxPtr/factor;
if (chnData->display.stats[RELATIVE][MIN] > *minPtr/factor)
chnData->display.stats[RELATIVE][MIN] = *minPtr/factor;
trcIter = g_slist_next(trcIter);
}
}
static void setMaxMin(CHNDATA *chnData, double *max, double *min)
{
double input[2][2];
input[ABSOLUTE][MAX] = chnData->display.stats[ABSOLUTE][MAX];
input[ABSOLUTE][MIN] = chnData->display.stats[ABSOLUTE][MIN];
input[RELATIVE][MAX] = chnData->display.stats[RELATIVE][MAX];
input[RELATIVE][MIN] = chnData->display.stats[RELATIVE][MIN];
switch(stnSettings.display.yScale[STNMAIN])
{
case WINDS:
if (stnStates.display.dataState == STNDRAWREFRESH)
{ 
*max = input[ABSOLUTE][MAX];
*min = input[ABSOLUTE][MIN];
}
else
{ 
*max = input[RELATIVE][MAX];
*min = input[RELATIVE][MIN];
}
break;
case DISPS:
*max = input[RELATIVE][MAX];
*min = input[RELATIVE][MIN];
break;
case CHNGROUPS:
if (stnStates.display.dataState == STNDRAWREFRESH)
{ 
*max = input[ABSOLUTE][MAX];
*min = input[ABSOLUTE][MIN];
}
else
{
char *mxmnS;
double maxT=input[RELATIVE][MAX], 
minT=input[RELATIVE][MIN],
mxmn, diff;
diff=maxT-minT;
mxmnS = getChnGrpScale(chnData->data.name, STNMAIN, MAX);
if (!strcmp(mxmnS, YSCALEAUTO))
{ 
*max = maxT;
}
else if (getUserMaxMin(mxmnS, &mxmn))
{ 
*max = maxT - (float) (diff/2) * (float) (mxmn/100.);
chnData->display.stats[RELATIVE][MAX] = *max;
}
else
{ 
if (strlen(mxmnS))
*max = mxmn;
else
*max = maxT;
chnData->display.stats[RELATIVE][MAX] = *max;
}
mxmnS = getChnGrpScale(chnData->data.name, STNMAIN, MIN);
if (!strcmp(mxmnS, YSCALEAUTO))
{ 
*min = minT;
}
else if (getUserMaxMin(mxmnS, &mxmn))
{ 
*min = minT + (float) (diff/2) * (float) (mxmn/100.);
chnData->display.stats[RELATIVE][MIN] = *min;
}
else
{ 
if (strlen(mxmnS))
*min = mxmn;
else
*min = minT;
chnData->display.stats[RELATIVE][MIN] = *min;
}
}
break;
case FIXEDS:
{
char *mxmnS;
double maxT=input[RELATIVE][MAX], 
minT=input[RELATIVE][MIN],
mxmn, diff; 
diff=maxT-minT;
mxmnS = (char *) gtk_entry_get_text(GTK_ENTRY(stnYfixed[STNMAIN][MAX]));
if (getUserMaxMin(mxmnS, &mxmn))
{ 
*max = maxT - (float) (diff/2) * (float) (mxmn/100.);
}
else
{ 
if (strlen(mxmnS))
*max = mxmn;
else
*max = maxT;
}
mxmnS = (char *) gtk_entry_get_text(GTK_ENTRY(stnYfixed[STNMAIN][MIN]));
if (getUserMaxMin(mxmnS, &mxmn))
{ 
*min = minT + (float) (diff/2) * (float) (mxmn/100.);
}
else
{ 
if (strlen(mxmnS))
*min = mxmn;
else
*min = minT;
}
}
break;
}
if (*max==*min)
{ 
(*max)++; (*min)--;
}
}
static int chnAxisPlot(CHNARGS *chnArgs)
{
graph chnGR;
double max, min;
CHNDATA *chnData = chnArgs->chnData;
int  chnNum = chnArgs->chnNum, format=MYINT;
char *units;
setMaxMin(chnData, &max, &min);
if (stnSettings.display.units[STNMAIN] == STNSENSITIVITY &&
chnData->data.chnMETA)
{
CHNMETA *chnMeta;
chnMeta = chnData->data.chnMETA->data;
format = MYFLOAT;
if (!strncmp(chnMeta->units, "M/S", 3))
{
units = g_strdup_printf("%s*", chnMeta->units);
}
else
{
units = g_strdup_printf("%s", chnMeta->units);
}
}
else
{
units = g_strdup("counts");
}
viewport(&chnGR, STNLFTM, STNLFTM+YAXISW, STNTOPBD, STNBOTBD);
window(&chnGR, (double) 0, (double) 10, (double) min, (double) max, 0, 0);
fontDrawPR(pmap, units, 
STNLFTM - fontSIZEP(units, STNLBLF, HEIGHT) - 2, 
STNBOTBD - fontSIZEP(units, STNLBLF, WIDTH) - 1, 
STNLBLF, STNFLBL);
free(units);
yaxisP(pmap, stnSettings.drawing.ctxts[STNMAIN][STNFGBG][NORMALGC], &chnGR, 
(double) 0, (double) chnGR.user_ymin, (double) chnGR.user_ymax, 
1, 1, 0, (double) 0.0, format, PDFSTATSF);
free(chnArgs);
return FALSE;
}
static gboolean trcPlotData(TRCARGS *trcArgs)
{
CHNARGS *chnArgs2;
TRCPLOT *trcPlot=trcArgs->trcPlot;
TRCDATA *trcData=trcArgs->trcData;
GDate *startT, *endT;
traceInfo *trc;
graph trcGR, chnGR;
struct ptime date;
int  increment, chnNum;
double ttlSecs, start, stop, max, min;
if (!trcData ||  
!trcPlot)
return FALSE;
chnNum=trcPlot->chnNum;
trc = (traceInfo *) trcData->display.trc;
start = 0.0;
stop = trc->data.head.length;
ttlSecs = stop - start;
viewport(&chnGR, x, chnW+x, STNTOPM+(chnNum*stnStates.display.chnH), 
STNTOPM+((chnNum+1)*stnStates.display.chnH));
window(&chnGR, (double) g_date_julian(startD), (double) g_date_julian(endD),
(double) 0.0, (double) stnStates.display.chnH, 0, 0);
passcal_etoh(&date, trc->data.head.epochs);
startT = g_date_new_dmy(date.day, date.mo, date.yr);
trcPlot->time[STARTDT] = (double) ((double) g_date_julian(startT) + 
(double) ((double)(date.hr*3600. + date.mn*60. + date.sec) /
(double) ONEDAYOFSECS));
passcal_etoh(&date, trc->data.head.epochStop);
endT = g_date_new_dmy(date.day, date.mo, date.yr);
trcPlot->time[ENDDT] = (double) ((double) g_date_julian(endT) + 
(double) ((double)(date.hr*3600. + date.mn*60. + date.sec) /
(double) ONEDAYOFSECS));
trcData->display.pixelPos[STARTDT] = 
trcPlot->pixel[STARTDT] = USER2PIXX(&chnGR, trcPlot->time[STARTDT]);
trcData->display.pixelPos[ENDDT] = 
trcPlot->pixel[ENDDT] = USER2PIXX(&chnGR, trcPlot->time[ENDDT]);
if (trcPlot->pixel[STARTDT] < chnGR.pix_xmin)
trcPlot->pixel[STARTDT] = chnGR.pix_xmin;
if (trcPlot->pixel[ENDDT] > chnGR.pix_xmax)
trcPlot->pixel[ENDDT] = chnGR.pix_xmax;
setMaxMin(trcPlot->chnData, &max, &min);
if (stnSettings.display.units[STNMAIN] == STNSENSITIVITY &&
trcPlot->chnData->data.chnMETA)
{
CHNMETA *chnMeta = trcPlot->chnData->data.chnMETA->data;
max *= chnMeta->sensitivity;
min *= chnMeta->sensitivity;
}
viewport(&trcGR, trcPlot->pixel[STARTDT], trcPlot->pixel[ENDDT], STNTOPBD, STNBOTBD);
window(&trcGR, start, stop, (double) min, (double) max, 0, 0);
increment = getSTNDataInc(ttlSecs, trcPlot->pixel[ENDDT] - trcPlot->pixel[STARTDT], 
trc->data.head.sampInt);
plotSTNtrc(pmap, &trcGR, trc, NULL, (double) start, increment, chnNum, STNMAIN);
if (freeMem)
{
freeMyData(TRCINFO, trc);
free(trc);
trcData->display.trc = NULL;
}
else
{ 
trcPlotList = g_slist_prepend(trcPlotList, trcData);
}
free(trcArgs);
if (stnSettings.display.yAxis[STNMAIN] == ON)
{
chnArgs2 = calloc(1, sizeof(CHNARGS));
chnArgs2->chnData = trcPlot->chnData;
chnArgs2->chnNum = chnNum;
chnAxisPlot(chnArgs2);
}
return FALSE;
}
static TRCARGS *trcReadData(TRCDATA *trcData, TRCPLOT *trcPlot, gboolean readData)
{
traceInfo *trc;
TRCARGS  *trcArgs;
trcArgs = calloc(1, sizeof(TRCARGS));
if (readData)
{ 
if (!trcData->display.trc)
{ 
trc = trcData->display.trc = calloc(1, sizeof(traceInfo));
trc->data.fileName = g_strdup(trcData->data.name);
if(readTrace(trc) == NO_MEMORY)
{
freeTrcData(trcPlotList);
readTrace(trc);
}
}
else
{
trc = trcData->display.trc;
}
}
if (readData && trc->data.dataInfo.data)
{ 
trcArgs->trcData = trcData;
trcArgs->trcPlot = trcPlot;
trcData->display.plot = TRUE;
}
else 
{ 
if (readData && !trc->data.dataInfo.data)
{ 
trcData->display.plot = FALSE;
free(trcArgs->trcPlot);
free(trcArgs);
trcArgs = NULL;
}
else
{ 
trcArgs->trcData = trcData;
trcArgs->trcPlot = trcPlot;
trcData->display.plot = TRUE;
}
}
g_idle_add((GSourceFunc) updateProg, GINT_TO_POINTER(FALSE));
return(trcArgs);
}
#define ONEDAYOFPIXELS (chnW/stnSettings.main.days)
static int chnPlotData(CHNARGS *chnArgs)
{
graph chnGR;
GSList *trcIter;
TRCDATA *trcData;
TRCPLOT *trcPlot=NULL, *trcPlotN;
TRCARGS *readTrace, *trcArgs;
GSList *readTraces=NULL, *readTrcIter, **trcsToMarry;
GDate *start, *end;
CHNDATA *chnData = chnArgs->chnData;
PQLDATA *pqlOut, *pqlIn;
traceInfo *trc;
int   chnNum=chnArgs->chnNum, pixelEnd;
DATAINFO *dataInfo;
int   j, activeFilter = stnStates.display.dataFilter.active, lastPixel=0; 
gboolean readData = (chnData->display.trcData ? FALSE : TRUE), lastDay=FALSE;
double  timeEnd;
gboolean dataExists=TRUE;
char  *trcname;
viewport(&chnGR, x, chnW+x, STNTOPM+(chnNum*stnStates.display.chnH), 
STNTOPM+((chnNum+1)*stnStates.display.chnH));
window(&chnGR, (double) g_date_julian(startD), (double) g_date_julian(endD),
(double) 0.0, (double) stnStates.display.chnH, 0, 0);
if (!chnData->data.trcCnt)
{ 
g_idle_add((GSourceFunc) nextChannel, GINT_TO_POINTER(NEXT));
return FALSE;
}
if (!chnData->display.trcData)
{
for (trcIter=chnData->data.traceFiles;
trcIter;
trcIter = g_slist_next(trcIter))
{
trcData = trcIter->data;
if (!trcData)
continue;
if (!strcmp(trcData->data.name, "/") ||
!trcData->display.plot)
{ 
trcData->display.plot = FALSE;
continue;
}
trcPlot = calloc(1, sizeof(TRCPLOT));
trcPlot->chnData = chnData;
trcPlot->chnNum = chnNum;
start = g_date_new_dmy( trcData->data.dates[STARTDT].date.day, 
trcData->data.dates[STARTDT].date.mo, 
trcData->data.dates[STARTDT].date.yr);
trcPlot->time[STARTDT] = (double) ((double) g_date_julian(start) + 
(double) ((double)(trcData->data.dates[STARTDT].date.hr*3600. + 
trcData->data.dates[STARTDT].date.mn*60. +
trcData->data.dates[STARTDT].date.sec)/(double) ONEDAYOFSECS));
end = g_date_new_dmy(trcData->data.dates[ENDDT].date.day, 
trcData->data.dates[ENDDT].date.mo, 
trcData->data.dates[ENDDT].date.yr);
trcPlot->time[ENDDT] = (double) ((double) g_date_julian(end) + 
(double) ((double)(trcData->data.dates[ENDDT].date.hr*3600. + 
trcData->data.dates[ENDDT].date.mn*60. +
trcData->data.dates[ENDDT].date.sec)/(double) ONEDAYOFSECS));
trcData->display.pixelPos[STARTDT] = 
trcPlot->pixel[STARTDT] = USER2PIXX(&chnGR, trcPlot->time[STARTDT]);
trcData->display.pixelPos[ENDDT] = 
trcPlot->pixel[ENDDT] = USER2PIXX(&chnGR, trcPlot->time[ENDDT]);
if (trcPlot->pixel[STARTDT] < chnGR.pix_xmin)
trcPlot->pixel[STARTDT] = chnGR.pix_xmin;
if (trcPlot->pixel[ENDDT] > chnGR.pix_xmax)
trcPlot->pixel[ENDDT] = chnGR.pix_xmax;
if ((readTrace=trcReadData(trcData, trcPlot, readData)))
{
readTraces = g_slist_append(readTraces, readTrace);
}
if (julian(&trcData->data.dates[ENDDT].date) == 
(g_date_get_day_of_year(stnSettings.display.dates[ENDDT])-1) &&
!trcIter->next)  
{
double midnight;
trc = trcData->display.trc;
midnight = getMidnight(trc->data.head.epochs);
trcData->display.pixelPos[ENDDT] = trcPlot->pixel[ENDDT] = 
(int) ((trc->data.head.length)/(ONEDAYOFSECS) * ONEDAYOFPIXELS) + 
(int) ((trc->data.head.epochs-midnight)/(ONEDAYOFSECS) * ONEDAYOFPIXELS) +
USER2PIXX(&chnGR, g_date_julian(endD)-1);
if (trcPlot->pixel[ENDDT] > chnGR.pix_xmax)  
trcData->display.pixelPos[ENDDT] = trcPlot->pixel[ENDDT] = chnGR.pix_xmax;
trcData->display.lastDay = TRUE; 
lastDay = TRUE;
lastPixel = trcData->display.pixelPos[ENDDT];
trcPlot->time[ENDDT] = (double) ((double) g_date_julian(end) + 
(double) ((double)(trc->data.head.length)/(double) ONEDAYOFSECS));
}
if (trcPlot->pixel[STARTDT] >= trcPlot->pixel[ENDDT]
&& !trcIter->next)
{ 
trcData->display.plot = FALSE;
chnData->data.trcCnt--;   
g_idle_add((GSourceFunc) updateProg, GINT_TO_POINTER(FALSE));
continue;
}
}
}
else
{ 
trcPlot = NULL;
readTraces = NULL;
readTrace = calloc(1, sizeof(TRCARGS));
readTrace->trcData = chnData->display.trcData;
readTrace->trcPlot = chnData->display.trcPlot;
readTraces = g_slist_append(readTraces, readTrace);
}
switch(g_slist_length(readTraces))
{
case 0:  
trcArgs = calloc(1, sizeof(TRCARGS));
trcArgs->trcPlot = trcPlot;
dataExists = FALSE;
break;
case 1:  
trcArgs = readTraces->data;
trcData = trcArgs->trcData;
trcname = trcData->data.name;
if (!trcPlot)
{ 
trcPlotN = chnData->display.trcPlot;
}
else
{
trcPlotN = trcPlot;
}
if (readData)
{ 
double startE, endE; 
pqlIn = calloc(1, sizeof(PQLDATA));
pqlIn->trc = trcData->display.trc;
pqlIn->trcData = trcData;
startE = GDate2Epoch(chnGR.user_xmin);
endE = GDate2Epoch(chnGR.user_xmax);
pqlOut = cutTrc(pqlIn, startE, endE);
}
break;
default: 
trcsToMarry = calloc(1, sizeof(GSList *));
trcPlotN = calloc(1, sizeof(TRCPLOT));
trcPlotN->chnData = chnData;
trcPlotN->chnNum = chnNum;
readTraces = g_slist_sort(readTraces, (GCompareFunc) sortTrcArgs);
readTrcIter = readTraces;
trcArgs = readTrcIter->data;
trcPlot = trcArgs->trcPlot;
trcPlotN->time[STARTDT] = trcPlot->time[STARTDT];
trcPlotN->pixel[STARTDT] = trcPlot->pixel[STARTDT];
while(readTrcIter)
{
trcArgs = readTrcIter->data;
trcPlot = trcArgs->trcPlot;
trcData = trcArgs->trcData;
if (readData)
{
pqlIn = calloc(1, sizeof(PQLDATA));
trc = pqlIn->trc = trcData->display.trc;
pqlIn->trcData = trcData;
*trcsToMarry = g_slist_prepend(*trcsToMarry, pqlIn);
}
timeEnd = trcPlot->time[ENDDT];
pixelEnd = trcPlot->pixel[ENDDT];
trcname = trcData->data.name;
free(trcPlot);
free(trcArgs);
readTrcIter = g_slist_next(readTrcIter);
}
trcPlotN->time[ENDDT] = timeEnd;
trcPlotN->pixel[ENDDT] = pixelEnd;
if (readData)
{
double startE, endE;
*trcsToMarry = g_slist_sort(*trcsToMarry, (GCompareFunc) sortTrcs);
startE = GDate2Epoch(chnGR.user_xmin);
endE = GDate2Epoch(chnGR.user_xmax);
pqlOut = marryTrcs(*trcsToMarry, startE, endE);
g_slist_free(*trcsToMarry);
}
break;
}
if (dataExists)
{
if (readData)
{
trcData = calloc(1, sizeof(TRCDATA));
trcData->keys.trcKey = NONE * chnNum;
trcData->display.plot = TRUE;
trcData->data.name = g_strdup(trcname);
chnData->display.trcData = trcData;
trcData->display.trc = pqlOut->trc;
trcData->display.pixelPos[STARTDT] = trcPlotN->pixel[STARTDT];
trcData->display.pixelPos[ENDDT] = trcPlotN->pixel[ENDDT];
if (lastDay)
{
trcData->display.pixelPos[ENDDT] = lastPixel;
trcData->display.lastDay = TRUE; 
}
trc = trcData->display.trc;
get_maxmin_amp(trc);
chnData->display.stats[RELATIVE][MIN] = 0;  
chnData->display.stats[RELATIVE][MAX] = 0;
chnData->display.numGaps = trc->trace.numGaps;
chnData->display.numOlaps = trc->trace.numOlaps;
free(pqlOut);
}
trcArgs = calloc(1, sizeof(TRCARGS));
trcArgs->trcData = chnData->display.trcData;
trcArgs->trcPlot = trcPlotN;
chnData->display.trcPlot = trcPlotN;
trc = chnData->display.trcData->display.trc;
if (trc->data.dataInfo.data && 
stnStates.display.dataFilter.on && 
activeFilter != NONE)
{
if (!trc->data.dataFilt)
{ 
for(j=0;j<settings.general.filter.numFilters;j++)
{
dataInfo = calloc(1, sizeof(DATAINFO));
trc->data.dataFilt = g_slist_append(trc->data.dataFilt, dataInfo);
}
}
dataInfo = g_slist_nth_data(trc->data.dataFilt, activeFilter);
if (!dataInfo->data)
{ 
dataInfo->data = getMemory(trc->data.dataInfo.head.numSamples*sizeof(float));
get_maxmin_amp(trc);
_iir(&trc->data.dataInfo, dataInfo, activeFilter);
}
if (stnSettings.display.units[STNMAIN] == STNSENSITIVITY &&
chnData->data.chnMETA)
{
CHNMETA *chnMeta = chnData->data.chnMETA->data;
chnData->display.stats[RELATIVE][MIN] = dataInfo->amps.min/chnMeta->sensitivity;
chnData->display.stats[RELATIVE][MAX] = dataInfo->amps.max/chnMeta->sensitivity;
}
else
{
chnData->display.stats[RELATIVE][MAX] = dataInfo->amps.max;
chnData->display.stats[RELATIVE][MIN] = dataInfo->amps.min;
}
trcArgs->trcData = chnData->display.trcData;
}
else
{
if (trc->data.dataInfo.data)
{
if (stnSettings.display.units[STNMAIN] == STNSENSITIVITY &&
chnData->data.chnMETA)
{
CHNMETA *chnMeta = chnData->data.chnMETA->data;
chnData->display.stats[RELATIVE][MIN] = 
trc->data.dataInfo.amps.min/chnMeta->sensitivity;
chnData->display.stats[RELATIVE][MAX] = 
trc->data.dataInfo.amps.max/chnMeta->sensitivity;
}
else
{
chnData->display.stats[RELATIVE][MIN] = trc->data.dataInfo.amps.min;
chnData->display.stats[RELATIVE][MAX] = trc->data.dataInfo.amps.max;
}
}
}
}
g_slist_free(readTraces);
free(chnArgs);
freeTrcData(chnData->data.traceFiles);  
g_idle_add((GSourceFunc) trcPlotData, trcArgs);
g_idle_add((GSourceFunc) nextChannel, GINT_TO_POINTER(NEXT));
return FALSE;
}
enum {
STNNXTDUMMY,
STNNXTCHN,
STNNXTPREFINISH,
STNNXTFINISH
};
static GStaticMutex myMutex = G_STATIC_MUTEX_INIT;
gboolean nextChannel(gpointer s)
{
int    stage = GPOINTER_TO_INT(s);
static GSList *chnIter;
static int  chnNum;
CHNDATA   *chnData;
CHNARGS   *chnArgs;
static int  threadCnt;
int    state;
if (g_async_queue_length(drawQ))
{ 
if (threadCnt)
{
threadCnt--;
if (!threadCnt)
{ 
g_idle_add((GSourceFunc) readDrawQ, NULL);
}
}
else
{ 
g_idle_add((GSourceFunc) readDrawQ, NULL);
}
return FALSE;
}
g_static_mutex_lock(&myMutex);
switch(stage)
{
case INIT1:
if (stnStates.display.dataState == STNDRAWINIT &&
stnStates.display.yScaleGrp[STNMAIN].autoScale)
{ 
AUTOSCALE *autoScale;
GSList *iter;
for(iter = stnStates.display.yScaleGrp[STNMAIN].autoScale;
iter;
iter = g_slist_next(iter))
{
autoScale = iter->data;
g_slist_free(autoScale->channels);
autoScale->channels = NULL;
}
}
if (stnSettings.display.yAxis[STNMAIN])
x = STNLFTM+10;
else
x = STNLFTM;
updateProg(GINT_TO_POINTER(TRUE));
chnIter = stnStates.main.chnList;
chnNum = 0;
threadCnt=0;
if (memGovernor && trcCnt > memTrcMax)
freeMem = TRUE;
else
freeMem = FALSE;
trcPlotList = NULL;
if(chnIter)
chnData = chnIter->data;
break;
case NEXT:
{
GdkPixmap *pmapInterim = gdk_pixmap_new(STNDA[STNMAIN]->window, width, height, -1);
gdk_draw_drawable(pmapInterim, 
STNDA[STNMAIN]->style->fg_gc[GTK_WIDGET_STATE (STNDA[STNMAIN])],
pmap, 0, 0, 0, 0, -1, -1);
g_object_unref(stnStates.pmap.main[stnSettings.main.data]);
stnStates.pmap.main[stnSettings.main.data] = pmapInterim;
gdk_draw_drawable(STNDA[STNMAIN]->window, 
STNDA[STNMAIN]->style->fg_gc[GTK_WIDGET_STATE (STNDA[STNMAIN])],
pmapInterim, 0, 0, 0, 0, width, height);
threadCnt--;
}
case INIT2:
if (chnIter)
chnIter = g_slist_next(chnIter);
chnNum++;
break;
}
if (chnIter)
{ 
chnData = chnIter->data;
threadCnt++;
if (chnData->keys.chnKey == NONE)
state = STNNXTDUMMY;
else
state = STNNXTCHN;
}
else
{ 
if (!threadCnt)
state = STNNXTFINISH;
else
state = STNNXTPREFINISH;
}
g_static_mutex_unlock(&myMutex);
switch(state)
{
case STNNXTDUMMY:
fontDrawP(pmap, "No CHANNELS Match Current Filter", 
STNLFTM, STNTOPM + chnNum*stnStates.display.chnH + stnStates.display.chnH/3, 
STNLBLF, STNFLBL);
g_idle_add((GSourceFunc) nextChannel, GINT_TO_POINTER(NEXT));
break;
case STNNXTCHN:
chnArgs = calloc(1, sizeof(CHNARGS));
chnArgs->chnData = chnIter->data;
chnArgs->chnNum = chnNum;
makeThread(ASYNC, (GThreadFunc) chnPlotData, chnArgs, NULL);
gdk_window_set_cursor(topLevel, hourCursor);
break;
case STNNXTPREFINISH:
break;     
case STNNXTFINISH:
setSensitive(STNSYSTEM, STNDATABUSYSENS, STNMAIN, TRUE);
if (stnStates.display.dataFilter.active == NONE)
setSensitive(STNSYSTEM, STNNOFILTERSENS, STNMAIN, FALSE);
gdk_window_set_cursor(topLevel, NULL);
gtk_widget_hide(stnProgBar);
g_object_unref(stnStates.pmap.main[stnSettings.main.data]);
stnStates.pmap.main[stnSettings.main.data] = pmap;
stnStates.request.plotBUSY = FALSE;
g_slist_free(trcPlotList);
switch(stnStates.display.dataState)
{
case STNDRAWINIT:
switch (stnSettings.display.yScale[STNMAIN])
{
case CHNGROUPS:
if (!stnStates.display.yScaleGrp[STNMAIN].autoScale)
{ 
stnStates.display.dataState = STNDRAWDONE;
break;
}
case WINDS:  
setSensitive(STNSYSTEM, STNDATABUSYSENS, STNMAIN, FALSE);
maxMinGlbl(stnStates.main.chnList);
stnStates.display.dataState = STNDRAWREFRESH;
pmap = gdk_pixmap_new(STNDA[STNMAIN]->window, width, height, -1);
gdk_draw_drawable(pmap, 
STNDA[STNMAIN]->style->fg_gc[GTK_WIDGET_STATE (STNDA[STNMAIN])],
stnStates.pmap.main[stnSettings.main.data], 0, 0, 0, 0, -1, -1);
gdk_draw_rectangle (pmap, 
stnSettings.drawing.ctxts[STNMAIN][STNFGBG][ABNORMALGC],
TRUE,STNLFTM, STNTOPM,
width-(STNRGTM+STNLFTM), height-(STNBOTM+STNTOPM));
g_idle_add((GSourceFunc) stnDataInstance, NULL);
break;
default:
stnStates.display.dataState = STNDRAWDONE;
break;
}
break;
case STNDRAWREFRESH:
stnStates.display.dataState = STNDRAWDONE;
break;
case STNDRAWDONE:
break;
}
break;
}
return FALSE;
}
