#include <stdlib.h>
#include <string.h>
#include <math.h>
#ifndef MAC
#include <values.h>
#endif
#include "pqlx_defs.h"
#include "pql_defines.h"
#include "pqlx_externs.h"
#include "pql_externs.h"
#include "gtk_pql_externs.h"
#include "pqlx_stn.h"
#include "gtk_stn_externs.h"
static void ANAminMax(GSList *traces)
{
int i, dataFormat;
gint32 *ptr=NULL;
short *sptr=NULL;
float  *lptr=NULL;
double  sps, *dptr=NULL, dataV;
int ptInc, startPoint, endPoint;
GSList  *anaIter;
traceInfo *trcData;
ANADATA  *anaData;
states.magnify.absAmp.diff = 0;
states.magnify.absAmp.diffVolts = 0;
states.magnify.absAmp.min = 100000000.;
states.magnify.absAmp.max = states.magnify.absAmp.min * -1;
for(anaIter = traces, i=0;
anaIter;
anaIter = g_slist_next(anaIter), i++)
{
anaData = ((PQLDATA *) (anaIter->data))->anaData;
trcData = ((PQLDATA *) (anaIter->data))->trc;
sps = 1000000. / (double) trcData->data.head.sampInt;
startPoint = (int) ((ceil)((trcData->magnify.begin-trcData->data.head.epochs) * sps));
endPoint = (int) ((trcData->magnify.end-trcData->data.head.epochs) * sps);
dataFormat = MY_FLOAT;
lptr = (float *) anaData->dataInfo.data;
if (trcData->magnify.begin == -1) 
{
continue; 
}
anaData->dataInfo.amps.max = -1 * G_MAXFLOAT;
anaData->dataInfo.amps.min = G_MAXFLOAT;
for (ptInc = startPoint; ptInc < endPoint; ++ptInc)
{
DATAP(dataFormat, ptInc, dataV);
if (trcData->trace.numGaps)
{ 
if (dataV == 0.)
continue; 
}
if (dataV > anaData->dataInfo.amps.max)
{
anaData->dataInfo.amps.max = dataV;
if ( anaData->dataInfo.amps.min < anaData->dataInfo.amps.max)
continue;
}
if (dataV < anaData->dataInfo.amps.min)
anaData->dataInfo.amps.min = dataV;
}
if ((anaData->dataInfo.amps.max) == (anaData->dataInfo.amps.min)) 
{
anaData->dataInfo.amps.max += 1.;
anaData->dataInfo.amps.min -= 1.;
}
}    
}
void magNumPts(traceInfo *trcData, ANADATA *anaData)
{
int temp_int_2, temp_int;
double temp_float;
temp_float = ((1000000.0/trcData->data.head.sampInt) *
(trcData->magnify.begin - trcData->data.head.epochs));
temp_int_2 = ((ceil)(temp_float)); 
temp_int = temp_int_2 * dsizes[MY_FLOAT];
trcData->magnify.data_start = (char *) (((long) anaData->dataInfo.data) + temp_int);
trcData->magnify.num_points_shown = (int) ((1000000. / trcData->data.head.sampInt) * 
(trcData->magnify.end - trcData->magnify.begin));
}
static void ANAstartTimes(GSList *traces)
{
float length_of_trace;
double user_x1, user_x2;
double targ_diff;
int temp_int_2, i, temp_int;
double temp_float;
GSList  *anaIter;
ANADATA  *anaData;
traceInfo  *trcData;
double  start=0, stop, absStart=0, absStop=0, relLen, totLen;
user_x1 = stnStates.analysis.plot.limits.selection.user.left;
user_x2 = stnStates.analysis.plot.limits.selection.user.right;
stnStates.analysis.plot.limits.selection.user.length = user_x2 - user_x1;
for(anaIter = traces, i=0, relLen=0;
anaIter;
anaIter = g_slist_next(anaIter), i++)
{
anaData = ((PQLDATA *) (anaIter->data))->anaData;
trcData = ((PQLDATA *) (anaIter->data))->trc;
start = trcData->data.head.epochs;
stop = start + ((anaData->dataInfo.head.numSamples) * (trcData->data.head.sampInt/1000000.) - 
(trcData->data.head.sampInt/1000000.));
switch(stnSettings.display.xScale)
{
case ABSOLUTE:
if (!i)
absStart = start;
else if (absStart > start)
absStart = start;
if (absStop < stop)
absStop = stop;
break;
case RELATIVE:
if (stop-start > relLen)
relLen = stop - start;
break;
}
}
switch(stnSettings.display.xScale)
{
case ABSOLUTE:
totLen = absStop - absStart;
stnStates.analysis.plot.limits.times[STARTABS] = absStart;
stnStates.analysis.plot.limits.times[STOPABS] = absStop;
break;
case RELATIVE:
totLen = relLen;
stnStates.analysis.plot.limits.times[STARTABS] = 0;
stnStates.analysis.plot.limits.times[STOPABS] = totLen;
break;
}
for(anaIter = traces;
anaIter;
anaIter = g_slist_next(anaIter))
{
anaData = ((PQLDATA *) (anaIter->data))->anaData;
trcData = ((PQLDATA *) (anaIter->data))->trc;
trcData->magnify.offset = 0;
length_of_trace = (float) trcData->data.dataInfo.head.numSamples / 
(1000000. / trcData->data.head.sampInt);
switch (stnSettings.display.xScale) 
{
case ABSOLUTE:
start = absStart;
break;
case RELATIVE:
start = trcData->data.head.epochs;
break;
}
if (!user_x1 &&
!user_x2)
{
trcData->magnify.begin = trcData->data.head.epochs;
trcData->magnify.end = trcData->magnify.begin + length_of_trace;
}
else
{
if (user_x1 + start > trcData->data.head.epochs + length_of_trace ||
user_x2 + start < trcData->data.head.epochs)
{
trcData->magnify.begin = -1;
continue;
}
else
trcData->magnify.begin = user_x1 + start;
if (trcData->magnify.begin < trcData->data.head.epochs)
trcData->magnify.begin = trcData->data.head.epochs;
if (user_x2 + start > trcData->data.head.epochs + length_of_trace)
trcData->magnify.end = trcData->data.head.epochs + length_of_trace;
else
trcData->magnify.end = user_x2 + start;
trcData->magnify.offset = (ceil(user_x1)) - user_x1;
targ_diff = (trcData->data.head.sampInt) / 1000000.0;
for (;trcData->magnify.offset > targ_diff; trcData->magnify.offset -= targ_diff);
}
temp_float = ((1000000.0/trcData->data.head.sampInt) *
(trcData->magnify.begin - trcData->data.head.epochs));
temp_int_2 = ((ceil)(temp_float)); 
temp_int = temp_int_2 * dsizes[MY_FLOAT];
trcData->magnify.data_start = (char *) (((long) anaData->dataInfo.data) + temp_int);
trcData->magnify.num_points_shown = (int) ((1000000. / trcData->data.head.sampInt) * 
(trcData->magnify.end - trcData->magnify.begin));
}
}
#if 0
static float RMS(int startPt, int endPt, traceInfo *trcData)
{
int  dataFormat = trcData->data.head.data_form;
int  ptInc, nPts = endPt - startPt + 1;
double av=0, sum=0, val;
gint32 *ptr;
short *sptr;
float  *lptr;
double  *dptr, dataV;
DATAINFO *dataInfo;
if (states.filter.on)
{
dataInfo = g_slist_nth_data(trcData->data.dataFilt,states.filter.active);
lptr = (float *) dataInfo->data;
dataFormat = MY_FLOAT;
}
else
{
lptr = (float *) trcData->data.dataInfo.data;
ptr = (gint32 *) trcData->data.dataInfo.data;
sptr = (short *) trcData->data.dataInfo.data;
dptr = (double *) trcData->data.dataInfo.data;
}
for (ptInc = startPt; ptInc < endPt; ++ptInc)
{
DATAP(dataFormat, ptInc, dataV);
av += dataV;
}
av /= (float) nPts;
for (ptInc = startPt; ptInc < endPt; ++ptInc)
{
DATAP(dataFormat, ptInc, dataV);
val = dataV - av;
sum += val * val;
}
val = sqrt(sum) / sqrt((double) nPts - 1);
return(val);
}
#endif
static int max_jump = 0;
static int min_jump = 0;
static double mag_mouse_time = 0.0;
static double mag_mouse_amp = 0.0;
static int mag_x, mag_y;
static void ana_point(PQLDATA *pqlData, int m_x)
{
double tm, tm_inc;
int ndata, dataLoc, dataFormat;
int y1, y2, pix_x0, pix_x1, pix_y0, pix_y1, i;
double fmax, fmin;
gint32 *ptr=NULL;
short *sptr=NULL;
float *lptr=NULL;
double  *dptr=NULL;
float plot_length;
double l_trace;
double old_time;
double old_amp, val;
graph   *gr;
int   inc;
double  begin;
traceInfo  *trcData = pqlData->trc;
max_jump = 0;
min_jump = 0;
mag_mouse_time = 0.0;
mag_mouse_amp = 0.0;
inc = trcData->magnify.plot.increment;
begin = trcData->magnify.begin;
gr = &trcData->magnify.GR[ANAPLOT];
tm = begin + trcData->magnify.offset;
tm_inc = (double) (((trcData->data.head.sampInt) / 1000000.) * ((float) inc));
plot_length = trcData->magnify.end - trcData->magnify.begin;
l_trace = ((float) trcData->data.dataInfo.head.numSamples / (1000000. / trcData->data.head.sampInt));
ndata = (int) ((1000000. / trcData->data.head.sampInt) * plot_length);
if(((ceil)(trcData->magnify.end)) == ((ceil)(l_trace)))
ndata -= inc;
dataLoc = 0;
#if 0
char   *udata;
ANADATA  *anaData = pqlData->anaData;
udata = anaData->dataInfo.data;
if (!states.filter.on) 
{
dataFormat = trcData->data.head.data_form;
ptr = (gint32 *) udata;
sptr = (short *) udata;
lptr = (float *) udata;
dptr = (double *) udata;
}
else
{ 
#endif
lptr = (float *) trcData->magnify.data_start;
dataFormat = MY_FLOAT;
DATAP(dataFormat, dataLoc, val);
pix_x0 = USER2PIXX(gr, tm);
pix_y0 = USER2PIXY(gr, val);
old_time = tm;
old_amp = val;
tm += tm_inc;
dataLoc += inc;
DATAP(dataFormat, dataLoc, val);
pix_x1 = USER2PIXX(gr, tm);
pix_y1 = USER2PIXY(gr, val);
if ( m_x <= pix_x0) 
{
mag_x = pix_x0;
mag_y = pix_y0;
mag_mouse_time = old_time;
mag_mouse_amp = old_amp;
return;
} 
if ( m_x <= pix_x1) 
{
if ((m_x - pix_x0) < (pix_x1 - m_x)) 
{
mag_x = pix_x0;
mag_y = pix_y0;
mag_mouse_time = old_time;
mag_mouse_amp = old_amp;
}
else 
{
mag_x = pix_x1;
mag_y = pix_y1;
mag_mouse_time = tm;
mag_mouse_amp = val;
if ( pix_x1 > gr->pix_xmax)
{ 
mag_x = pix_x0;
mag_y = pix_y0;
mag_mouse_time = old_time;
mag_mouse_amp = old_amp;
}
}
return;
}
pix_x0 = pix_x1;
pix_y0 = pix_y1;
ndata -= inc;
old_time = tm;
old_amp = val;
if (ndata < inc) 
{ 
mag_mouse_time = tm;
mag_mouse_amp = val;
}
for (; ndata >= inc; ndata -= inc, pix_x0 = pix_x1, pix_y0 = pix_y1) 
{
dataLoc += inc;
DATAP(dataFormat, dataLoc, val);
tm += tm_inc;
pix_x1 = USER2PIXX(gr, tm);
pix_y1 = USER2PIXY(gr, val);
if (( m_x > pix_x0) && ( m_x <= pix_x1)) 
{
if ((m_x - pix_x0) < (pix_x1 - m_x)) 
{
mag_x = pix_x0;
mag_y = pix_y0;
mag_mouse_time = old_time;
mag_mouse_amp = old_amp;
}
else 
{
mag_x = pix_x1;
mag_y = pix_y1;
mag_mouse_time = tm;
mag_mouse_amp = val;
}
if (inc > 1) 
{
fmax = fmin = val;
for (i=1; (i < inc) && (dataLoc < ndata); i++) 
{
DATAP(dataFormat, dataLoc+i, val);
if (val < fmin)
fmin = val;
if (val > fmax)
fmax = val;
}
y1 = USER2PIXY(gr, (double) fmin);
y2 = USER2PIXY(gr, (double) fmax);
mag_y = (y1 + y2)/2;
max_jump = y2;
min_jump = y1;
mag_mouse_time = 0.0;
mag_mouse_amp = 0.0;
mag_mouse_time = old_time;
mag_mouse_amp = old_amp;
}
if ( pix_x1 > gr->pix_xmax) 
{ 
mag_x = pix_x0;
mag_y = pix_y0;
mag_mouse_time = old_time;
mag_mouse_amp = old_amp;
}
return;  
} 
if (inc > 1) 
{
fmax = fmin = val;
for (i=1; (i < inc) && (dataLoc < ndata); i++) 
{
DATAP(dataFormat, dataLoc+i, val);
if (val < fmin)
fmin = val;
if (val > fmax)
fmax = val;
}
y1 = USER2PIXY(gr, (double) fmin);
y2 = USER2PIXY(gr, (double) fmax);
}   
old_time = tm;
old_amp = val;
mag_mouse_time = old_time;
mag_mouse_amp = old_amp;
}
mag_x = pix_x1;
mag_y = pix_y1;
return;
}
void ANAPoint(PQLDATA *pqlData, int m_x, pointID *ptr)
{
graph  *gr;
traceInfo *trcData = pqlData->trc;
ana_point(pqlData, m_x);
if (stnSettings.display.xScale == RELATIVE)
{
ptr->epoch = (double) (mag_mouse_time);
}
else
{
ptr->epoch = (double) (mag_mouse_time);
}
passcal_etoh(&ptr->timeVal, ptr->epoch);
if (min_jump && max_jump)
{  
gr = &trcData->magnify.GR[ANAPLOT];
ptr->minAmp = PIX2USERY(gr, min_jump);
ptr->maxAmp = PIX2USERY(gr, max_jump);
}
else
{  
ptr->minAmp = ptr->maxAmp = mag_mouse_amp;
}
#if 0
if (settings.general.units == VOLTS && trcData->data.fileType == SEGY_DATA)
{ 
scale = trcData->data.head.scale_fac / (float) trcData->data.head.gainConst;
ptr->minAmp *= scale;
ptr->maxAmp *= scale;
}
#endif
ptr->xVal = mag_x;
ptr->yVal = mag_y;
}
void ANAsetDatas(GSList *traces)
{
ANAstartTimes(traces);
ANAminMax(traces);
}
