#!/bin/bash

cwd=`pwd`

echo "Generate travel-time tables for either iasp91 or ak135 for import to PQLX"
echo -n "Would you like to do this now? (Y/N)  "
read ans

if [ "$ans" != "Y" ] ; then
	echo "quitting without doing anything, goodbye..."
	exit
fi

cd $PQLXPROD/sup
if [ ! -e $PQLXPROD/sup/ak135.hed ] ; then
	./build-tables
fi

./pqlxTTtable
