#include "pqlx_errors.h"
#include "dbl_iface.h"
#include "dblinc.h"
int dblg_request(DBLDI *dbldi)
{
int ret = FAILURE;
switch(dbldi->descr.tableData)
{
case DEFAULTST:   
ret = dblg_defaults(dbldi);
break;
case FILTERST:   
ret = dblg_filter(dbldi);
break;
#ifndef PQL_ONLY
case PDFST:    
break;
case PDFSRVRST:   
ret = dblg_pdfsrvr(dbldi);
break;
case PDFDFAULTST:
ret = dblg_pdf(dbldi);
break;
case STNCHNFLTRST:
case STNDFAULTST:
case STNCHNYSCALE:
case STNGRPYSCALE:
ret = dblg_STN(dbldi);
break;
#endif
}
return ret;
}
