#!/bin/bash

start=-50
end=-200
curPer=0
let powerLoop=end-1

while read line ; do
	period=`echo $line | awk ' { print $1 } '`
	power=`echo $line | awk ' { print $2 } '`
	cnt=`echo $line | awk ' { print $3 } '`

	if [ "$curPer" != "$period" ] ; then
	# new period, fill in previous and start powerLoop over
		while [ $powerLoop -ge $end ] ; do
			echo "$curPer	$powerLoop	0"
			let powerLoop-=1
		done
		powerLoop=$start
		curPer=$period
	fi
	
	while [ $power -lt $powerLoop -a $power -ge $end ] ; do
	# gap - fill in with 0 cnt period/power combos
		echo "$period	$powerLoop	0"
		let powerLoop-=1
	done
	
	echo "$period	$power	$cnt"
	let powerLoop=$power-1
done

while [ $powerLoop -ge $end ] ; do
	echo "$period	$powerLoop	0"
	let powerLoop-=1
done

exit 0
