-- MySQL dump 10.10
--
-- Host: localhost    Database: PQLXMETA
-- ------------------------------------------------------
-- Server version	5.0.18-standard

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

CREATE DATABASE PQLXMETA CHARACTER SET latin1 COLLATE latin1_swedish_ci;
use PQLXMETA;

DROP TABLE IF EXISTS `PQLXDBS`;
CREATE TABLE `PQLXDBS` (
  `pqlxdb_pk` mediumint(8) NOT NULL auto_increment,
  `dbName` varchar(15) NOT NULL,
  `organisation` varchar(45) NOT NULL,
  `description` varchar(100) NOT NULL,
  `techAdminName` varchar(50) NOT NULL,
  `techAdminEmail` varchar(30) NOT NULL,
  `dataAdminName` varchar(50) NOT NULL,
  `dataAdminEmail` varchar(30) NOT NULL,
  `status` enum('ACTIVE', 'INACTIVE') NOT NULL default 'ACTIVE',
  `type` enum('PRODUCTION', 'SCRATCH') NOT NULL default 'PRODUCTION',
  `access` enum('PUBLIC', 'PRIVATE') NOT NULL default 'PUBLIC',
  `wwwDir` varchar(250) NOT NULL,
  `ntw` mediumint(6) NOT NULL default '0',
  `stn` mediumint(6) NOT NULL default '0',
  `loc` mediumint(6) NOT NULL default '0',
  `chn` mediumint(6) NOT NULL default '0',
  `creation` timestamp,  
  `dbMaker` varchar(30) NOT NULL default '',
  `dbVersion` varchar(10) NOT NULL default '0',
  `adminPWord` varchar(20) NOT NULL default 'sapassword',
  PRIMARY KEY  (`pqlxdb_pk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
