#include <mysql.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
enum {
SYSTEMEVENT,
KEYEVENT,
TTLFOLLOWUPS
};
int _db_event(MYSQL *conn, SQLDI *sqldi)
{
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
gchar  *sqlStr=NULL;
int   ret=PQLXSUCCESS;  
gboolean lockON = FALSE;
switch(sqldi->descr.tableData)
{
case EVENT_GET:
{
int  followUP;
sqlStr = g_strdup_printf(SQL_EVENTQ_LOCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
lockON = TRUE;
sqlStr = g_strdup_printf(SQL_EVENT_NEXT);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
memset(&sqldi->event, 0, sizeof(sqldi->event));
if (row)
{
sqldi->event.id = atoi(row[0]);    
sqldi->event.type = atoi(row[1]);   
sqldi->event.typeKey = atoi(row[2]);  
sqldi->event.typeKey2 = atoi(row[3]);  
sqldi->event.chnKey = atoi(row[4]);   
}
mysql_free_result(res_set); res_set = NULL;
do { } while (!mysql_next_result(conn));
sqlStr = g_strdup_printf(SQL_EVENTQ_UNLCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
lockON = FALSE;
if (sqldi->event.id == NONE) 
{
break;
}
switch(sqldi->event.type)
{ 
case TRC1evt:
sqldi->descr.tableData = TRCTBL; 
followUP = KEYEVENT;
break;
case PSD1evt:
case PSD2evt:
sqldi->descr.tableData = PSDTBL;
followUP = KEYEVENT;
break;
case SYSPDFPNG:
case SYSSPECPNG:
followUP = KEYEVENT;
break;
default:
followUP = NONE;
break;
}
switch(followUP)
{
case KEYEVENT:
{
_db_key(conn, sqldi);       
if (sqldi->event.errorNO)
{ 
sqlStr = g_strdup_printf(SQL_EVENT_END, 
sqldi->event.errorNO, 
sqldi->event.id);
db_exec_sql(conn, sqlStr); bug15752(conn);
ret = FAILURE;
}
}
break;
}
}
break;
case EVENT_PUT:
{
sqlStr = g_strdup_printf(SQL_EVENT_PUT,
sqldi->event.type,
sqldi->event.typeKey,
sqldi->event.typeKey2,
sqldi->event.chnKey);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case SYSPDFEVTS:
{ 
int chnCnt;
sqlStr = g_strdup_printf(SQL_SYSPDF_CNT,
SYSPDF);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{ 
bug15752(conn);
break;
}
ret = 0;
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
if (row)
{
chnCnt = atoi(row[0]);
}
bug15752(conn);
mysql_free_result(res_set); res_set=NULL;
ret = chnCnt;
}
break;
case PNGEVTS:
{ 
PNGWWW *pngWWW = sqldi->data;
int  cmd = GPOINTER_TO_INT(sqldi->data2);
switch (cmd)
{
case SYSPNGMAKE:
sqlStr = g_strdup_printf(SQL_PNG_MKEVT,
pngWWW->type, SYSPDF);
break;
case SYSPNGPROC:
sqlStr = g_strdup_printf(SQL_EVENT_UNPROC,
pngWWW->type);
break;
}
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case EVENT_DEL:
{
sqlStr = g_strdup_printf(SQL_EVENTQ_LOCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
lockON = TRUE;
sqlStr = g_strdup_printf(SQL_EVENT_DEL, sqldi->event.id);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
sqlStr = g_strdup_printf(SQL_EVENT_DELARGS, sqldi->event.id);
ret = db_exec_sql(conn, sqlStr);  bug15752(conn);
}
break;
case EVENT_INPROC:
{
sqlStr = g_strdup_printf(SQL_EVENTQ_LOCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
lockON = TRUE;
sqlStr = g_strdup_printf(SQL_EVENT_INPROC, sqldi->event.id);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case EVENT_PAUSE:
{
sqlStr = g_strdup_printf(SQL_EVENTQ_LOCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
lockON = TRUE;
sqlStr = g_strdup_printf(SQL_EVENT_PAUSE, PAUSEevt);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case EVENT_PAUSE_INPROC:
{
sqlStr = g_strdup_printf(SQL_EVENTQ_LOCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
lockON = TRUE;
sqlStr = g_strdup_printf(SQL_EVENT_PAUSE_IP, PAUSEevt);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case EVENT_RESUME:
{
sqlStr = g_strdup_printf(SQL_EVENTQ_LOCK, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
break;
}
lockON = TRUE;
sqlStr = g_strdup_printf(SQL_EVENT_RESUME, PAUSEevt);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
}
break;
case EVENT_GET_PAUSE:
case EVENT_GET_RESUME:
{
int  count;
sqlStr = g_strdup_printf(SQL_EVENT_RESUME_GET, PAUSEevt);
ret = db_exec_sql(conn, sqlStr);  
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
count = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set=NULL;
if (count > 0)
ret = PQLXSRVRPAUSE;
else
ret = PQLXSRVRRESUME;
}
break;
case EVENT_GET_UNPROC:
case EVENT_GET_NOPROC:
{
int  count;
switch (sqldi->descr.tableData)
{
case EVENT_GET_UNPROC:
sqlStr = g_strdup(SQL_EVENT_CNT_UNPROC);
break;
case EVENT_GET_NOPROC:
sqlStr = g_strdup(SQL_EVENT_CNT_NOPROC);
break;
}
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
count = atoi(row[0]);
bug15752(conn);
mysql_free_result(res_set); res_set=NULL;
ret = (int) (gboolean) count;
}
break;
case EVENT_PUT_SYSPDF:
{
sqlStr = g_strdup_printf(SQL_EVENT_EPOCHS, SPSE, SPSE);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_EVENT_SYSPDF, SYSPDF, SYSPDF);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
break;
}
bug15752(conn);
} 
break;
default: 
fprintf(stderr, "Internal Error: Unknown DB request (request type = %d), not processed.\n",
sqldi->args.dataEvent);
break;
}
if (lockON)
{
sqlStr = g_strdup_printf(SQL_EVENTQ_UNLCK, dbName);
db_exec_sql(conn, sqlStr); bug15752(conn);
}
return ret;
}
int db_event(SQLDI *sqldi)
{
int   ret=PQLXSUCCESS;
MYSQL  *conn = mngDBConn(sqldi, GETDBCONN);
switch(sqldi->descr.tableData)
{
case EVENT_GET:
ret = FAILURE;   
while(ret == FAILURE)
{
ret = _db_event(conn, sqldi); 
sqldi->descr.tableData = EVENT_GET;
}
break;
default:
ret = _db_event(conn, sqldi);
break;
}
return ret;
}
