#include <mysql.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
int _db_key(MYSQL *conn, SQLDI *sqldi)
{ 
int i, ret=PQLXSUCCESS;
MYSQL_RES *res_set;
MYSQL_ROW row;
gchar *sqlStr;
if (sqldi->data)
{ 
free(sqldi->data);
sqldi->data = NULL;
}
switch(sqldi->event.type)
{ 
case TRC1evt:
{
TRC1 *trc1;
sqlStr = g_strdup_printf(SQL_TRC1_KEY,
sqldi->event.typeKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
break;
res_set = mysql_store_result(conn);
if(!res_set->row_count)
{ 
sqldi->event.errorNO = NO_SUCH_RECORD;
mysql_free_result(res_set);
ret = FAILURE;
break;
}
trc1 = (TRC1 *) calloc(1, sizeof(TRC1));
sqldi->data = (void *) trc1;
row = mysql_fetch_row(res_set);
trc1->keys.chnKey = atoi(row[0]);
strcpy(trc1->keys.directory, row[1]);
strcpy(trc1->keys.filename, row[2]);
for(i=0;i<TOTALDATATYPE;i++)
{
if(!g_ascii_strcasecmp(dataTypes[i], row[3]))
{
trc1->keys.fileType=i;
break;
}
}
mysql_free_result(res_set);
}
break;
case PSD1evt:
{
PSD1 *psd;
sqlStr = g_strdup_printf(SQL_PSD1_KEY,
sqldi->event.typeKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
break;
psd = (PSD1 *) calloc(1, sizeof(PSD1));
sqldi->data = (void *) psd;
res_set = mysql_store_result(conn);
if((row = mysql_fetch_row(res_set)))
{
psd->keys.chnKey = atoi(row[0]);
psd->keys.trcKey = atoi(row[1]);
strcpy(psd->keys.filename[0], row[2]);
for(i=0;i<TOTALDATATYPE;i++)
{
if(!g_ascii_strcasecmp(dataTypes[i], row[3]))
{
psd->keys.fileType=i;
break;
}
}
psd->keys.year = atoi(row[4]);
psd->keys.jday = atoi(row[5]);
strcpy(psd->keys.ntw, row[6]);
strcpy(psd->keys.stn, row[7]);
strcpy(psd->keys.loc, row[8]);
strcpy(psd->keys.chn, row[9]);
psd->keys.resp.data.fileName = g_strdup(row[10]);
psd->keys.resp.keys.respKey = atoi(row[11]);
sqldi->event.errorNO = PQLXSUCCESS;
}
else
{ 
sqldi->event.errorNO = NO_RESP_FILE;
}
mysql_free_result(res_set);
sqlStr = g_strdup_printf(SQL_PSDCFG_KEY,
sqldi->event.typeKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
break;
res_set = mysql_store_result(conn);
if((row = mysql_fetch_row(res_set)))
{
psd->keys.conf.min_power = atoi(row[0]);
psd->keys.conf.max_power = atoi(row[1]);
psd->keys.conf.sections = atoi(row[2]);
psd->keys.conf.steps = atoi(row[3]);
psd->keys.conf.psd_dur = atoi(row[4]);
psd->keys.conf.db_offset = atoi(row[5]);
psd->keys.conf.max_period = (float) atof(row[6]);
psd->keys.conf.bin_width = (float) atof(row[7]);
psd->keys.conf.gap_thresh = (float) atof(row[8]);
psd->keys.conf.units = g_strdup(row[9]);
psd->keys.conf.last_stage = atoi(row[10]);
psd->keys.conf.type = atoi(row[11]);
psd->keys.conf.overlap = atoi(row[12]);
}
mysql_free_result(res_set);
}
break;
case PSD2evt:
{
PSD1 *psd;
sqlStr = g_strdup_printf(SQL_PSD2A_KEY,
sqldi->event.typeKey,
sqldi->event.typeKey2);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
break;
psd = (PSD1 *) calloc(1, sizeof(PSD1));
sqldi->data = (void *) psd;
res_set = mysql_store_result(conn);
if((row = mysql_fetch_row(res_set)))
{
psd->keys.chnKey = atoi(row[0]);
psd->keys.trcKey = atoi(row[1]);
strcpy(psd->keys.filename[0], row[2]);
for(i=0;i<TOTALDATATYPE;i++)
{
if(!g_ascii_strcasecmp(dataTypes[i], row[3]))
{
psd->keys.fileType=i;
break;
}
}
psd->keys.year = atoi(row[4]);
psd->keys.jday = atoi(row[5]);
strcpy(psd->keys.ntw, row[6]);
strcpy(psd->keys.stn, row[7]);
strcpy(psd->keys.loc, row[8]);
strcpy(psd->keys.chn, row[9]);
psd->keys.resp.data.fileName = g_strdup(row[10]);
psd->keys.resp.keys.respKey = atoi(row[11]);
strcpy(psd->keys.filename[1], row[12]);
psd->keys.trcKey2 = atoi(row[13]);
}
else
{ 
sqldi->event.errorNO = NO_RESP_FILE;
}
mysql_free_result(res_set); res_set=NULL;
sqlStr = g_strdup_printf(SQL_PSDCFG_KEY,
sqldi->event.typeKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
break;
res_set = mysql_store_result(conn);
if((row = mysql_fetch_row(res_set)))
{
psd->keys.conf.min_power = atoi(row[0]);
psd->keys.conf.max_power = atoi(row[1]);
psd->keys.conf.sections = atoi(row[2]);
psd->keys.conf.steps = atoi(row[3]);
psd->keys.conf.psd_dur = atoi(row[4]);
psd->keys.conf.db_offset = atoi(row[5]);
psd->keys.conf.max_period = (float) atof(row[6]);
psd->keys.conf.bin_width = (float) atof(row[7]);
psd->keys.conf.gap_thresh = (float) atof(row[8]);
psd->keys.conf.units = g_strdup(row[9]);
psd->keys.conf.last_stage = atoi(row[10]);
psd->keys.conf.type = atoi(row[11]);
psd->keys.conf.overlap = atoi(row[12]);
}
mysql_free_result(res_set); res_set = NULL;
}
break;
case SYSPDFPNG:
{
PDFPNG *pdfPNG;
pdfPNG = calloc(1, sizeof(PDFPNG));
pdfPNG->keys.chnKey = sqldi->event.typeKey;
sqldi->descr.tableData = SYSPDFPNG;
sqldi->data = pdfPNG;
getData(conn, sqldi);
}
break;
case SYSSPECPNG:
{
SPECPNG *specPNG;
specPNG = calloc(1, sizeof(SPECPNG));
specPNG->keys.chnKey = sqldi->event.typeKey;
sqldi->descr.tableData = SYSSPECPNG;
sqldi->data = specPNG;
getData(conn, sqldi);
}
break;
}
return ret;
}
