#include <mysql.h>
#include "pqlx_defs.h"
#include "dbmysqldefs.h"
#include "db_sql.h"
#include "db_upgrade_sql.h"
#define GLAPTMP1 "`%sTMP`.`GLAPTRCFK`"
#define GLAPTMP2 "`%sTMP`.`TRCTRCPK`"
int _db_maintain(MYSQL *conn, SQLDI *sqldi)
{
int   ret=PQLXSUCCESS;
gchar  *sqlStr;
switch(sqldi->descr.tableData)
{
case SYSDBPSDOPTCHANS:
{ 
DBMAINT *dbMaint = sqldi->data;
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
int  *chnKey;
sqlStr = g_strdup_printf(SQL_PSDOPT_GET,
dbName);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
res_set = mysql_store_result(conn);
while((row = mysql_fetch_row(res_set)))
{
chnKey = calloc(1, sizeof(int));
*chnKey = atoi(row[0]);
dbMaint->data.channels = g_slist_prepend(dbMaint->data.channels, chnKey);
}
mysql_free_result(res_set); res_set = NULL;
bug15752(conn);
}
break;
case SYSDBPSDCLEAN:
{ 
MYSQL_RES *res_set=NULL;
MYSQL_ROW row;
int  chnKey = GPOINTER_TO_INT(sqldi->data2), cnt;
char *tmpTbl = g_strdup_printf("`%s%d`", "PSDTMPCLEAN", sqldi->args.sqr); 
char *psdD = g_strdup_printf("`%sDATA`.`psd%d`", dbName, chnKey);
char *psdI = g_strdup_printf("`%sDATA`.`psd%didx`", dbName, chnKey);
sqlStr = g_strdup_printf(SQL_PSDTBL_CLEANKEYS,
tmpTbl,
dbName, chnKey,
chnKey);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
goto SYSDBPSDCLEANDONE;
}
sqlStr = g_strdup_printf(SQL_PSDTBL_CLEANCNT,
tmpTbl);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
goto SYSDBPSDCLEANDONE;
}
res_set = mysql_store_result(conn);
row = mysql_fetch_row(res_set);
cnt = atoi(row[0]);
mysql_free_result(res_set); res_set = NULL;
bug15752(conn);
if (cnt == 0)  
goto SYSDBPSDCLEANDONE;
sqlStr = g_strdup_printf(SQL_PSDTBL_CLEAND,
psdD, psdD, tmpTbl,
psdD, tmpTbl);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
goto SYSDBPSDCLEANDONE;
}
bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDTBL_CLEANI,
psdI, psdI, tmpTbl,
psdI, tmpTbl);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
goto SYSDBPSDCLEANDONE;
}
SYSDBPSDCLEANDONE:
bug15752(conn);
sqlStr = g_strdup_printf(SQL_PSDTBL_CLEANDEL,
tmpTbl);
ret = db_exec_sql(conn, sqlStr);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
}
bug15752(conn);
free(tmpTbl);
free(psdD); free(psdI);
}
break;
case SYSDBPSDDELCHAN:
{
int chnKey = GPOINTER_TO_INT(sqldi->data2);
sqlStr = g_strdup_printf(SQL_PSDOPT_DEL,
dbName, chnKey);
ret = db_exec_sql(conn, sqlStr);
}
break;
case SYSDBTBLOPT:
{
DBMAINT *dbMaint = sqldi->data;
sqlStr = g_strdup_printf(SQL_TBL_OPTIMIZE,
dbMaint->keys.tableName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
}
break;
case SYSDBGLAP:
{
char *tmp1 = g_strdup_printf(GLAPTMP1, dbName);
char *tmp2 = g_strdup_printf(GLAPTMP2, dbName);
sqlStr = g_strdup_printf(SQL_GLAPTMP_MK,
tmp1, tmp1);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_GLAPTMP_MK,
tmp2, tmp2);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_GLAP_TRCFK,
tmp1);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_GLAP_TRCPK,
tmp2);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_GLAP_DEL1,
tmp1, tmp1, tmp2,
tmp1, tmp2);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_GLAP_DEL2,
tmp1, tmp1);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_GLAPTMP_DEL,
tmp1, tmp2);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
free(tmp1);
free(tmp2);
}
break;
case SYSMETATBLOPTEVENT:
{
sqlStr = g_strdup_printf(SQL_TBL_OPTIMIZE,
"SEISEVENT");
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_TBL_OPTIMIZE,
"SEISMAG");
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
}
break;
case SYSEVENTCLEAN:
{
sqlStr = g_strdup(SQL_EVTQTBL_CLEAN2);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_EVTQTBL_ERRMOVE, logKey, NO_RESP_FILE);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_EVTQTBL_CLEAN, NO_RESP_FILE);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_TBL_OPTIMIZE,
"EVENTQ");
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
}
break;
case SYSDBLOGS:
{
sqlStr = g_strdup_printf(SQL_LOG_CLEAN);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_TBL_OPTIMIZE, "SRVREXEC");
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_TBL_OPTIMIZE, "SRVRLOG");
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
}
break;
case SYSDBTMPDROP:
sqlStr = g_strdup_printf(SQL_TMPTBL_DROP, 
dbName, dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
sqlStr = g_strdup_printf(SQL_DBUPG_27_E1, 
dbName);
ret = db_exec_sql(conn, sqlStr); bug15752(conn);
if (ret != PQLXSUCCESS)
{
sqldi->event.errorNO = SQL_FAILURE;
ret = FAILURE;
break;
}
break;
}
return ret;
}
int db_maintain(SQLDI *sqldi)
{
int   ret=PQLXSUCCESS;
MYSQL  *conn = mngDBConn(sqldi, GETDBCONN);
ret = _db_maintain(conn, sqldi);
return ret;
}
