#ifndef __DB_SQL_H
#define __DB_SQL_H 
enum {
SQL_WITHZ,
SQL_WOUTZ
};
#define SQL_SET_READTIMEOUT "SET SESSION net_read_timeout = %d"
#define SQL_SET_MODE_NUS  "SET SESSION sql_mode = 'NO_UNSIGNED_SUBTRACTION'"
#define SQL_META_DBLST "SELECT dbName ""FROM `PQLXMETA`.`PQLXDBS` ""WHERE dbName <> 'PQLXMETA' ""AND dbVersion > 20 ORDER BY 1"
#define SQL_SRVR_DBSL "SELECT dbName, organisation, description, techAdminName, techAdminEmail, dataAdminName, ""dataAdminEmail, type, access, adminPWord, dbVersion, ""convert(type, signed), convert(access, signed), hint ""FROM PQLXDBS ""WHERE status = 'ACTIVE' and dbName <> 'PQLXMETA' ORDER BY dbName"
#define SQL_SRVR_DBSR "SELECT dbName, organisation, description, techAdminName, techAdminEmail, ""dataAdminName, dataAdminEmail, type, access, adminPWord, dbVersion, ""convert(type, signed), convert(access, signed), hint ""FROM PQLXDBS WHERE status = 'ACTIVE' and access='PUBLIC' and ""dbName <> 'PQLXMETA' ORDER BY dbName"
#define SQL_SRVR_DBLST "SELECT dbName, organisation, description, techAdminName, techAdminEmail, ""dataAdminName, dataAdminEmail, type, access, adminPWord, dbVersion, ""convert(type, signed), convert(access, signed), hint ""FROM PQLXMETA.PQLXDBS WHERE dbName = '%s'"
#define SQL_SRVR_STATE "SELECT type, count(*) FROM EVENTQ WHERE processed = 'UNPROC' and ""type in (1, 2, 3, 90, 100) GROUP BY type ORDER BY type"
#define SQL_SRVR_TRCCNT "SELECT count(*) FROM TRC WHERE format <> 'DUMMY'"
#define SQL_SRVR_DONE "SELECT count(*) FROM EVENTQ WHERE type=%d"
#define SQL_SRVR_CHNICNT "SELECT count(*) FROM CHNI"
#define SQL_DBVERSION "SELECT dbVersion FROM PQLXMETA.PQLXDBS where dbName = '%s'"
#define SQL_PDBVERSION_G0 "SELECT COUNT(*) FROM PQLXMETA.PQLXDBS WHERE dbName = 'PQLXMETA'"
#define SQL_PDBVERSION_G1 "SELECT dbVersion FROM PQLXMETA.PQLXDBS WHERE dbName = 'PQLXMETA'"
#define SQL_PNGWWW  "SELECT p.width, p.height, convert(p.border, signed)-1, p.bordercolorR, ""p.bordercolorG, p.bordercolorB, p.Iwidth, p.Iheight, ""convert(p.Iborder,signed)-1, p.IbordercolorR, p.IbordercolorG, ""p.IbordercolorB, p.wwwDir, p.type, c.description ""FROM `%s`.`PNGWWW` p, `%s`.`CONSTANT` c ""WHERE p.type = c.val AND c.type = 'DBCONST'"
#define SQL_SP_CHNIUPD "CALL spCHNIupd ()"
#define SQL_SP_DIRSUPD "CALL dirsStats ()"
#define SQL_USER_LOCK "SELECT GET_LOCK('%s.REGUSER', 100)"
#define SQL_USER_UNLOCK "SELECT RELEASE_LOCK('%s.REGUSER')"
#define SQL_REG_USER "CALL spRegUser ('%s', '%s', %s, %s)"
#define SQL_IDS_GET  "SELECT IDS_PK FROM IDS WHERE TYPE = '%s' AND NAME = '%s'"
#define SQL_IDS_PUT  "INSERT INTO IDS (TYPE, NAME) VALUES ('%s', '%s')"
#define SQL_NSLC_GETALLSTNS "CREATE TEMPORARY TABLE STNKEYS (`stn_fk` int(10) unsigned NOT NULL PRIMARY KEY)"" ENGINE=MEMORY; INSERT INTO STNKEYS (stn_fk) SELECT DISTINCT(C.STN_FK) from CHNI C"
#define SQL_NSLC_GETLIVESTNS "CREATE TEMPORARY TABLE STNKEYS (`stn_fk` int(10) unsigned NOT NULL PRIMARY KEY)"" ENGINE=MEMORY; INSERT INTO STNKEYS (stn_fk) SELECT DISTINCT(C.STN_FK) from CHNI C"" where C.endT > SUBDATE(CURDATE(), %d) and nTraces > 0"
#define SQL_NSLC_GETLIVE "SELECT DISTINCT NTW, n.NTW_FK, STN, n.STN_FK, LOC, n.LOC_FK, CHN, n.CHNI_PK"" FROM nslc n, CHNI C, STNKEYS S where n.CHNI_PK = C.CHNI_PK and"" C.STN_FK = S.stn_fk and C.nTraces > 0 ""GROUP BY 2, 4, 6, 7 ORDER BY NTW DESC, STN, LOC, CHN"
#define SQL_NSLC_GETALL "SELECT DISTINCT NTW, n.NTW_FK, STN, n.STN_FK, LOC, n.LOC_FK, CHN, n.CHNI_PK ""FROM nslc n GROUP BY 2, 4, 6, 7 ORDER BY NTW DESC, STN, LOC, CHN"
#define SQL_NSLC_PSDGET "SELECT DISTINCT NTW, n.NTW_FK, STN, n.STN_FK, LOC, n.LOC_FK, CHN, n.CHNI_PK"" FROM nslc n, CHNI C, PSDCFG P where n.CHNI_PK = C.CHNI_PK and"" C.nTraces > 0 and P.chni_fk = n.chni_pk ""GROUP BY 2, 4, 6, 7 ORDER BY NTW DESC, STN, LOC, CHN"
#define SQL_NSLC_PSDGET_X "SELECT DISTINCT NTW, n.NTW_FK, STN, n.STN_FK, LOC, n.LOC_FK, CHN, n.CHNI_PK ""FROM nslc n, CHNI C, PSDCFG P ""WHERE C.endT > SUBDATE(CURDATE(), %d) AND ""n.CHNI_PK = C.CHNI_PK AND ""C.nTraces > 0 AND P.chni_fk = n.chni_pk ""GROUP BY 2, 4, 6, 7 ORDER BY NTW DESC, STN, LOC, CHN"
#define SQL_CHNI_PUT "INSERT INTO CHNI (NTW_FK, STN_FK, LOC_FK, CHN_FK) VALUES (%d, %d, %d, %d)"
#define SQL_NSLC_NAMES "SELECT ntw, stn, loc, chn FROM nslc WHERE chni_pk = %d"
#define SQL_NSLC_NAME "SELECT CONCAT(ntw, '.', stn, '.', loc, '.', chn) FROM nslc WHERE chni_pk = %d"
#define SQL_PSDCFG_ALL "SELECT chni_fk FROM PSDCFG WHERE chni_fk <> 0"
#define SQL_PDF_BOUNDS "SELECT DAY(MIN(day)), MONTH(MIN(day)), YEAR(MIN(day)), DAY(MAX(day)),"" MONTH(MAX(day)), YEAR(MAX(day)) FROM `%sDATA`.`psd%didx`"
#define SQL_CHNI_TTLPSD "UPDATE CHNI c SET c.ttlPSD = (SELECT MAX(p.ttlPSD) FROM PDFIDX p ""WHERE p.chni_fk = %d and p.epoch = 0) WHERE c.chni_pk = %d"
#define SQL_CHNI_STATS "UPDATE CHNI C ""SET ""C.STARTT = (SELECT MIN(T.START) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.ENDT = (SELECT MAX(T.END) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.GAPMAX = (SELECT MAX(T.GAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.GAPMIN = (SELECT MIN(T.GAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.GAPAVG = (SELECT AVG(T.GAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.OLAPMAX = (SELECT MAX(T.OLAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.OLAPMIN = (SELECT MIN(T.OLAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.OLAPAVG = (SELECT AVG(T.OLAPS) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.MAXMAX = (SELECT MAX(T.MAX) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.MAXMIN = (SELECT MIN(T.MAX) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.MAXAVG = (SELECT AVG(T.MAX) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.MINMAX = (SELECT MAX(T.MIN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.MINMIN = (SELECT MIN(T.MIN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.MINAVG = (SELECT AVG(T.MIN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.MEANMAX = (SELECT MAX(T.MEAN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.MEANMIN = (SELECT MIN(T.MEAN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.MEANAVG = (SELECT AVG(T.MEAN) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0), ""C.NTRACES = (SELECT COUNT(*) FROM TRC T WHERE C.CHNI_PK = T.CHNI_FK AND T.NSAMPS <> 0) ""WHERE C.chni_pk = %d"
#define SQL_LOGEXEC_PUT "INSERT INTO SRVREXEC (pgmName) VALUES ('%s')"
#define SQL_LOGEXEC_DONE "UPDATE SRVREXEC SET doneTime = NOW() WHERE srvrExec_pk = %d"
#define SQL_LOGEXEC_GET "SELECT srvrExec_pk, pgmName, execTime, ""COALESCE(doneTime, ''), ""COALESCE(TIMEDIFF(doneTime, execTime), '') ""FROM SRVREXEC s1 ORDER BY srvrExec_pk"
#define SQL_LOGEXEC_UPD "SELECT COALESCE(doneTime, ''), COALESCE(TIMEDIFF(doneTime, execTime), '') ""FROM SRVREXEC WHERE srvrExec_pk = %d"
#define SQL_LOGEXEC_NEXT "SELECT COUNT(*) FROM SRVRLOG where srvrExec_fk > %d"
#define SQL_LOGMSG_PUT "INSERT INTO SRVRLOG (srvrExec_fk, type, msg) VALUES (%d, %d, \"%s\")"
#define SQL_LOGMSG_GET "SELECT convert(type, signed)-1, logTime, msg, srvrLog_pk ""FROM SRVRLOG ""WHERE srvrExec_fk = %d AND type = '%s' ""ORDER BY srvrLog_pk DESC"
#define SQL_LOGMSG_GETLAST "SELECT msg ""FROM SRVRLOG ""WHERE srvrExec_fk = %d AND ""type = 'LOG' ""ORDER BY srvrLog_pk DESC ""LIMIT 1"
#define SQL_LOGMSG_NEXT "SELECT convert(type, signed)-1, logTime, msg, srvrLog_pk ""FROM SRVRLOG ""WHERE srvrExec_fk = %d AND srvrLog_pk > %d AND type = '%s' ""ORDER BY srvrLog_pk"
#define SQL_LOGMSG_LOCK "SELECT GET_LOCK('%s.SRVRLOG', 100)"
#define SQL_LOGMSG_UNLOCK "SELECT RELEASE_LOCK('%s.SRVRLOG')"
#define SQL_LOG_CLEAN "DELETE SRVREXEC, SRVRLOG FROM SRVREXEC, SRVRLOG WHERE ""srvrExec_pk = srvrExec_fk AND ""DATEDIFF(execTime, CURDATE()) > 31"
#define SQL_EVENT_PAUSE "INSERT INTO EVENTQ (type, processed) VALUES (%d, 'UNPROC')"
#define SQL_EVENT_PAUSE_IP "UPDATE EVENTQ SET processed = 'INPROC' WHERE type = %d"
#define SQL_EVENT_RESUME "DELETE FROM EVENTQ WHERE type = %d"
#define SQL_EVENT_RESUME_GET "SELECT COUNT(*) FROM EVENTQ WHERE type = %d"
#define SQL_EVENT_INPROC "UPDATE EVENTQ SET processed = 'INPROC' WHERE EVTQ_ID = %d"
#define SQL_EVENT_NEXT "CALL spNextEvent()"
#define SQL_EVENTQ_LOCK "SELECT GET_LOCK('%s.EVENTQ', 100)"
#define SQL_EVENTQ_UNLCK "SELECT RELEASE_LOCK('%s.EVENTQ')"
#define SQL_EVENT_PUT "INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2, CHNI_FK) VALUES (%d, %d, %d, %d)"
#define SQL_EVENT_PUTNP "INSERT INTO EVENTQ (TYPE, TYPEKEY, TYPEKEY2, CHNI_FK, processed) ""VALUES (%d, %d, %d, %d, 'NOPROC')"
#define SQL_EVENT_END "UPDATE EVENTQ SET PROCESSED = 'PROCD', ERROR_NO = %d WHERE EVTQ_ID = %d"
#define SQL_EVENT_DEL "DELETE FROM EVENTQ WHERE evtq_id = %d"
#define SQL_EVENT_DELARGS "DELETE FROM EVENTQargs WHERE evtq_id = %d"
#define SQL_EVENT_FOLLOWUPS "CALL EVENTQ_FOLLOWUPS(%d)"
#define SQL_EVENT_DIRS "CALL EVENTQ_DIRS(%d)"
#define SQL_EVENT_PSD1 "CALL EVENTQ_PSD1(%d)"
#define SQL_EVENT_PSD2 "CALL EVENTQ_PSD2(%d)"
#define SQL_EVENT_PSD2ERR "CALL EVENTQ_PSD2ERR()"
#define SQL_EVENT_DEL1000 "DELETE FROM EVENTQ WHERE type=%d"
#define SQL_EVENT_LIST "SELECT evtq_id, typeKey FROM EVENTQ WHERE type = %d AND processed in ('NOPROC', 'UNPROC')"
#define SQL_EVENT_UNPROC "UPDATE EVENTQ SET processed = 'UNPROC' WHERE processed = 'NOPROC' and type = %d"
#define SQL_EVENT_CNT "SELECT COUNT(*) FROM EVENTQ WHERE type = %d AND processed <> 'PROCD'"
#define SQL_EVENT_CNT_UNPROC "SELECT COUNT(*) FROM EVENTQ WHERE processed in ('UNPROC')"
#define SQL_EVENT_CNT_NOPROC "SELECT COUNT(*) FROM EVENTQ WHERE processed in ('NOPROC')"
#define SQL_EVENT_SYSPDF "DELETE FROM EVENTQ ""WHERE type = %d; ""INSERT INTO EVENTQ (type, typeKey, processed) ""SELECT %d, chni_fk, 'NOPROC' ""FROM PSDCFG p, CHNI c ""WHERE p.chni_fk <> 0 AND ""c.chni_pk = p.chni_fk AND ""c.nTraces > 0"
#define SQL_EVENT_EPOCHS "DELETE FROM EVENTQ ""WHERE type = %d; ""INSERT INTO EVENTQ (type, typeKey, processed) ""SELECT %d, chni_pk, 'NOPROC' ""FROM CHNI WHERE nTraces > 0"
#define SQL_EVENT_BLINE  "INSERT INTO EVENTQ (type, typeKey, chni_fk, processed) ""SELECT %d, typeKey, chni_fk, 'NOPROC' ""FROM EVENTQ WHERE type = %d"
#define SQL_EVENT_BLINE_DEL "DELETE FROM EVENTQ WHERE type = %d"
#define SQL_DIRS_GETALL "SELECT DIR_PK, DIRECTORY, FROM_UNIXTIME(TIME), STATUS, ttlTrace, ttlResp ""FROM `%s`.DIRS WHERE TYPE = 'FILESCAN' ORDER BY STATUS, ttlResp, TIME"
#define SQL_DIRS_GET "SELECT DIR_PK, DIRECTORY, TIME FROM DIRS WHERE ""TYPE = 'FILESCAN' AND STATUS = 'ACTIVE' ORDER BY TIME"
#define SQL_DIRS_PUT "INSERT INTO DIRS (TYPE, DIRECTORY, TIME, STATUS) ""VALUES('%s', '%s', %lld, 'INACTIVE')"
#define SQL_SCAN_PUT "INSERT INTO SCAN (DIR_FK, TIME, TRACES, RESPONSES, NTW, STN, LOC, CHN) ""VALUES (%d, %lld, %d, %d, %d, %d, %d, %d)"
#define SQL_DIRS_STATS "UPDATE `DIRS` d ""SET ""d.ttlTrace = (SELECT COUNT(*) FROM `TRC` t "" WHERE d.dir_pk = %d AND "" LOCATE(concat(d.directory, '/'), concat(t.directory, '/')) > 0 AND "" t.nsamps <> 0), ""d.ttlResp = (SELECT COUNT(*) FROM `RESP` r "" WHERE d.dir_pk = %d AND "" LOCATE(concat(d.directory, '/'), concat(r.directory, '/')) > 0) ""WHERE dir_pk = %d"
#define SQL_TRC_INS  "INSERT INTO TRC (CHNI_FK, FORMAT, DIRECTORY, FILENAME) VALUES (%d, '%s', '%s', '%s')"
#define SQL_TRC_DELDUP1 "CREATE TEMPORARY TABLE %s (`trc_fk` int unsigned) ENGINE=MEMORY ""SELECT t1.trc_pk FROM `%s`.TRC t1, `%s`.TRC t2 ""WHERE t1.chni_fk = t2.chni_fk AND ""t1.directory = t2.directory AND ""t1.filename = t2.filename AND ""t1.trc_pk < t2.trc_pk"
#define SQL_TRC_DELDUP2 "DELETE t FROM %s t, %s t2 ""WHERE t.trc_pk = t2.trc_fk"
#define SQL_TRC_DELDUP3 "DROP TABLE %s"
#define SQL_TRC_DELDUP "DELETE t1 FROM `%s`.TRC t1, `%s`.TRC t2 ""WHERE t1.chni_fk = t2.chni_fk AND ""t1.directory = t2.directory AND ""t1.filename = t2.filename AND ""t1.trc_pk < t2.trc_pk" 
#define SQL_TRC1_KEY "SELECT CHNI_FK, DIRECTORY, FILENAME, FORMAT FROM TRC WHERE TRC_PK = %d"
#define SQL_TRC1_VALS "UPDATE TRC SET START = '%d-%d-%d %02d:%02d:%02d', STARTM = %d,"" END = '%d-%d-%d %02d:%02d:%02d', ENDM = %d, MAX = %g, MIN = %g,"" MEAN = %g, GAPS = %d, OLAPS = %d, NSAMPS = %d, sampInt = %f WHERE TRC_PK = %d"
#define SQL_TRC_KEY2 "SELECT TRC_PK FROM TRC WHERE (CHNI_FK = %d) AND ((START >= '%d-%d-%d %02d:%02d'"" and END < '%d-%d-%d %02d:%02d') or (FORMAT='DUMMY')) ORDER BY TRC_PK DESC LIMIT 1"
#define SQL_TRC_CLEAN1 "DELETE FROM TRC WHERE nsamps = 0 AND format <> 'DUMMY'"
#define SQL_TRC_CLEAN2 "DELETE FROM TRC WHERE format <> 'DUMMY' AND ""((DATE(start) > adddate(curdate(), INTERVAL 1 DAY) OR ""DATE(end) > adddate(curdate(), INTERVAL 1 DAY)))"
#define SQL_TRC_CLEAN3 "DELETE FROM TRC WHERE YEAR(start) < 1970 and format <> 'DUMMY'"
#define SQL_TRC_NEXT "SELECT T1.trc_pk, CONCAT(T1.directory, '/', T1.filename) FROM TRC T1, TRC T2"" WHERE T1.chni_fk = %d AND T2.trc_pk = %d AND T1.start > T2.start ORDER BY T1.start LIMIT 1"
#define SQL_TRC_CRASH "SELECT E.type, CONCAT(T.directory, '/', T.fileName) from TRC T, EVENTQ E"" WHERE E.PROCESSED = 'INPROC' AND E.typeKey = T.TRC_PK AND E.type < %d"
#define SQL_TRC_SAMPRATE "SELECT chni_fk, sampint, DATE(MIN(start)), DATE(MAX(end)), COUNT(*) FROM TRC ""WHERE nsamps <> 0 AND chni_fk = %d AND start >= '%s'and end <= '%s'""GROUP BY 1, 2 ORDER BY 1, 2"
#define SQL_SYS_CRASH "SELECT E.type, n.chni_pk, CONCAT(n.ntw, '.', n.stn, '.', n.loc, '.', n.chn)"" from nslc n, EVENTQ E WHERE E.PROCESSED = 'INPROC' AND E.typeKey = n.chni_pk"
#define SQL_EVT_CLOSE "UPDATE EVENTQ E SET E.processed = 'PROCD', E.error_no = %d WHERE E.processed = 'INPROC'"
#define SQL_RESP_INSSP "CALL RESP_INSERT ( %d, '%s', '%s')"
#define SQL_RESP_FILE "SELECT CONCAT(R.DIRECTORY, '/', R.FILENAME) FROM RESP R WHERE R.chni_fk = %d"
#define SQL_GLAP_INS "INSERT INTO GLAP (TRC_FK, TYPE, STARTPT, ENDPT) VALUES (?, ?, ?, ?)"
#define SQL_PSD_CFG  "SELECT channel, minPower, maxPower, type ""FROM PSDCFG P WHERE P.chni_fk = 0"
#define SQL_PSD1_KEY "SELECT T.CHNI_FK, T.TRC_PK, CONCAT(T.DIRECTORY, '/', T.FILENAME), T.FORMAT,"" YEAR(T.START), DAYOFYEAR(T.START), N.NTW, N.STN, N.LOC, N.CHN,"" CONCAT(R.DIRECTORY, '/', R.FILENAME), R.resp_pk ""FROM TRC T, nslc N,RESP R ""WHERE T.TRC_PK = %d AND N.CHNI_PK = T.CHNI_FK AND R.CHNI_FK = T.CHNI_FK"
#define SQL_PSD2A_KEY "SELECT T.CHNI_FK, T.TRC_PK, CONCAT(T.DIRECTORY, '/', T.FILENAME), T.FORMAT,"" YEAR(T.START), DAYOFYEAR(T.START), N.NTW, N.STN, N.LOC, N.CHN,"" CONCAT(R.DIRECTORY, '/', R.FILENAME), R.resp_pk,"" CONCAT(T2.DIRECTORY, '/', T2.FILENAME), T2.TRC_PK"" FROM TRC T, TRC T2, nslc N, RESP R WHERE T.TRC_PK = %d"" AND N.CHNI_PK = T.CHNI_FK AND R.CHNI_FK = T.CHNI_FK AND T2.TRC_PK = %d"
#define SQL_PSDCFG_KEY "SELECT minPower, maxPower, sections, steps, duration, dbOffset, ""maxPeriod, binWidth, gapThresh, units, lastStage, type, overlap ""FROM PSDCFG P, TRC T ""WHERE T.TRC_PK = %d AND P.CHNI_FK = T.CHNI_FK"
#define SQL_PSDD_LOCK "SELECT GET_LOCK('%s.PSDTABLE%d', 100)"
#define SQL_PSDI_INS "INSERT INTO `%sDATA`.`psd%didx` (TRC_FK, DAY, STARTT, ENDT)"" VALUES (%d, MAKEDATE(%d, %d), '%02d:%02d:%02d', '%02d:%02d:%02d')"
#define SQL_PSDD_INS1 "INSERT INTO `%sDATA`.psd%d (PSD_FK, PERIOD, POWER) VALUES %s"
#define SQL_PSDD_UNLCK "SELECT RELEASE_LOCK('%s.PSDTABLE%d')"
#define SQL_PSDD_DELCNT "SELECT COUNT(*) ""FROM `%sDATA`.`psd%didx` P1 ""WHERE ""P1.trc_fk = %d AND ""P1.day = MAKEDATE(%d,%d) AND ""P1.startT >= '%02d:%02d' AND ""P1.startT <= '%02d:%02d:%02d'"
#define SQL_PSDD_RECS "INSERT INTO `%sTMP`.`psdidx91` ""SELECT %d, psd_pk FROM `%sDATA`.`psd%didx` P1 ""WHERE ""P1.trc_fk = %d AND ""P1.day = MAKEDATE(%d,%d) AND ""P1.startT >= '%02d:%02d' AND ""P1.startT <= '%02d:%02d:%02d'"
#if 0
#define SQL_PSDD_DELD "DELETE `%sDATA`.P2 ""FROM `%sDATA`.`psd%d` P2, `%sDATA`.`psd%didx` P1 ""WHERE P2.psd_fk = P1.psd_pk AND ""P1.trc_fk = %d AND ""P1.day = MAKEDATE(%d,%d) AND ""P1.startT >= '%02d:%02d' AND ""P1.startT <= '%02d:%02d:%02d'"
#define SQL_PSDD_DELI "DELETE `%sDATA`.P1 ""FROM `%sDATA`.`psd%didx` P1 ""WHERE ""P1.trc_fk = %d AND ""P1.day = MAKEDATE(%d,%d) AND ""P1.startT >= '%02d:%02d' AND ""P1.startT <= '%02d:%02d:%02d'"
#define SQL_PSDD_DATE "DELETE %s, %s FROM %s, %s, TRC T, EVENTQargs e ""WHERE %s.psd_fk = %s.psd_pk AND ""e.evtq_id = %d AND ""T.chni_fk = %d AND ""DATE(T.start) >= CAST(e.arg1 as date) AND ""DATE(T.end) <= CAST(e.arg2 as date) AND ""%s.trc_fk = T.trc_pk"
#endif
#define SQL_PSDD_DELD "DELETE %s ""FROM %s, %s ""WHERE %s.psd_fk = %s.psd_pk AND ""%s.trc_fk = %d AND ""%s.day = MAKEDATE(%d,%d) AND ""%s.startT >= '%02d:%02d' AND ""%s.startT <= '%02d:%02d:%02d'"
#define SQL_PSDD_DELI "DELETE %s ""FROM %s ""WHERE ""%s.trc_fk = %d AND ""%s.day = MAKEDATE(%d,%d) AND ""%s.startT >= '%02d:%02d' AND ""%s.startT <= '%02d:%02d:%02d'"
#define SQL_PSDD_DATE "DELETE %s, %s FROM %s, %s, TRC T, EVENTQargs e ""WHERE %s.psd_fk = %s.psd_pk AND ""e.evtq_id = %d AND ""T.chni_fk = %d AND ""DATE(T.start) >= CAST(e.arg1 as date) AND ""DATE(T.end) <= CAST(e.arg2 as date) AND ""%s.trc_fk = T.trc_pk"
#define SQL_PSDTMP_MK "CREATE TABLE %s (`reqID` int unsigned NOT NULL, `psd_fk` int unsigned NOT NULL, KEY `req` (`reqID`, `psd_fk`)) ENGINE=InnoDB;""CREATE TABLE %s (`reqID` int unsigned NOT NULL, `cnt` int unsigned NOT NULL, KEY `req` (`reqID`)) ENGINE=InnoDB;""CREATE TABLE %s (`reqID` int unsigned NOT NULL, `psd_fk` int unsigned NOT NULL, KEY `req` (`reqID`, `psd_fk`)) ENGINE=InnoDB;""CREATE TABLE %s (`reqID` int unsigned NOT NULL, `cnt` int unsigned NOT NULL, KEY `req` (`reqID`)) ENGINE=InnoDB;"
#define SQL_PSDTMP_DROP  "DROP TABLE IF EXISTS %s; DROP TABLE IF EXISTS %s; DROP TABLE IF EXISTS %s; DROP TABLE IF EXISTS %s"
#define SQL_PSDTMP_TMPMK  "SET max_heap_table_size = 1024*1024*32; ""CREATE TEMPORARY TABLE `%s` (`psd_fk` int unsigned NOT NULL PRIMARY KEY) ENGINE=MEMORY;""CREATE TEMPORARY TABLE `%s` (`cnt` int(8) unsigned NOT NULL) ENGINE=MEMORY"
#define SQL_PSDTMP_TMPDROP "DROP TABLE `%s`;DROP TABLE `%s`"
#define SQL_KEYTMP_TMPMK  "CREATE TEMPORARY TABLE `%s` (`key_fk` int unsigned NOT NULL PRIMARY KEY) ENGINE=MEMORY"
#define SQL_PSD2TMP_TMPMK "CREATE TEMPORARY TABLE `%s` (`trc_fk` int unsigned NOT NULL PRIMARY KEY) ENGINE=MEMORY;"
#define SQL_EVTQIC_TMPMK  "CREATE TEMPORARY TABLE IF NOT EXISTS `%s` (`chni_fk` int unsigned NOT NULL ) ENGINE=MEMORY"
#define SQL_PSDD_MKTBL  "CREATE TABLE `%sDATA`.`psd%d` (`psd_fk` int(10) unsigned NOT NULL,"" `period` decimal(12,6) NOT NULL,""`power` smallint(6) NOT NULL) ENGINE=MyISAM DEFAULT CHARSET=latin1"
#define SQL_PSDIDX_MKTBL "CREATE TABLE `%sDATA`.`psd%didx` (`psd_pk` int(11) NOT NULL auto_increment,""`trc_fk` int(10) NOT NULL,`day` date NOT NULL,`startT` time NOT NULL,""`endT` time NOT NULL,PRIMARY KEY (`psd_pk`)) ENGINE=MyISAM DEFAULT CHARSET=latin1"
#define SQL_PSDIDX_MKIDX "CREATE INDEX `psd_fk` ON `%sDATA`.`psd%d` (`psd_fk`);""CREATE INDEX `perpow` ON `%sDATA`.`psd%d` (`period`, `power`);""CREATE INDEX `trc_fk` ON `%sDATA`.`psd%didx` (`trc_fk`,`day`,`startT`);""CREATE INDEX `day` ON `%sDATA`.`psd%didx` (`day`,`startT`);""CREATE INDEX `startT` ON `%sDATA`.`psd%didx` (`startT`)"
#define SQL_PDFIDX_CLEAN "DELETE FROM PDFIDX WHERE chni_fk = %d"
#define SQL_PDFD_MK  "CREATE TABLE `%sDATA`.`pdf%d` (`pdf_fk` int(11) NOT NULL,"" `period` decimal(12,6) NOT NULL, `power` smallint(6) NOT NULL,"" `prob` float NOT NULL, KEY (`pdf_fk`)) ENGINE=MyISAM DEFAULT CHARSET=latin1;"
#define SQL_PDFKEY_CNT "SELECT cnt FROM %s"
#define SQL_PDFKEY_KEY "SELECT psd_fk FROM %s %s LIMIT 1"
#define SQL_SYSPDF_CNT "SELECT COUNT(*) FROM EVENTQ WHERE type = %d and processed = 'NOPROC'"
#define SQL_PNG_MKEVT "INSERT INTO EVENTQ (TYPE, TYPEKEY, processed, chni_fk) ""SELECT %d, typeKey, 'NOPROC', chni_fk ""FROM EVENTQ E ""WHERE E.type = %d and processed = 'NOPROC'"
#define SQL_PDF_TRUNC "TRUNCATE `%sDATA`.`pdf%d`"
#define SQL_PDFIDX_MK "INSERT INTO PDFIDX (PDFCFG_FK, CHNI_FK, epoch) SELECT PDFCFG_PK, %d, %d FROM PDFCFG"
#define SQL_PDF_INS1 "INSERT INTO `%sDATA`.pdf%d (pdf_fk, period, power, prob) ""SELECT pdf_pk, period, power, hits/(%d) ""FROM `%sSTATS`.hits%d h, PDFIDX P2 ""WHERE h.pdfcfg_fk = %d AND P2.chni_fk = %d AND ""P2.pdfcfg_fk = %d AND P2.epoch = %d ""GROUP BY period, power"
#define SQL_PDF_INS2 "FROM `%sDATA`.psd%didx z, %s P where z.psd_pk = P.psd_fk"
#define SQL_PDF_METASTATS "UPDATE PDFIDX set ttlPSD = %d, dayE = (select max(day) %s) ""WHERE chni_fk = %d and pdfcfg_fk = %d and epoch = %d"
#define SQL_PDF_DTS "UPDATE PDFIDX set dayS = (select min(day) %s) ""WHERE chni_fk = %d AND pdfcfg_fk = %d AND epoch = %d"
#define SQL_PDF_SRC "UPDATE PDFIDX set ttlPSD = %d where chni_fk = %d"
#define SQL_PDF_QRY "SELECT P1.PERIOD, P1.POWER, P1.PROB FROM `%sDATA`.pdf%d P1, PDFIDX P2 ""WHERE P2.chni_fk = %d AND P2.pdfcfg_fk = %d AND P2.epoch = 0 ""AND P1.PDF_FK = P2.PDF_PK ORDER BY P1.PERIOD"
#define SQL_PDF_PDFRNG "SELECT YEAR(dayS), DAYOFYEAR(dayS), YEAR(dayE), ""DAYOFYEAR(dayE), ttlPSD, e.startD, e.endD ""FROM PDFIDX P2, EPOCHSPS e ""WHERE P2.chni_fk = %d AND P2.pdfcfg_fk = %d ""AND P2.epoch = 0 AND P2.ttlPSD <> 0 AND ""e.chni_fk = P2.chni_fk AND ""e.sps_pk = (SELECT sps_pk FROM EPOCHSPS WHERE chni_fk = %d ORDER BY 1 DESC LIMIT 1)"
#define SQL_PDF_YBDS "SELECT minPower, maxPower, type FROM PSDCFG WHERE chni_fk = %d"
#define SQL_SYSPDF_LST "SELECT pdfcfg_pk, name, description, dayStart, dayEnd, year, type, dateFmt ""FROM PDFCFG ORDER BY pdfcfg_pk"
#define SQL_SYSPDF_STATS "SELECT pdfcfg_pk, name, convert(min, signed)-1, convert(max, signed)-1, ""convert(mode, signed)-1, convert(median, signed)-1, convert(mean, signed)-1, ""convert(p5, signed)-1, convert(p10, signed)-1, convert(p25, signed)-1, ""convert(p75, signed)-1, convert(p90, signed)-1, convert(p95, signed)-1, ""dateFmt, convert(HLNM, signed)-1 ""FROM PDFCFG ORDER BY pdfcfg_pk"
#define SQL_PDF_EPOCHS "SELECT startD, endD FROM EPOCHSPS WHERE chni_fk = %d ORDER BY endD DESC LIMIT 1"
#define SQL_PDF_EPOCHSCNT "SELECT count(*) FROM EPOCHSPS WHERE chni_fk = %d AND ""startD <= STR_TO_DATE('%04d%03d','%%Y%%j') AND ""endD >= STR_TO_DATE('%04d%03d','%%Y%%j')"
#define SQL_SPS_TMPMK "DROP TABLE IF EXISTS %s; CREATE TABLE %s (""tmp_pk integer unsigned NOT NULL AUTO_INCREMENT, ""chni_fk mediumint unsigned NOT NULL, ""sampInt int NOT NULL, ""startD date NOT NULL, ""endD date NOT NULL, ""PRIMARY KEY(`tmp_pk`), ""KEY `chni_fk` (`chni_fk`, `tmp_pk`, `sampint`))""ENGINE=MyISAM DEFAULT CHARSET=latin1"
#define SQL_SPS_TMPFILL "TRUNCATE TABLE %s; ""INSERT INTO %s (chni_fk, sampint, startD, endD) ""SELECT chni_fk, sampint, DATE(start), DATE(end) ""FROM TRC ""WHERE format <> 'DUMMY' AND ""sampint > 0 AND ""chni_fk = %d ""ORDER BY start"
#define SQL_SPS_TMPDROP "DROP TABLE %s"
#define SQL_SPS_SPSE "DELETE FROM `%s`.`EPOCHSPS` WHERE chni_fk = %d; ""INSERT INTO `%s`.`EPOCHSPS` (chni_fk, sampint, startD, endD) ""SELECT ""a.chni_fk, ""a.sampint, ""a.startD, ""COALESCE("" (SELECT b.endD ""  FROM %s b, %s f ""  WHERE b.chni_fk = a.chni_fk AND b.chni_fk = f.chni_fk AND ""   a.sampint = b.sampint AND b.tmp_pk = f.tmp_pk-1 AND ""   f.tmp_pk > a.tmp_pk AND f.sampint <> a.sampint ""  ORDER BY b.tmp_pk ASC LIMIT 1), "" (SELECT MAX(e.endD) FROM %s e ""  WHERE e.chni_fk = a.chni_fk)) AS endD ""FROM %s a ""WHERE ""a.chni_fk = %d AND ""a.sampint <> ""COALESCE((SELECT c.sampint "" FROM %s c "" WHERE c.chni_fk = a.chni_fk AND c.tmp_pk < a.tmp_pk "" ORDER BY c.tmp_pk DESC LIMIT 1), 0) ""ORDER BY a.startD"
#define SQL_SPS_BDRY "UPDATE EPOCHSPS e1, EPOCHSPS e2 ""SET e1.startD = ADDDATE(e2.endD, INTERVAL 1 DAY) ""WHERE ""e1.chni_fk = e2.chni_fk AND ""e2.endD >= e1.startD AND ""e2.sps_pk < e1.sps_pk AND ""e1.chni_fk = %d"
#define SQL_PSDIDX_LOCK  "SELECT GET_LOCK('%s.PSDIDX%d', 100)"
#define SQL_PSDIDX_UNLCK "SELECT RELEASE_LOCK('%s.PSDIDX%d')"
#define SQL_PSDREQ_DEL  "DELETE FROM %s WHERE reqID = %d;DELETE FROM %s WHERE reqID = %d;""DELETE FROM %s WHERE reqID = %d;DELETE FROM %s WHERE reqID = %d"
#define SQL_PSDD_CNT "select count(*) from `%sDATA`.`psd%didx` P %s"
#define SQL_PSDD_QRY "select period, power, count(*)/(%d) from `%sDATA`.psd%d z, `%sDATA`.`psd%didx` P"" where z.psd_fk = P.psd_pk %s group by period, power"
#define SQL_PSDD_CNTI "TRUNCATE %s; TRUNCATE %s; ""INSERT INTO %s SELECT P.psd_pk ""FROM `%sDATA`.`psd%didx` P, TRC T ""WHERE T.chni_fk = %d AND P.trc_fk = T.trc_pk %s; ""INSERT INTO %s SELECT count(*) FROM %s"
#define SQL_PSDD_CNTR "SELECT cnt FROM %s %s"
#define SQL_PSDD_QRYB "select period, power, count(*), CAST(count(*)/(%d) as DECIMAL(8,6))"" from `%sDATA`.psd%d z, %s P where z.psd_fk = P.psd_fk group by period, power"
#define SQL_PDF_PSDQRY1Az "TRUNCATE %s; TRUNCATE %s; ""INSERT INTO %s (psd_fk, reqID) SELECT DISTINCT(psd_pk), %d ""FROM `%sDATA`.`psd%didx` P, `%sDATA`.psd%d z WHERE P.psd_pk = z.psd_fk %s; ""INSERT INTO %s (cnt, reqID) SELECT COUNT(*), reqID FROM %s WHERE reqID = %d"
#define SQL_PDF_PSDQRY1A  "TRUNCATE %s; TRUNCATE %s; ""INSERT INTO %s (psd_fk, reqID) SELECT DISTINCT(psd_pk), %d"" FROM `%sDATA`.`psd%didx` P /*WHERE*/ %s;"" INSERT INTO %s (cnt, reqID) SELECT COUNT(*), reqID FROM %s WHERE reqID = %d"
#define SQL_PDF_PSDQRY1B "DELETE FROM %s WHERE reqID = %d; DELETE FROM %s WHERE reqID = %d; ""INSERT INTO %s (reqID, psd_fk) SELECT reqID, psd_fk FROM %s WHERE reqID = %d; ""INSERT INTO %s (reqID, cnt) SELECT reqID, COUNT(*) FROM %s WHERE reqID = %d GROUP BY 1"
#define SQL_PDF_PSDQRY1C "DELETE FROM %s WHERE reqID = %d; DELETE FROM %s WHERE reqID = %d;""INSERT INTO %s (psd_fk, reqID) select distinct(psd_pk), reqID ""FROM `%sDATA`.`psd%didx` P, %s z WHERE z.reqID = %d AND P.psd_pk = z.psd_fk %s;""DELETE FROM %s WHERE reqID = %d; DELETE FROM %s WHERE reqID = %d;""INSERT INTO %s (reqID, psd_fk) SELECT reqID, psd_fk FROM %s WHERE reqID = %d;""INSERT INTO %s (reqID, cnt) SELECT reqID, COUNT(*) FROM %s WHERE reqID = %d GROUP BY 1"
#define SQL_PDF_PSDQRY2A "DELETE FROM %s WHERE reqID = %d; DELETE FROM %s WHERE reqID = %d;""INSERT INTO %s (psd_fk, reqID) SELECT DISTINCT(p1.psd_fk), p1.reqID ""FROM %s p1, `%sDATA`.psd%d z WHERE p1.reqID = %d AND p1.psd_fk = z.psd_fk %s; ""DELETE FROM %s WHERE reqID = %d; DELETE FROM %s WHERE reqID = %d;""INSERT INTO %s (reqID, psd_fk) SELECT reqID, psd_fk FROM %s WHERE reqID = %d; ""INSERT INTO %s (reqID, cnt) SELECT reqID, COUNT(*) FROM %s WHERE reqID = %d GROUP BY 1" 
#define SQL_PDF_PSDQRY2 "DELETE FROM %s WHERE reqID = %d; DELETE FROM %s WHERE reqID = %d; ""INSERT INTO %s (psd_fk, reqID) SELECT distinct(p1.psd_fk), p1.reqID ""FROM %s p1, `%sDATA`.psd%d z WHERE p1.reqID = %d AND p1.psd_fk = z.psd_fk %s;""INSERT INTO %s (reqID, cnt) SELECT reqID, COUNT(*) FROM %s WHERE reqID = %d GROUP BY 1; ""SELECT cnt FROM %s WHERE reqID = %d" 
#define SQL_PDF_PSDQRY3B "SELECT period, power, COUNT(*), ""CAST(COUNT(*)/(SELECT cnt FROM %s WHERE reqID = %d) as DECIMAL(8,6)) prob ""FROM `%sDATA`.psd%d z, %s p1 ""WHERE p1.reqID = %d AND p1.psd_fk = z.psd_fk ""GROUP BY period, power ORDER BY period"
#define SQL_PDF_HRPDF1 "DELETE FROM %s WHERE reqID = %d; DELETE FROM %s WHERE reqID = %d; ""INSERT INTO %s (psd_fk, reqID) SELECT DISTINCT(psd_fk), z.reqID ""FROM `%sDATA`.`psd%didx` P, %s z ""WHERE z.reqID = %d AND P.psd_pk = z.psd_fk %s;""INSERT INTO %s (reqID, cnt) SELECT reqID, COUNT(*) FROM %s WHERE reqID = %d GROUP BY 1; ""DELETE FROM %s WHERE reqID = %d"
#define SQL_PDF_HRPDF2 "SELECT cnt FROM %s WHERE reqID = %d"
#define SQL_PDF_PSDCNT "SELECT cnt FROM %s WHERE reqID = %d"
#define SQL_PDF_PSDRNG "SELECT YEAR(min(day)), DAYOFYEAR(min(day)), YEAR(max(day)), DAYOFYEAR(max(day)) ""FROM `%sDATA`.`psd%didx` P, %s p1 ""WHERE p1.reqID = %d AND P.psd_pk = p1.psd_fk"
#define SQL_PDF_TRCQRY "SELECT DISTINCT(CONCAT(T.directory, '/', T.filename)), max, min, mean, ""YEAR(start), DAYOFYEAR(start), HOUR(start), MINUTE(start), SECOND(start), ""YEAR(end), DAYOFYEAR(end), HOUR(end), MINUTE(end), SECOND(end), endM, ""sampInt FROM TRC T, `%sDATA`.`psd%didx` P, %s p1 ""WHERE p1.reqID = %d AND P.psd_pk = p1.psd_fk AND T.trc_pk = P.trc_fk ""ORDER BY P.day desc, P.startT DESC"
#define SQL_PDF_HRQRY "SELECT YEAR(day), DAYOFYEAR(day), HOUR(startT), MINUTE(startT), ""(TIME_TO_SEC(TIMEDIFF(endT, startT))/60) ""FROM `%sDATA`.`psd%didx` P, %s p1 ""WHERE p1.reqID = %d AND P.psd_pk = p1.psd_fk ""ORDER BY 1, 2, 3, 4"
#define SQL_PER_BD1I "DELETE FROM %s WHERE reqID = %d; ""INSERT INTO %s (psd_fk, reqID) SELECT MIN(psd_pk), %d FROM `%sDATA`.`psd%didx` P" 
#define SQL_PER_BD1S "SELECT z.period FROM `%sDATA`.psd%d z, %s p WHERE p.reqID = %d AND ""z.psd_fk = p.psd_fk AND z.period < %f UNION SELECT MIN(z.period) ""FROM `%sDATA`.psd%d z, %s p WHERE p.reqID = %d AND z.psd_fk = p.psd_fk ""ORDER BY 1 DESC LIMIT 1"
#define SQL_PER_BD2I "DELETE FROM %s WHERE reqID = %d; ""INSERT INTO %s (psd_fk, reqID) SELECT MIN(psd_pk), %d FROM `%sDATA`.`psd%didx` P" 
#define SQL_PER_BD2S "SELECT z.period FROM `%sDATA`.psd%d z, %s p ""WHERE p.reqID = %d AND z.psd_fk = p.psd_fk AND z.period > %f ""UNION SELECT MAX(z.period) FROM `%sDATA`.psd%d z, %s p ""WHERE p.reqID = %d AND z.psd_fk = p.psd_fk ""ORDER BY 1 ASC LIMIT 1"
#define SQL_REQ_YRS  " (YEAR(P.day) >= %d) "
#define SQL_REQ_YRE  " (YEAR(P.day) <= %d) "
#define SQL_REQ_DYS  " (P.day >= '%d-%02d-%02d') "
#define SQL_REQ_DYE  " (P.day <= '%d-%02d-%02d') "
#define SQL_REQ_DYSR " (DAYOFYEAR(P.day) >= DAYOFYEAR(CONCAT(YEAR(P.day), '-%02d-%02d'))) "
#define SQL_REQ_DYER " (DAYOFYEAR(P.day) <= DAYOFYEAR(CONCAT(YEAR(P.day), '-%02d-%02d'))) "
#define SQL_REQ_DYSER " (DAYOFYEAR(P.day) <= DAYOFYEAR(CONCAT(YEAR(P.day), '-%02d-%02d')) ""OR DAYOFYEAR(P.day) >= DAYOFYEAR(CONCAT(YEAR(P.day), '-%02d-%02d'))) "
#define SQL_REQ_HRS  " (P.startT >= '%02d:%02d:00') "
#define SQL_REQ_HRE  " (P.startT <= '%02d:%02d:00') "
#define SQL_REQ_HRSE " (P.startT <= '%02d:%02d:00' OR P.startT >= '%02d:%02d:00') "
#define SQL_REQ2_DAY0 " (day = '%d-%02d-%02d' AND startT >= '%02d:%02d:%02d' AND startT <= '%02d:%02d:%02d') "
#define SQL_REQ2_BEG " (day = '%d-%02d-%02d' AND startT >= '%02d:%02d:%02d') " 
#define SQL_REQ2_END " (day = '%d-%02d-%02d' AND startT <= '%02d:%02d:%02d') "
#define SQL_REQ2_BTWN " (day > '%d-%02d-%02d' AND day < '%d-%02d-%02d') "
#define SQL_REQ_FREQED " ((DATEDIFF(P.day,'%d-%02d-%02d'))%%(%d) <= %d) "
#define SQL_REQ_PRD  " (z.period between %f and %f) "
#define SQL_REQ_PWRR " (z.power between %d and %d) "
#define SQL_REQ_PWRP " (z.power = %d) "
#define SQL_REQ_AGOS " (P.day > (select max(P1.day) from `%sDATA`.`psd%didx` P1) - INTERVAL %d day) "
#define SQL_REQ_AGOE " (P.day <= (select max(P1.day) from `%sDATA`.`psd%didx` P1) - INTERVAL %d day) "
#define SQL_SYSPDF_EPOCH " P.day >= '%s' and P.day <= '%s'"
#define SQL_SYSPDF_YRB " (YEAR(P.day) = YEAR(DATE_ADD(CURDATE(), INTERVAL %d YEAR))) "
#define SQL_SYSPDF_AGOS " (P.day > DATE_ADD('%s', INTERVAL %d DAY)) "
#define SQL_SYSPDF_AGOE " (P.day <= DATE_ADD('%s', INTERVAL %d DAY)) "
#define SQL_PDFSH_MK "CREATE TABLE `%sSTATS`.`hits%d` (`pdfcfg_fk` TINYINT UNSIGNED NOT NULL, ""`period` DECIMAL(12,6) NOT NULL DEFAULT 0, `power` SMALLINT NOT NULL DEFAULT 0, ""`hits` MEDIUMINT UNSIGNED NOT NULL DEFAULT 0, KEY (`pdfcfg_fk`, `period`, `power`)) ""ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_PDFSS_MK "CREATE TABLE `%sSTATS`.`stats%d` (`pdfcfg_fk` TINYINT UNSIGNED NOT NULL, ""`period` DECIMAL(12,6) NOT NULL DEFAULT 0, `min` SMALLINT NOT NULL DEFAULT 0, ""`max` SMALLINT NOT NULL DEFAULT 0, `mode` SMALLINT NOT NULL DEFAULT 0, `median` ""SMALLINT NOT NULL DEFAULT 0, `mean` SMALLINT NOT NULL DEFAULT 0, `p5` SMALLINT ""NOT NULL DEFAULT 0, `p10` SMALLINT NOT NULL DEFAULT 0, `p25` SMALLINT NOT NULL ""DEFAULT 0, `p75` SMALLINT NOT NULL DEFAULT 0, `p90` SMALLINT NOT NULL DEFAULT 0, ""`p95` SMALLINT NOT NULL DEFAULT 0, KEY (`pdfcfg_fk`, `period`)) ""ENGINE = MYISAM DEFAULT CHARSET=latin1"
#define SQL_PDFST_TRUNC "TRUNCATE `%sSTATS`.hits%d; TRUNCATE `%sSTATS`.stats%d"
#define SQL_PDFST_HITSI "INSERT INTO `%sSTATS`.hits%d (pdfcfg_fk, period, power, hits) ""SELECT %d, period, power, count(*) ""FROM `%sDATA`.psd%d z, %s P ""WHERE z.psd_fk = P.psd_fk ""GROUP BY 2, 3"
#define SQL_PDFST_HITSG "SELECT period, power, hits ""FROM `%sSTATS`.hits%d ""WHERE pdfcfg_fk = %d ORDER BY 1, 2"
#define SQL_PDFST_HITSPER "SELECT COUNT(DISTINCT(period)) FROM `%sSTATS`.hits%d ""WHERE pdfcfg_fk = %d"
#define SQL_PDFST_TTLPER "SELECT COUNT(period) FROM `%sDATA`.psd%d WHERE psd_fk = %d"
#define SQL_PDFST_STATSI "INSERT INTO `%sSTATS`.stats%d (pdfcfg_fk, period, min, max, mode, median, mean, p5, ""p10, p25, p75, p90, p95) VALUES %s"
#define SQL_PDFST_STATSG "SELECT min, max, mode, median, mean, p5, p10, p25, p75, p90, p95, period FROM ""`%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY period"
#if 0
#define SQL_PDFST_MIN "SELECT period, min FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_MAX "SELECT period, max FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_MEAN "SELECT period, mean FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_MEDIAN "SELECT period, median FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_MODE "SELECT period, mode FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_P5 "SELECT period, p5 FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_P10 "SELECT period, p10 FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_P25 "SELECT period, p25 FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_P75 "SELECT period, p75 FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_P90 "SELECT period, p90 FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#define SQL_PDFST_P95 "SELECT period, p95 FROM `%sSTATS`.stats%d where pdfcfg_fk = %d ORDER BY 1"
#endif
#define SQL_SPECTRO_PSD "TRUNCATE %s; TRUNCATE %s; INSERT INTO %s SELECT P.psd_pk ""FROM `%sDATA`.`psd%didx` P %s ORDER BY P.day, P.startT; ""INSERT INTO %s SELECT COUNT(*) FROM %s"
#define SQL_SPECTRO_CNT "select cnt from %s"
#define SQL_SPECTRO_PSDDAY "SELECT (24*60*60)/(duration/(100/(100-overlap))) FROM `PSDCFG` WHERE chni_fk = %d" 
#define SQL_SPECTRO_FK "SELECT psd_fk FROM %s LIMIT 1"
#define SQL_SPECTRO_DATA "SELECT ((DATEDIFF(p1.day, p3.day)*86400 + TIME_TO_SEC(p1.startT))/""(PSD.duration/(100/(100-PSD.overlap))) + .05), p2.period, p2.power, p1.psd_pk ""FROM %s P, PSDCFG PSD, ""`%sDATA`.`psd%didx` p1, `%sDATA`.`psd%d` p2, `%sDATA`.`psd%didx` p3 ""WHERE P.psd_fk = p1.psd_pk AND p1.psd_pk = p2.psd_fk AND p3.psd_pk = %d AND ""PSD.chni_fk = %d ""ORDER BY 1, 4, 2 DESC"
#define SQL_SPECTRO_YBDS "SELECT min(period), max(period), count(*) ""FROM `%sDATA`.`psd%d` p2 ""WHERE p2.psd_fk = %d"
#define SQL_SPECTRO_DATES "SELECT DAY(min(p1.day)), MONTH(min(p1.day)), YEAR(min(p1.day)), ""DAY(max(p1.day)), MONTH(max(p1.day)), YEAR(max(p1.day)) ""FROM %s P, `%sDATA`.`psd%didx` p1 ""WHERE P.psd_fk = p1.psd_pk"
#define SQL_STN_TRCINS  "TRUNCATE %s; INSERT INTO %s (key_fk) SELECT T.trc_pk FROM TRC T WHERE ""T.chni_fk in ( %s ) and ((T.start < '%d-%d-%d' and T.end > '%d-%d-%d') or ""(T.format = 'DUMMY'))"
#define SQL_STN_TRC "SELECT T.chni_fk, T.sampInt, T.directory, T.filename, T.start, T.startM, T.end, ""T.endM, T.trc_pk, T.max, T.min, T.mean FROM TRC T, %s tt WHERE T.trc_pk = tt.key_fk ""ORDER BY T.chni_fk, T.start DESC"
#define SQL_STN_GLAP "SELECT G.trc_fk, G.type, G.startPt, G.endPt FROM GLAP G, %s tt WHERE ""G.trc_fk = tt.key_fk ORDER BY 1, 2 DESC"
#define SQL_STN_DBDRY "SELECT YEAR(C1.startT), MONTH(C1.startT), DAYOFMONTH(C1.startT), ""YEAR(ADDDATE(C2.endT,1)), MONTH(ADDDATE(C2.endT,1)), DAYOFMONTH(ADDDATE(C2.endT,1)) ""from CHNI C1, CHNI C2 ""where C1.startT = (select MIN(startT) from CHNI where nTraces > 0 AND YEAR(startT) > 1969) ""and C2.endT = (select MAX(endT) from CHNI where nTraces > 0) LIMIT 1"
#define SQL_CHNMETA_LIST "SELECT distinct(n.CHNI_PK), CM.instID"" FROM nslc n, CHNI C, STNKEYS S, CHNMETA CM "" WHERE n.CHNI_PK = C.CHNI_PK and"" C.STN_FK = S.stn_fk and C.nTraces > 0 and"" n.CHNI_PK = CM.CHNI_FK ORDER BY 1, CM.startT DESC"
#define SQL_CHNMETA_DEL "DELETE FROM CHNMETA WHERE chni_fk = %s AND startT = '%s' AND ""(endT = '%s' OR DATE(endT) >= '2599-12-31')"
#define SQL_CHNMETA_INS "INSERT INTO CHNMETA (chni_fk, startT, endT, latitude, longitude, elevation, depth, ""sensitivity, units, instID, azimuth, dip, sampInt, sitename) ""VALUES (%s, '%s', '%s', %s, %s, %s, %s, %s, '%s', '%s', %s, %s, %s, \"%s\")"
#define SQL_CHNMETA_GET "SELECT chni_fk, startT, endT, sitename, latitude, longitude, elevation, depth, ""sensitivity, units, instID, azimuth, dip, sampInt FROM CHNMETA where chni_fk in ""( %s ) and startT < '%d-%d-%d' and endT > '%d-%d-%d'"
#define SQL_CHNMETA_GETINST "SELECT chni_fk, instID from CHNMETA WHERE chni_fk in %s"
#define SQL_PSDIDX_91C "SELECT DISTINCT(chni_fk) FROM EVENTQ WHERE type = %d" 
#define SQL_PSDIDX_91M "DROP TABLE IF EXISTS `%sTMP`.`psdidx91`; CREATE TABLE `%sTMP`.`psdidx91` ""(`chni_fk` mediumint NOT NULL, `psd_fk` int unsigned NOT NULL, ""KEY `chni_fk` (`chni_fk`, `psd_fk`)) ENGINE=MyISAM;"
#define SQL_PSDIDX_91I "INSERT INTO `%sTMP`.`psdidx91` ""SELECT %d, psd_pk ""FROM `%sDATA`.`psd%didx` p, `%s`.EVENTQ e ""WHERE e.type = %d AND ""e.chni_fk = %d AND ""p.trc_fk = e.typeKey"
#define SQL_PSDIDX_91D "DELETE FROM EVENTQ WHERE type = %d"
#define SQL_PSDIDX_91N "INSERT INTO EVENTQ (typeKey, chni_fk, type, processed) ""SELECT distinct(chni_fk), chni_fk, %d, 'NOPROC' ""FROM `%sTMP`.`psdidx91`"
#define SQL_PSDIDX_91P1 "DELETE `%sSTATS`.`BLineS%d` FROM `%sSTATS`.`BLineS%d`, `%sTMP`.`psdidx91` ""WHERE `%sTMP`.`psdidx91`.chni_fk = %d AND ""`%sSTATS`.`BLineS%d`.psd_fk = `%sTMP`.`psdidx91`.psd_fk;"
#define SQL_PSDIDX_91P "DELETE `%sDATA`.`psd%d` FROM `%sDATA`.`psd%d`, `%sTMP`.`psdidx91` ""WHERE `%sTMP`.`psdidx91`.`chni_fk` = %d AND ""`%sDATA`.`psd%d`.`psd_fk` = `%sTMP`.`psdidx91`.`psd_fk`;""DELETE `%sDATA`.`psd%didx` FROM `%sDATA`.`psd%didx`, `%sTMP`.`psdidx91` ""WHERE `%sTMP`.`psdidx91`.`chni_fk` = %d AND ""`%sDATA`.`psd%didx`.`psd_pk` = `%sTMP`.`psdidx91`.`psd_fk`"
#define SQL_PSDIDX_91F "DROP TABLE IF EXISTS `%sTMP`.`psdidx91`"
#define SQL_SYS_GLAPDEL "DELETE GLAP FROM GLAP, EVENTQ ""WHERE EVENTQ.type = %d AND ""GLAP.trc_fk = EVENTQ.typeKey"
#define SQL_GLAPTMP_MK "DROP TABLE IF EXISTS %s; CREATE TABLE %s (`trc_fk` INT UNSIGNED PRIMARY KEY)"
#define SQL_GLAP_TRCFK "INSERT INTO %s SELECT distinct(trc_fk) FROM GLAP"
#define SQL_GLAP_TRCPK "INSERT INTO %s SELECT trc_pk FROM TRC WHERE format <> 'DUMMY'"
#define SQL_GLAP_DEL1 "DELETE %s FROM %s, %s WHERE %s.trc_fk = %s.trc_fk"
#define SQL_GLAP_DEL2 "DELETE GLAP FROM GLAP, %s WHERE GLAP.trc_fk = %s.trc_fk"
#define SQL_GLAPTMP_DEL "DROP TABLE %s; DROP TABLE %s"
#define SQL_PSDTBL_CLEANKEYS "CREATE TEMPORARY TABLE %s (`psd_pk` int unsigned) ENGINE=MEMORY ""SELECT P2.psd_pk ""FROM `%sDATA`.`psd%didx` P2 ""WHERE NOT EXISTS ""(SELECT trc_pk FROM TRC T WHERE T.chni_fk = %d AND ""P2.trc_fk = T.trc_pk)"
#define SQL_PSDTBL_CLEANCNT "SELECT COUNT(*) FROM %s"
#define SQL_PSDTBL_CLEAND "DELETE %s ""FROM %s, %s ""WHERE %s.`psd_fk` = %s.`psd_pk`"
#define SQL_PSDTBL_CLEANI "DELETE %s ""FROM %s, %s ""WHERE %s.psd_pk = %s.psd_pk"
#define SQL_PSDTBL_CLEANDEL "DROP TABLE %s"
#if 0
#define SQL_PSDTBL_CLEAND "DELETE `%sDATA`.P1 ""FROM `%sDATA`.`psd%d` P1, `%s` P2 ""WHERE P1.psd_fk = P2.psd_pk"
#define SQL_PSDTBL_CLEANI "DELETE `%sDATA`.P1 ""FROM `%sDATA`.`psd%didx` P1, `%s` P2 ""WHERE P1.psd_pk = P2.psd_pk"
#endif
#define SQL_PSDOPT_INS "INSERT INTO `%sTMP`.`PSDOPT` (`chni_fk`) VALUES (%d)"
#define SQL_PSDOPT_GET "SELECT DISTINCT(chni_fk) FROM `%sTMP`.`PSDOPT`"
#define SQL_PSDOPT_DEL "DELETE FROM `%sTMP`.`PSDOPT` WHERE chni_fk = %d"
#define SQL_PSDOPT_DOW "SELECT DAYOFWEEK(max(execTime)) FROM SRVREXEC ""WHERE pgmName = 'pqlxSrvr' AND doneTime is NULL"
#define SQL_PSDOPT_DSL "SELECT COUNT(*) FROM SRVREXEC s1 ""WHERE s1.pgmName = 'pqlxSrvr' AND ""s1.execTime > ""(SELECT COALESCE(max(s2.execTime), '2011-01-01') ""FROM SRVREXEC s2 ""WHERE s2.pgmName = 'pqlxDBMaint')"
#define SQL_BLINE_LIST "SELECT bline_pk, name, descr, convert(dir, signed), convert(active, signed) ""FROM `%s`.BLine WHERE chni_fk = 0"
#define SQL_BLINE_ACTIVE "SELECT bline_pk, name, descr, convert(dir, signed), chni_fk ""FROM `%s`.BLine WHERE active = 'Y'"
#define SQL_BLINE_ACTIVE_CNT "SELECT COUNT(*) FROM `%s`.BLine WHERE active = 'Y'"
#define SQL_BLINE_TBLMK "CREATE TABLE `%sSTATS`.`BLineS%d` "" (`bline_fk` mediumint NOT NULL, "" `psd_fk` integer NOT NULL, "" `pct` decimal(5,2) UNSIGNED NOT NULL, "" KEY `bline_fk` (`bline_fk`, `psd_fk`)) ""ENGINE = MyISAM COMMENT = 'Baseline Statistics';"
#define SQL_PSDTBL_TMPMK "DROP TABLE IF EXISTS %s; ""CREATE TABLE %s (`psd_fk` INTEGER UNSIGNED PRIMARY KEY) ENGINE=MEMORY"
#define SQL_PSDTBL_DROP  "DROP TABLE IF EXISTS %s"
#define SQL_BLINE_EPOCHSPK "SELECT sps_pk, sampInt FROM EPOCHSPS WHERE chni_fk = %d ORDER BY endD DESC LIMIT 1"
#define SQL_BLINE_PSDKEY "SELECT psd_pk ""FROM `%sDATA`.`psd%didx` p, `%s`.EPOCHSPS e ""WHERE e.sps_pk = %d AND ""p.day >= e.startD LIMIT 1"
#define SQL_BLINE_PERMAX "SELECT MAX(period) FROM `%sDATA`.`psd%d` WHERE psd_fk = %d"
#define SQL_BLINE_PSDKEYS "TRUNCATE TABLE %s; INSERT INTO %s ""SELECT psd_pk ""FROM `%sDATA`.`psd%didx` p, `%s`.EPOCHSPS e ""WHERE e.sps_pk = %d AND ""p.day >= e.startD AND ""NOT EXISTS ""(SELECT * FROM `%sSTATS`.`BLineS%d` br ""WHERE bline_fk = %d AND br.psd_fk = p.psd_pk)"
#define SQL_BLINE_PSDKEYS1 "TRUNCATE TABLE %s; INSERT INTO %s ""SELECT p.psd_pk ""FROM `%sDATA`.`psd%didx` p JOIN `%s`.EPOCHSPS e "" ON e.sps_pk = %d AND p.day >= e.startD "" LEFT JOIN `%sSTATS`.`BLineS%d` br "" ON br.bline_fk = %d AND p.psd_pk = br.psd_fk ""WHERE ""br.psd_fk IS NULL"
#define SQL_BLINE_CMP1 "INSERT INTO `%sSTATS`.`BLineS%d` (bline_fk, psd_fk, pct) ""SELECT %d, p.psd_fk, 0 ""FROM %s p "
#define SQL_BLINE_CMP "UPDATE `%sSTATS`.`BLineS%d` br, %s p ""SET br.pct = "" (SELECT convert(100*count(pd.psd_fk)/%d, decimal(5,2)) "" FROM `%sDATA`.`psd%d` pd, `%sSTATS`.`BLineID` b "" WHERE "" br.psd_fk = p.psd_fk AND "" p.psd_fk = pd.psd_fk AND "" b.blinei_fk = %d AND "" b.period = pd.period AND "" b.power %s pd.power) ""WHERE ""br.bline_fk = %d AND ""br.psd_fk = p.psd_fk"
#define SQL_BLINE_INTERP "SELECT blinei_fk, count(blinei_fk) ""FROM `%sSTATS`.`BLineI` i, `%sSTATS`.`BLineID` id ""WHERE i.blinei_pk = id.blinei_fk AND ""i.bline_fk = %d AND ""i.sampInt = %d AND ""i.periodMAX = %f ""HAVING blinei_fk IS NOT NULL"
#define SQL_PSD_PERIODS "SELECT period FROM `%sDATA`.`psd%d` WHERE psd_fk = %d ORDER BY 1 DESC"
#define SQL_BLINE_PERIODS "SELECT period, power FROM `%sSTATS`.`BLineD` WHERE bline_fk = %d ORDER BY 1 DESC"
#define SQL_INTERP_MAKE "INSERT INTO `%sSTATS`.`BLineI` (bline_fk, sampInt, periodMAX) ""VALUES (%d, %d, %f)"
#define SQL_INTERP_INSDATA "INSERT INTO `%sSTATS`.`BLineID` (blinei_fk, period, power) VALUES %s"
#define SQL_BLINE_CNT "SELECT count(*) FROM `%sSTATS`.`BLineD` WHERE bline_fk = %d"
#define SQL_BLINE_PTS "SELECT period, power FROM `%sSTATS`.`BLineD` WHERE bline_fk = %d ORDER BY period"
#define SQL_BLINE_PDF "DELETE FROM %s WHERE reqID = %d; DELETE FROM %s WHERE reqID = %d;""INSERT INTO %s (psd_fk, reqID) SELECT DISTINCT(psd_fk), %d ""FROM `%sSTATS`.BLineS%d bs WHERE bs.bline_fk = %d AND bs.pct > %d;""INSERT INTO %s (cnt, reqID) SELECT COUNT(*), reqID FROM %s WHERE reqID = %d"
#define SQL_SYS_KEEPALIVE "SELECT CURDATE()"
#define SQL_TMPTBL_DROP "DROP DATABASE IF EXISTS `%sTMP`; CREATE DATABASE `%sTMP` CHARACTER SET latin1 COLLATE latin1_general_cs"
#define SQL_TBL_OPTIMIZE "OPTIMIZE TABLE %s"
#define SQL_EVTQTBL_ERRMOVE "INSERT INTO EVENTQerr (srvrExec_fk, evtq_id, type, typeKey, ""typeKey2, error_no, user_fk, chni_fk) ""SELECT %d, evtq_id, type, typeKey, typeKey2, ""error_no, user_fk, chni_fk ""FROM EVENTQ WHERE processed = 'PROCD' and error_no <> %d"
#define SQL_EVTQTBL_CLEAN "DELETE FROM EVENTQ WHERE processed = 'PROCD' and error_no <> %d"
#define SQL_EVTQTBL_CLEAN2 "DELETE FROM EVENTQ WHERE type IN (1, 2, 3) AND error_no <> 0 ""AND NOT EXISTS (SELECT trc_pk FROM TRC t WHERE typeKey = t.trc_pk)"
#define SQL_TABLE_REPAIR "REPAIR TABLE %s"
#define SQL_DBMAAT_NINST "SELECT DISTINCT(name) FROM `%s`.`IDS` WHERE type = 'STN'"
#define SQL_DBMAAT_NP  "SELECT SUM(ttlPSD) FROM `%s`.`CHNI`"
#define SQL_MODEL_KEY "SELECT model_pk FROM PQLXMETA.MODELNM WHERE name = '%s'"
#define SQL_MODEL_DEL1 "DELETE FROM PQLXMETA.MODELNM WHERE model_pk = %d"
#define SQL_MODEL_DEL2 "DELETE FROM PQLXMETA.MODELPH WHERE model_fk = %d"
#define SQL_MODEL_DEL3 "DELETE FROM PQLXMETA.MODELTT WHERE model_fk = %d"
#define SQL_MODEL_DEL4 "DELETE FROM PQLXMETA.MODELTB WHERE model_fk = %d"
#define SQL_MODEL_OPT1 "OPTIMIZE TABLE PQLXMETA.MODELTT"
#define SQL_MODEL_OPT2 "OPTIMIZE TABLE PQLXMETA.MODELTB"
#define SQL_MODEL_INSN "INSERT INTO PQLXMETA.MODELNM (name, importT) VALUES ('%s', current_timestamp())"
#define SQL_MODEL_INSP "INSERT INTO PQLXMETA.MODELPH (model_fk, name) VALUES (%d, '%s')"
#define SQL_MODEL_INST "INSERT INTO PQLXMETA.MODELTT (model_fk, phase_fk, depth, distance, ttime) VALUES %s"
#define SQL_MODEL_INSB1 "INSERT INTO PQLXMETA.MODELTB (value, model_fk, type) ""SELECT DISTINCT(depth), model_fk, 'DEPTH' ""FROM PQLXMETA.MODELTT WHERE model_fk = %d"
#define SQL_MODEL_INSB2 "INSERT INTO PQLXMETA.MODELTB (value, model_fk, type) ""SELECT DISTINCT(distance), model_fk, 'DISTANCE' ""FROM PQLXMETA.MODELTT WHERE model_fk = %d"
#define SQL_MODEL_GETNM "SELECT n.name, n.model_pk, p.name, p.phase_pk FROM PQLXMETA.MODELNM n, ""PQLXMETA.MODELPH p WHERE n.model_pk = p.model_fk ORDER BY 1 DESC, 3 DESC"
#define SQL_MODEL_GETTB "SELECT max(value) FROM PQLXMETA.MODELTB WHERE model_fk = %d and type = 'DEPTH' and value <= '%0.2f' UNION ALL ""SELECT min(value) FROM PQLXMETA.MODELTB WHERE model_fk = %d and type = 'DEPTH' and value >= '%0.2f' UNION ALL ""SELECT max(value) FROM PQLXMETA.MODELTB WHERE model_fk = %d and type = 'DISTANCE' and value <= '%0.3f' UNION ALL ""SELECT min(value) FROM PQLXMETA.MODELTB WHERE model_fk = %d and type = 'DISTANCE' and value >= '%0.3f'"
#define SQL_MODEL_GETT "SELECT phase_fk, p.name, depth, distance, ttime, 1 FROM PQLXMETA.MODELTT t, PQLXMETA.MODELPH p ""WHERE t.model_fk = %d and t.depth = '%s' and t.distance = '%s' and t.phase_fk = p.phase_pk UNION ALL ""SELECT phase_fk, p.name, depth, distance, ttime, 2 FROM PQLXMETA.MODELTT t, PQLXMETA.MODELPH p ""WHERE t.model_fk = %d and t.depth = '%s' and t.distance = '%s' and t.phase_fk = p.phase_pk UNION ALL ""SELECT phase_fk, p.name, depth, distance, ttime, 3 FROM PQLXMETA.MODELTT t, PQLXMETA.MODELPH p ""WHERE t.model_fk = %d and t.depth = '%s' and t.distance = '%s' and t.phase_fk = p.phase_pk UNION ALL ""SELECT phase_fk, p.name, depth, distance, ttime, 4 FROM PQLXMETA.MODELTT t, PQLXMETA.MODELPH p ""WHERE t.model_fk = %d and t.depth = '%s' and t.distance = '%s' and t.phase_fk = p.phase_pk ""ORDER BY 2, 6 DESC, 5"
#define SQL_SEISE_DEL "DELETE PQLXMETA.SEISEVENT, PQLXMETA.SEISMAG FROM PQLXMETA.SEISEVENT, PQLXMETA.SEISMAG ""WHERE originID = %s AND seisevent_pk = seisevent_fk"
#define SQL_SEISE_INS "INSERT INTO PQLXMETA.SEISEVENT (description, eventID, originID, catalog, time, msec, ""lat, lon, depth) VALUES ('%s', %s, %s, '%s', '%s', %s, %s, %s, %s)"
#define SQL_SEISM_INS "INSERT INTO PQLXMETA.SEISMAG (seisevent_fk, magnitude, type) VALUES (%d, %s, '%s')"
#define SQL_SEISE_GET "SELECT eventID, originID, catalog, YEAR(time), MONTH(time), DAY(time), HOUR(time), ""MINUTE(time), SECOND(time), msec, lat, lon, depth, magnitude, type, ""seisevent_pk, description, concat(time, '.'), msec FROM PQLXMETA.SEISEVENT s, ""PQLXMETA.SEISMAG m WHERE DATE(time) = '%d-%02d-%02d' ""AND s.seisevent_pk = m.seisevent_fk ORDER BY time DESC"
#define SQL_SP_SNE1 "DROP PROCEDURE IF EXISTS `spNextEvent`"
#define SQL_SP_SNE2 "CREATE PROCEDURE `spNextEvent` () \n""BEGIN \n"" -- get the next available event and mark as INPROC \n"" DECLARE EVENT_PK, T, TK, TK2, CHNK INT; \n"" TRUNCATE TABLE `%s`; INSERT INTO `%s` SELECT chni_fk FROM EVENTQ where processed = 'INPROC'; \n"" -- first try to retrieve an event of a channel not currently executing \n"" SELECT `e1`.`evtq_id` AS `EVTQ_ID`,`e1`.`type` AS `TYPE`,`e1`.`typeKey` AS `TYPEKEY`, \n"" `e1`.`typeKey2` AS `TYPEKEY2`,`e1`.`chni_fk` AS `CHNI_FK` \n"" FROM `EVENTQ` `e1` \n"" WHERE ((`e1`.`processed` = 'UNPROC') AND \n"" (NOT(`e1`.`chni_fk` in (SELECT `%s`.`chni_fk` FROM `%s`)))) \n"" ORDER BY `e1`.`type` LIMIT 1 \n"" INTO EVENT_PK, T, TK, TK2, CHNK; \n"" \n"" if (EVENT_PK is NULL) THEN -- if that fails, just get any next event \n"" SELECT EVTQ_ID, TYPE, TYPEKEY, TYPEKEY2, CHNI_FK \n"" FROM eventQV \n"" LIMIT 1 \n"" INTO EVENT_PK, T, TK, TK2, CHNK; \n"" END IF; \n"" IF (EVENT_PK > %d AND T > %d) THEN \n""  UPDATE EVENTQ SET PROCESSED = 'INPROC' WHERE evtq_id = EVENT_PK; \n"" END IF; \n"" SELECT EVENT_PK, T, TK, TK2, CHNK; \n""END "
#endif
