#ifndef __DBMYSQLDEFS
#define __DBMYSQLDEFS
int db_event(SQLDI *sqldi);
int db_data(SQLDI *sqldi);
int db_key(SQLDI *sqldi);
int db_conn(int REQ_TYPE, SQLDI *sqldi);
int db_system(SQLDI *sqldi);
int db_maintain(SQLDI *sqldi);
int db_admin(SQLDI *sqldi);
int getDataSTN(MYSQL *conn, SQLDI *sqldi);
int db_upgrade(SQLDI *sqldi);
int pdb_upgrade(SQLDI *sqldi, int pdbVersion);
int insertXML(MYSQL *conn, SQLDI *sqldi);
void getUIP();
char *getUserName();
void PSDTblProc(MYSQL *conn, int chniKey);
#ifdef PQLX_THREAD_DEBUG
void db_debug(SQLDI *);
#endif
extern MYSQL *connG[MAXDBCONNS];
extern gboolean dbConns[MAXSQRCONNS];
extern char *dbName;
extern int dbVersion;
extern char *tmpTblNm[TTLTMPTBLS][TTLNAMETYPES];
extern char *dataTypes[];
extern char *scanTypes[];
extern char *uTypes[];
extern char *eTypes[];
extern char *myuname, *myipaddr;
extern int myutype;
extern GSList *ntw;
extern GSList *ntwPDF;
extern GSList *systemPDFdb;
extern GSList *PDFchn;
extern GSList *PDFcfg;
extern char  *stnSQL;
extern int  logKey;
extern int  cpu[TTLCPUTYPES];
enum {
PDFDETAILREQ,
PDFSUBREQ
};
enum {
SRVR,
CLNT,
ADMIN,
TTLUTYPES
};
enum {
LOGINEVT,
LOGOUTEVT
};
enum {
GETDBCONN,
RLSDBCONN,
DISDBCONN,
RESETDBCONN
};
enum {
REGISTERKEEPALIVE,
DEREGISTERKEEPALIVE,
CLEARKEEPALIVE
};
enum {
PFX_WHERE,
PFX_AND,
TTLPREFIXES
};
enum {
SFX_PSDD_CNTI,
TTLSUFFIXES
};
enum {
PSDDEL_OVERLAP,
PSDDEL_CHANNEL
};
enum {
BLLIST_INIT,
BLLIST_FETCH
};
enum { 
BLINECMP_UP,
BLINECMP_DOWN
};
#define EVENT_COMPLETE FAILURE
#define MINSRVREXECS 7
#define SATURDAY  7
#define ONEHOURSECS  (60*60)
#define MYSQLTIMEOUT (23*ONEHOURSECS)
#define MAXDBRETRIES 5
#define PQLXMETADB "PQLXMETA"
#define TMPDBASE "%sTMP"
#define TMPTBLNM "`%sTMP`.`z%d%s%d`"
#define IDXTBL "IDX"
#define CNTTBL "CNT"
#define TMPTBLIDX "psdidxtmp"
#define TMPTBLCNT "psdcnttmp"
#define KEYTMPTBL "tmpkeytable"
#define TRCKEYTMPTBL "trcKeyTemp"
#define EVTQIC  "evtqic"
enum {
TMPTBL1,
TMPTBL2
};
#define KEEPALIVETIME (10*60*1000)
#define ADDPREFIX(a, b) { char *tmp = a, *pfx; if (strlen(a)) { switch (b) { case PFX_WHERE: pfx = " WHERE "; break; case PFX_AND: pfx = " AND "; break; } a = g_strconcat(pfx, tmp, NULL); free(tmp); } }
#if 0
#define ADDSUFFIX(a, b) { char *tmp = a, *sfx; if (strlen(a)) { switch (b) { case SFX_PSDD_CNTI: sfx = " AND P.trc_fk = T.trc_pk AND T.chni_fk = "; break; }a = g_strconcat(tmp, sfx, NULL); free(tmp); } else { switch (b) { case SFX_PSDD_CNTI: a = " WHERE P.trc_fk = T.trc_pk"; break; }} }
#endif
typedef struct _PDFCFG
{
char  *chn;     
int  chnKey;
int  yBounds[TTLYBOUNDS]; 
int  type;     
} PDFCFG;
typedef struct _WHEREARGS
{
int  chnKey;
int  sysPdfKey;
char **sysPDFB;
float *criteria;
int  reqType;
} WHEREARGS;
typedef struct _BLINEINTERP
{
int blinei_pk;
int ttlPeriods;
} BLINEINTERP;
typedef struct _THREADARGS
{
int evtq_id;
int typeKey;
int threadNum;
} THREADARGS;
char *makeWhere(int subType, WHEREARGS *whereArgs);
int getData(MYSQL *conn, SQLDI *sqldi);
int insertData(MYSQL *conn, SQLDI *sqldi);
int updateByEvent(MYSQL *conn, SQLDI *sqldi);
int updateByData(MYSQL *conn, SQLDI *sqldi);
MYSQL *mngDBConn(SQLDI *sqldi, int request);
void mngDBConnClose();
int db_exec_sql(MYSQL *conn, char *sqlStr);
PDFSTATS *pdf_STATS(PDFHITS *);
GSList *stats_LINES(PDFSTATS *pdfStats, gboolean *statistics);
int get_ncpu_pqlx();
int _db_event(MYSQL *conn, SQLDI *sqldi);
int _db_maintain(MYSQL *conn, SQLDI *sqldi);
int _db_key(MYSQL *conn, SQLDI *sqldi);
int _db_system(MYSQL *conn, SQLDI *sqldi);
void keepAliveReg(int connNum, int action);
gint findSysPDF(SYSPDFDEF *s1, gpointer k);
void bug15752(MYSQL *conn);
void getPSDCFG(MYSQL *conn, PDFREQ *pdfReq);
void freeStr(char *str, gpointer nil);
int insertPSD(MYSQL *conn, SQLDI *sqldi, int chnKey, GPtrArray *strings);
int delPSD(MYSQL *conn, int cmd, int chnKey, int trcKey, PTIME *s1, PTIME *s2);
GSList *BLList(MYSQL *conn, int cmd);
BLINEINTERP *BLInterp(MYSQL *conn, int bline_pk, int chnKey, int psdKey, int sampInt, float perMAX);
gboolean checkDBMaintExec(char *);
int procThread(MYSQL *, int, int, void *, void *, void *);
int spsEpochInit(MYSQL *conn, int threadNum);
int spsEpochProc(MYSQL *conn, THREADARGS *);
int spsEpochDone(MYSQL *conn, int threadNum);
int psdDelProc(MYSQL *conn, THREADARGS *);
int psdDelDateProc(MYSQL *conn, THREADARGS *threadArgs);
int sysPDFinit(MYSQL *conn, int threadNum);
int sysPDFproc(MYSQL *conn, THREADARGS *);
int sysPDFdone(MYSQL *conn, int threadNum);
int psdIndex(MYSQL *conn, THREADARGS *);
int chniStats(MYSQL *conn, THREADARGS *);
int dirStats(MYSQL *conn, THREADARGS *);
int BLineCmpInit(MYSQL *conn, int threadNum);
int BLineCmpDone(MYSQL *conn, int threadNum);
int BLineCmpProc(MYSQL *conn, THREADARGS *);
#endif
