#ifndef _PQLXADMIN_H
#define _PQLXADMIN_H
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "pql_version.h"
#include "pqlx_defs_head.h"
#include "db_iface_head.h"
#include "db_iface_admin.h"
#include "pqlx_defs.h"
#include "pqlx_types.h"
#define BUTTONW 85 
#define BUTTONH 24 
#define ACTIVESTR "ACTIVE"
#define INACTIVESTR "INACTIVE"
enum { 
A_INFO,
A_CHAN,
A_LOGS,
TTLADMINTABS
};
enum { 
INFO_DESC,
INFO_DATADIR,
INFO_PSDCFG,
INFO_PNG,
TTLDBINFOTABS
};
enum { 
NB_MAIN,
NB_DEF,
TTLNB
};
enum { 
SRVR1,
SRVR2,
TTLSRVRVIEWS
};
enum { 
DBHOSTNAME,
DBDBNAME,
DBDESC,
DBORG,
DBTYPE,
DBACCESS,
DBDADMIN,
DBDADMINEM,
DBTADMIN,
DBTADMINEM,
DBPNGDIR,
DBPNGDF,
DBPNGHLNM,
DBPNGNW,
DBPNGNH,
DBPNGNB,
DBPNGNBC,
DBPNGIW,
DBPNGIH,
DBPNGIB,
DBPNGIBC,
DBTTLDETAILS
};
enum { 
DBTYPEPROD,
DBTYPESCRATCH,
TTLDBTYPES
};
enum { 
DBACCPUB,
DBACCPRIV,
TTLDBACCESS
};
enum { 
DBACTIONCREATE,
DBACTIONDELETE,
DBACTIONSAVE,
DBACTIONCANCEL,
DBACTIONEDIT,
DBACTIONREPSD,
DBACTIONNEW,
DBACTIONPREV,
DBACTIONNEXT,
DBACTIONLOGREF,
DBACTIONCOPY,
DBACTIONSRVRPAUSE,
DBACTIONSRVRRESUME,
TTLDBACTIONS
};
enum {
PGMEXEC_SRVR,
PGMEXEC_PQLX,
TTLPGMEXECS
};
enum { 
DBCREATE, 
DBEDIT, 
DBNOCONN, 
DBDISPLAY, 
TTLDBDISPSTATES
};
enum { 
DISPSENS, 
DISPVISIBLE, 
DISPEDITABLE, 
TTLDISPTYPES
};
enum { 
DATADIRS, 
CHANNELS, 
LOGEXEC, 
LOGMSGS, 
EQEXEC, 
EQQUED, 
EQPEND, 
SPSEPS, 
PSDCFG, 
TTLDATAMODELS
};
enum { 
SRVREXEC_DONE,
SRVREXEC_EXEC,
SRVREXEC_PAUSE,
SRVREXEC_CRASH,
TTLSRVREXECSTATES
};
enum { 
BUTCOPYDB,
BUTEXECEXEC,
BUTPAUSEEXEC,
BUTRESUMEEXEC,
BUTEXECCFG,
TTLINDBUTS
};
enum {
CHN_TTL,
CHN_STARTD,
CHN_ENDD,
TTLCHNSTATS
};
enum { 
DD_ADD,
DD_ENABLE,
DD_DISABLE,
DD_DELETE,
PNG_ADD,
IDFILE_ADD
};
enum { 
DD_DIR,
DD_ED,
DD_LS,
DD_TT,
DD_TR,
DD_TTLHDRS
};
enum { 
CH_NAME,
CH_STARTDT,
CH_ENDDT,
CH_TTLTRC,
CH_TTLPSD,
CH_TTLSPSEPOCH,
CH_RESP,
CH_TTLHDRS
};
enum { 
SPSE_SR,
SPSE_STARTDT,
SPSE_ENDDT,
SPSE_TTLHDRS
};
enum {
PSDCFGHDR_CHNGRP,
PSDCFG_TTLHDRS
};
enum {
PSDCFG_CONT,
PSDCFG_TRIG,
PSDCFG_TTLTYPES
};
enum { 
PSDCFG_ADD,
PSDCFG_TTLACTIONS
};
enum {
PSDCFG_CHNGRP,
PSDCFG_OVERLAP,
PSDCFG_MINDB,
PSDCFG_MAXDB,
PSDCFG_DURATION,
PSDCFG_MAXPER,
PSDCFG_TYPE,
PSDCONFTTLDETAILS
};
enum {
LOGA_DISPLAY,
LOGA_REFRESH,
TTLLOGACTIONS
};
enum { 
LOGE_NAME,
LOGE_TIME,
LOGE_DONETIME,
LOGE_DURATION,
LOGE_STATUS,
LOGE_TTLHDRS
};
enum { 
LOGM_TYPE,
LOGM_TIME,
LOGM_MSG,
LOGM_TTLHDRS
};
enum {
EQ_TOTAL,
EQ_TYPE,
EQ_TTLHDRS
};
enum {
PNGPLOT_PDF,
PNGPLOT_SPECTRO,
TTLPNGPLOTS
};
enum {
NORMPNG,
ICONPNG,
TTLPNGTYPES
};
enum {
PNGSIZE,
PNGTEST,
TTLPNGDISP
};
enum {
FREE_DBINFO,
FREE_DBLISTING
};
enum { 
POLL_LOG,
POLL_EVENTQ,
TTLPOLLTYPES
};
enum {
SRVR_CFG_SHOW,
SRVR_CFG_DESTROY
};
enum {
FILE_SEL_DD,
FILE_SEL_PNG,
FILE_SEL_ID
};
enum { 
CBO_LOGMSGTYPE,
TTLCBOTYPES
};
enum {
TRSTARTT,
TRENDT,
TTLTRTIMES
};
enum {
TRHOUR,
TRMIN,
TTLTRSEGS
};
#define NORMPNGMINW 290
#define NORMPNGMINH 220
#define ICONPNGMINW 170
#define ICONPNGMINH 145
#define ICONPNGMAXW (THUMBSIZEMAXWPDF-1)
#define ICONPNGMAXH (184)
typedef struct _TIME24
{ 
int time[TTLTRSEGS];
} TIME24;
typedef struct _SRVREXECCFG
{
int numCPU; 
gboolean dirScan; 
gboolean refreshSysPNG; 
char *identFile; 
struct {
gboolean set; 
TIME24 bounds[TTLTRTIMES]; 
} timeRestricted;
} SRVREXECCFG;
typedef struct _ADMINDATA
{
struct {
int main; 
int sub; 
} tab;
int state; 
DBDEF dbInfo; 
int sel[TTLDATAMODELS]; 
struct {
int maxCPU; 
int logDisplay; 
SRVREXECCFG srvrCFG; 
} settings;
struct {
struct {
struct {
GSList *list; 
gboolean changed; 
} psdConf;
} edit;
struct {
GSList *list; 
} channels;
struct { 
int srvrNum;
SRVRLOG *srvrLog;
EVENTQLIST EQList; 
gboolean polling[TTLPOLLTYPES]; 
} log;
struct {
int which; 
GSList *statLines; 
char *pdfWWWDir; 
} png;
} states;
} ADMINDATA;
#endif
