#ifndef __PQLX_STN_INCLUDE
#define __PQLX_STN_INCLUDE
enum { 
STNCVG=0, 
STNDTA, 
TTLSTNMAINDISPLAYMODES
};
enum {
STNNOSRVR, 
STNBUSY, 
STNDRAW, 
STNCNCT, 
STNNOSEL, 
TTLSTNMSGS
};
enum {
STNMSG,
STNTEXT,
STNFGBG,
STNSBAR,
STNGAPI,
STNOLAP,
STNARR,
STNPICK,
TOTALSTNCONTEXTS
};
enum {
STNCURDT, 
STNPREVDT, 
STNNEXTDT, 
STNPREVSTN1, 
STNNEXTSTN1, 
TTLSTNLOOKAHEADS,
STNINIT, 
STNREINIT
};
#define TTLPERIODSTNDATA (STNNEXTDT+1)
#define STNPREVSTN (STNPREVSTN1-STNPREVSTN1) 
#define STNNEXTSTN (STNNEXTSTN1-STNPREVSTN1) 
#define TTLSTNSTNDATA (STNNEXTSTN+1)
enum { 
CURDTS, 
CURDTE, 
PRVDTS, 
PRVDTE, 
NXTDTS, 
NXTDTE, 
TTLSTNDATES
};
enum {
STNSTATSPLT,
STNPDFPLT,
STNCHNMETAPLT,
STNNOPLT,
STNTRCSELPLT,
STNTRCSELSTN,
STNTRCSELCHN,
STNTRCSELDAY,
STNCHNSELECT,
TTLSTNPLTS
};
enum {
STNTRCPQLN, 
STNTRCPQLA, 
STNTRCEVTN, 
STNTRCEVTA,
STNTRCANAN, 
STNTRCANAA,
STNTRCDATA, 
TTLSTNTRCACTIONS
};
#define MAXSTNXDAYS (365*5)
#define MAXSTNDAYS 60
#define MAXSTNLINES 36
#define MAXTHREADSPCPU 2
enum { 
STNMAINCTRL,
STNANLCTRL,
STNEVTCTRL,
STNSPECCTRL,
STNPSDCTRL,
STNPMCTRL,
STNTTLCTRLS
};
enum { 
STNFG, 
STNBG, 
STNSB, 
STNGP, 
STNOP, 
STNPA, 
STNUP, 
STNMAXCOLOURS
};
enum {
STNHL=STNGP, 
STNPMC, 
STNPMSP, 
STNPMEP, 
STNPMEBA, 
STNPMLA, 
STNMAXPOPUPCOLOURS
};
enum {
STNUNITS,
STNOVERLAY,
STNXSCALE,
STNZANCHOR,
STNAMPSCALE,
STNEPIORDER
};
enum {
INIT1,
INIT2,
NEXT
};
enum {
STNCHNFLTSGNL,
STNFLTSGNL,
STNFLTCBOSGNL,
STNANATFORMSGNL,
STNOVLYSGNL,
STNXSCLSGNL,
STNSRVRDFAULTSGNL,
STNDBDFAULTSGNL,
STNDISPCVGSGNL,
STNDISPDATASGNL,
STNYCHNGROUPSGNL,
MAXSTNSIGNALTYPES
};
enum {
STNDRAWINIT,
STNDRAWREFRESH,
STNDRAWDONE,
STNDRAWNOTDONE,
TTLSTNDRAWSTATES
};
enum {
STNREDRAWREQ=1,
STNREINITREQ,
STNNOREQ
};
enum { 
STNWSCALE,
TTLSTNRADIOS
};
enum {
STNEVTEPINEAR1ST, 
STNEVTEPIFAR1ST, 
STNEVTEPIORDERS,
};
enum TRCDISPORDER {
EVTDISPEVT,
EVTDISPSTN,
TTLDISPORDERS
};
#if 0
enum EPISORTORDER {
EVTSORTNEAREST, 
EVTSORTFARTHEST 
};
#endif
enum EVTALIGNMENT {
STNALIGNUSER=ABSOLUTE+1,
STNALIGNPRDCT,
MAXALIGNMENTS
};
enum {
EVTEVTCAT,
EVTEVTUSER,
TTLEVTEVTTYPES
};
enum {
ANATFORMS,
ANADEMEAN,
ANADIFFERENTIATE,
ANAINTEGRATE,
ANAREVPOL,
ANADETREND,
ANASPECTRA,
ANAPSD,
ANAUVW,
ANADECONVOLVE,
ANAPARTMOTION,
TTLSTNANALYSES,
ANAORIG,
ANAFILTER
};
enum {
ANAPLOT 
};
enum {
STNCHNGRPMAIN,
STNCHNGRPANALYSIS,
TOTSTNCHNGROUPS, 
};
enum {
STNDRAGUP,
STNDRAGDOWN
};
enum {
STNSHIFTFORWARD,
STNSHIFTBACKWARD
};
enum {
STNCOUNTS,
STNSENSITIVITY,
TTLSTNUNITS
};
enum {
YSCALEMANAGE,
YSCALETRACE,
YSCALEWINDOW,
YSCALEFIXED,
YSCALEFIXEDENTRIES
};
#define YSCALEAUTO "AUTO"
enum {
STNSORTNAME,
STNSORTTIME,
STNSORTEPI
};
enum {
STARTABS,
STOPABS,
TTLABSTIMES
};
enum {
STN_POPUP_WIN_SINGLE,
STN_POPUP_WIN_SEPARATE
};
enum {
SPECTRA_WIN,
PSD_WIN,
PM_WIN,
TTLPOPUPWIN
};
enum {
PM_PLOT=TTLPOPUPWIN,
PM_TRC,
TTLPMDA
};
enum {
PU_SPECTRA_DRAW_TOP,
PU_SPECTRA_POINT,
TTLPUACTIONS
};
enum {
EVTCLEAR,
EVTGET
};
typedef struct _INTERPTT
{ 
char *phaseName;
float ttime;
} INTERPTT;
typedef struct _YCHNSCALE
{
char *name;
char *loc, *chn;
char *scale[2];
} YCHNSCALE;
typedef struct _YCHNGROUP
{
char *name;
GSList *chnScales; 
} YCHNGROUP;
typedef struct _AUTOSCALE
{
char *name;
GSList *channels;
} AUTOSCALE;
typedef struct _TRCPLOT
{ 
int chnNum;
double time[TTLDATES];
int pixel[TTLDATES];
int bdry[TTLDATES]; 
CHNDATA *chnData;
double stats[MAXSTATS];
} TRCPLOT;
typedef struct _MODELPHASES
{
int modelKey; 
GtkWidget *widget; 
GSList *phasesR; 
} MODELPHASES;
typedef struct _SET_ARGS
{
int setting;
gboolean *val;
} SET_ARGS;
#define MODELSEP "`"
#define MODELSSEP ":"
#define STNTOPM 0
#define STNBOTM 30
#define STNRGTM 45
#define STNLFTM 70
#define YAXISW 10
#define STNTOPBD (STNTOPM+(chnNum*stnStates.display.chnH)+1) 
#define STNBOTBD (STNTOPM+((chnNum+1)*stnStates.display.chnH)-1)
#define EVTTOPM 30
#define EVTBOTM TRC_B_MARGIN
#define EVTTOTALM (EVTTOPM+EVTBOTM)
#define EVTTOPBD (EVTTOPM+(i*chnH)+1) 
#define EVTBOTBD (EVTTOPM+((i+1)*chnH)-1)
#define ANATOPMSG1 20
#define ANATOPMSG2 20
#define ANATOPMSG (ANATOPMSG1 + ANATOPMSG2)
#define ANATOPXIS 25
#define ANATOPM (ANATOPMSG1+ANATOPMSG2+ANATOPXIS)
#define ANABOTM TRC_B_MARGIN
#define ANALFTM (STNLFTM+10)
#define ANARGTM 10
#define ANATOTALM (ANATOPM+ANABOTM)
#define ANATOPBD(x) (x+(i*trcH)+1) 
#define ANABOTBD(x) (x+((i+1)*trcH)-1)
#define SPECTOPM 25
#define PM_MARGIN 45
#define DOTSIZE 2
#define DOTSIZEF 2
#define TORAD(a) ((double)((a)*G_PI)/180.)
#define TODEG(a) ((double)((a)*180./G_PI))
typedef struct _STNCHN 
{ 
int key;
char *name1;
char *name2;
char *shortName;
char *longName;
} STNCHN;
typedef struct _ANALYSIS
{
TRACEINFO orig;
DATAINFO mod;
} ANALYSIS;
typedef struct _STNSETTINGS
{
int ttlStns; 
int pqlDest; 
struct {
GDate *dates[TTLDATES]; 
int yScale[TTLSTNSCREENS]; 
char *yFixed[TTLSTNSCREENS][2]; 
gboolean yAxis[TTLSTNSCREENS]; 
int xScale; 
int overlay[TTLSTNSCREENS]; 
int units[TTLSTNSCREENS]; 
gboolean unitsD; 
} display;
struct {
int data; 
int lines; 
int days; 
struct {
CHN_FILTER filters;
int active; 
} chnFilter;
struct {
GSList *scales; 
GSList *groups; 
char *selected; 
} yChnScale;
int shiftDays; 
} main;
struct {
int dispOrder; 
int epiOrder; 
char *modelsSV; 
GSList *models; 
char *modelSel; 
char *alignPhase; 
char userP[MAXPICKS][11]; 
int userPA; 
} event;
struct {
struct {
char *selected; 
} yChnScale;
int anchor; 
struct {
gboolean type[TTLPOPUPWIN]; 
GdkColor colors[TTLPOPUPWIN][STNMAXPOPUPCOLOURS]; 
GdkGC *ctxt[TTLPOPUPWIN][STNMAXPOPUPCOLOURS][3]; 
SPECSETTINGS spectra; 
PSDSETTINGS psd; 
struct {
int width, height; 
int xPos, yPos; 
} dims[TTLPOPUPWIN];
} popup;
} analysis;
struct {
GdkGC *ctxts[TTLSTNSCREENS][TOTALSTNCONTEXTS][3]; 
GdkColor colors[TTLSTNSCREENS][STNMAXCOLOURS]; 
} drawing;
struct {
GtkWidget *DA;
GdkGC *GC;
int font; 
PangoContext *context[NUMDATASCREENS];
PangoFontDescription *desc[NUMFONTTYPES];
} font;
struct {
gboolean startup;
char *server;
char *database;
int stnXDays; 
} general;
} STNSETTINGS;
typedef struct _EVTDATA
{
traceInfo *trc;
int trcNum; 
struct {
gboolean selected; 
} display;
} EVTDATA;
typedef struct _USERPICK
{
int pickNum;
double time;
} USERPICK;
typedef struct _ANADATA
{
traceInfo *trc; 
GSList *chnMETA; 
int trcNum; 
float *original; 
DATAINFO dataInfo; 
struct {
gchar *dispStr; 
gboolean deconvolve; 
} tForm;
struct {
double stats[2][MAXSTATS]; 
gboolean selected; 
} display;
ARRIVALS *arrivals; 
GSList *userPicks; 
} ANADATA;
typedef struct _ANAPOPUPDATA
{ 
traceInfo *trc;
struct {
graph gr;
} spectra;
} ANAPOPUPDATA;
typedef struct _ANAPOPUP
{ 
int which; 
GtkWidget *topW; 
GtkWidget *da; 
GtkWidget *sb; 
GdkPixmap *pmap; 
GtkWidget *statusBar; 
union {
SPECSETTINGS spec; 
PSDSETTINGS psd; 
} settings;
union {
struct {
double glob[TTLSPECGLOBALS];
double user_length;
gboolean overlay, amp;
graph gr;
} spectra;
struct {
int ptNum;
GdkPoint *line;
GtkWidget *da; 
GdkPixmap *pmap; 
} PM;
} plot;
GSList *data; 
} ANAPOPUP;
typedef struct _STNSTATES 
{ 
struct {
int state; 
int type; 
int dataBUSY; 
int plotBUSY; 
GDate *endDate; 
} request;
struct {
gboolean initiate; 
int dataState; 
gboolean dataRequest; 
gboolean pdfBUSY; 
gboolean pdfRESET; 
int pdfCtr;
int ttlChn; 
int chnH; 
float dayW; 
CHN_FLT_STATE chnFilter; 
struct {
int active; 
YCHNGROUP *chnGroupScale; 
GSList *autoScale; 
} yScaleGrp[TTLSTNSCREENS];
struct {
int active;
gboolean on;
} dataFilter;
struct {
gboolean valid; 
gboolean mouseDown; 
gboolean dragging; 
int event;
int action;
struct {
GSList *list; 
GdkPoint *active; 
int chnStart; 
int curChan; 
} box;
int keyActive;
} user;
} display;
struct {
PTIME dateRng[TTLSTNDATES]; 
GList *startStn, *endStn; 
GSList *stns[TTLPERIODSTNDATA]; 
int stnStrtNum, stnCnt; 
int ttlChnCnt[TTLPERIODSTNDATA]; 
GList *stnList; 
GSList *chnList; 
GSList *selections; 
GSList *pdfList; 
graph mainGR; 
} main;
struct { 
GList *startStn, *endStn; 
GSList *stns; 
int ttlChnCnt; 
} NP[TTLSTNSTNDATA]; 
struct {
GSList *models; 
TTMODEL *model; 
GSList *events; 
EVENTINFO *event; 
EVENTINFO user; 
GSList *arrivals; 
int curPick; 
gint evtPhInfoX, evtPhInfoY; 
} event;
struct {
GSList *traces; 
GSList *selections; 
struct {
int active;
gboolean on;
} dataFilter;
struct {
int transform; 
gboolean common; 
gchar *tFormStr; 
GHashTable *tForms; 
gboolean list; 
double left, right; 
} tForm;
struct {
graph gr[TTLGR]; 
graph absGR; 
struct {
struct {
coords user; 
bounds pix; 
} selection;
double times[TTLABSTIMES]; 
} limits;
struct {
points user; 
} extra;
} plot;
struct {
struct {
GHashTable *data; 
} separate;
struct {
GtkWidget *win; 
ANAPOPUP *data; 
} same;
} popup[TTLPOPUPWIN]; 
} analysis;
struct {
int keyActive; 
gboolean mouseDown;
} user;
struct {
gboolean dirty[TTLSTNSCREENS][TTLSTNMAINDISPLAYMODES]; 
GdkPixmap *main[TTLSTNMAINDISPLAYMODES]; 
GdkPixmap *event[TTLPMAPTYPES]; 
GdkPixmap *analysis[TTLPMAPTYPES]; 
GdkPixmap *specPsdPrint; 
} pmap;
int screen; 
struct {
GHashTable *instIDs; 
} data;
} STNSTATES;
#endif
