#ifndef __PQLX_TYPES_H
#define __PQLX_TYPES_H
#include <glib.h>
typedef struct _NSLCDATA
{
char name[10];
char fullname[50];
char alias[20];
int id;
} NSLCDATA;
typedef struct _CHN_FILTER
{
int numFilters; 
char **filts;
} CHN_FILTER;
typedef struct _CHN_FLT_STATE
{
char *filt; 
int active;
} CHN_FLT_STATE;
typedef struct _SRVRDB
{
char *name[2];
} SRVRDB;
typedef struct _DBRPLCSTR
{ 
char *fromStr;
char *toStr;
} DBRPLCSTR;
typedef struct _PQLX_STATES
{
int startupSys; 
int system; 
int pqlDest; 
struct {
SERVERDBS *server; 
DBLST *dbInfo; 
GSList *srvrDB; 
} servers;
struct {
gboolean state; 
char *srvrNm, *dbNm; 
gboolean editPermit; 
} conn;
#if 0
functionality suspended
search for function FNameRplc to re-instate in all pqlx systems source directories
struct {
struct {
DBRPLCSTR *replace; 
GHashTable *rplc; 
} fname;
} user;
#endif
struct {
int numCPUs;
gboolean myWordOrder;
} machine;
} PQLXSTATES;
typedef struct _PQLXGDATA
{
GSList *systemPDFs; 
GSList *systemBLINEs; 
} PQLXGDATA;
typedef struct _LOGFILES
{
char *fileName;
FILE *fp;
} LOGFILES;
#endif
