#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "PSD.h"
int PSD_bin(PSD_DATA *analysis)
{
static int PDFalloc;
int  period, powerPos, numperiods;
int  *hourBin;
int  maxpwrs = analysis->conf->max_power - analysis->conf->min_power + 1;
DType *powPtr;
numperiods = analysis->hzData.cnt;
if (!(analysis->hourBinHit)) 
{ 
PDFalloc = numperiods * maxpwrs * sizeof(int);
if ((analysis->hourBinHit = malloc(PDFalloc)) == NULL) 
{ 
return(NO_MEMORY);
}
}
memset(analysis->hourBinHit, 0, PDFalloc);  
hourBin=analysis->hourBinHit;
powPtr=analysis->hzData.power;
for (period=0; period < numperiods; period++) 
{
powerPos = *(powPtr+period) + analysis->conf->db_offset - 
analysis->conf->min_power;   
powerPos = (powerPos < 0) ? 0 : powerPos; 
powerPos = (powerPos >= maxpwrs) ? maxpwrs-1 : powerPos;
(*(hourBin + period * maxpwrs + powerPos))++; 
} 
return(PQLXSUCCESS);
}
