#include <stdio.h>
#include "pql_defines.h"
#include "pql_externs.h"
#define LOG10(x) ((double) (log(x)*.434294))
#define POW10(x) ((double) (exp(x*2.302585)))
void window(graph *gr, double x1, double x2, double y1, double y2, int lx, int ly)
{
double log();
if (lx) {
gr->user_xmin = LOG10(x1);
gr->user_xmax = LOG10(x2);
}
else {
gr->user_xmin = x1;
gr->user_xmax = x2;
}
if (ly) {
gr->user_ymin = LOG10(y1);
gr->user_ymax = LOG10(y2);
}
else {
gr->user_ymin = (float) y1;
gr->user_ymax = (float) y2;
}
gr->user_xdif = gr->user_xmax - gr->user_xmin;
gr->user_ydif = (double) gr->user_ymax - (double) gr->user_ymin;
if (gr->user_ydif == 0) {
gr->user_ymax += 1;
gr->user_ymin -= 1; 
gr->user_ydif = (double) gr->user_ymax - (double) gr->user_ymin;
}
gr->logx = lx;
gr->logy = ly;
}
void viewport(graph *gr, int x1, int x2, int y1, int y2)
{
gr->pix_xmin = x1;
gr->pix_xmax = x2;
gr->pix_xdif = x2 - x1;
gr->pix_ymin = y1;
gr->pix_ymax = y2;
gr->pix_ydif = y2 - y1;
}
#if 0
int user_to_pix_x(graph *gr, double x)
{
double a, b, log();
double rint();
if (gr->logx)
a = LOG10(x);
else
a = x;
a = ((gr)->logx?LOG10(x):x)
b = ((a - gr->user_xmin) / gr->user_xdif) * ((double) gr->pix_xdif) + ((double) gr->pix_xmin);
return ((rint)(b));
}
int user_to_pix_y(graph *gr, double y)
{
double a, b, log();
if (gr->logy)
a = LOG10(y);
else
a = y;
b = ((double) gr->pix_ydif) - ((double) (((gr)->logy ? LOG10(y) : y) - gr->user_ymin) / gr->user_ydif) * ((double) gr->pix_ydif) + ((double) gr->pix_ymin);
return ((int) b);
}
double pix_to_user_x(graph *gr, int pix_x)
{
double a, factor, exp();
factor = ((double) (pix_x - gr->pix_xmin)) / ((double) gr->pix_xdif);
a = factor * (double)(gr->user_xdif) + gr->user_xmin;
if (gr->logx)
a = POW10(a);
return (a);
return ((a))
}
double pix_to_user_y(graph *gr, int pix_y)
{
double a, factor, exp();
factor = (1. - (((double) pix_y - gr->pix_ymin) / ((double) gr->pix_ydif)));
a = factor * gr->user_ydif + gr->user_ymin;
if (gr->logy)
a = POW10(a);
return (a);
}
#endif
