#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if 0
main(int argc, char *argv[]) 
{
double stalat, stalon, evtlat, evtlon;
double delta, az, baz;
double scolat, slon, ecolat, elon;
double a,b,c,d,e,aa,bb,cc,dd,ee,g,gg,h,hh,k,kk;
double rhs1,rhs2,sph,rad,del,daz,dbaz,pi,piby2;
if (argc != 5) {
printf("Usage: distaz sta_lat sta_lon evt_lat evt_lon\n");
printf(" Returns: Delta Baz Az\n");
exit(1);
} else {
stalat = atof(argv[1]);
stalon = atof(argv[2]);
evtlat = atof(argv[3]);
evtlon = atof(argv[4]);
}
if ((stalat == evtlat)&&(stalon == evtlon)) {
printf("%6.3f %6.3f %6.3f\n", 0.0, 0.0, 0.0);
exit(0);
}
#endif
double distaz(double stalat, double stalon, double evtlat, double evtlon)
{
double delta, az, baz;
double scolat, slon, ecolat, elon;
double a,b,c,d,e,aa,bb,cc,dd,ee,g,gg,h,hh,k,kk;
double rhs1,rhs2,sph,rad,del,daz,dbaz,pi,piby2;
pi=3.141592654;
piby2=pi/2.0;
rad=2.*pi/360.0;
sph=1.0/298.257;
scolat=piby2 - atan((1.-sph)*(1.-sph)*tan(stalat*rad));
ecolat=piby2 - atan((1.-sph)*(1.-sph)*tan(evtlat*rad));
slon=stalon*rad;
elon=evtlon*rad;
a=sin(scolat)*cos(slon);
b=sin(scolat)*sin(slon);
c=cos(scolat);
d=sin(slon);
e=-cos(slon);
g=-c*e;
h=c*d;
k=-sin(scolat);
aa=sin(ecolat)*cos(elon);
bb=sin(ecolat)*sin(elon);
cc=cos(ecolat);
dd=sin(elon);
ee=-cos(elon);
gg=-cc*ee;
hh=cc*dd;
kk=-sin(ecolat);
del=acos(a*aa + b*bb + c*cc);
delta=del/rad;
rhs1=(aa-d)*(aa-d)+(bb-e)*(bb-e)+cc*cc - 2.;
rhs2=(aa-g)*(aa-g)+(bb-h)*(bb-h)+(cc-k)*(cc-k) - 2.;
dbaz=atan2(rhs1,rhs2);
if (dbaz<0.0) {
dbaz=dbaz+2*pi;
} 
baz=dbaz/rad;
rhs1=(a-dd)*(a-dd)+(b-ee)*(b-ee)+c*c - 2.;
rhs2=(a-gg)*(a-gg)+(b-hh)*(b-hh)+(c-kk)*(c-kk) - 2.;
daz=atan2(rhs1,rhs2);
if(daz<0.0) {
daz=daz+2*pi;
}
az=daz/rad;
if(abs(baz-360.) < .00001) baz=0.0;
if(abs(az-360.) < .00001) az=0.0;
return (delta);
}
